
#if	!defined(__CONFRW_ERRNO_H__OPQEWUIPADSJKHZXCXZVNZCADLHJFOQEWPOQYUEHJASDFHPWQEUQ)
#define	__CONFRW_ERRNO_H__OPQEWUIPADSJKHZXCXZVNZCADLHJFOQEWPOQYUEHJASDFHPWQEUQ
/*!
 *	\if developer_doc
 *		\file 
 *	
 *		\brief  读配置文件的调用接口函数库的错误代码定义头文件。
 *
 *		id: $Id: confrw_errno.h,v 1.2 2006/08/04 03:37:33 zhuzhenhua Exp $
 *
 *		\author 杨小波 prcharold@sina.com.cn develop1@szscada.com 
 *	\endif
*/

#include "global_errno.h"

/*!
*	\if by_group
*		\addtogroup grp_config_rw
*		@{
*	\endif
*/

//!< 不能为当前打开的配置文件缓冲分配一个句柄，原因是句柄已经全被占用
#define	ERROR_CONF_NOHANDLE					(ERROR_CONF_BASE + 1)

//!< 创建哈希表失败
#define ERROR_CONF_CREATEHASH				(ERROR_CONF_BASE + 2)

//!< 输入了非法的配置文件缓冲句柄
#define ERROR_CONF_INVALIDHANDLE			(ERROR_CONF_BASE + 3)

//!< 在读配置文件时，用户开辟的接收缓冲区不够大
#define ERROR_CONF_REVBUFFER				(ERROR_CONF_BASE + 4)

//!< 在读配置文件时，因指定的段的项目名不存在，函数执行缺省拷贝，并返回此结果
#define SUCCESS_CONF_DEFCOPY				(ERROR_CONF_BASE + 5)

//!< 不能输入一个空的句柄指针作参数
#define ERROR_CONF_NULL_HANDEPTR			(ERROR_CONF_BASE + 6)

//!< 输入的段名，项目名，项目值的字符串长度超长
#define ERROR_CONF_INPUTSTRING_TOOLARGE		(ERROR_CONF_BASE + 7)

//!< 指定的段或项目并不存在
#define ERROR_CONF_NOTEXIST					(ERROR_CONF_BASE + 8)


/*!
*\verbatim
	以下为confrw_ex中定义的错误代码
*\endvervatim
*/
//!<	无效的配置文件句柄
#define	ERROR_CONF_HANDLE					(ERROR_CONF_BASE + 9)

//!<	指定的段不存在
#define	ERROR_CONF_SECTION					(ERROR_CONF_BASE + 10)

//!<	指定的键值不存在
#define	ERROR_CONF_KEY						(ERROR_CONF_BASE + 11)

/*!
*	\if by_group
*		@}
*	\endif
*/
#endif	//!defined(__CONFRW_ERRNO_H__OPQEWUIPADSJKHZXCXZVNZCADLHJFOQEWPOQYUEHJASDFHPWQEUQ)
