#ifndef _HEADER_H
#define _HEADER_H

#ifdef    OS_UNIX
    #include <unistd.h>
	#include <assert.h>
	#include <time.h>
	#include <sys/types.h>
	#include <sys/stat.h>
	#include <fcntl.h>
	#include <termios.h>
#endif    //OS_UNIX
#ifdef    OS_WINDOWS
    #include <direct.h>
#endif    //OS_WINDOWS

#include	<stdio.h>
#include	<stdlib.h>

static const char* const image_protect_data[] = { 
"16 15 6 1",
"# c #000000",
"a c #008000",
"c c #00ff00",
"d c #808080",
". c #ff0000",
"b c #ffffff",
".......#.......#",
".aaaaaa#.aaaaaa#",
".a.aa.a#.a.aa.a#",
".aaaaaa#.aaaaaa#",
".abbbba#.abbbba#",
".acccba#.acccba#",
".adccba#.adccba#",
".acdcba#.acdcba#",
".acdcba#.acdcba#",
".accdba#.accdba#",
".acccba#.acccba#",
".acccba#.acccba#",
".aaaaaa#.aaaaaa#",
".aaaaaa#.aaaaaa#",
".#######.#######"};

static const char* const image_protectclose_data[] = { 
"16 15 5 1",
"# c #000000",
"c c #808080",
"a c #c0c0c0",
". c #ff0000",
"b c #ffffff",
".......#.......#",
".aaaaaa#.aaaaaa#",
".a.aa.a#.a.aa.a#",
".aaaaaa#.aaaaaa#",
".abbbba#.abbbba#",
".a###ba#.a###ba#",
".ac##ba#.ac##ba#",
".a#c#ba#.a#c#ba#",
".a#c#ba#.a#c#ba#",
".a##cba#.a##cba#",
".a###ba#.a###ba#",
".a###ba#.a###ba#",
".aaaaaa#.aaaaaa#",
".aaaaaa#.aaaaaa#",
".#######.#######"};

static const char* const image_open_data[] = { 
"16 15 5 1",
"# c #040404",
"c c #808000",
"a c #808080",
". c #c0c0c0",
"b c #ffff00",
".......#a###....",
".......##...#...",
".......###...#..",
".###.........#..",
"#.b.#######..#..",
"#b.b.b.b.b#.....",
"#.b.b.b.b.#.....",
"#b.b.##########.",
"#.b.#ccccccccc#.",
"#b.#ccccccccc#..",
"#.#ccccccccc#...",
"##ccccccccc#....",
"###########.....",
"................",
"................"};

static const char* const image_print_data[] = { 
"16 15 5 1",
"# c #040404",
"b c #808080",
". c #c0c0c0",
"c c #ffff00",
"a c #ffffff",
".....#########..",
"....#aaaaaaaa#..",
"....#a#####a#...",
"...#aaaaaaaa#...",
"...#a#####a####.",
"..#aaaaaaaa#.#.#",
".##########.#.##",
"#..........#.#.#",
"#############..#",
"#......bbb..#.#.",
"#......ccc..###.",
"#############.#.",
".#.........#.#..",
"..###########...",
"................"};

static const char* const image_start_data[] = { 
"16 15 7 1",
"d c #000000",
"e c #00ff00",
"# c #800000",
"a c #808080",
". c #c0c0c0",
"c c #ff0000",
"b c #ffff00",
".....######.....",
"...##aaaaaa##...",
"..#aabbbcccccd..",
".#abbcccccccc#d.",
".#abcccccccceed.",
"#abbccccccceee#d",
"#abccccccceeec#d",
"#abceeccceeecc#d",
"#abceeeceeeccc#d",
"#accceeeeeccc##d",
".#accceeecccc#d.",
".#accccecccc##d.",
"..daaccccc###d..",
"...dd######dd...",
".....dddddd....."};

static const char* const image_stop_data[] = { 
"16 15 6 1",
"d c #000000",
"# c #800000",
"a c #808080",
". c #c0c0c0",
"c c #ff0000",
"b c #ffff00",
".....######.....",
"...##aaaaaa##...",
"..#aabbbcccccd..",
".#abbcccccccc#d.",
".#ab...ccc...cd.",
"#abbc...c...cc#d",
"#abccc.....ccc#d",
"#abcccc...cccc#d",
"#abccc.....ccc#d",
"#accc...c...c##d",
".#ac...ccc...#d.",
".#accccccccc##d.",
"..dacccccc###d..",
"...ad######dd...",
".....dddddd....."};

static const char* const image_bird_data[] = { 
"16 15 15 1",
"# c #040404",
"d c #222222",
"k c #333300",
"f c #333333",
"b c #393939",
"g c #424242",
"i c #555555",
"h c #666666",
"l c #808000",
"a c #808080",
"e c #969696",
". c #c0c0c0",
"m c #cccc00",
"j c #cccc33",
"c c #ffffff",
"...###..........",
"..#aa.b...#####.",
".#c.ab#..#dde##.",
".#.fag#..dd.e##.",
".#hehg##ggee##..",
".#.eig##h##h#...",
"..#hf#ddh#####..",
"...feh#dhb.c.jk.",
"...#eehg#bcca#k.",
"...########b....",
"..#f###ff##.....",
"ffhhfhh###......",
"feh##.klk.......",
"#f#..##ml###....",
"..#...###lk....."};

static const char* const image_bookclose_data[] = { 
"16 15 5 1",
"# c #040404",
"a c #800080",
"b c #808080",
". c #c0c0c0",
"c c #ffffff",
".......##.......",
".....##aa#......",
"...##aaaaa#.....",
".##aaaaaaaa#....",
"#.aaaaaaaaaa#...",
"#a.aaaaaaaaaa#..",
"#aa.aaaaaaaaaa#.",
"#aaa.aaaaaaaaa##",
"#aaaa.aaaaaa###.",
".#aaaa.aaa##bc#.",
"..#aaaa.##b.c.##",
"...#aaa#bc.c.##.",
"....#aa#c.c##...",
".....#a#b##.....",
"......###......."};

static const char* const image_bookopen_data[] = { 
"16 15 6 1",
"# c #040404",
"a c #800080",
"d c #808080",
". c #c0c0c0",
"c c #ffff00",
"b c #ffffff",
"..#.............",
".#.#............",
"#ab.#....###....",
"#abb#..##bb#....",
"#abb.##bbbcd##..",
"#abbb#.bcbbdba#.",
"#abbb#.bbbcdba#.",
"#abbb#.bcbbdba##",
"#abbb#.bbbcdba#.",
"#abbb#.bcbbdba#.",
"#aabb#.bbbd.ba##",
".#aab#.bdd.bba#.",
"..#ab#dd.bbbba#.",
"...#aaaaaaaaaa#.",
"....###########."};

static const char* const image_computer_data[] = {
"16 15 7 1",
"d c #0000ff",
"e c #008000",
"c c #008080",
"# c #040404",
"b c #808080",
"a c #c0c0c0",
". c #ffffff",
"....###########.",
"...#aaaaaaaaaa##",
"...#.........bb#",
"...#.#######abb#",
"...#.#cbbbdcabb#",
"...#.#caaabcabb#",
"...#.#cbbbbcabb#",
"...#.#ccccccabb#",
"...#.aaaaaaaab##",
"...#aaaaaaeea#b#",
"...#bbbbbbbbbba#",
"...#aaaaaaaaaab#",
"..##b#b#b#b#bbb#",
".##a#a#a#a#a#b#.",
"##############.."};

static const char* const image_computeropen_data[] = { 
"16 15 7 1",
"d c #0000ff",
"e c #00ff00",
"c c #00ffff",
"# c #040404",
"b c #808080",
"a c #c0c0c0",
". c #ffffff",
"....###########.",
"...#aaaaaaaaaa##",
"...#.........bb#",
"...#.#######abb#",
"...#.#cbbbdcabb#",
"...#.#caaabcabb#",
"...#.#cbbbbcabb#",
"...#.#ccccccabb#",
"...#.aaaaaaaab##",
"...#aaaaaaeea#b#",
"...#bbbbbbbbbba#",
"...#aaaaaaaaaab#",
"..##b#b#b#b#bbb#",
".##a#a#a#a#a#b#.",
"##############.."};

static const char* const image_exit_data[] = { 
"16 15 7 1",
"b c #000080",
"d c #008000",
"a c #008080",
"e c #00ffff",
"# c #040404",
". c #c0c0c0",
"c c #ffff00",
"....##########..",
"....#aaaaaaab#..",
"....#aaaaaabb#..",
"....#caaaabbd#..",
"....#ccaaabdd#..",
".cccccccaabdd#..",
".eeeeeeccabdd#..",
".cccccccaab#d#..",
"....#ccaaab#d#..",
"....#caaaabdd#..",
"....#aaaaabdd#..",
"....#.....bdd#..",
"#####.....bdb###",
"..........bb....",
"..........b....."};

static const char* const image_eventblock_data[] = { 
"16 15 6 1",
"# c #000000",
"a c #000080",
"c c #0000ff",
"d c #808080",
". c #ff0000",
"b c #ffffff",
".......#.......#",
".aaaaaa#.aaaaaa#",
".a.aa.a#.a.aa.a#",
".aaaaaa#.aaaaaa#",
".abbbba#.abbbba#",
".acccba#.acccba#",
".adccba#.adccba#",
".acdcba#.acdcba#",
".acdcba#.acdcba#",
".accdba#.accdba#",
".acccba#.acccba#",
".acccba#.acccba#",
".aaaaaa#.aaaaaa#",
".aaaaaa#.aaaaaa#",
".#######.#######"};

static const char* const image_delevents_enable_data[] = { 
"15 15 5 1",
"c c #800000",
"# c #808080",
". c #c0c0c0",
"a c #ff0000",
"b c #ffff00",
"...............",
".#a#.........a.",
".abac......ac..",
"..aaac....ac...",
"....aac..ac....",
".....aacac.....",
"......aac......",
".....aacac.....",
"....aac..ac....",
"...aac....ac...",
"..aaa......a...",
".abac.......a..",
".aac...........",
"..c..........a.",
"..............."};

static const char* const image_delevents_disable_data[] = { 
"15 15 4 1",
"b c #000000",
"# c #808080",
". c #c0c0c0",
"a c #ffffff",
"...............",
".###.........#.",
".#a.b......#b..",
"..##.b....#b...",
"....#.b..#b....",
".....##b#b.....",
"......##b......",
".....##b#b.....",
"....##b..#b....",
"...#.b....#b...",
"..#.b......#...",
".#a#b.......#..",
".##b...........",
"..b..........#.",
"..............."};

static const char* const image_fixsetting_data[] = { 
"16 16 11 1",
"a c #000000",
"b c #000080",
"d c #0000ff",
"i c #008080",
"e c #00ff00",
"h c #00ffff",
"f c #808000",
"# c #808080",
". c #c0c0c0",
"g c #ffff00",
"c c #ffffff",
"................",
"############a...",
"#bbbbbbbbbbba...",
"############a...",
"#.cccccccccca...",
"#.cdecffc##ca...",
"#.cebcfga#caafa.",
"#.ccccafg#cafga.",
"#.cdhaaca#caafaa",
"#.cihafgcaaacgfa",
"#.cccafagcgcgafa",
"#.....agfacffga.",
"aaaaaaffaagfafga",
"......aa.afa.aa.",
".........aaa....",
"................"};

static const char* const image_login_data[] = { 
"16 16 22 1",
"# c #000000",
"t c #000080",
"p c #0000ff",
"o c #0099ff",
"a c #040404",
"r c #330000",
"h c #333300",
"j c #666600",
"m c #800000",
"f c #808080",
"i c #996600",
"b c #ada990",
"e c #c0c0c0",
". c #cbcbcb",
"s c #cc9900",
"c c #cc9933",
"q c #cccc33",
"g c #eaeaea",
"n c #ff0000",
"d c #ffcc66",
"l c #ffff00",
"k c #ffff99",
"...########.....",
".########a##....",
"######a#bc##....",
"#####de#cd#.....",
"###aded#b##.....",
"##eded##cbcf....",
"##dedgdbhd#.....",
".##dedb#cb#ij#i.",
"..#eced###ikkl#i",
".#ecf###..jkj#l#",
"###ec#mmn.illil#",
"#op#####m#lhql#j",
"#poppppphkrsr#j.",
"..#oott#krqrj...",
".......#qsrj....",
"........#rj....."};

static const char* const image_suo256_data[] = { 
"16 16 60 1",
"3 c #5f5b52",
"d c #676663",
"s c #707070",
"4 c #746538",
"5 c #777777",
"l c #9c7f46",
"k c #ad883a",
"f c #ae9855",
"n c #b69244",
"v c #bfb176",
"M c #c7ac58",
"B c #c89603",
"r c #cc9900",
"m c #cd9a03",
"1 c #d3a00f",
"Z c #d4a10f",
"o c #d4a110",
"i c #d5a212",
"# c #d6ac1d",
"h c #d6ac30",
"t c #dcb53c",
"g c #dcbc5a",
"T c #dfac25",
"0 c #e1ba46",
"N c #e2c56b",
"G c #e3cc7a",
"u c #e5bd50",
"P c #e6b333",
"S c #e8d479",
"w c #e9d28f",
"e c #ebcf55",
"q c #ebd899",
"a c #ecd960",
"p c #edba42",
"J c #f2c250",
"X c #f2cb58",
"c c #f2de6a",
". c #f2e4b5",
"H c #f2e686",
"b c #f5ec7c",
"y c #f8efd1",
"j c #f9d46d",
"Y c #f9d86c",
"x c #f9e0a7",
"K c #fcf3c3",
"A c #fcf5cb",
"Q c #fef5ae",
"D c #fefae0",
"C c #ffd771",
"2 c #ffd872",
"V c #ffe17b",
"W c #ffe37e",
"R c #ffee88",
"L c #fff993",
"O c #fffc96",
"F c #fffcac",
"z c #fffdd9",
"I c #ffff9c",
"U c #ffffa6",
"E c #ffffb3",
".......###......",
"......#aba#.....",
".....#cddef.....",
".....#d..gf#....",
".....#d..ghf....",
".....#ijjklm....",
"....#nkoipqrs...",
"...tuvwxyzABs...",
"...tCDEFGHIrs...",
"...tJKLLMNOrs...",
"...tPQRRnSRrs...",
"...tTUVWXYZ0s...",
"...t1K22iik3....",
"....1iii43s.....",
".....5555.......",
"................"};

static const char* const image_key256_data[] = { 
"16 16 170 2",
"az c #ae6c00",
"aB c #ae6d0f",
"aM c #af6e00",
"aE c #b0741a",
"aC c #b17216",
"aD c #b1741a",
".B c #b37519",
"aF c #b37618",
"aG c #b37717",
".O c #b5781e",
"aH c #b67a13",
".1 c #b67b23",
"#n c #b77c21",
"#b c #b77c23",
"an c #b87602",
"aK c #b87a07",
"#x c #b87d1d",
"#H c #b97e18",
"aL c #ba7902",
"ac c #ba7b05",
"aJ c #ba7c0a",
"aI c #ba7c0d",
"#2 c #bb7d0b",
"#Q c #bb7f12",
"ao c #cb8011",
"aN c #ceaf7f",
".m c #cf8a23",
"ay c #d08e01",
".A c #d3922f",
"ad c #d58a19",
".N c #d59635",
"#3 c #d78e22",
"at c #d79d24",
"as c #d89f38",
"aA c #d8b685",
"#R c #d9942c",
".l c #d99631",
"am c #d99b04",
"ax c #d99b05",
"#P c #d9a018",
"aw c #d9a10d",
"#k c #da9624",
"#I c #da9835",
"ab c #daa008",
"#1 c #daa10f",
"au c #daa11c",
"av c #daa215",
"ar c #daa248",
".n c #daba8a",
"#h c #db9a36",
".8 c #db9a3a",
".k c #dc9b3b",
".W c #dc9b3e",
".j c #dc9d3f",
"## c #dc9e3b",
"#u c #dd9d24",
"#t c #dd9e2c",
".V c #dd9e45",
"#s c #dd9f36",
"#G c #dda839",
".z c #dea045",
".i c #dea146",
"#5 c #dea248",
".g c #dea24a",
"#v c #dea32e",
"#B c #dea341",
".h c #dea34b",
"#g c #dfa44e",
"#V c #dfa546",
"#L c #dfa549",
"#U c #dfa54c",
".f c #dfa54f",
".X c #dfa651",
"#i c #e0a546",
".2 c #e0a753",
".e c #e0a754",
"#y c #e0a956",
"#p c #e1a857",
"#e c #e1a959",
".7 c #e1aa5a",
".d c #e1aa5b",
"#o c #e1aa5c",
".5 c #e1ab5e",
"al c #e2ac0a",
".P c #e2ac5e",
"#0 c #e2ad14",
"ai c #e2ad24",
"#d c #e2ad61",
"#D c #e2ae41",
"#r c #e2af5e",
".R c #e3ae63",
"#c c #e3af63",
".S c #e3af66",
"aa c #e3b00e",
"ak c #e3b013",
"aj c #e3b01c",
".G c #e3b167",
".0 c #e3b775",
"#Z c #e4b11b",
"#9 c #e4b12b",
".c c #e4b167",
".Y c #e4b267",
".4 c #e4b268",
".t c #e4b26a",
"a. c #e4b321",
"#j c #e4b362",
"ae c #e4b36b",
"ah c #e4b54c",
"a# c #e5b418",
"#C c #e5b45b",
".C c #e5b46b",
".3 c #e5b46c",
".F c #e5b66f",
".s c #e5b670",
"aq c #e5bf85",
"#S c #e6b874",
"#E c #e6b955",
".b c #e6b976",
"#f c #e7b97a",
"#O c #e7ba43",
".o c #e7ba77",
".r c #e7bb79",
".Q c #e7bc7a",
".6 c #e8bd80",
".E c #e8bf80",
"#J c #e9bf83",
"#z c #e9c186",
".u c #e9c187",
"#w c #e9c98c",
"#Y c #eac252",
"#X c #eac564",
".q c #eac58c",
".D c #eac58d",
"#6 c #ebc68e",
".H c #ebc691",
"af c #ebc891",
"#q c #ebc894",
"#M c #ebc98b",
".y c #ecc893",
".K c #ecc996",
".p c #eecd9d",
".9 c #eece9e",
"#4 c #eed0a3",
"#l c #efd2a1",
"#A c #f0d4aa",
".L c #f0d5ae",
"Qt c #f0dab7",
"#K c #f1d7b0",
".M c #f1d7b1",
".a c #f1d7b2",
"#T c #f1d9b4",
"#a c #f2d9b2",
"#m c #f2dfbf",
"#7 c #f3ddb8",
".U c #f3dfc1",
".v c #f4e0c3",
"ap c #f6e8d4",
"#8 c #f7e7c5",
".x c #f7e9d4",
"#W c #f8eace",
"#N c #f8ecca",
".J c #f9eddd",
"ag c #faf1df",
".T c #faf1e4",
"#F c #fbf3e3",
".w c #fbf5eb",
"#. c #fefcf8",
".I c #fefcf9",
".Z c #fffefd",
".# c #ffffff",
"Qt.#.#.#.#.#.#.#.#.#.#.#.#.#.#Qt",
".#.a.b.c.d.e.f.g.h.i.j.k.l.m.n.#",
".#.o.p.q.r.s.t.u.v.w.x.y.z.A.B.#",
".#.C.D.E.F.G.H.I.J.K.L.#.M.N.O.#",
".#.P.Q.s.R.S.T.U.V.W.X.Y.Z.0.1.#",
".#.2.3.4.5.6.#.7.8.9#.###aQt#b.#",
".#.f#c#d#e#f.##g#h#i#j#k#l#m#n.#",
".#.z.7#o#p#q.##r#s#t#u#v.##w#x.#",
".#.j.2#y#z.##A#B#C#D#E.##F#G#H.#",
".##I.h#J.##K#L#M#..#.##N#O#P#Q.#",
".##R#S.##T#U#V.##W#X#Y#Z#0#1#2.#",
".##3.##4#5#6#7.##8#9a.a#aaabac.#",
".#ad.#aeaf.#.#agahaiajakalaman.#",
".#aoap.#.#aqarasatauavawaxayaz.#",
".#aAaBaCaDaEaFaGaHaIaJaKaLaMaN.#",
"Qt.#.#.#.#.#.#.#.#.#.#.#.#.#.#Qt"};

static const char* const image_power256_data[] = { 
"16 16 245 2",
"bF c #7b431e",
"bE c #7e4623",
"ay c #82401e",
"bJ c #843318",
"#P c #854426",
"aO c #893217",
"bA c #8b3a29",
"bz c #8b4636",
"bw c #8c4527",
".R c #8d4838",
"bK c #8e4729",
"bG c #904e2c",
"bD c #915032",
"ai c #915934",
"bg c #934227",
"#4 c #935b38",
"#3 c #965b39",
"bB c #983c2d",
"#z c #98412d",
"bI c #993d24",
"bH c #9b4429",
"a3 c #9e4229",
"bv c #9f3f27",
"bC c #9f4834",
"ah c #9f6540",
".w c #9f735a",
"#k c #a14536",
".A c #a15346",
"bj c #a25f4f",
".B c #a36050",
"al c #a36b54",
"#K c #a56343",
"bq c #a56b46",
".v c #a67c63",
"bk c #a84a42",
"a5 c #a85a4d",
"#Z c #a8734b",
"bp c #a96e4c",
"#T c #a97b61",
"#7 c #a97d64",
"aB c #aa5b4c",
"br c #aa5e3e",
"bo c #aa5e44",
"#8 c #ab7c62",
".6 c #ac5a4c",
"bf c #ad3a28",
"#C c #ad7d67",
"ad c #af784f",
"#W c #af7d5a",
"#S c #af856c",
"at c #b16d48",
".r c #b2776f",
"bs c #b44531",
"au c #b45539",
".y c #b56659",
"aq c #b67454",
"aR c #b76056",
"#m c #b9756a",
".5 c #ba4943",
"bn c #ba4c3f",
"#L c #ba5b45",
"ax c #ba6e4e",
"#H c #bb7e61",
"aa c #bb8762",
".u c #bc8c76",
"a2 c #bd4232",
"am c #bd7966",
".x c #bf8770",
".K c #bf9177",
"be c #c03e31",
"#y c #c05245",
".t c #c07c71",
".s c #c17b73",
"#O c #c2765c",
".z c #c36c62",
".M c #c37f6a",
"bL c #c38667",
"bu c #c4513f",
"aN c #c45541",
".L c #c4957b",
".Q c #c5675f",
"ap c #c66b56",
".E c #c6978d",
"a6 c #c75753",
"#t c #c76353",
"#0 c #c85f4a",
"#u c #c86d58",
"a1 c #c94e3e",
"#i c #c94f4a",
".q c #c99a90",
"#D c #ca8d7a",
".T c #ca8f87",
"ae c #cb624c",
"bt c #cc5141",
"aC c #cc635d",
"#s c #cc6b5a",
"aJ c #cc6d51",
"#r c #cc7562",
"#G c #cc7763",
"bm c #cd524d",
"aG c #ce6f59",
"a7 c #cf4f4e",
".J c #cf927f",
"bd c #d05545",
".4 c #d15150",
".C c #d19684",
".9 c #d28c84",
"bl c #d5645e",
"aT c #d65f59",
"aI c #d66d57",
"#j c #d75c57",
"aS c #d75f5e",
"#V c #d77665",
".P c #d96965",
".N c #d9706a",
".3 c #db645e",
"#v c #db9176",
"aH c #dc735d",
"a# c #dc7966",
"a8 c #dd635e",
".I c #de817c",
"Qt c #e4c8bc",
"#n c #e68984",
"#e c #e77d70",
".O c #e97170",
".W c #e97f7f",
".p c #eac8bc",
"#d c #eb8376",
"aK c #eb9f7d",
"## c #ec8483",
"#q c #edad94",
".U c #ef9394",
"#1 c #f07f6d",
"#U c #f0887d",
".F c #f1a7a4",
"aX c #f2826e",
"af c #f68672",
"aM c #f68974",
".V c #f6898c",
"bN c #f6c1af",
"#. c #f78f90",
"aF c #f7ad92",
"#x c #f98d80",
"a. c #f98f82",
".2 c #fa9287",
"#o c #fb9e96",
".n c #fbc6b4",
".H c #fd9596",
"bY c #fec8a6",
"a9 c #ff9386",
"bc c #ff947f",
"aD c #ff9e93",
"#f c #ffa898",
".G c #ffa8a9",
".X c #ffaaa2",
"#h c #ffab97",
"ao c #ffb1a1",
"#c c #ffb3a5",
"#M c #ffb4a0",
"a0 c #ffb597",
"aY c #ffb79e",
"av c #ffbba2",
"aW c #ffbca8",
"#F c #ffbcae",
"aU c #ffbda9",
"#a c #ffbdaf",
"bb c #ffcdb1",
"aw c #ffceb2",
"b. c #ffd1bb",
".Y c #ffd3c2",
"#N c #ffd5bf",
"aE c #ffd8c1",
"#p c #ffdac7",
"#w c #ffddc3",
"#E c #ffdecd",
"#b c #ffdfcc",
".1 c #ffe0cd",
"ag c #ffe1c1",
"aZ c #ffe2c1",
"aV c #ffe3c9",
"aL c #ffe5c4",
"bU c #ffe5c6",
"an c #ffe5d2",
".m c #ffe6d4",
"#A c #ffe7ce",
".7 c #ffe7d3",
"#2 c #ffe8ca",
"bi c #ffe8d4",
"a4 c #ffe8d6",
"aQ c #ffe8d9",
"#g c #ffe9d2",
"bQ c #ffead1",
"bx c #ffebc8",
"b# c #ffebcd",
".e c #ffebd6",
"#l c #ffebdc",
"#I c #ffecc7",
"bT c #ffecc8",
"ba c #ffeccc",
"aP c #ffeccd",
"bP c #ffecd6",
".S c #ffecd8",
".i c #ffecdb",
".j c #ffecdc",
".8 c #ffece0",
"bh c #ffedcd",
"#9 c #ffedd6",
".h c #ffedd7",
".0 c #ffedd8",
"aA c #ffeddc",
".Z c #ffeed8",
"bW c #ffefcc",
"bX c #ffefce",
"bV c #ffefcf",
"bO c #ffefdb",
".k c #ffefdd",
".D c #ffefe2",
"#5 c #fff0cc",
"#Q c #fff0d1",
"bR c #fff0d3",
".c c #fff0e4",
"as c #fff1ca",
"az c #fff1cd",
"#R c #fff1d8",
".l c #fff1dd",
"by c #fff1df",
".d c #fff1e1",
"#6 c #fff2d9",
"ak c #fff2dc",
".a c #fff2e5",
"aj c #fff3cd",
"bS c #fff3cf",
"bM c #fff3d1",
"ar c #fff4cc",
"#J c #fff4cf",
"#B c #fff4df",
".g c #fff5dc",
".b c #fff5e6",
".f c #fff6dd",
".o c #fff7ec",
"ab c #fff8c9",
".# c #fff8ea",
"ac c #fffaca",
"#Y c #fffacb",
"#X c #fffccd",
"Qt.#.a.b.c.d.e.f.g.h.i.j.k.l.m.n",
".o.p.q.r.s.t.u.v.w.x.y.z.A.B.C.l",
".D.E.F.G.H.I.J.K.L.M.N.O.P.Q.R.S",
".b.T.U.V.W.X.Y.Z.0.1.2.3.4.5.6.7",
".8.9#.###a#b#c#d#e#f#g#h#i#j#k.e",
"#l#m#n#o#p#q#r#s#t#u#v#w#x#y#z#A",
"#B#C#D#E#F#G#H#I#J#K#L#M#N#O#P#Q",
"#R#S#T.Z#U#V#W#X#Y#Z#0#1#2#3#4#5",
"#6#7#8#9a.a#aaabacadaeafagahaiaj",
"akalamanaoapaqarasatauavawaxayaz",
"aAaBaCaDaEaFaGaHaIaJaKaLaMaNaOaP",
"aQaRaSaTaUaVaW#1aXaYaZa0a1a2a3aP",
"a4a5a6a7a8a9b.b#babbbcbdbebfbgbh",
"bibjbkblbmbnbobpbqbrbsbtbubvbwbx",
"by.CbzbAbBbCbDbEbFbGbHbIbJbKbLbM",
"bNbObObP.ebQbRbSbSbTaPbUbVbWbXbY"};

static const char* const image_carton24b_data[] = { 
"80 100 7721 3",
"#SU c #000013",
"#HL c #000219",
"#HM c #00021b",
"#Ff c #000c29",
"#Fe c #001139",
"#Gk c #002458",
".#m c #010f67",
"#I1 c #012245",
"#Ry c #01266c",
".az c #030e7a",
"#ww c #03215f",
"#QQ c #032d2b",
".#n c #041368",
"#I2 c #042649",
".gk c #05168a",
"#ST c #051a4f",
"#ug c #051d59",
"#J2 c #052a61",
"#QP c #052d2c",
"#HB c #06114f",
".jx c #061a97",
"#F. c #061b52",
"#HK c #070723",
".gi c #071989",
"#uh c #071c51",
"#Fd c #071d4e",
"#tR c #071f5b",
".#h c #081283",
".ay c #08137f",
".fb c #081391",
".#l c #081571",
"#s5 c #081b53",
"#DY c #081c5b",
"#tS c #081e58",
"#DX c #08205e",
".ig c #08209a",
"#xZ c #082970",
"#s2 c #083061",
"#A# c #083753",
"#HJ c #09092d",
"#Fg c #091126",
".bG c #091386",
".fa c #091494",
"#uk c #091f5b",
"#sC c #092064",
".k0 c #092a9e",
"#wv c #092b72",
"#Gj c #092e65",
"#IW c #092e74",
"#Ke c #094078",
"#D7 c #0a0a22",
".au c #0a1487",
"#s7 c #0a1e59",
"#sz c #0a1e5d",
"#s8 c #0a205c",
"#wx c #0a2155",
"#s4 c #0a2359",
"#x0 c #0a2568",
"#uf c #0a2a63",
"#s3 c #0a2b5e",
".kZ c #0a2da1",
"#Aa c #0a324c",
".fc c #0b1692",
".hs c #0b1c92",
"#sy c #0b1f5e",
".aN c #0b1fb6",
"#ui c #0b2057",
"#s6 c #0b2059",
"#DW c #0b245c",
"#xM c #0b2653",
"#I0 c #0b294f",
"#J3 c #0b2f63",
"#xY c #0b3077",
"#s1 c #0b3364",
"#F6 c #0b3c4a",
"#D8 c #0c0e25",
"#Qt c #0c0f20",
"#CU c #0c0f2e",
"#BD c #0c1347",
"#BC c #0c154c",
"#An c #0c165b",
"#i9 c #0c195f",
"#0j c #0c1a1b",
".jw c #0c1c96",
"#sA c #0c2162",
"#sB c #0c2164",
".if c #0c229c",
"#ul c #0c2464",
"#Ql c #0c2961",
".kz c #0c29ab",
".q1 c #0c2d96",
"#LT c #0c2f29",
".uz c #0c4393",
"#z9 c #0c4b74",
"#NW c #0c4b98",
"#CV c #0d1230",
".cR c #0d1786",
".dZ c #0d1792",
".#i c #0d1884",
".cU c #0d188c",
".f4 c #0d1a83",
"#Gl c #0d1d59",
".jv c #0d1d97",
".aO c #0d22bd",
"#uj c #0d235c",
"#Ac c #0d2444",
".kx c #0d24a8",
".ey c #0d24b2",
"#E3 c #0d2565",
".ky c #0d25a9",
".l5 c #0d2fab",
"#V6 c #0d302a",
".l6 c #0d31ab",
"#IK c #0d3b90",
"#ue c #0d3c70",
"#A. c #0d405d",
".uE c #0d418c",
".uD c #0d428e",
".vP c #0d4693",
".uA c #0d4894",
"#CT c #0e0f2d",
".bH c #0e188b",
".#k c #0e1a7c",
"#Bu c #0e1c5b",
".f# c #0e1e8d",
".hu c #0e1e97",
".hr c #0e1f93",
".k. c #0e1f95",
".kw c #0e20a6",
"#RD c #0e2455",
"#xR c #0e2571",
"#E9 c #0e275f",
"#pv c #0e2875",
"#IY c #0e2a5c",
".aU c #0e2ab9",
"#IZ c #0e2b57",
"#Ab c #0e2d49",
".#H c #0e2fbc",
".uy c #0e4595",
".AU c #0e57c6",
"#BE c #0f1342",
"QtT c #0f16bc",
".bD c #0f1784",
"QtS c #0f17ba",
".cS c #0f1988",
".dY c #0f1994",
"#i8 c #0f1c62",
".dX c #0f1d8a",
".la c #0f1e95",
"#rK c #0f1f5a",
".fS c #0f1f98",
".gj c #0f2092",
"#D2 c #0f2243",
"#rL c #0f225d",
".j9 c #0f228b",
"#sx c #0f2360",
"#qy c #0f255e",
"#sD c #0f266c",
"#RC c #0f2753",
"#wt c #0f2765",
"#tM c #0f2868",
"#yZ c #0f294e",
"#IX c #0f2a61",
"#E5 c #0f2a6f",
"#tO c #0f2b6a",
"#tN c #0f2b6c",
"#wu c #0f2c68",
"#pw c #0f2c78",
"#xL c #0f2f58",
"#L7 c #0f372e",
".l7 c #0f37a8",
".tr c #0f3f8b",
".tq c #0f408c",
".uC c #0f4792",
"#Kf c #0f487f",
".uB c #0f4993",
"#NV c #0f4c9c",
"#CS c #10112f",
"#CR c #101332",
"Qt9 c #10149c",
"#HN c #101733",
".bE c #101885",
".bM c #101895",
".d0 c #101a93",
"#MC c #101b5d",
".aA c #101b87",
".cL c #101c8c",
".fd c #101c94",
".f5 c #101d86",
"#va c #101e5b",
"#Fj c #101f36",
"#pt c #101f70",
"#Av c #102051",
"#F# c #102054",
".fk c #102082",
".e7 c #10208f",
".hc c #102091",
"#Fk c #10213d",
".hy c #10218b",
".hd c #10218d",
"#pu c #102372",
".hC c #102382",
"#CJ c #10245f",
".jy c #1024a1",
"#qz c #102864",
"#vC c #102969",
".aP c #1029c3",
"#wP c #102d69",
"#vB c #10306d",
".l4 c #1031b2",
"#QT c #10323b",
"#J1 c #103674",
"#L2 c #103935",
"#Kd c #10427d",
".vO c #104690",
"#NX c #10509a",
".bf c #11109a",
"Qt2 c #1112ab",
"#D6 c #11132a",
"#HI c #11143f",
".#f c #111497",
"Qt7 c #1114a1",
".#a c #111592",
".eW c #11178f",
".#7 c #1117ad",
"#vb c #11195a",
".ax c #111b8a",
".av c #111b8c",
".#g c #111b8e",
".d1 c #111c92",
".#j c #111d83",
".f3 c #111d8b",
"#kh c #112065",
"#ps c #112071",
".go c #112093",
".k# c #112097",
".lh c #11219a",
"#rJ c #11225a",
"#Lm c #112268",
".i6 c #112296",
".ht c #112298",
".ds c #1123b5",
".hU c #1124a4",
".oC c #112595",
".hT c #1125a0",
"#qx c #11265b",
"#Ll c #112669",
"#tK c #112965",
"#wQ c #112967",
"#tJ c #112a63",
"#E4 c #112a6d",
"#tL c #112b68",
"#E6 c #112c71",
"#xS c #112e7c",
".k1 c #1130a5",
"#Rx c #11348e",
"#s0 c #113567",
"#Gg c #11366d",
"#QR c #113939",
".l8 c #1139aa",
"#so c #113b65",
".ts c #113f8a",
".uF c #11428e",
"#vz c #114382",
".vN c #114791",
"#vy c #114a8d",
".vQ c #114b95",
"#z8 c #114f78",
"#Gu c #120e2f",
".bg c #121298",
".#b c #121694",
".at c #121890",
".#6 c #1218ac",
".#1 c #1219b2",
".bC c #121a87",
".d2 c #121d93",
"#Au c #121e4e",
".cM c #121e8e",
"#DZ c #12205f",
"#kk c #122166",
".hb c #122196",
".ha c #122198",
"#0k c #122222",
".ju c #12229c",
".gs c #12238d",
".i5 c #122397",
"#ws c #122464",
".gf c #122492",
"#xQ c #122571",
"#rS c #12265b",
".do c #1226bb",
"#tT c #122760",
".nv c #1228a2",
"#ks c #122b6e",
".iK c #122ca7",
"#tP c #122e6d",
".iy c #122e99",
"#xP c #123076",
".iL c #1235ad",
"#Rz c #123668",
".it c #1236a8",
"#Bn c #123754",
"#vA c #123a77",
".yo c #123f94",
"#IJ c #12468f",
".ya c #124a95",
"#vx c #125196",
"#Gv c #130e25",
"QtZ c #1314bc",
".## c #131794",
".#8 c #1318b2",
".as c #131991",
"#Fh c #131a2c",
"#o9 c #131b59",
".bL c #131b97",
".eZ c #131c93",
"#0i c #131d1e",
"#Fi c #131e30",
"#hK c #131f69",
".kb c #131f97",
"#Am c #132066",
".dU c #132090",
"#vi c #132162",
".dV c #13218e",
".lk c #13219b",
".i8 c #132297",
".hD c #132385",
"#0s c #13241c",
".eC c #1324b0",
"#1A c #132620",
"#v# c #132661",
"#qw c #13275a",
"#rT c #13275c",
"#rR c #13285d",
"#qK c #132867",
"#s9 c #132869",
".hm c #132895",
".j3 c #13289b",
".ns c #1329a0",
".ie c #1329a3",
"#kr c #132a6e",
".jL c #132a9a",
"#rl c #132c64",
"#E8 c #13306a",
".iz c #133098",
".kA c #1330b2",
"#sZ c #133165",
"#yY c #133558",
"#V5 c #133630",
"#Gf c #133767",
"#ri c #133864",
".kY c #1338ab",
"#Hz c #133a7d",
".b7 c #133bc1",
".na c #133eb1",
".sd c #133f8a",
"#Cw c #134173",
".80 c #1341b1",
"#QV c #134238",
".tp c #134894",
"#ud c #134b7c",
".ye c #134c93",
"#IH c #13507f",
".AT c #1359d2",
"#D9 c #14162f",
"Qt5 c #1416a9",
"#BF c #141740",
".#e c #14179a",
".#4 c #1419b1",
"#p. c #141a56",
".#5 c #141ab0",
".ar c #141b90",
"#BI c #141c43",
".bF c #141c89",
".eY c #141d94",
".aw c #141e8d",
"#Fc c #141f5f",
"#k. c #142068",
".f8 c #142090",
".i9 c #142096",
"#j. c #142167",
".gO c #14229f",
".kv c #1422a9",
".dt c #1422b6",
"#Ad c #14234c",
"#vg c #142366",
"#kj c #142368",
".hE c #142388",
".gb c #142396",
".i7 c #142398",
".f. c #142493",
".gp c #142495",
".jt c #14249e",
"#Ln c #14256d",
".gc c #142597",
"#qJ c #142666",
"#qv c #14285a",
"#rM c #142865",
".iQ c #14289b",
"#pr c #142978",
".hn c #142996",
".mi c #1429a0",
".jz c #1429a6",
"#sY c #142b61",
"#vD c #142b6e",
"#m2 c #142b6f",
".iw c #142b9d",
"#o. c #142c6a",
"#oj c #142c84",
".#I c #142dbb",
"#og c #142e85",
".iv c #142fa2",
"#sw c #143173",
"#z1 c #143369",
".k2 c #1433a8",
".sg c #1433cb",
"#wO c #143675",
".n# c #143daf",
".tt c #14408b",
".dg c #1440b9",
"#QU c #14413a",
".vU c #144891",
".ux c #144b9d",
".yb c #144c96",
".vR c #144c97",
".y# c #144c99",
".w4 c #144e98",
".be c #1513a2",
".#c c #151899",
".#. c #151996",
"#BH c #151a40",
".eR c #151a82",
".bB c #151d8a",
"QtR c #151dbe",
"#BJ c #151e45",
"#hN c #151e6b",
"#vf c #151f64",
".cQ c #151f90",
"#qH c #152062",
".cX c #152094",
".f6 c #15218d",
".kc c #152199",
"#Bt c #152257",
".f9 c #152295",
"#qI c #152364",
".dW c #152390",
"#D3 c #152445",
"#rI c #15245b",
"#Gm c #15245d",
"#iY c #152467",
".ka c #15249b",
"#iX c #15266c",
".hz c #15278d",
".gh c #152797",
".iG c #15288e",
".g4 c #15288f",
".i2 c #15289e",
"#qL c #152972",
".ke c #152999",
"#rW c #152a6b",
"#rX c #152a6d",
"#oh c #152a83",
"#um c #152c70",
".aV c #152cba",
"#o# c #152e6e",
"#Qm c #152f6c",
"#kt c #153172",
"#oQ c #15326c",
"#rj c #153564",
"#T4 c #153679",
"#sv c #153774",
".bX c #1537b3",
"#Gi c #153973",
".l9 c #153aac",
"#Jz c #153b44",
"#JA c #153c43",
"#Bm c #153c59",
"#sn c #153e6a",
".iM c #153eb4",
"#YI c #153f4b",
"#Yy c #153f4d",
".nd c #1542b5",
"#Hv c #154390",
"#Hj c #15475e",
".vM c #154a98",
".w8 c #154e95",
".w3 c #154e9b",
".w5 c #154f99",
"#VF c #16171b",
".#d c #16199a",
"#Gp c #161a49",
".#9 c #161bb7",
"#Go c #161c4e",
".ck c #161ca4",
".aq c #161d92",
".cT c #16208f",
".cP c #162091",
".f2 c #162194",
".cV c #162195",
"#mY c #16226a",
".f7 c #162290",
".fe c #162298",
"#qr c #16235a",
"#lM c #16246f",
".js c #16249f",
"#rV c #16255c",
"#pd c #16255e",
".gn c #16259a",
".gw c #162688",
".li c #16269f",
"#rU c #16275d",
".he c #162793",
".jP c #16279d",
"#wy c #162856",
"#HG c #16285a",
"#lP c #162874",
"#kq c #16296e",
"#lQ c #162975",
".ib c #1629a2",
"#xD c #162a67",
"#rY c #162a6f",
"#m1 c #162a71",
"#oi c #162a83",
"#n9 c #162b6a",
".mj c #162ba2",
"#n8 c #162c68",
"#qN c #162c77",
".gS c #162c9c",
"#wA c #162d61",
"#kw c #162e78",
"#m3 c #162f72",
".jF c #162fa6",
"#rk c #163166",
"#ok c #163188",
"#E7 c #163377",
"#wD c #16347d",
".r. c #1634c8",
"#K. c #163689",
"#of c #16368b",
".b3 c #1636c9",
"#IV c #16377c",
"#Xj c #16393b",
".Jd c #16394c",
"#Bo c #163955",
"#rh c #163b67",
"#QS c #163c3f",
"#DR c #164178",
".rb c #1642d6",
".iN c #1643b8",
"#Hi c #16466a",
".uG c #164690",
".vT c #164a93",
".wY c #164b99",
".vL c #164b9b",
".w2 c #164c94",
".vS c #164c96",
".w7 c #164e98",
"#z7 c #164f7c",
".zt c #16509a",
".Ax c #1653a6",
"#NY c #16549d",
".zy c #16559a",
".pN c #1655b6",
".BQ c #1658a6",
".bh c #17179d",
"#BG c #171b41",
".eQ c #171b87",
".#3 c #171bba",
"#pa c #171c56",
"#CQ c #171d41",
".eX c #171d95",
".ap c #171e92",
".bA c #171f8c",
".fT c #171f9b",
"#Gn c #172057",
"#HC c #172059",
"#xz c #17215e",
"#Y5 c #172228",
"#i0 c #172272",
"#mZ c #17236d",
".j. c #172399",
"#RS c #17242a",
"#o3 c #172459",
"#o4 c #17245b",
"#i7 c #17246a",
"#lN c #172570",
"#pe c #17265f",
"#Bv c #172667",
"#kg c #17266b",
".hH c #17268d",
".h4 c #17269b",
"#Bs c #17275a",
"#vh c #172772",
".gx c #172787",
".ez c #1727b8",
".iC c #172890",
".i4 c #17289c",
".iW c #172aa0",
".ic c #172aa3",
"#m0 c #172b72",
".l. c #172b9e",
".jA c #172ca9",
".np c #172d9d",
".lo c #172da7",
".nr c #172ea0",
".gU c #172ea2",
"#LS c #173130",
"#sF c #17316e",
".q9 c #1731c4",
"#oa c #173374",
".aK c #1734b2",
".oS c #1734be",
".iu c #1736aa",
".tv c #1736cc",
"#wB c #173774",
"#ol c #17378c",
"#oe c #173d90",
"#JB c #173e43",
".ec c #173fae",
"#wN c #174080",
"#IL c #174098",
".tw c #1742de",
"#L5 c #17432c",
"#Cx c #174372",
".nc c #1744b9",
".ne c #1745b4",
"#Jy c #17464e",
".uH c #174791",
".nl c #1748b1",
".wZ c #174c98",
".w6 c #174f99",
".yd c #175097",
".zs c #17509d",
".GM c #1755a2",
".zx c #17569d",
".pM c #1756b7",
"#EV c #17606f",
"#Gw c #181327",
"Qt6 c #181baa",
".eS c #181d85",
"#p# c #181e58",
"#bD c #181f4d",
"#vj c #181f56",
".bI c #182196",
"#o8 c #182260",
"#hM c #18226a",
".cO c #182293",
".c0 c #182397",
".cj c #1823b0",
"#zd c #18245e",
"#mX c #18246c",
".h. c #182490",
".h5 c #18249a",
"#rH c #18255a",
"#j# c #18256b",
".dR c #182595",
".fy c #182598",
"#kn c #18266d",
"#lK c #18266f",
"#pb c #18275e",
"#lq c #182760",
"#ki c #18276c",
".j5 c #18279a",
".kJ c #1827a8",
".pO c #182899",
".lg c #1828a1",
".ia c #1828a2",
"#lm c #182957",
"#kp c #18296f",
"#kL c #182985",
".gr c #182993",
".eD c #1829b5",
".dp c #1829bf",
"#wz c #182a58",
".oB c #182a9a",
".iZ c #182aa8",
"#Br c #182b56",
"#tV c #182b63",
".jQ c #182ba3",
"#wj c #182c61",
".jJ c #182c9f",
".id c #182ca7",
".mq c #182ca9",
".a7 c #182cc3",
"#rQ c #182d62",
"#CK c #182d6e",
".hS c #182da2",
"#kJ c #182e7a",
".no c #182e9d",
".mh c #182ea5",
".nu c #182ea6",
"#sE c #182f75",
"#qA c #183070",
"#XY c #18312b",
"#xN c #183167",
"#xE c #18326d",
"#y8 c #18327c",
"#m9 c #183488",
".oR c #1835bf",
".b2 c #1836c8",
"#J9 c #183787",
".kB c #1839ba",
".l3 c #1839bc",
"#Gh c #183c78",
".mb c #183cae",
"#DQ c #183d72",
"#wC c #183d83",
".kX c #183db0",
"#Xi c #183e31",
"#ZM c #183e41",
".c4 c #183fb8",
"#JC c #184145",
".c3 c #1841b7",
".n. c #1842b2",
".nb c #1842b8",
".eb c #1844af",
".iO c #1847bb",
"#JJ c #184a47",
".wX c #184d9b",
".w1 c #184e96",
".yc c #18509a",
".yg c #18529c",
".pA c #1852bd",
".zn c #1853a1",
".zm c #1853a3",
".yk c #18549a",
".yj c #18549c",
".oz c #1856b9",
"#Yd c #185720",
".zz c #18579c",
".AH c #18579e",
".BU c #185aa4",
".BP c #185aa8",
".bd c #1917a8",
"#vc c #191a5d",
"Qt4 c #191ab2",
"#oE c #191b4e",
"Qt0 c #191cc3",
"#ve c #191e62",
".dM c #191e93",
".jn c #191e9c",
".bb c #191eae",
".bc c #191eb0",
".by c #19229b",
"#At c #192354",
"#t2 c #19235e",
".io c #192392",
"#Ao c #192464",
"#qG c #192466",
".cW c #192498",
"#jp c #192579",
".h6 c #19259b",
"#qs c #19265d",
"#jl c #192675",
".h# c #19268c",
".b. c #1926b3",
"#ko c #19276e",
"#lL c #192772",
".hI c #192790",
".lj c #1927a1",
".h3 c #19289d",
".lw c #1929b2",
"#Al c #192a72",
"#ic c #192a7c",
".gq c #192a96",
".jO c #192a9c",
".jI c #192aa0",
".ex c #192aae",
".hq c #192b9b",
".iY c #192ba7",
".nx c #192ba9",
".lv c #192bb3",
"#j9 c #192c66",
"#qM c #192c78",
"#MD c #192c88",
".lt c #192caf",
".kf c #192d9d",
".i3 c #192d9e",
".fR c #192da6",
".iJ c #192daa",
"#px c #192e7d",
".fM c #192eab",
".nK c #192ebb",
".hp c #192f9c",
".jK c #192f9f",
".lp c #192fa9",
".mx c #192fb8",
"#t. c #193074",
"#Bq c #193155",
"#n. c #193187",
".q2 c #1932a6",
"#m4 c #193477",
"#xv c #193567",
".yp c #1935a2",
"#pq c #193682",
".k3 c #1936ac",
"#XZ c #19372b",
"#lW c #193777",
"#m8 c #19388b",
"#Qj c #193a7f",
"#wE c #193a87",
"#xT c #193d8b",
"#sp c #193e72",
".m. c #193eb0",
"#J4 c #19408b",
"#su c #194175",
".xg c #1941a1",
"#L3 c #194433",
"#Cv c #194479",
"#L4 c #19452c",
"#wM c #194a8d",
".vK c #194da0",
".w0 c #194f99",
"#xI c #195089",
".y. c #1950a0",
"#II c #19518a",
".yf c #19529f",
".zu c #19539d",
".tm c #1954a0",
".yl c #19559b",
".yi c #19559d",
".pB c #1956c0",
".AM c #1959a0",
".C2 c #195ba9",
"#VG c #1a1b1f",
"#D5 c #1a1e37",
"##c c #1a1e5d",
"#i# c #1a1e75",
".aj c #1a20a8",
".FJ c #1a2127",
"#vk c #1a214f",
".ih c #1a2193",
".ao c #1a2195",
".h8 c #1a2196",
"QtN c #1a21c9",
"#vl c #1a2250",
".bz c #1a228f",
"#D4 c #1a2340",
"#bC c #1a234a",
".bJ c #1a239a",
".bK c #1a239c",
"#hL c #1a246c",
"#kB c #1a2479",
"#t1 c #1a255d",
".cK c #1a2598",
".cJ c #1a2599",
".cG c #1a259b",
".jp c #1a25a1",
".eA c #1a25b5",
".j# c #1a269c",
".ku c #1a26ae",
"#RR c #1a2730",
"#sX c #1a275e",
".g. c #1a279a",
".iH c #1a27a7",
"#c0 c #1a2865",
"#pc c #1a2960",
"#o5 c #1a2962",
".e6 c #1a2a99",
".gz c #1a2b85",
".iD c #1a2b95",
".h2 c #1a2b9f",
"#kC c #1a2c6a",
"#CL c #1a2c6e",
"#kx c #1a2c78",
".mt c #1a2caa",
".oO c #1a2cbc",
"#rN c #1a2e6b",
"#lR c #1a2e77",
"#jA c #1a2e8d",
".kg c #1a2e9f",
".jG c #1a2ea7",
".mp c #1a2eab",
".lu c #1a2eb5",
"#kI c #1a307b",
".nt c #1a30a8",
"#vE c #1a3174",
".gT c #1a31a1",
"#nF c #1a326e",
".ix c #1a32a0",
"#kN c #1a3387",
".mc c #1a34a3",
"#My c #1a3582",
"#kO c #1a3785",
".oT c #1a37c1",
"#CI c #1a3876",
".p2 c #1a3bc8",
".r# c #1a3ed4",
"#I3 c #1a4065",
"#rc c #1a4071",
"#Oj c #1a4228",
"#xW c #1a4288",
".ra c #1a44d8",
".sc c #1a4691",
".rc c #1a49d7",
"#Hu c #1a4b8e",
".HX c #1a4b98",
".nm c #1a4db6",
".x# c #1a4ea1",
".GN c #1a4f95",
".to c #1a529d",
".yh c #1a549e",
".BN c #1a56ac",
".C9 c #1a5ca6",
".C5 c #1a5ca8",
".CY c #1a60b5",
".D8 c #1a62b4",
".Qr c #1b180f",
"#Gx c #1b182d",
".fZ c #1b1b89",
".eP c #1b1e8f",
".#2 c #1b1fc0",
"#BB c #1b2062",
".dL c #1b2095",
"#c4 c #1b216d",
".jm c #1b219d",
".ai c #1b21ad",
"QtM c #1b21cd",
"#kz c #1b2374",
".bw c #1b23a0",
"#c2 c #1b245f",
"#nY c #1b2465",
"#nX c #1b2467",
"#0h c #1b2526",
"#ec c #1b2562",
"#kc c #1b257a",
"#jo c #1b2678",
".e0 c #1b269c",
".kK c #1b26a6",
".eE c #1b26b4",
".eB c #1b26b6",
"#zc c #1b2763",
"#iZ c #1b276f",
".ll c #1b27a1",
"#qq c #1b285d",
"#qu c #1b285f",
"#i6 c #1b286e",
".dT c #1b2898",
".ja c #1b289a",
".j6 c #1b289b",
"#Ui c #1b2934",
"#Vr c #1b2936",
".q3 c #1b2aa7",
"#xC c #1b2b69",
".e8 c #1b2b9a",
".a9 c #1b2bbc",
".jM c #1b2c96",
".ip c #1b2c98",
".l# c #1b2ca2",
".dr c #1b2cc0",
"#jk c #1b2d79",
".jN c #1b2d99",
".ny c #1b2dad",
"#0t c #1b2e28",
".hB c #1b2e8d",
".kk c #1b2ea6",
".ls c #1b2eb1",
".oP c #1b2ebb",
"#tU c #1b3069",
"#lY c #1b3081",
".gW c #1b30ad",
"#un c #1b317a",
"#n# c #1b3187",
".my c #1b31ba",
".g3 c #1b3298",
".ir c #1b329c",
".mg c #1b32a6",
"#jB c #1b338d",
".nD c #1b33b7",
"#tI c #1b346c",
".pU c #1b34b3",
".oW c #1b35c0",
"#X0 c #1b362d",
"#T5 c #1b3781",
"#ob c #1b387a",
".jE c #1b38b0",
"#R4 c #1b3a32",
".lM c #1b3bb2",
".ma c #1b3fb1",
"#xK c #1b4170",
"#xV c #1b428d",
"#sq c #1b4374",
"#IG c #1b4a76",
".nk c #1b4ab4",
"#L0 c #1b4b3d",
"#Hs c #1b517f",
"#uc c #1b5585",
"#Kg c #1b568e",
".pz c #1b56be",
"#vw c #1b5c9c",
".Az c #1b5dab",
".CX c #1b61b6",
".D9 c #1b62b4",
"#vd c #1c1c62",
".#r c #1c1e8b",
".eT c #1c208b",
".eV c #1c208e",
".ac c #1c20b5",
".bt c #1c23a7",
".ak c #1c23a8",
"#jn c #1c2477",
".#P c #1c25a8",
"#ib c #1c267b",
".cN c #1c2697",
".kd c #1c269f",
"#t0 c #1c275f",
".jf c #1c279b",
".aE c #1c27a5",
"#oZ c #1c285a",
".ff c #1c289e",
"#S6 c #1c2932",
"#qt c #1c2960",
".d7 c #1c2992",
".dS c #1c2999",
".jc c #1c299b",
".je c #1c299c",
"#wp c #1c2a67",
"#o6 c #1c2a6b",
"#je c #1c2a73",
".fj c #1c2a93",
".fE c #1c2aa4",
"#1z c #1c2b28",
"#pf c #1c2b66",
"#yL c #1c2b70",
".hG c #1c2b92",
".ga c #1c2b9e",
".gm c #1c2ba2",
"#wo c #1c2c68",
".e9 c #1c2c9b",
".le c #1c2c9d",
".e4 c #1c2d99",
"#lp c #1c2e60",
"#jf c #1c2e76",
".kI c #1c2eae",
".ki c #1c2fa5",
".nw c #1c2fa8",
"#kD c #1c306d",
"#na c #1c3087",
".kl c #1c30a9",
"#pz c #1c3182",
".gX c #1c31b0",
".pY c #1c31c8",
".oJ c #1c32ac",
".is c #1c339d",
".mf c #1c33a5",
"#nb c #1c348a",
".nE c #1c34b8",
".pV c #1c34bc",
"#Lk c #1c3578",
"#fQ c #1c3790",
".#G c #1c37c2",
"#xO c #1c3877",
"#Bp c #1c3957",
"#lV c #1c3a7a",
"#EK c #1c3b69",
"#Qi c #1c3c8f",
".xa c #1c3da4",
".p3 c #1c3dca",
"#rg c #1c3e6e",
".yn c #1c3e95",
"#xF c #1c3f77",
"#SN c #1c42ad",
"#xX c #1c4388",
"#Hy c #1c448a",
".xh c #1c44a6",
"#L6 c #1c4537",
"#Jx c #1c4547",
".nf c #1c4bb7",
".7M c #1c4cbb",
".HW c #1c4ea5",
"#NU c #1c50a3",
"#wL c #1c5197",
".om c #1c51b9",
"#LZ c #1c523a",
".x9 c #1c53a3",
".uw c #1c53a6",
".rf c #1c55d8",
".tn c #1c56a0",
".zw c #1c58a0",
".zv c #1c58a1",
".AC c #1c59a9",
".AA c #1c59aa",
".AD c #1c5aa7",
".AL c #1c5ba2",
".oA c #1c5cbe",
".AN c #1c5da1",
".BY c #1c5fa5",
".BX c #1c5fa6",
".cn c #1d179b",
".bi c #1d1da3",
".a# c #1d1db3",
"QtY c #1d1ec6",
".eO c #1d2095",
"#D1 c #1d215e",
"#i. c #1d2377",
"#ia c #1d2379",
"#nO c #1d245b",
".an c #1d2496",
".am c #1d24a6",
"#D0 c #1d2563",
"#jm c #1d2576",
".du c #1d25b8",
"QtQ c #1d25c5",
"QtO c #1d25c8",
"#N7 c #1d262b",
"#Ob c #1d262d",
"#wr c #1d2667",
".gL c #1d269d",
".kt c #1d26af",
".mB c #1d26b3",
"#o0 c #1d2758",
"#hO c #1d276e",
".cY c #1d289c",
"#RP c #1d2935",
"#nQ c #1d295d",
"#mW c #1d2971",
"#lD c #1d2973",
".ln c #1d29a3",
"#nR c #1d2a5f",
".lX c #1d2aaa",
".gJ c #1d2aac",
"#mN c #1d2b74",
".hJ c #1d2b96",
".gl c #1d2ba5",
"#i2 c #1d2c67",
"#kl c #1d2c6f",
"#kK c #1d2c8b",
".ch c #1d2cbd",
"#ek c #1d2d7b",
".iB c #1d2d8f",
".hx c #1d2d9c",
".fQ c #1d2da7",
"#HA c #1d2e76",
".fl c #1d2e8a",
".gd c #1d2ea0",
".iR c #1d2ea2",
"#XX c #1d2f2f",
"#qF c #1d2f6f",
"#id c #1d2f81",
".iX c #1d30a8",
".i1 c #1d30a9",
"#vm c #1d3163",
"#x1 c #1d316e",
"#z2 c #1d3170",
"#jg c #1d3178",
"#rP c #1d3267",
"#lX c #1d3283",
".oF c #1d32a9",
".oK c #1d32b1",
"#nG c #1d336d",
".ho c #1d33a0",
".nq c #1d33a3",
".kP c #1d33ab",
"#lS c #1d347a",
".nH c #1d34b8",
"#y9 c #1d357d",
".eq c #1d35af",
".jB c #1d35b1",
"#oR c #1d3770",
".jD c #1d37b2",
".oV c #1d37c2",
"#y7 c #1d3885",
".oU c #1d38c3",
"#Qk c #1d3c75",
"#oc c #1d3c7f",
"#Dv c #1d3d63",
".p1 c #1d3ecb",
".j0 c #1d40b6",
"#pp c #1d418b",
".j1 c #1d42b7",
".ng c #1d43b0",
"#xU c #1d4491",
".di c #1d44c3",
"#Cy c #1d4674",
"#yR c #1d467a",
".b4 c #1d46c2",
"#Bh c #1d487b",
".XC c #1d4bba",
"#F5 c #1d4c66",
"#xJ c #1d4c82",
"#z6 c #1d4d7e",
".wW c #1d52a2",
".AB c #1d5aaa",
".BM c #1d5bb0",
"#yU c #1d5c88",
".BO c #1d5eae",
".BW c #1d5fa9",
".CZ c #1d5fb3",
".BL c #1d5fb5",
".BZ c #1d60a6",
".E. c #1d61b2",
".BK c #1d63b8",
".cr c #1e1c97",
".cs c #1e1d94",
".a. c #1e1eb4",
".il c #1e1f93",
"Qt8 c #1e21ac",
"#HH c #1e2252",
".eU c #1e228e",
".ad c #1e22b7",
".i# c #1e2399",
".jo c #1e23a1",
".cB c #1e2496",
"#S1 c #1e2535",
"#c1 c #1e256b",
"#fx c #1e2677",
"#wq c #1e2768",
".h7 c #1e279c",
".g9 c #1e27a0",
"#tZ c #1e295f",
"#lt c #1e2979",
".cZ c #1e299d",
".b# c #1e29b6",
"#nP c #1e2a5c",
"#k# c #1e2a72",
".ci c #1e2aba",
"#nS c #1e2b62",
"#lO c #1e2b79",
".jb c #1e2b9d",
".fg c #1e2b9e",
"#ll c #1e2c5d",
"#rm c #1e2c6b",
"#n7 c #1e2c6d",
"#mJ c #1e2c73",
".en c #1e2c97",
".jr c #1e2ca7",
"#nT c #1e2d66",
"#oS c #1e2d68",
".hF c #1e2d92",
".hh c #1e2da0",
".fD c #1e2da2",
"#0r c #1e2e23",
"#ej c #1e2e7b",
".iA c #1e2e8d",
".hw c #1e2e9f",
".jH c #1e2ea7",
".mA c #1e2eb9",
".dq c #1e2ec2",
"#ze c #1e2f67",
".gy c #1e2f8b",
".hf c #1e2f9b",
".a8 c #1e2fc3",
"#y2 c #1e3070",
"#jq c #1e307c",
"#c9 c #1e3082",
".hA c #1e3092",
"#jy c #1e3096",
"#lk c #1e3169",
".iF c #1e3198",
".kj c #1e31a9",
"#kM c #1e328b",
".hX c #1e32ad",
"#0l c #1e332e",
".iq c #1e339e",
".oI c #1e33b0",
".pZ c #1e33ca",
".gV c #1e34ac",
"#wi c #1e3567",
".k5 c #1e38a7",
".df c #1e3ab7",
"#0o c #1e3b25",
"#m5 c #1e3b7d",
".jX c #1e3cb4",
"#rf c #1e3e71",
"#p0 c #1e3f75",
".ed c #1e3fb0",
".dj c #1e41c3",
".sl c #1e41d9",
"#rd c #1e4272",
"#wc c #1e4482",
"#JD c #1e4749",
"#ty c #1e486e",
"#tz c #1e487a",
"#wF c #1e4894",
".nj c #1e48b4",
"#tx c #1e4a71",
"#Kc c #1e4a89",
"#DS c #1e4c87",
"#xH c #1e5083",
".ol c #1e53b9",
".on c #1e53bd",
".AJ c #1e58a2",
".or c #1e58b9",
".AK c #1e5aa3",
"#yV c #1e5c85",
".pC c #1e5cc3",
"#vv c #1e5fa3",
".C4 c #1e60ae",
".B0 c #1e61a7",
".Ed c #1e62ad",
".D7 c #1e64b9",
".CW c #1e64ba",
"#SV c #1f1d28",
".91 c #1f1e57",
"Qta c #1f2073",
".aa c #1f20b6",
".kr c #1f21a8",
".cl c #1f22a7",
".kq c #1f23a8",
".ah c #1f24b3",
".h9 c #1f269b",
"#Ua c #1f2732",
"#nZ c #1f2766",
"#jb c #1f2772",
"#xA c #1f277a",
".bx c #1f27a3",
"#lr c #1f2869",
"#t8 c #1f295e",
"#nW c #1f296e",
"#lE c #1f2971",
"#lu c #1f2a7c",
".d3 c #1f2a9e",
".kN c #1f2aa6",
"#o1 c #1f2b5d",
".fF c #1f2ba5",
".tu c #1f2bcf",
"#mV c #1f2c72",
".fh c #1f2c9c",
".jd c #1f2c9e",
".fC c #1f2c9f",
"#n6 c #1f2d6e",
"#Mz c #1f2e71",
".iI c #1f2ead",
"#Z# c #1f2f2e",
".hv c #1f2fa8",
"#sM c #1f3068",
".h1 c #1f30a4",
"#lZ c #1f3183",
".gg c #1f31a1",
".ms c #1f31af",
".lr c #1f32b3",
".mz c #1f32bc",
"#0v c #1f332a",
"#kH c #1f337c",
".kh c #1f33a6",
".mr c #1f33b0",
"#rO c #1f3469",
".k9 c #1f34a7",
".lq c #1f34b3",
".jT c #1f35a5",
"#1B c #1f3729",
"#pk c #1f3773",
"#pj c #1f3870",
"#pl c #1f3878",
".k6 c #1f39a8",
"#wh c #1f3a6f",
"#pm c #1f3a7d",
"#RB c #1f3d63",
"#od c #1f3d83",
".lN c #1f3db5",
"#yQ c #1f3e77",
"#Cl c #1f3f6e",
"#K# c #1f4198",
".m# c #1f43b5",
"#UR c #1f4433",
"#kQ c #1f4488",
"Qts c #1f46cf",
"#xq c #1f487c",
".ni c #1f48b4",
"#sr c #1f4a77",
"#xG c #1f4a7f",
"#Iw c #1f4f77",
"#OZ c #1f539f",
".vJ c #1f53a7",
".I8 c #1f56b0",
".os c #1f5ab8",
".py c #1f5ac0",
".AG c #1f5ea5",
".pL c #1f5ebf",
".BV c #1f61ab",
".C3 c #1f61af",
".B1 c #1f62a8",
".D. c #1f62a9",
".Eb c #1f62b0",
".Ee c #1f63ae",
".Fq c #1f65ad",
".BJ c #1f65bb",
".Fj c #1f68b5",
".cq c #201e9d",
"QtX c #201ec7",
"#pP c #202054",
"#t3 c #202060",
"QtE c #2023ae",
".cg c #2023b2",
"#ls c #20246b",
".aB c #20259d",
".eF c #2025b4",
"#t7 c #20275e",
".g7 c #202799",
"QtP c #2028c8",
"#bB c #202952",
"#fu c #202974",
"#fv c #202976",
".kL c #2029aa",
"#XW c #202b31",
"#tY c #202b61",
".jg c #202b9f",
"#o2 c #202c5e",
"#y3 c #202c74",
"#u7 c #202c80",
".e2 c #202ca2",
".km c #202d9f",
".g# c #202da0",
".#W c #202db9",
"#Uj c #202e37",
"#aq c #202e6f",
".g2 c #202e99",
".jq c #202ea9",
".ml c #202eab",
"#Uf c #202f34",
"#lx c #202f84",
".gv c #202f94",
"#HF c #203061",
"#i1 c #203064",
"#oT c #203167",
"#Lo c #203181",
".ew c #2031b3",
"#jz c #203296",
".gB c #2032a0",
".i0 c #2032ae",
".fo c #203382",
".jR c #2033a9",
".pR c #2033ab",
"#x2 c #203471",
"#kE c #203473",
"#jw c #20348d",
".hY c #2034ad",
".m8 c #2034b1",
"#y0 c #203564",
"#py c #203586",
".bO c #2035b5",
".aM c #2035c6",
"#t# c #20367f",
".kQ c #2036b0",
".pX c #2036ca",
"#oW c #203761",
"#jh c #20377d",
".pT c #203ab5",
"#lU c #203b7e",
".kH c #203bbe",
".aQ c #203bd4",
"#re c #203d75",
".k4 c #203db3",
".l2 c #203ec2",
".tx c #2041e6",
"#QO c #204345",
".jZ c #2043b9",
".B4 c #2043c3",
"#KT c #20443a",
"#v5 c #20466a",
".nh c #2046b3",
"#wb c #204886",
"#KN c #20494b",
"#Hw c #20499b",
"#B. c #204a72",
"#L1 c #204b42",
"#st c #204c7b",
"#v8 c #204e7f",
"#DV c #204f93",
"#In c #205066",
"#Bi c #205080",
"#yS c #205283",
".XI c #2054ba",
".q0 c #2058b9",
".AI c #2059a6",
".zl c #205bab",
".oy c #205bbf",
".zo c #205ca5",
".C1 c #205cb2",
".uI c #205cd4",
".AE c #205ea9",
".C0 c #205eb3",
"#vu c #2060a7",
".E# c #2061b3",
".C6 c #2062ae",
".D# c #2063a9",
".Eh c #2064ad",
".Fi c #2069b8",
"#2M c #20783c",
".ct c #212095",
".N0 c #21221d",
"#Qs c #212237",
".dF c #21228e",
".ab c #2122b8",
"#Gt c #21234c",
"#bE c #212354",
".fU c #212392",
".#E c #2123aa",
"##b c #21265e",
".jj c #21269b",
".i. c #21269c",
".cE c #21289a",
".mC c #2128b6",
"QtK c #2128be",
"#ql c #212a61",
"#ed c #212a6b",
"#eb c #212a6f",
".dQ c #212b9e",
"#Y4 c #212c30",
"#tX c #212c62",
"#ky c #212c7c",
".e1 c #212ca2",
"#RQ c #212d39",
"#Ae c #212d5f",
"#jd c #212d77",
".e3 c #212da3",
".#V c #212dbd",
"#XQ c #212e37",
"#cY c #212e5b",
"#rG c #212e65",
".fL c #212eb1",
"#Ud c #212f2f",
"#zb c #212f70",
"#mK c #212f78",
".mk c #212fac",
"#nU c #21306b",
".gu c #213097",
".gP c #2130b1",
"#y4 c #21317c",
".hg c #2131a2",
".kO c #2131ab",
".H4 c #213239",
"#da c #21328c",
"#ie c #21328e",
".iE c #21329c",
".nL c #2132be",
"#v0 c #213349",
".hV c #2134b4",
".oQ c #2134bf",
".oN c #2134c1",
"#jv c #21358e",
".oD c #2135a6",
".iP c #2135a8",
".oL c #2135ba",
"#nL c #213661",
"#qO c #213685",
".sf c #2136c3",
".pW c #2137c8",
"#Zc c #21383e",
"#pi c #21386e",
"#wR c #21387b",
"#tb c #213884",
".nG c #2138bc",
"#nc c #21398f",
".jC c #2139b5",
".nF c #2139bd",
"#lT c #213a7d",
".b0 c #213ac8",
"#Lp c #213b92",
".md c #213baa",
".de c #213bb6",
".bY c #213ec0",
".jY c #2141b8",
"#Zp c #214227",
"#kP c #21438b",
"#Bg c #21467d",
".XA c #2146ae",
"#ZF c #214738",
"#Ge c #21476c",
"#IM c #21479c",
".lJ c #2148bd",
"#v6 c #214b73",
"#v7 c #214c79",
"#tA c #214d7c",
".ot c #214db6",
".XB c #214ec1",
".x. c #2150a0",
"Qtr c #2151d9",
"#Bl c #21527d",
"#QY c #215443",
"#Ht c #21548b",
".Wt c #2156b4",
"#Ii c #215761",
".oq c #2158bd",
"#yT c #215b89",
".r6 c #215db5",
"#vt c #215faa",
".Ay c #2160b0",
".AO c #2162a6",
".BT c #2163af",
".BR c #2163b1",
".Da c #2164a8",
".Ei c #2165ac",
".Fk c #2166b4",
"#OT c #216896",
".GA c #2169b3",
"QtU c #221fc8",
".eG c #222198",
"#Gy c #22223c",
"#nu c #222254",
".dE c #222292",
".dG c #22238f",
"Qtg c #222576",
".af c #2227b9",
".ji c #222898",
".cC c #22289a",
"#N9 c #222a35",
"#Ap c #222a69",
"#kA c #222a7d",
".kM c #222aa9",
"QtI c #222aaf",
"#Y6 c #222c36",
"#mH c #222c71",
"#i3 c #222d7d",
".ly c #222dba",
"#CP c #222e56",
"#tW c #222e62",
"#hP c #222e68",
"#mO c #222e76",
"#mI c #222f73",
"#ja c #222f75",
".lx c #222fb9",
"#Uh c #22303b",
"#n5 c #22306f",
"#lJ c #223077",
"#mM c #223079",
".gt c #223099",
".fi c #22309d",
"#pg c #22316c",
"#nM c #223361",
"#jr c #223381",
"#l1 c #223385",
"#if c #22338f",
".ge c #2233a5",
".hL c #2233a9",
".a2 c #2233b5",
"#ln c #223462",
"#mC c #223464",
"#l0 c #223486",
".lf c #22349a",
".eo c #2234a2",
"#0u c #22352f",
"#zf c #22356f",
"#aN c #223594",
".pS c #2235b5",
"#zZ c #223668",
"#NQ c #223673",
"#kG c #22367d",
".hZ c #2236a9",
"#lj c #223770",
"#x3 c #223776",
".jS c #2237aa",
"#uo c #223881",
"#pA c #22388b",
".dd c #2238b2",
"#ph c #22396d",
"#z. c #22397d",
"#r3 c #223989",
".me c #2239a9",
".j2 c #2239ab",
"#SS c #223a6a",
"#qB c #223b7d",
"#c# c #223cab",
".fs c #223cad",
"#m6 c #223f81",
"#pn c #223f83",
"#m7 c #224182",
".b8 c #2244cc",
".lL c #2245bb",
"#0F c #22462a",
"#S# c #22474d",
"#xu c #22477c",
"Qtq c #2248cf",
"#.c c #2249b0",
".B5 c #224dcd",
".b6 c #224dd0",
"#ss c #224e7b",
".sb c #22509d",
"#xk c #22517f",
"#F2 c #225268",
"#Q# c #225294",
".XD c #2253ba",
".wV c #2257a7",
".zr c #225ea4",
".Fl c #2261b0",
".C8 c #2264ae",
".Ej c #2266ad",
".Em c #2267aa",
".Fn c #2267b2",
".Fc c #2268ca",
".Fh c #2269b9",
"#Je c #23203b",
".cp c #2320a1",
".cm c #2321a6",
"#nt c #232556",
"#t4 c #232562",
".#O c #2325ac",
"#gi c #232659",
".jl c #2328a0",
".dN c #232a9e",
".#u c #232b98",
"#qk c #232c65",
"#mQ c #232c71",
"#gJ c #232c77",
".cF c #232da6",
"#sW c #232e66",
"#MB c #232e70",
".#D c #232ebc",
"#nN c #232f63",
".hN c #232fa5",
".lm c #232fa9",
"#Ug c #23313a",
"#Ue c #233235",
"#km c #233275",
".mm c #2332a9",
"#X1 c #233333",
"#lA c #233380",
"#db c #233392",
"#Vx c #23343e",
".h0 c #2334a8",
"#sK c #233670",
"#kF c #23367a",
"#yM c #233682",
"#g0 c #23378d",
"#ju c #23378e",
".gR c #2337aa",
".nJ c #2337bc",
".p0 c #2338cf",
".oH c #2339b3",
"#rZ c #233a80",
"#fP c #233b95",
"#fU c #233b9b",
"#g1 c #233c90",
".bZ c #233dc6",
".kG c #233ec1",
".p7 c #233fce",
"#kv c #234086",
".jW c #2340b8",
"#vn c #23417d",
".l1 c #2342c1",
"#DL c #234374",
".fq c #2344ad",
"#u0 c #234781",
"#Sc c #234841",
"#vo c #23498a",
"#xr c #234b7c",
"#J0 c #234d89",
"#ER c #235462",
"#TZ c #23548f",
"#Bk c #235681",
"#Bj c #235683",
".x7 c #2356a9",
".x8 c #2357aa",
".vI c #2357ab",
"#Yc c #23582a",
".uv c #2359af",
".oo c #2359c5",
".AS c #2359d7",
".zk c #235cad",
"#0U c #235f3b",
".r7 c #235fb5",
".Ea c #2360b3",
".BI c #2366bd",
".El c #2368ab",
".Ek c #2368ad",
".Fp c #2368b3",
".Fm c #2368b5",
".Ft c #2369af",
".GC c #236bb3",
".Gu c #236fba",
".f0 c #24238b",
".dD c #242398",
".dJ c #242496",
".cx c #242599",
".fV c #242697",
".ks c #2426af",
".#s c #242798",
".cA c #24279a",
".dK c #24279c",
"#t5 c #242865",
"#CN c #242867",
"#t6 c #242963",
"#n0 c #242a68",
"QtL c #242ac6",
".al c #242baf",
".bN c #242ca9",
"#N8 c #242d34",
"#fw c #242d7c",
".lz c #242dba",
"#hW c #242e75",
".gK c #242ea9",
"#o7 c #242f6f",
"#mG c #242f71",
"#t9 c #243062",
"#lv c #243084",
".fG c #2430aa",
"#LM c #243141",
"#qp c #243166",
"#rF c #243168",
"#VB c #243235",
"#n4 c #243271",
"#CM c #243273",
"#lC c #24327d",
"#jx c #24329b",
".lb c #2432ad",
".gI c #2432b7",
"#rn c #243374",
"#ig c #243493",
".pP c #2435a7",
"#i5 c #24365e",
"#js c #243688",
".gA c #2436a2",
".hl c #2436a4",
"#oX c #243762",
"#jj c #243783",
".oE c #2437ad",
"#j8 c #243877",
"#g4 c #24389b",
".oG c #2438b1",
".hW c #2438b5",
"#oU c #243a6b",
"#mw c #243a74",
"#pB c #243a8d",
"#fT c #243b9b",
".of c #243baf",
"#z3 c #243c7a",
".aL c #243cc4",
"##N c #243dbc",
"#eI c #243e9d",
".oe c #243eaf",
"#Dz c #244169",
"#p6 c #24416b",
".dn c #2441c1",
"#ku c #244282",
"#Bc c #244379",
"#Pw c #244530",
"#0x c #24453a",
"#UQ c #244647",
"#Cz c #244674",
"#2d c #244741",
"#ZN c #244c54",
"#z5 c #244c80",
"#Xh c #244d2f",
".dh c #244dc9",
".7L c #244eb2",
"#TL c #245073",
".I9 c #2459a7",
".op c #245ac4",
".rg c #245bdc",
"#TV c #245c8b",
".AF c #2462ab",
".GL c #2462b5",
".pD c #2464c6",
".D4 c #2466ba",
".Fu c #246ab0",
".GD c #246db2",
".Go c #246dcc",
".dB c #251789",
"Qtb c #25217f",
"QtW c #2523cc",
".eH c #25249b",
".dx c #2524a6",
".dI c #252595",
".dH c #252692",
".cy c #25269a",
"#hJ c #252968",
".jk c #252aa0",
".mD c #252ab9",
".cD c #252b9d",
"#WB c #252c3c",
".g6 c #252d9c",
"#WX c #252e2d",
"#gw c #252e71",
"#jc c #252e79",
".gM c #252ea3",
"#Ub c #252f38",
"#1I c #252f39",
"#gH c #252f76",
".fz c #252f9e",
".g5 c #25309a",
".hO c #2530a4",
".kn c #2530a6",
"#S5 c #25313d",
"#lw c #253185",
".#U c #2531c3",
"#S4 c #25323b",
"#qn c #253266",
"#mU c #253276",
"#oY c #253362",
"#xB c #253372",
"#gZ c #25338b",
"#kb c #25346f",
".e# c #253491",
".e. c #253493",
".ld c #2534ab",
"#nI c #253569",
"#RV c #25362c",
"#WL c #25363e",
"#Vw c #253640",
"#By c #25367c",
"#l2 c #253688",
"#ca c #2536b8",
".Jc c #25374d",
".fn c #253789",
".hj c #2537a5",
"#im c #2537a7",
".aF c #2537b5",
"#u6 c #25387d",
"#ih c #253897",
"#g5 c #25399c",
".ep c #2539aa",
"#mx c #253a73",
".dc c #253ab1",
".er c #253ab7",
".kR c #253ab9",
"#ta c #253b86",
"#oq c #253b90",
"#g6 c #253ba0",
"#oV c #253c68",
".bQ c #253cbe",
"#ot c #253e92",
".xe c #253ea2",
"##z c #253ea5",
".b1 c #253fd0",
".p6 c #2541d0",
"#po c #254288",
"#EJ c #25456c",
"#Cm c #25476d",
"#R5 c #25493b",
"#IN c #254a98",
"#L8 c #254b3c",
"#kR c #254c8d",
".xf c #254cab",
"#1W c #254d32",
"#zP c #254e7a",
"#xp c #254e86",
"#yC c #254f7f",
"#Vg c #255087",
"#yX c #255174",
"#zV c #25517e",
".rd c #2553dd",
"#tB c #255583",
"#ub c #25578a",
".ri c #2557d0",
"#0S c #255a2e",
"#No c #255c3f",
".qZ c #255fc0",
"#Kh c #256098",
".Fg c #2569ba",
".D6 c #2569be",
".Fo c #256ab5",
".Fv c #256bb0",
".Fz c #256cae",
".Gs c #256cba",
".Gz c #256db7",
".GF c #256eb3",
".Gt c #256ebb",
".Gq c #256ebd",
".Gv c #256fba",
".Gn c #2579d1",
"#LE c #261e35",
"#as c #262060",
".cu c #26259c",
".bj c #2625af",
".Pc c #26281d",
"#dY c #262960",
"Qt# c #262976",
".cz c #26299c",
".fO c #2629aa",
".ae c #262abf",
"#mE c #262b6b",
".fP c #262bab",
"#qm c #262d64",
"#XV c #262e3b",
"#h9 c #262e81",
".bv c #262ead",
".#C c #262ebd",
"#RZ c #262f2a",
"#Oc c #262f34",
"#Za c #262f3e",
".fK c #2630b3",
"#MA c #263173",
".c1 c #2631a7",
"#sN c #263266",
"#hQ c #26326e",
"#mP c #26327a",
"#aT c #2632a0",
".a1 c #2632b8",
"#S7 c #263339",
"#rE c #263368",
"#nH c #26336a",
"#0q c #263425",
"#n3 c #263473",
"#ly c #26348c",
".lc c #2634ae",
"#kf c #26357a",
"#el c #263586",
"#em c #263588",
".mw c #2635b4",
"#Bw c #26377c",
".pQ c #2637ad",
".nz c #2637bb",
"#jt c #26388c",
".oM c #2639c4",
".sh c #2639dd",
"#g3 c #263a9b",
"#lo c #263b68",
"#qE c #263b7a",
"#yP c #263c78",
"#qP c #263c8f",
"#fS c #263d9b",
"#eH c #263e9e",
".lQ c #263eb8",
"#jC c #264095",
".lO c #2640b9",
"#ni c #264192",
"#p5 c #26436d",
".kF c #2643c5",
".kE c #2644c6",
".dk c #2644c8",
"#Zx c #26472a",
"#S. c #264852",
"#KO c #264a48",
"#wf c #264c7d",
"#tF c #264c8d",
"#wd c #264d86",
"#Hx c #264d9c",
"#Vh c #264e89",
"#xt c #26537a",
"#JM c #265782",
"#EL c #265871",
".XE c #2658bb",
"#Lt c #265ba7",
".Av c #265bb7",
".nn c #265bc3",
".B6 c #265bcd",
"#yW c #265d84",
"#MI c #265daf",
".rh c #265ddb",
".Kj c #265fa6",
"#0T c #266037",
".r5 c #2661bb",
"#Zs c #26622f",
".zq c #2662aa",
".pK c #2666c7",
".C7 c #2668b2",
".CV c #2668bf",
".Fw c #266cb1",
".Fr c #266cb4",
".Fy c #266daf",
".Gw c #266eb8",
".GG c #266fb3",
".HG c #2673bb",
".92 c #271a52",
"#Jd c #272332",
".bm c #2728a6",
".#A c #272ab7",
"#VI c #272d2d",
"#BA c #272e72",
"#bP c #272e74",
".ba c #272ebc",
"#Y. c #272f0a",
"#mD c #272f6d",
"#1x c #27302d",
"#1y c #273130",
"#hV c #273176",
".gN c #2731aa",
"#VC c #273236",
".cI c #2732a6",
".cb c #2733c3",
"#S3 c #27343a",
"#Bz c #27347a",
".d8 c #27349a",
"#qc c #273574",
"#mL c #27357e",
"#bO c #273580",
".hK c #2735a0",
"#fO c #273695",
".fx c #2736ad",
".ce c #2736c3",
"#lB c #273784",
"#aQ c #273797",
"#sL c #273870",
".gE c #2738ae",
"#ii c #27399b",
".hk c #2739a7",
"#WI c #273a41",
"#ij c #273b9e",
"#NO c #273c7f",
"#om c #273c8f",
"#E2 c #273d6e",
"#r0 c #273d88",
"#op c #273d90",
"#r1 c #273e8a",
".bP c #273ebe",
".kS c #273ec0",
".lP c #273fb9",
".bR c #2740c1",
"#y6 c #27418e",
"#eJ c #2741a0",
".p4 c #2746d4",
".B3 c #2747c0",
"#M5 c #274a44",
".c5 c #274ac2",
".Xv c #274bab",
".lK c #274cc1",
"#A8 c #274f72",
"#2c c #27513b",
"#XK c #27518d",
"#A9 c #275287",
"#YJ c #27556c",
"#Yx c #275636",
".1h c #2757bb",
"#Rv c #2758d8",
"#QW c #275a4b",
".1g c #275ac7",
"#yF c #275d81",
".1d c #275dca",
"#MJ c #275eae",
".43 c #275eb8",
".px c #275ec5",
"#vs c #275fac",
".tl c #2761b3",
".tk c #2761b5",
".AV c #2762c8",
".zp c #2763ab",
".Ff c #2769bd",
".IK c #276bbe",
".Fx c #276db2",
".GH c #2770b4",
".HH c #2774ba",
"Qtf c #281d83",
".aX c #2821ab",
".dy c #2823a3",
".#R c #2825aa",
".N1 c #28272c",
"QtD c #2828ae",
".ik c #28299d",
".bl c #2829a7",
"#LD c #282a36",
".cf c #282dbc",
".jh c #282e9e",
".dP c #282fa3",
".lT c #282fb3",
"QtJ c #282fbd",
"#ee c #283078",
"#fn c #283174",
".aW c #2831be",
"#gx c #283279",
"#gI c #28327a",
".fI c #2833af",
".fN c #2833b1",
".m4 c #2833b3",
"#Ph c #28353b",
"#qo c #283569",
"#rD c #28356a",
"#n2 c #283673",
".mu c #2837b6",
"#dc c #28389a",
"#WM c #283943",
"#rp c #28397e",
"#Ak c #283a84",
"#d. c #283a8e",
"#g2 c #283a9c",
".gY c #283aa6",
".nC c #283ab6",
".nB c #283ab8",
"#ik c #283ba1",
"#il c #283ba2",
"#Zd c #283c45",
".c. c #283cbf",
".nI c #283cc1",
"#sJ c #283d76",
"#oo c #283d90",
".GT c #283e49",
"#g7 c #283ea4",
"#eG c #2840a0",
"##y c #2840aa",
"#du c #2841a8",
".kW c #2841bf",
".jU c #2842bb",
"#0n c #284332",
"#u# c #28457f",
"#aC c #284595",
".dm c #2845c7",
".c6 c #2846be",
".l0 c #2846c2",
"#R7 c #284741",
"#CA c #284776",
"#v2 c #284861",
"#vG c #28496c",
".kC c #2849ca",
"#RA c #284a70",
"##o c #284aa4",
"#u1 c #284b81",
"#Rw c #284bb3",
".oj c #284bbf",
"#vp c #284c96",
".bW c #284cc6",
"#KV c #284e35",
"#uZ c #284e8d",
"#Kb c #285095",
"#Lg c #285096",
".ok c #2850c2",
"#xs c #28517d",
"#Lf c #285193",
"#UU c #28523e",
"#NT c #2852a6",
"#yD c #28537e",
"#DC c #285397",
"#W9 c #28564b",
"#v9 c #285688",
"#wG c #2857a5",
"#O0 c #2857a9",
".ea c #2857bf",
"#DT c #285896",
"#Ru c #2858d6",
"#Ih c #28595d",
"#Hf c #285968",
".3M c #2859c2",
".De c #285acd",
".3Q c #285bc4",
".5p c #2860c1",
".r4 c #2863bf",
"#Y3 c #2867c8",
"#NI c #2868d2",
".BH c #286ac1",
".Ec c #286bb9",
".Gr c #286bba",
".Fe c #286fc1",
".GB c #2870b8",
".GI c #2871b5",
".GE c #2871b6",
".GK c #2872b1",
".HF c #2872bb",
".qT c #2879d2",
".fY c #29289d",
"#oF c #29295b",
"#WV c #292a2e",
".g1 c #292b9a",
".#Q c #292cb1",
"#Us c #292d2e",
".lU c #292db2",
"QtF c #292db5",
".ag c #292ebe",
"#As c #292f61",
".bs c #2930b5",
"#O. c #29313e",
"#Vo c #29323b",
"#Pg c #293241",
"#HO c #293251",
".g8 c #2932a9",
".m5 c #2932b3",
".lW c #2932b5",
"#ef c #293371",
"#mF c #293476",
"#HE c #293567",
"#sO c #293569",
"#i4 c #29357d",
"#kd c #29357f",
".q8 c #2935bf",
"#RO c #29363f",
"#nV c #29367c",
"#0p c #293726",
"#RT c #29373a",
"#Zb c #293742",
"#n1 c #293774",
".hM c #2938ad",
"#ka c #29396c",
"#Vv c #293a42",
"#rq c #293a80",
".e5 c #293aa6",
".aR c #293abe",
"#uL c #293b4f",
"#d# c #293b91",
"#in c #293ba7",
"#y1 c #293c76",
"#y5 c #293c88",
"#aO c #293c9a",
"#io c #293ca5",
"#RU c #293d32",
"#b. c #293db0",
".es c #293dba",
"#nd c #293e91",
"#fR c #29409e",
"#g8 c #2940a6",
".k7 c #2940b2",
".og c #2940b4",
"#ME c #29429c",
".kV c #2942c1",
"#R8 c #294344",
"#tQ c #294380",
"#cg c #2943b4",
".mW c #2946bb",
"#wg c #294783",
"#FS c #294867",
"#uq c #294877",
"#p1 c #29487e",
"#z4 c #294881",
"#2e c #294a3f",
"#Dw c #294a6d",
"#tG c #294b92",
"#Jw c #294c45",
"#v4 c #294c6a",
"#Cu c #295089",
"#Sb c #295149",
".HY c #29518f",
"#W8 c #295244",
".rj c #2953c9",
"#Im c #295673",
".re c #2957e0",
"#JZ c #29588e",
"#Ls c #2958a8",
"#U0 c #29596d",
"#DU c #29599b",
".42 c #295ab9",
".1j c #295ac0",
"#Hh c #295b72",
"#Ix c #295b7c",
".st c #295bd8",
".1f c #295cc9",
".XH c #295dc2",
".1e c #295dca",
".uu c #295fb5",
"#wK c #2960a1",
"#2I c #296460",
".qO c #2969d5",
".pE c #296ac8",
".D5 c #296bc1",
"#EU c #296d76",
"#NG c #296db8",
".GJ c #2973b4",
".Hz c #297bc5",
"Qtj c #2a1f95",
"QtC c #2a24ac",
"QtV c #2a28d1",
"#h0 c #2a2b7d",
"#VH c #2a2e31",
".bp c #2a2eab",
"#vM c #2a3060",
".nN c #2a30bc",
"#h3 c #2a3181",
".hP c #2a31a6",
".bu c #2a31b3",
"#Oa c #2a323d",
"#fy c #2a3285",
".kp c #2a32b1",
"#N6 c #2a335e",
"#Af c #2a336a",
"#fm c #2a3376",
"#hZ c #2a347c",
"#sS c #2a356d",
"#h8 c #2a3587",
".j8 c #2a35a9",
"#u. c #2a3668",
".d6 c #2a36a4",
".lR c #2a37b9",
"#mz c #2a3869",
"#en c #2a3890",
"#qd c #2a397a",
".eu c #2a39ba",
"#Vy c #2a3b43",
"#xc c #2a3b57",
".cc c #2a3bc7",
"#WK c #2a3c40",
"#yO c #2a3c7a",
".gG c #2a3cac",
".oX c #2a3cc2",
"#Vt c #2a3d39",
"#cZ c #2a3d77",
"#NP c #2a3e7d",
"#DM c #2a4072",
"#tH c #2a4079",
"#0m c #2a4137",
"##B c #2a41a7",
"#g9 c #2a41a9",
"#cf c #2a41b1",
"#fV c #2a44a3",
".jV c #2a44bd",
"#dv c #2a45ac",
".ee c #2a45b6",
".aT c #2a45d0",
"#p4 c #2a4676",
".oi c #2a47bc",
".fr c #2a48b6",
"#Zy c #2a4937",
".p5 c #2a49d7",
"#uO c #2a4a63",
"#Lq c #2a4a9f",
".v5 c #2a4db1",
".81 c #2a4db3",
".zA c #2a4eaf",
"#we c #2a4f83",
"#ua c #2a4f86",
".v6 c #2a50b5",
"#SM c #2a50cb",
"#V9 c #2a524a",
"#DK c #2a5283",
"#0G c #2a5335",
"#XL c #2a53a2",
".4Z c #2a53bc",
"#0Q c #2a543c",
"#tE c #2a548e",
".41 c #2a57bc",
".1i c #2a5ac0",
".6A c #2a5bc1",
".sq c #2a5ce3",
"#MH c #2a5eb2",
".1c c #2a5ecc",
".Ws c #2a60b8",
".Lu c #2a61b4",
".Ki c #2a62af",
".44 c #2a63ba",
".tj c #2a64b8",
"#TU c #2a6591",
".r3 c #2a65c3",
".45 c #2a67ba",
".qN c #2a68d5",
".Gp c #2a6bc7",
".Gx c #2a6cb8",
".Fs c #2a70b6",
".HL c #2a72bc",
".HE c #2a72be",
".HS c #2a73b7",
".HC c #2a77bf",
".mE c #2b1cb5",
"#LF c #2b263d",
".cv c #2b29a4",
"#LC c #2b2a38",
"#q2 c #2b2b61",
".hR c #2b2ca0",
".dw c #2b2eb1",
".#J c #2b2ebb",
"#Gz c #2b2f4c",
".#z c #2b2fb4",
"#wn c #2b3074",
"#gY c #2b308b",
".br c #2b31ad",
".ii c #2b32a4",
".dO c #2b32a6",
".#0 c #2b32c8",
"#c3 c #2b3372",
".#v c #2b33a0",
"#1H c #2b3439",
"#gL c #2b3481",
"#HD c #2b356a",
"#u8 c #2b3573",
"#gG c #2b357c",
".fB c #2b35a4",
"#sQ c #2b366c",
"#sR c #2b366e",
"#gv c #2b3678",
".d4 c #2b36aa",
".fJ c #2b36b4",
"#sP c #2b376b",
".iS c #2b38ab",
"#cb c #2b38b8",
".nM c #2b38c4",
"#S2 c #2b393c",
".GU c #2b3942",
".ev c #2b39bc",
"#dd c #2b3a9f",
"#qg c #2b3b79",
"#l3 c #2b3c8e",
"#WJ c #2b3d3f",
"#nJ c #2b3d6d",
".gH c #2b3dab",
"#WH c #2b3e45",
"#Bx c #2b3e83",
".ej c #2b3ea5",
".cd c #2b3ec9",
".gQ c #2b3fb2",
"#MZ c #2b4045",
"#nK c #2b406b",
".ei c #2b40a9",
"#ha c #2b40ab",
".db c #2b40b3",
"#bY c #2b4197",
"#aL c #2b41a7",
"#a9 c #2b41cb",
".kT c #2b42c6",
"#p7 c #2b436f",
"#v1 c #2b4462",
"#qC c #2b4487",
".oh c #2b44ba",
".kU c #2b44c5",
"#qD c #2b4582",
"#ch c #2b45b6",
"#dt c #2b46af",
".mX c #2b46bb",
"#zE c #2b476e",
"#eF c #2b47a8",
".p8 c #2b47d6",
"#eK c #2b48a6",
"#1R c #2b4931",
".Xu c #2b49a9",
"#Zn c #2b4a20",
"#ZA c #2b4b3e",
".8Z c #2b4cab",
"#Zo c #2b4d2c",
".fp c #2b4eb4",
"#V4 c #2b4f45",
"#1E c #2b512c",
"#KQ c #2b5142",
"#ZG c #2b5144",
".xi c #2b52b7",
"#2o c #2b5377",
"#DG c #2b538e",
"#jN c #2b5470",
".40 c #2b54bd",
"#wa c #2b5591",
"#YB c #2b564c",
"#M6 c #2b564f",
"#xo c #2b568d",
".c2 c #2b56c9",
"#yG c #2b5788",
".ou c #2b5ac2",
".sp c #2b5be3",
"#Xo c #2b5e73",
".XG c #2b5fc2",
".tB c #2b5ff3",
"#JY c #2b608a",
".MI c #2b61b9",
".Lv c #2b62bd",
"#Lu c #2b63ae",
"#qT c #2b6478",
"#wJ c #2b64a9",
".4a c #2b66c4",
".CU c #2b6bc3",
".BG c #2b6bc5",
".BS c #2b6db9",
"#e3 c #2b6e7e",
".qS c #2b70cd",
".HP c #2b74b9",
".Fb c #2b77d7",
".Gj c #2b7edc",
".co c #2c25a7",
"#Kp c #2c2a37",
".#T c #2c2fb2",
"#Ut c #2c3031",
"#hx c #2c3060",
".#t c #2c32a2",
"#XU c #2c3343",
"#gK c #2c3580",
"#gz c #2c367b",
"#gy c #2c367e",
"#q. c #2c376f",
".cH c #2c37ad",
"#wk c #2c396d",
"Qtt c #2c39c3",
"#yN c #2c3a79",
"#Z. c #2c3b3e",
"#ro c #2c3b7e",
".m2 c #2c3bb8",
".m7 c #2c3bba",
"#Ze c #2c3c4b",
"#za c #2c3d82",
".c# c #2c3dbf",
"#Tl c #2c3e42",
"#p9 c #2c3e70",
"#eD c #2c3ea4",
"#on c #2c4194",
"#bZ c #2c419a",
"#S9 c #2c4235",
"#h# c #2c42af",
".ft c #2c42b2",
"#a8 c #2c42cb",
"#1L c #2c4444",
"#z0 c #2c4588",
"#or c #2c4599",
".c7 c #2c47ba",
"#jD c #2c489b",
"#eZ c #2c49a7",
"#2f c #2c4b3c",
"#Lj c #2c4b8e",
"#f9 c #2c4ba6",
".57 c #2c4bbf",
".59 c #2c4cbb",
".58 c #2c4cbd",
"#DP c #2c4d82",
"#dH c #2c4db8",
".kD c #2c4dce",
"#v3 c #2c4e69",
"#Li c #2c4f93",
".sn c #2c50d8",
"#YQ c #2c5159",
"#Ka c #2c5198",
".Xz c #2c51b9",
".3H c #2c51c3",
"#KR c #2c5243",
".yt c #2c52bd",
"#ZL c #2c5350",
".Xw c #2c54b4",
"#bf c #2c55cb",
"#JQ c #2c567c",
".2w c #2c56c6",
"#xj c #2c5782",
"#T0 c #2c59ac",
"#xl c #2c5a8c",
".wU c #2c5aaf",
"#ZW c #2c5b77",
"#Rk c #2c5cb0",
".tJ c #2c5cca",
".2z c #2c5dc4",
"#gb c #2c5e75",
".1l c #2c5ec1",
"#qU c #2c5f74",
".Wo c #2c60b3",
"#OW c #2c60b6",
"#Xp c #2c6173",
"#e2 c #2c697e",
".Gy c #2c6bb8",
".pJ c #2c6ccd",
".qP c #2c6cd6",
".Fd c #2c6dc9",
"#JW c #2c7083",
".Gm c #2c70c1",
"#NF c #2c71a8",
".HD c #2c71be",
".HM c #2c74bc",
".IV c #2c76bd",
".IY c #2c77bb",
"Qtk c #2d219f",
".dA c #2d2298",
"#RF c #2d2942",
".bk c #2d2cb8",
"#ez c #2d30a3",
".FK c #2d3134",
"#WW c #2d3235",
"#h2 c #2d3283",
".#B c #2d32c2",
".H3 c #2d3349",
"#uw c #2d3365",
".ij c #2d33a5",
".bq c #2d33af",
"#Qu c #2d343a",
"#U# c #2d343c",
".iT c #2d34a9",
"#fz c #2d358a",
"#eC c #2d35a0",
"#sV c #2d366f",
"#hR c #2d377f",
"#mT c #2d3a7e",
"##M c #2d3cb1",
"#bM c #2d3d70",
"#mA c #2d3f6d",
".fm c #2d3f95",
"#bN c #2d4085",
"#Qo c #2d408f",
"#ip c #2d40a6",
"#T. c #2d4135",
".lI c #2d41c6",
"#mB c #2d426f",
".k8 c #2d42b5",
"#QK c #2d4336",
"#Qn c #2d438c",
"#l4 c #2d4396",
"#ji c #2d448a",
"##A c #2d44aa",
"#u4 c #2d4575",
"#O8 c #2d459f",
"#eO c #2d46aa",
"#uM c #2d4762",
"#fW c #2d47a8",
".bS c #2d49c7",
"#IU c #2d4a8e",
"#uN c #2d4b63",
"#zF c #2d4b71",
".lZ c #2d4bc5",
"#2i c #2d4c47",
"#g. c #2d4ca7",
"#uP c #2d4e6d",
"#vF c #2d4e71",
"#2p c #2d4e83",
"#dG c #2d4eb9",
"#dI c #2d4fba",
"#Co c #2d5086",
"#cs c #2d50c4",
"#V0 c #2d5143",
".B2 c #2d51c3",
"#KS c #2d5348",
"#Yv c #2d545b",
"#Gd c #2d5473",
"#Xf c #2d5634",
".so c #2d57df",
"#xn c #2d5a91",
".3L c #2d5acf",
".2x c #2d5cc6",
".sa c #2d5eaa",
".3N c #2d5ec4",
"#W2 c #2d622e",
"#QX c #2d6250",
"#G5 c #2d6268",
"#ZX c #2d6284",
"#ZZ c #2d6392",
".ox c #2d64c9",
"#r5 c #2d6681",
"#Nb c #2d6751",
"#2H c #2d6b66",
".qM c #2d6cd6",
".pF c #2d6ec8",
"#Na c #2d6f53",
".Ef c #2d71ba",
".qQ c #2d71d6",
".qR c #2d72d1",
"#N# c #2d7351",
".HO c #2d75bd",
".HT c #2d76ba",
".I2 c #2d78bb",
".IJ c #2d79b7",
".IQ c #2d7cc1",
".H2 c #2e2a45",
".#S c #2e2bb0",
".nO c #2e2bb6",
".cw c #2e2ca9",
"#VE c #2e2f34",
".bn c #2e2fad",
"#e9 c #2e3166",
".hQ c #2e31a6",
"#Aq c #2e346e",
"#mR c #2e3579",
"#iW c #2e3675",
"#h4 c #2e3687",
".in c #2e36a5",
"#Po c #2e373e",
"#qj c #2e3873",
".a3 c #2e38bc",
"#qi c #2e3a76",
".#X c #2e3ac2",
"#WE c #2e3b41",
"#rC c #2e3b70",
"#aR c #2e3ba1",
".fv c #2e3fab",
".nA c #2e3fc3",
"#ke c #2e4066",
".#w c #2e40a4",
"#R9 c #2e4249",
"#b1 c #2e42a3",
"#l5 c #2e4497",
"#h. c #2e44b1",
"#p3 c #2e457b",
"#r2 c #2e4595",
"#NN c #2e4690",
"#fZ c #2e46aa",
"#eQ c #2e47ab",
"#c. c #2e48b6",
"#nh c #2e499a",
"#f8 c #2e4daa",
".mV c #2e4dc1",
".sm c #2e4ed5",
".7j c #2e4fb6",
".mU c #2e4fc2",
"#xe c #2e506c",
"#UT c #2e513b",
"#V8 c #2e513d",
".v7 c #2e51b7",
".3G c #2e51c5",
"#uQ c #2e5276",
"#KP c #2e534b",
"#Bd c #2e5387",
"#IO c #2e5399",
"#GY c #2e546b",
"#uR c #2e557e",
".6. c #2e55bc",
"#OX c #2e58c4",
"#0Y c #2e593b",
"#yE c #2e5983",
"#Yw c #2e5a41",
"#Cq c #2e5b84",
"#SA c #2e5c8d",
".uO c #2e5cd4",
"#Wb c #2e5d6d",
"#tC c #2e5e8c",
"#tD c #2e5e8f",
"#ES c #2e5f6d",
".1k c #2e5fc5",
".Db c #2e5fd6",
".XF c #2e60c1",
".sr c #2e60e3",
".1m c #2e63c1",
".6d c #2e64ba",
"#LY c #2e6546",
"#SK c #2e65c0",
".pG c #2e6ecf",
".Eg c #2e72bb",
"#OS c #2e739d",
".HA c #2e75cf",
".HI c #2e76be",
".HV c #2e78b7",
".HU c #2e78b9",
".IZ c #2e79bd",
".IR c #2e7bbf",
".IP c #2e7bc1",
"#Ny c #2e8455",
".LB c #2f253e",
".g0 c #2f2c9f",
"#MY c #2f2e3e",
".Kq c #2f3034",
"#LL c #2f3241",
".bo c #2f33b0",
"Qto c #2f33b8",
"#ti c #2f3454",
".ca c #2f35c7",
"#fN c #2f3799",
".ko c #2f37b3",
"#S0 c #2f383d",
"#Fa c #2f3974",
"#Fb c #2f3976",
"#hX c #2f3980",
"#1G c #2f3a36",
"#Vq c #2f3a4e",
"#cc c #2f3ab8",
"#1J c #2f3b47",
"#my c #2f3b6f",
"#R0 c #2f3c35",
"#RM c #2f3d40",
"#lz c #2f3d95",
"#CO c #2f3e67",
"#qe c #2f3e7f",
".lY c #2f3ebd",
"#1K c #2f4047",
"#b2 c #2f42a8",
"#hb c #2f42ab",
"#.M c #2f43b6",
"Qtp c #2f43c8",
"#p8 c #2f4473",
"#xd c #2f476b",
"#ba c #2f48bc",
"#Bf c #2f4986",
"#fX c #2f49aa",
"#1C c #2f4c36",
"#eY c #2f4dad",
"#01 c #2f4e50",
".56 c #2f4ec3",
".YI c #2f50b9",
"#Ci c #2f5177",
".7k c #2f52b8",
"##2 c #2f52c8",
"#KU c #2f5443",
"#bd c #2f54c9",
"#Lr c #2f55a8",
".uX c #2f55b6",
"#be c #2f56cd",
"#ZB c #2f573c",
"#YC c #2f574c",
"#Sa c #2f5756",
"#ct c #2f57c9",
"#yB c #2f598b",
".2s c #2f5acb",
"#0R c #2f5d39",
"#xm c #2f5d91",
".2t c #2f5dcd",
"#QZ c #2f5f4f",
"#vr c #2f5fab",
".Wn c #2f5fc1",
"#F9 c #2f6089",
".6b c #2f60bc",
".6c c #2f62bb",
"#Q. c #2f639f",
".3P c #2f63c9",
".tG c #2f63d9",
"#wH c #2f64b0",
"#OY c #2f65af",
"#Nn c #2f662f",
".zj c #2f66b9",
"#EW c #2f6798",
"#Lv c #2f67b2",
".6e c #2f67ba",
"#wI c #2f68af",
".r2 c #2f69ca",
".r8 c #2f6ab6",
"#ZE c #2f6b49",
".qY c #2f6ecd",
".qL c #2f6ed7",
"#NH c #2f71cf",
".vV c #2f74cf",
".HN c #2f77bf",
".HQ c #2f78bd",
"QtB c #3028b1",
"#Jc c #302b31",
"#HY c #302b41",
"#Ja c #302c3b",
".fX c #302fa6",
"#Jf c #303052",
"#gX c #30318e",
"#h1 c #303384",
".Je c #303435",
"#bS c #303684",
"QtH c #3037b9",
"QtG c #3037bb",
"#XR c #303948",
"#df c #303998",
"#QC c #303a44",
".FI c #303b41",
"#dq c #303baf",
".fH c #303cb6",
"#XP c #303d45",
"#h5 c #303d8c",
"#ep c #303d9b",
".ym c #303daf",
"#lI c #303e85",
".d9 c #303e9f",
"#Uk c #303f44",
".hi c #3040af",
"#WN c #304149",
".gD c #3041b5",
"#Vu c #304244",
"#rr c #30428a",
"#p2 c #30447f",
".oc c #3044bd",
"##C c #3045ae",
"#bX c #30469b",
".83 c #30499d",
"#a1 c #3049d7",
"#.P c #304bc0",
"#IR c #304c96",
"#dw c #304cb0",
"#eL c #304da9",
"#EI c #304e74",
"#FT c #304e80",
"#00 c #305158",
"#ga c #305476",
".3I c #3054c6",
"#KK c #30563d",
".7l c #3056b9",
"#vq c #3057a4",
"#zO c #305a84",
".6# c #305abe",
"#zM c #305b7e",
"#yw c #305b86",
"#uS c #305b88",
"#Ij c #305d70",
"#w. c #305d94",
"#w# c #305d96",
".wT c #305db2",
"#uT c #305e8f",
"#SH c #305fad",
"#ZC c #30603a",
"#LX c #306143",
"#TY c #30619c",
".zG c #3061d8",
".ss c #3061e1",
"#Wd c #30627b",
".2A c #3062c5",
"#zU c #306493",
".pw c #3064ca",
"#TW c #306599",
".1n c #3065c1",
".2C c #3065c5",
".uJ c #3066e0",
"#N. c #306f50",
".r0 c #3070c7",
".qK c #3072d0",
".HR c #3079bd",
"#10 c #307a3d",
".IX c #307ac1",
".I1 c #307bbe",
".8N c #31285f",
".MP c #312c40",
"#ml c #313163",
".Jb c #31324e",
"#v. c #313467",
".a6 c #3135ba",
"#Zf c #31374d",
"#c5 c #313978",
"#fA c #31398e",
"#wm c #313b6e",
"#Ag c #313b80",
"#lF c #313b82",
".lS c #313bbe",
".d5 c #313caf",
"#dh c #313d9f",
"#aX c #313dad",
".fw c #313fa8",
"#Vs c #314043",
"##Q c #3140bd",
".mv c #3140bf",
"#QJ c #314137",
"#e# c #314174",
".lH c #3141c8",
".j4 c #3142b6",
"#dr c #3143b3",
"#b0 c #3146a3",
"#ne c #31479a",
"#qR c #31479c",
"#dl c #3147b4",
".aG c #3147bf",
"##V c #3147ce",
"#WY c #314834",
"#AT c #314874",
".da c #3148ba",
"#tw c #314a68",
"#ng c #314a9c",
".aH c #314ac0",
"#ci c #314bba",
"#Tk c #314c43",
"#.p c #314db1",
"#dE c #314dba",
"#.n c #314eb6",
".bT c #314fc9",
"#Th c #315041",
"#NS c #3150a3",
"#cm c #3150ba",
"#zH c #315178",
".7h c #3151be",
".8v c #3152bb",
".7i c #3152bd",
".8z c #3153b4",
"#1D c #315434",
"#kW c #3154a6",
"#R6 c #315547",
"#hn c #3155ad",
".8A c #3155b3",
"#2h c #31564f",
"#SO c #3157ac",
"#FQ c #31595b",
".7m c #3159b8",
"#zQ c #315a88",
".7n c #315cb8",
".6a c #315dbe",
"#EP c #315e85",
"#yx c #315e88",
"#TM c #315f6e",
"#Iz c #315f80",
".7o c #315fb7",
"#Yh c #316036",
"#G4 c #316066",
"#uU c #316094",
".2y c #3160ca",
".Lw c #3161b6",
".1b c #3161d0",
"#X# c #31624f",
"#SI c #3164b7",
".Z1 c #3164cf",
".Z2 c #3164d1",
".ow c #3166cc",
".ut c #3167bf",
".ti c #316ac1",
".Aw c #316ac3",
"#Wl c #317393",
"#2L c #31785a",
".qW c #3178d4",
".IO c #3179c3",
".Fa c #317ad6",
".IW c #317bc2",
".Hu c #317ed6",
".IM c #317fc1",
".IE c #3180cd",
".qU c #3181da",
".lC c #3229b8",
".nP c #322ab3",
".MO c #322e2b",
"#gM c #322e85",
"#gN c #322f86",
"#gO c #32328a",
"#tj c #32336b",
"#Gq c #323868",
"#Ar c #32386c",
"#Pf c #323953",
".lA c #3239c7",
"#Uc c #323d41",
".#F c #323ec6",
"#eo c #323f9b",
".#x c #3240ab",
".m3 c #3240bd",
".q4 c #3241b8",
".mn c #3242b3",
"#a7 c #3246cb",
"#b# c #3247ba",
".m9 c #3247c4",
"#aD c #32497f",
"#ds c #324ab6",
"#l9 c #324b9b",
".n8 c #324cc3",
".w9 c #324eb9",
"#IA c #325188",
"#eN c #3251ac",
"#O2 c #3252b5",
".7g c #3252c1",
"#US c #32533e",
"#UZ c #325376",
".7N c #3253be",
".8y c #3254b6",
"##3 c #3255cb",
"#Xm c #325a5a",
".8B c #325ab2",
"#ZI c #325b39",
"#KL c #325b4b",
"#KM c #325b57",
"#DH c #325c96",
".2v c #325dcd",
"#SG c #325ea7",
"#Rt c #325ed7",
"#Be c #325f80",
"#Le c #325f9a",
"#Rl c #325fbc",
"#OD c #326053",
"#1a c #326091",
".2u c #3260cf",
".uM c #3260d0",
".pv c #3261c9",
".Wm c #3261cb",
".uN c #3261d5",
".x6 c #3262b4",
".7p c #3262b7",
".6B c #3263c9",
".ov c #3263ca",
".2B c #3267c7",
"#19 c #326d41",
".D2 c #326ed0",
".IL c #3271c1",
".HB c #3272c9",
"#OU c #3278a9",
".zI c #3278d7",
".Eo c #327ae6",
".I3 c #327dbe",
".I0 c #327dc0",
".I4 c #327ebc",
".J9 c #327fc3",
".J8 c #327fc5",
".Ka c #3280c2",
".GS c #332735",
"Qty c #332cb8",
"#fC c #332f8d",
"#Qp c #333043",
"#GJ c #333359",
"Qt3 c #3334cd",
"#cM c #33356e",
"#C7 c #333570",
".a4 c #3337bc",
"#VD c #333a40",
"#uK c #333a44",
"#XT c #333a4d",
"#bW c #333a82",
"#Kx c #333b52",
"#ap c #333c73",
"#q# c #333d78",
"#fp c #333d7b",
"#ea c #333f73",
"#qb c #333f7b",
"#di c #3340a6",
"#qh c #33417e",
".oY c #3341c6",
"##O c #3342b9",
".et c #3342c3",
".m0 c #3346be",
"#ce c #3347ba",
".od c #3347c0",
"##U c #3349d0",
"#P# c #334a98",
"#eE c #334baf",
"#R3 c #334c49",
"#nf c #334c9e",
"#eP c #334cb0",
"#QM c #334d5a",
"#SR c #334f7e",
"#dN c #334fb0",
".b9 c #334fd6",
"#eM c #3350ac",
"#dO c #3350ae",
"#cq c #3350c6",
"#Yr c #33515b",
".55 c #3351c9",
"#f7 c #3352af",
"#dK c #3352be",
"#CH c #33538c",
".8u c #3353c0",
"#hp c #335475",
"#dA c #3354b5",
"#0y c #33553c",
"#.d c #3355ac",
"#Mx c #3356a7",
".rk c #3357c9",
"#B# c #33596c",
"#xh c #33597d",
"#Lh c #3359a0",
"#Qa c #3359ba",
"#Rm c #335ac1",
".2r c #335acf",
"#Xe c #335b43",
"#A7 c #335b7f",
".su c #335dd6",
".uV c #335ec6",
"#Wj c #335f68",
"#zT c #335f84",
"#Ik c #336077",
"#0O c #33613d",
"#MG c #3361b7",
".Z3 c #3363d1",
"#2J c #33656c",
"#1b c #33659a",
".Au c #3365c6",
".tI c #3365d4",
"#Zr c #33663d",
"#SJ c #3366bf",
".tH c #3366d9",
".tF c #3366dc",
"#qS c #336981",
"#Hb c #336985",
"#0I c #336a42",
"#SL c #336ac7",
"#TT c #336e96",
".pI c #3373d4",
".qJ c #3374d2",
".IN c #3378c3",
".E9 c #337ce2",
".qV c #337ed9",
".I6 c #337fbb",
".I5 c #337fbd",
".JY c #3381bf",
".IC c #3384d5",
".La c #3392c2",
".7z c #342a5f",
".lD c #342dbb",
"#HZ c #343150",
".fW c #3435ab",
"#hw c #343673",
"#wZ c #343a6c",
"#ux c #343b6f",
"#O# c #343c49",
"#cN c #343d66",
"#j7 c #343e7b",
".j7 c #343fb3",
"#cd c #3442bc",
"#de c #3443aa",
"#aB c #344482",
"#h6 c #344492",
"#WG c #34454c",
"#a4 c #3445c7",
"#Vz c #34464a",
"#.N c #3449be",
"#f0 c #344aad",
".mY c #344ac1",
"#AU c #344b77",
"#O3 c #344cb8",
"#l8 c #344d9f",
"#fY c #344db2",
".o. c #344dc4",
".n9 c #344ec5",
"#m. c #344f9e",
"#.m c #3450bb",
".dl c #3450d5",
"#zG c #345179",
"#.Q c #3451c6",
"#eX c #3452b4",
".4U c #3452ca",
".4T c #3452cc",
"#Bb c #345370",
"#dF c #3453bf",
"##1 c #3453c8",
"#yH c #34547a",
".8x c #3454b9",
".8w c #3454bb",
".3K c #3454c5",
"#Xl c #345743",
"#kX c #3458ac",
"#V1 c #345a45",
"#uY c #345b9c",
"#O1 c #345bb6",
".uW c #345bc0",
".4L c #345bda",
"#L9 c #345c44",
".pu c #345dc6",
".Xx c #345ec0",
"#Ok c #346144",
"#Xx c #346178",
".J. c #34619c",
"#Xn c #346271",
"#YK c #346283",
"#0E c #346341",
"#Wa c #346373",
".XJ c #3464a4",
".7q c #3464b8",
".At c #3464c8",
".Dd c #3464e0",
"#e1 c #346583",
"#gc c #346d7e",
"#ET c #346d8a",
".D3 c #3474ce",
".pH c #3474d5",
"#dT c #34768c",
".qX c #3476d4",
".Gi c #347ada",
".IS c #347dc2",
".NO c #347ed5",
".NT c #347fda",
".I7 c #3480bc",
".Ke c #3482c0",
".Kd c #3482c2",
".mF c #3526bd",
".eL c #352997",
".dz c #352da7",
"#RE c #352f55",
"#uA c #352f6d",
"#Ks c #35313f",
"#Kt c #353247",
".lE c #3532bf",
"#la c #353364",
"#gW c #353492",
"#sb c #35356b",
"Qtz c #3537be",
"#sT c #353a74",
".dv c #353abc",
"#mS c #353c80",
"Qt. c #353c82",
"#Pi c #353e43",
"#hY c #353f86",
"#Eg c #35426f",
"#WF c #354449",
"##P c #3545be",
"#u3 c #354698",
"#0w c #35493e",
"#Yk c #35494a",
"#iq c #3549ac",
"#.H c #3549ce",
"#l6 c #354b9e",
".ob c #354bc3",
"#P. c #354c98",
"##p c #355095",
"#cA c #3551b4",
"#Hr c #355270",
".v1 c #3552b8",
"#Zz c #355349",
"#bg c #3553cf",
"#up c #355483",
"#FU c #35548a",
"#cx c #3554c0",
".4V c #3554c9",
".4Y c #3555c6",
"#zI c #35567f",
"#u2 c #355689",
".3J c #3556c7",
"#cr c #3556ca",
"#hm c #3557b0",
".v4 c #3557b9",
".bV c #3557c5",
"#Ic c #35585c",
"#ZK c #355967",
"#MF c #3559b1",
".09 c #355acc",
"#I4 c #355c83",
"#NL c #355cb9",
"#cu c #355ed0",
"#FX c #355f85",
"#Yz c #356067",
".uU c #3561ca",
".sv c #3562d9",
"#hq c #35637b",
"#DJ c #356395",
".vH c #3563b9",
"#We c #356474",
"#XO c #3564b4",
"#XN c #3564b6",
"#KX c #356555",
"#NK c #3565cb",
".uK c #3566dc",
"#0N c #356736",
"#Ld c #356798",
".Kk c #3568a1",
"#NJ c #3569d6",
"#pH c #356a7a",
".2D c #356aca",
".r1 c #356fd0",
".D0 c #3577d8",
"#dS c #35788b",
".HJ c #3579c2",
".NP c #357fd8",
".NS c #3580db",
".J3 c #3582c6",
".JQ c #3582c8",
".Kf c #3583c1",
".Kc c #3583c3",
".J2 c #3584c7",
".ID c #3584d3",
".Lc c #358bc4",
".dC c #362595",
"Qte c #362e95",
"#Jb c #363030",
"#Kq c #363032",
"#Kr c #363138",
".eI c #3631a9",
"#HX c #363241",
"#MX c #363449",
"#Ku c #36364e",
"#Ej c #363873",
"#Pb c #363940",
"Qt1 c #3639e0",
".lV c #363abf",
"#sU c #363c76",
"#N3 c #363d57",
"#vN c #363e6d",
"#Vn c #363f3c",
"#fo c #363f82",
"#lH c #363f84",
"#SZ c #364037",
"#QB c #36404c",
"#hS c #364183",
"#rA c #364377",
".m1 c #3646bf",
".gF c #3647bb",
"##R c #3648c8",
"#Sf c #364a55",
"#z# c #364a91",
"##E c #364abb",
".mZ c #364bc2",
"#Tn c #364c5a",
"#.s c #364dbd",
"#.I c #364dcf",
"#O9 c #364f9f",
"#kS c #364fa1",
".o# c #364fc6",
"#dD c #3650be",
"#cz c #3651b8",
".d# c #3652c0",
"#dx c #3653b7",
"#dL c #3653b9",
"#eW c #3653bb",
"#QN c #36545c",
".3F c #3654cc",
".4S c #3654ce",
"#UP c #365567",
"#jE c #3655a5",
"#cl c #3655bf",
"#dJ c #3655c1",
".4W c #3655c9",
"#.V c #3656c3",
".4X c #3656c7",
"#Xk c #365738",
"#V7 c #36573c",
"#zJ c #365780",
"#.W c #3657c2",
"#1S c #365b32",
"#iA c #365cb1",
".uR c #365dc6",
".4Q c #365dd4",
"#FY c #36618b",
"#yA c #366194",
"#SF c #3661a6",
".uS c #3661ca",
"#Il c #36627d",
"#uW c #36629f",
".b5 c #3662df",
"#XM c #3663b8",
"#K0 c #366a75",
"#Va c #366a8f",
".3O c #366acf",
"#Lc c #366b93",
".th c #366fc8",
".D1 c #3676d8",
".JV c #367db5",
".Hv c #367fce",
".NQ c #3680d9",
".J4 c #3681c4",
".NR c #3681dc",
".J1 c #3683c9",
".IB c #3683d3",
".Ht c #3683db",
".K# c #3684c6",
".Kg c #3685c0",
".Hs c #3686df",
".Lg c #3689bd",
"#GK c #373566",
"#fD c #373693",
"#gV c #373895",
".lF c #373ac5",
"#Gs c #373b6b",
"#gQ c #373b94",
".gZ c #373fae",
"#Pp c #374045",
"#e. c #374069",
"#dp c #3740b9",
".lG c #3740c9",
"#hU c #374186",
"#dn c #3741bd",
"#gA c #374280",
"#Y7 c #37434f",
"#qa c #37437d",
"#RW c #37443b",
"#RN c #37444a",
"#fk c #374479",
".em c #3744ac",
"#ey c #3745ae",
"#Y9 c #37464d",
"#DN c #37477a",
"#aP c #3747a6",
"#aM c #3749ab",
".9t c #374acd",
"#EE c #374b64",
"##T c #374bd0",
"#xw c #374c67",
"#NR c #374da2",
"#u5 c #375079",
"#os c #3750a4",
"#eR c #3750b4",
"#cp c #3750c7",
"#VK c #375146",
".c8 c #3751bf",
"#Yq c #375369",
"#dM c #3754b8",
"#cy c #3754bc",
"#bb c #3754c9",
"#Sd c #375553",
"#dz c #3755b7",
"#cw c #3755c3",
"#kV c #3756a8",
"#NM c #3756a9",
".bU c #3756ca",
"#.R c #3756cb",
".v8 c #3757ba",
".8t c #3757c4",
"#2q c #37588e",
".9J c #3758c1",
"#a# c #3758cb",
"#ZQ c #375a54",
"#0Z c #375a5c",
"#Cn c #375a84",
".xj c #375ac0",
"#Cj c #375b7f",
"#A6 c #375c86",
"#K7 c #375d66",
"#Qb c #375dc0",
"#FW c #375e85",
"#Cp c #375e95",
"#Zq c #375f3d",
".8C c #375fb6",
".ZY c #375fce",
".zF c #3763de",
"#Wc c #376575",
"#WA c #376596",
".YQ c #3765d5",
"#U1 c #37686d",
"#Io c #376877",
".Z0 c #376ad5",
"#Iq c #376c72",
".s# c #376cb8",
".MJ c #376cd6",
"#JV c #376d91",
".us c #376dc5",
"#r4 c #37708e",
"#Mp c #37719f",
"#Xz c #37758c",
"#OV c #3775b2",
".NN c #377ed6",
".J7 c #3784ca",
".Kb c #3785c7",
".Kh c #3786c1",
".JO c #3786d1",
".Lf c #3789c1",
".Lb c #3792c7",
"Qtu c #3828af",
"#w3 c #38356c",
".f1 c #38389a",
"#LK c #38394d",
"#s# c #383a61",
"#gP c #383a91",
".a5 c #383bc0",
"#MR c #383c47",
".90 c #383d74",
"#cP c #383f6d",
"#ar c #383f85",
".lB c #383fcd",
".#y c #3841ba",
".m6 c #3843c3",
"#Ey c #38457a",
"#eq c #3845a3",
"#VJ c #384848",
"#ir c #384cad",
"#Um c #384d46",
"#l7 c #384ea1",
".ef c #384ebb",
"#T6 c #3851a3",
"#.O c #3851c7",
"#cj c #3854c2",
"#J8 c #3855a1",
"#IQ c #3855a3",
"#iB c #385678",
"#bi c #3856ce",
"#bh c #3856d0",
"#G0 c #385769",
".pj c #3857c1",
"#.S c #3857cb",
"#bj c #3857cc",
".9N c #3858bb",
"#.U c #3858c7",
"#IP c #3859aa",
".9O c #3859ba",
".9I c #3859c2",
"#Ct c #385a97",
"#hl c #385ab3",
"#A4 c #385b85",
"#xi c #385f88",
".1. c #3860d1",
".AR c #3860da",
".4M c #3860dc",
".x3 c #3861b1",
".1a c #3861d3",
"#JE c #386260",
"#yv c #38628c",
".wS c #3862b4",
"#YN c #38638e",
"#UV c #386455",
"#TK c #386495",
".uT c #3864cf",
"#DI c #38669a",
".Z4 c #3866d5",
"#Nl c #386840",
".YT c #3868d6",
"#YO c #386991",
"#Iy c #386994",
".Z9 c #3869d2",
".zh c #386ac1",
"#1Y c #386b4a",
"#Nc c #386b5a",
"#PE c #386b64",
"#H# c #386b8a",
".YW c #386cd1",
"#DF c #386e92",
".yu c #3870cd",
".r9 c #3872bc",
"#JP c #387588",
".vW c #3875ce",
"#e4 c #387a8a",
"#Ye c #387c41",
".JZ c #387ec6",
".NM c #387fd7",
".Ep c #387fe7",
".J0 c #3880c8",
".IA c #3881ce",
".K1 c #3883c7",
".K. c #3885c9",
".JP c #3886ce",
".Ld c #388ac6",
"#jU c #392f6b",
".eJ c #3931a8",
"Qtn c #3934b2",
".Jf c #393536",
"#Ko c #393544",
".a0 c #3938c2",
"#q1 c #393a70",
".8M c #393a72",
"#gU c #393a97",
"#I5 c #393b47",
"#iJ c #393b76",
"#iK c #393d6d",
"#gR c #39409a",
"#N5 c #394168",
".8G c #39417f",
"#bQ c #39427b",
"#dm c #3944c2",
"#1F c #39463c",
"#rB c #39467a",
"#S8 c #39474a",
"#Ul c #39484b",
".ek c #3948af",
"#a0 c #3948c9",
"#aW c #394ab6",
".9s c #394acc",
"#VA c #394b4d",
"#b4 c #394bb7",
"#b3 c #394cb5",
"#a5 c #394ccd",
"#KE c #394e51",
"#cn c #394ec5",
"#pC c #394fa4",
"#ho c #395177",
"#sG c #39518f",
"#Se c #395257",
"#.q c #3954bb",
"##0 c #3954c9",
"#dy c #3956ba",
"#Ya c #39573d",
".4R c #3957d3",
".7f c #3958cc",
"#FR c #395968",
"#.T c #3959ca",
".9H c #395ac5",
"#aa c #395acb",
"#ZJ c #395b64",
".9P c #395cb8",
"#UY c #395d77",
".YJ c #395ec6",
"#Xd c #395f52",
"#Wi c #395f74",
".08 c #395fce",
"#1V c #396043",
"#ZP c #39605d",
"#iC c #39607d",
".ps c #3960c5",
".pt c #3960c7",
".4P c #3960d7",
".4O c #3960d9",
"#TD c #396149",
"#uX c #3962a2",
".sx c #3962d4",
"#ZH c #39633d",
".sw c #3963d9",
"#yz c #396596",
"#1X c #396649",
"#TG c #396652",
"#uV c #3966a1",
"#ZV c #39677f",
".Dc c #3967e1",
"#r6 c #396882",
".tE c #3968de",
"#1d c #396aa4",
"#KW c #396b46",
"#jO c #396b84",
"#Nm c #396c43",
"#Ne c #396c5b",
".vX c #396dc1",
".0. c #396dd2",
"#cH c #396e8e",
".1o c #396fc7",
"#OE c #397140",
"#pG c #397180",
"#dQ c #39718a",
".yv c #3971d2",
".rZ c #3977cc",
"#0J c #397947",
"#Zt c #397a44",
".Gh c #397fdf",
"#U8 c #3980a0",
".Hr c #3986e0",
".Kp c #3a2e44",
"#MT c #3a335c",
"#LG c #3a344e",
"#fB c #3a3591",
"#vQ c #3a3671",
"#mm c #3a3869",
"#fJ c #3a38a3",
"#MQ c #3a3c4b",
"#Fv c #3a3d74",
"#Ky c #3a3f5d",
"#RY c #3a403c",
"#C4 c #3a4074",
"#do c #3a42be",
"#rs c #3a4c94",
"#.G c #3a4dd0",
"##D c #3a4fbc",
"#2j c #3a504d",
".oa c #3a50c8",
"##Z c #3a51c5",
".9u c #3a51d1",
".8g c #3a52ce",
".5o c #3a54b3",
"#Sj c #3a5769",
"#f6 c #3a58b8",
".d. c #3a58c6",
"##4 c #3a58d0",
".9M c #3a5abf",
"#.X c #3a5ac7",
"#bc c #3a5bcf",
".zB c #3a5cb5",
"#2r c #3a5d95",
"#A5 c #3a5f89",
".zE c #3a60cb",
".4J c #3a61e2",
"#Rs c #3a63d7",
"#Q0 c #3a6458",
"#SB c #3a649e",
".Xy c #3a64c8",
"#TE c #3a6547",
"#0W c #3a6655",
"#yy c #3a6693",
"#Vb c #3a678e",
".vG c #3a67bc",
".uP c #3a67de",
".Z6 c #3a69d3",
"#PH c #3a6a52",
"#Ng c #3a6b55",
"#PB c #3a6c63",
"#15 c #3a6d4c",
"#dP c #3a6d8a",
"#Xy c #3a6e6c",
"#ZY c #3a6f99",
"#Rj c #3a6fb5",
".0a c #3a6fcb",
"#XC c #3a737c",
".tg c #3a73cd",
"#JX c #3a778a",
".F. c #3a78db",
"#NB c #3a7c9e",
".NJ c #3a81cf",
".JN c #3a88d3",
".FA c #3a8ae1",
"#iI c #3b3468",
".LC c #3b3539",
"Qtc c #3b3599",
"Qtm c #3b35b3",
"#pQ c #3b386d",
"#fK c #3b3aa2",
"#pO c #3b3c72",
"#eA c #3b3cb0",
".se c #3b3cd5",
"#Zg c #3b3d56",
".GV c #3b3f48",
"#mk c #3b3f6f",
"#C3 c #3b4060",
"#Fu c #3b4171",
".aD c #3b43c0",
"#dZ c #3b446d",
".9w c #3b46bc",
"#Ah c #3b488e",
"#h7 c #3b4b99",
"#hc c #3b4cb4",
".gC c #3b4cbe",
"#Tm c #3b4d61",
"##n c #3b4d95",
"#jF c #3b54a8",
"#cB c #3b55b6",
"#QL c #3b5647",
"#IS c #3b569d",
".uY c #3b56bf",
"#g# c #3b577e",
".YH c #3b57c2",
".3B c #3b57d2",
"#cv c #3b59c9",
"##5 c #3b59d1",
"#jI c #3b5aad",
".9L c #3b5bc2",
".9G c #3b5bc8",
".8s c #3b5bca",
"#TC c #3b5d4c",
"#bk c #3b5ed2",
".2q c #3b5ed4",
".uQ c #3b60c8",
".7O c #3b61c2",
"#03 c #3b6261",
".8D c #3b63ba",
".Wh c #3b64b6",
".AP c #3b65c7",
"#F7 c #3b669b",
"#JG c #3b675a",
"#1# c #3b6796",
"#YA c #3b6865",
".Wi c #3b68bb",
".As c #3b68cf",
"#0D c #3b693b",
"#TF c #3b6a4a",
"#F0 c #3b6b7f",
"#H. c #3b6b91",
".Z7 c #3b6bd7",
"#1c c #3b6ca6",
"#cD c #3b6d86",
"#Z0 c #3b6ea3",
".YU c #3b6ed7",
"#XB c #3b7686",
"#Mo c #3b76a2",
"#XA c #3b788b",
"#mc c #3b7988",
".6f c #3b79b4",
".0b c #3b7ac1",
".J5 c #3b80c5",
".Gg c #3b81e1",
"#0K c #3b8246",
".NL c #3b82d2",
".MF c #3b86d7",
".Y3 c #3c2039",
".#K c #3c27b2",
"#HU c #3c324d",
".eK c #3c32a5",
"#tl c #3c3970",
"#uz c #3c3d76",
"#X2 c #3c3e4b",
"##a c #3c3e6e",
"#eB c #3c3fb0",
"#et c #3c40a1",
"#Kw c #3c425a",
".fA c #3c44af",
".im c #3c44b3",
"#gT c #3c45a0",
"#fq c #3c477d",
".6z c #3c4ca1",
".pg c #3c4cbb",
".8f c #3c4fcf",
"##S c #3c4fd2",
"#ru c #3c508d",
"#Pa c #3c51a2",
"#sI c #3c528c",
"#eV c #3c54b6",
".c9 c #3c54be",
"#.b c #3c55a9",
"#jG c #3c56aa",
".aI c #3c57c8",
"#jH c #3c58ac",
"#KF c #3c5954",
".3C c #3c5ad6",
"#DA c #3c5b9c",
"#hk c #3c5bb6",
".9K c #3c5bc5",
"#Ym c #3c5d48",
"#.1 c #3c5dbe",
"#ab c #3c5ecc",
".54 c #3c5fd3",
".ZX c #3c60d0",
"#bl c #3c60d2",
"#Px c #3c6249",
"#pI c #3c6277",
"#jM c #3c62b7",
"#So c #3c6351",
"#yu c #3c638c",
"#T3 c #3c63a6",
"#VL c #3c644a",
"#Ig c #3c6463",
"#TB c #3c6547",
"#EM c #3c68a7",
"#0X c #3c694c",
".zg c #3c69c4",
"#PG c #3c6a50",
"#0H c #3c6b49",
".5q c #3c6bc3",
".MK c #3c6cd8",
".YR c #3c6cdb",
"#Nd c #3c6d69",
"#Nf c #3c6e53",
"#KY c #3c6f5e",
"#TX c #3c6fa8",
"#JL c #3c707e",
".zH c #3c70dd",
".0# c #3c71d1",
"#cE c #3c728a",
".Wp c #3c72bc",
"#14 c #3c7445",
"#V# c #3c769b",
"#PK c #3c775b",
"#md c #3c7787",
"#P7 c #3c77c3",
"#1Z c #3c794d",
"#OK c #3c7b5c",
".DZ c #3c7bdc",
".HK c #3c7cc4",
"#Wm c #3c7d9b",
".T1 c #3c7fc5",
".IT c #3c80c7",
".NI c #3c81ce",
".NK c #3c83d1",
".MG c #3c87d8",
".MH c #3c87da",
".K9 c #3c88c4",
".Ls c #3c89c1",
".Li c #3c8bc4",
".L# c #3c8dc5",
"#11 c #3c9345",
"#MS c #3d375d",
".#o c #3d3d9d",
"#Ur c #3d3e40",
"#C6 c #3d3f78",
"#AF c #3d4073",
"#BU c #3d4077",
"#jW c #3d4170",
"#BS c #3d4373",
"#HP c #3d444e",
"#Eh c #3d4979",
"#aS c #3d49b5",
"#Uu c #3d4a53",
".q5 c #3d4dbe",
".fu c #3d4fbf",
".eg c #3d50b9",
"#rt c #3d518e",
".3D c #3d51cc",
"#qQ c #3d53a8",
"#kT c #3d56a8",
".v2 c #3d59ba",
"#.o c #3d5ac0",
"#Qh c #3d5cb7",
"#.Y c #3d5cc8",
"##7 c #3d5cd0",
"##6 c #3d5cd1",
"#Uw c #3d5d52",
"#af c #3d5dc0",
"#.0 c #3d5dc2",
"#ae c #3d5dc4",
".9F c #3d5dca",
"##8 c #3d5dce",
"#WZ c #3d5e3f",
"#0z c #3d5e41",
"#.2 c #3d5ebd",
"#ad c #3d5ec7",
"#Rn c #3d5fcd",
"#xg c #3d6080",
".9Q c #3d60ba",
"#J5 c #3d61ab",
"#zW c #3d6274",
".2o c #3d62d7",
"#kY c #3d63b6",
".pr c #3d65c7",
".1# c #3d65d7",
".ZZ c #3d69d6",
".YP c #3d6bdb",
"#W0 c #3d6d3d",
".YS c #3d6ddc",
".uq c #3d6fc4",
"#Mv c #3d70db",
"#iD c #3d7187",
".9S c #3d7196",
".Hy c #3d72b4",
".Gk c #3d72ce",
".CR c #3d72d0",
"#1v c #3d7365",
"#Mt c #3d73c9",
".s. c #3d75c0",
"#dR c #3d7b90",
"#TS c #3d7ba2",
".zM c #3d7be2",
".JW c #3d7fcd",
".ME c #3d85d7",
".MD c #3d86d5",
".En c #3d87f0",
".Lm c #3d89c7",
".Lt c #3d8ac2",
".K2 c #3d8bd3",
".L. c #3d8cc5",
".K3 c #3d8fd8",
"Qtx c #3e20b4",
".aY c #3e2eb5",
"#Qr c #3e3c54",
"#yd c #3e3e72",
"#Fw c #3e3e7a",
"#gh c #3e3f7f",
"#C5 c #3e437a",
"#Pn c #3e4651",
"#lG c #3e468e",
"#Y# c #3e472a",
"#gB c #3e4a86",
"#Y8 c #3e4b54",
"#.F c #3e4dcc",
"#qf c #3e4e8c",
"#Un c #3e4f49",
"#a6 c #3e51d2",
".ph c #3e53c0",
".3E c #3e56d0",
"#iv c #3e59b2",
".82 c #3e59c0",
"#ck c #3e5ac7",
"#hj c #3e5bb7",
".uZ c #3e5bc3",
".7e c #3e5dd1",
"#.Z c #3e5ec5",
"#ac c #3e5ecb",
"#xf c #3e5f7e",
"#.3 c #3e5fbe",
".v0 c #3e60c4",
"#bm c #3e60ce",
"#2s c #3e619b",
"#wS c #3e6278",
"#W3 c #3e6341",
"#FV c #3e6390",
".vZ c #3e65c0",
"#UX c #3e6672",
"#1f c #3e679f",
"#zN c #3e688e",
"#T1 c #3e69b7",
".Wl c #3e6ac9",
"#YM c #3e6b95",
"#Sn c #3e6c45",
"#Vf c #3e6c9e",
"#Z2 c #3e6da3",
".Z5 c #3e6dd5",
".yy c #3e6ed4",
".Z8 c #3e6eda",
"#ai c #3e7093",
"#Mb c #3e7556",
"#Mc c #3e7862",
".qI c #3e79d7",
"#PY c #3e7a58",
".7r c #3e7ab0",
"#Or c #3e7d60",
".J6 c #3e81c7",
".NF c #3e83ce",
".NH c #3e83d0",
".MC c #3e85d5",
".Hq c #3e88df",
".Lr c #3e8bc3",
"#ON c #3e8e73",
".H1 c #3f3357",
"Qtl c #3f34b6",
".LA c #3f353d",
"#k7 c #3f3969",
"#Od c #3f3a51",
"#tm c #3f3a72",
"#I6 c #3f3e4c",
"#y# c #3f417e",
"#zq c #3f4373",
".xb c #3f449f",
"#jY c #3f4575",
".H5 c #3f464e",
"#Ei c #3f467c",
"#iL c #3f496c",
"#gS c #3f49a2",
"#gC c #3f4a8a",
".#Y c #3f4bd5",
".q7 c #3f4cce",
".9r c #3f4dc8",
"#Zh c #3f4f5c",
".8# c #3f519b",
"#Yi c #3f5646",
".9v c #3f57d3",
"#To c #3f585d",
"#Jp c #3f585f",
"#AY c #3f5881",
"#Tp c #3f595a",
"#kU c #3f59ad",
".qo c #3f59c8",
"#2u c #3f5a91",
"#Sk c #3f5b80",
"#f5 c #3f5bbe",
"#Du c #3f5d83",
"#iw c #3f5db5",
".2p c #3f5dd5",
".tN c #3f5ec8",
"#Sh c #3f5f47",
"#jJ c #3f5fb4",
".u0 c #3f5fc6",
"#bn c #3f5fcc",
"##9 c #3f5fce",
".aJ c #3f5fd6",
"#W6 c #3f604d",
".pk c #3f60c9",
"#Sg c #3f6140",
".5Z c #3f61dd",
"#ys c #3f6288",
".2n c #3f62d8",
"#iz c #3f63b9",
".4N c #3f65e0",
"#Xu c #3f6685",
"#SC c #3f66a9",
".4K c #3f66e7",
".tD c #3f68de",
"#0P c #3f6951",
"#Vc c #3f698f",
"#1U c #3f6a4e",
"#G9 c #3f6a97",
".x4 c #3f6ab9",
"#YP c #3f6b84",
"#.4 c #3f718c",
"#17 c #3f7249",
"#Mu c #3f73d6",
"#Q9 c #3f7446",
".YX c #3f75bb",
".yw c #3f76da",
"#P6 c #3f78c5",
".CT c #3f7ece",
".Mh c #3f80d0",
"#NC c #3f84a3",
"#U9 c #3f84a5",
".NG c #3f84cf",
".Gf c #3f84e3",
".K8 c #3f86c4",
".MB c #3f86d4",
".JM c #3f89d2",
".Ll c #3f8bc9",
".Le c #3f8fcc",
"#12 c #3f9b46",
".0i c #402627",
".mG c #4030c6",
"#MU c #403a60",
".Ew c #403e43",
"#zn c #404086",
"#GI c #404160",
"#BR c #404273",
"#q0 c #404378",
"#es c #4043a2",
".iV c #4045ba",
"#LN c #404757",
"#AE c #404775",
"#u9 c #404876",
".yq c #4048ad",
"#f. c #404970",
"#QE c #404c4c",
"#AR c #404e7b",
"#M0 c #405256",
"#Aj c #40529c",
"#is c #4054b3",
"#.7 c #40558c",
"#T7 c #4055ae",
"#sm c #405779",
"#ur c #405781",
".YF c #4057bf",
"#eU c #4058ba",
".8h c #4058d2",
".69 c #4058d4",
".7a c #405ad1",
"#02 c #405c72",
".xk c #405dc1",
"#Si c #405f57",
"#2t c #406099",
".u1 c #4060c7",
".9E c #4060cf",
".8r c #4060d1",
"#yq c #406182",
"#SQ c #406194",
"#bo c #4061ca",
".5Y c #4062e0",
"#Q4 c #40635d",
"#Dx c #406383",
".sy c #4064d4",
"#Hk c #40659c",
"#V2 c #406651",
"#jL c #4066bb",
"#Q1 c #40685f",
"#zR c #406995",
"#1T c #406b40",
"#e0 c #406b8d",
"#W. c #406c6f",
"#Wu c #406c8f",
".AW c #406ccf",
"#YL c #406d94",
".Wk c #406ecc",
"#0V c #406f4d",
"#pF c #407084",
".B7 c #4072d1",
"#PD c #40736a",
"#PF c #40736c",
"#Wp c #407489",
"#nm c #407585",
".yx c #4075db",
"#JN c #407887",
".tf c #4078d5",
"#Mq c #407aac",
"#k2 c #407f90",
"#PZ c #408360",
".SL c #4083d1",
".Md c #4087c9",
".MA c #4087d5",
".Lk c #408cc6",
".Kn c #413646",
"QtA c #413dc6",
"#MP c #413e53",
"#H0 c #413e69",
"#Qq c #413f55",
".Pb c #414045",
"#sa c #414278",
"#BV c #41437c",
".#q c #4143aa",
"#Jj c #414574",
"#VQ c #414659",
"#W5 c #41494b",
"#N4 c #414a6b",
"#cO c #414a71",
".pf c #414dbd",
"#rz c #414e85",
"#R1 c #415049",
"#yK c #415172",
".4n c #4152ac",
"#WO c #415357",
"#b7 c #4153b5",
"#Yj c #41564f",
"##x c #4156b3",
".pi c #4157c4",
"#b9 c #4159c5",
"#iu c #415ab4",
"#Dy c #415b80",
"#cC c #415bba",
"#Cd c #415c77",
".tO c #415dc8",
"#Xw c #415e9a",
"#hi c #415eba",
"#Jv c #416050",
"#VX c #416156",
"#qV c #41617a",
"#a. c #4161d0",
"#VW c #416259",
".zC c #4162b3",
".pl c #4162cb",
".tM c #4162cd",
"#JU c #416480",
"#A3 c #41648a",
".9R c #4164be",
".pm c #4164cc",
".53 c #4164da",
"#OC c #416a4a",
"#kZ c #416abc",
"#G6 c #416b81",
".Ar c #416ed5",
".qG c #4172cf",
"#2# c #41735a",
"#Z1 c #4173a8",
".Wj c #4175cb",
"#Y2 c #4176c2",
"#DD c #41778f",
"#Oo c #417b62",
".rY c #417dd3",
".F# c #417edb",
"#Yf c #418049",
".Mg c #4180d0",
".IU c #4184ca",
".Mi c #4184d3",
".TS c #4185d0",
"#1w c #418667",
".K0 c #4186c7",
".Mx c #4189d1",
".Mw c #418acf",
"#OM c #418d71",
".Lj c #418dc7",
".Qh c #418fcf",
".Qi c #4191d0",
".FB c #4191e8",
".7A c #422e5f",
".#N c #422fbd",
".GR c #42344b",
"#J# c #423b4d",
".Eu c #423c3c",
".Ev c #423d44",
".7t c #423d7f",
".n5 c #423eb6",
"#vP c #42437b",
"#e8 c #424384",
"#er c #4243a0",
"#cQ c #424475",
"#fM c #4244a9",
"#Td c #424848",
"#BT c #42487a",
"#N2 c #42495c",
"#zp c #424975",
"#XS c #424a5d",
"#Gr c #424a7b",
".mT c #424ac7",
"#QA c #424c58",
"#dg c #424cab",
"#fI c #424cae",
".8d c #424ec4",
"#ry c #424f86",
"#b5 c #4251b0",
".qm c #4252c3",
"##F c #4253c9",
".84 c #425496",
".4m c #4255b3",
"#Tg c #425654",
".9e c #4257b2",
"#EH c #425a88",
"#.B c #425ac4",
"#.r c #425ac6",
".7. c #425ad4",
"#IT c #425da2",
"#m# c #425dac",
".7P c #4261bc",
".7d c #4261d6",
".w# c #4262c9",
".9D c #4262d3",
"#TA c #426466",
"#GZ c #426579",
".52 c #4265db",
"#jK c #4266ba",
"#CF c #426794",
"#YH c #42686b",
"#K6 c #42687b",
".xn c #4268cb",
"#Yb c #426a48",
"#ZO c #426a6c",
".YK c #426bd4",
"#Sp c #426d52",
"#G7 c #426d8d",
"#UW c #426f6c",
"#TQ c #426f74",
"#Wz c #4270a4",
"#X. c #427266",
"#16 c #427353",
"#PC c #42756c",
"#Ha c #427590",
".t# c #4275c6",
"#hr c #42768b",
".ta c #4276c9",
".YV c #4276dc",
"#Xq c #427882",
"#2K c #427976",
"#gd c #427a8b",
".tc c #427ad1",
"#tc c #427ca1",
"#nl c #427d8b",
"#Zw c #427e48",
".NC c #427fd0",
".TR c #4284d0",
".Iz c #4286d1",
".Hp c #4286d9",
".Mz c #428ad4",
".Lq c #428dc4",
".Ml c #428eca",
".8O c #432656",
".6n c #432855",
".n4 c #4339b3",
"#ld c #433b6c",
"#MV c #433d5f",
"#sc c #433e76",
"#nv c #434172",
"#AD c #434284",
"#yc c #434576",
"#Kv c #434760",
"#fF c #4347a8",
"#ak c #434888",
"#yb c #434a76",
".8e c #4352d1",
"#dj c #4354bc",
"#O4 c #4357c8",
".YG c #4358c1",
"#FM c #43597e",
".7# c #435bd5",
"#2g c #435d6a",
"#it c #435db4",
".rl c #435dce",
".3s c #435fdd",
"#Tz c #436082",
".tK c #4361cf",
"#bp c #4363ca",
".8q c #4363d4",
"#CG c #436499",
"#yr c #436588",
".5X c #4365e3",
"#VZ c #43665f",
"#Ys c #436a4d",
".yz c #436dd3",
"#R. c #436f58",
"#zS c #436f96",
"#cI c #437099",
"#1e c #4370ab",
"#Nh c #437167",
"#PA c #43716e",
"#bs c #43718b",
".x5 c #4372c2",
"#Sz c #43739b",
"#F1 c #437580",
".qH c #4378d6",
".8E c #4379a7",
"#Ms c #4379c1",
".DY c #437ade",
"#ZD c #437b54",
".U8 c #437cd3",
"#cG c #437d95",
".46 c #4383c0",
"#Zu c #43844c",
"#P3 c #43867d",
".TT c #4388d3",
".Rv c #438bd3",
".Ln c #438cc1",
".Mt c #438cd0",
".Rw c #438dd4",
".Lp c #438ec5",
".Qj c #4392d4",
".O6 c #4392dd",
"##e c #442d63",
".Ko c #443647",
"#q3 c #444176",
"#fL c #4443ab",
"#qZ c #444573",
"#w2 c #444679",
"#.e c #4448a9",
"#w1 c #444a7a",
"#fG c #444aac",
"#zo c #444b75",
"#Ft c #444b77",
"#w0 c #444b79",
".oZ c #444bcd",
".qk c #444fb9",
"#ew c #4450b6",
"#wl c #44517d",
"#hT c #445281",
"#Ez c #445580",
".p9 c #4456d2",
"#dk c #4457c0",
"#co c #445ad1",
"#AV c #445b87",
".Xr c #445cbe",
"#FN c #445d7b",
"#k0 c #446183",
".u2 c #4461c9",
".tL c #4462d0",
"#GX c #446377",
"#wT c #44647b",
"#TH c #44696f",
"#bv c #446b94",
".Wu c #446bae",
".u6 c #446bc8",
".tC c #446be0",
".wR c #446dbc",
"#St c #446e6a",
".ze c #446fcb",
"#Wq c #447385",
".CQ c #4474d8",
"#Mj c #447a7a",
"#ah c #447a94",
"#W1 c #447b42",
"#ow c #447e8a",
".JX c #447fcd",
"#Op c #448064",
".ND c #4481d1",
"#Oq c #448366",
".zJ c #448aea",
".My c #448cd4",
".Lo c #448dc2",
".Mv c #448dd2",
".Rx c #448ed7",
".Y2 c #452346",
".eM c #4538a1",
"#dX c #454689",
"#l# c #454777",
"#oD c #45487b",
".n6 c #4548bd",
".n7 c #454abf",
"#k9 c #454b7b",
"#WD c #454f58",
"#QD c #455054",
"#rx c #45548d",
"#rw c #455590",
".eh c #4557bd",
"#R2 c #45585c",
"#f1 c #4559bc",
"#AS c #455b8d",
"#dB c #455bca",
".aS c #455be2",
"#TJ c #455d8d",
"#hh c #455fbc",
".Xq c #4561c2",
"#I# c #456574",
"#Sl c #45657e",
"#bw c #456598",
"#ix c #4565bc",
"#Rp c #4565ca",
"#CE c #456794",
"#Yu c #456a70",
"#yt c #456b92",
".YO c #456bd8",
".zf c #4570cc",
"#Wy c #4572ad",
".Gl c #4572c7",
".uL c #4573e3",
"#ox c #457486",
".BD c #4574d0",
"#M. c #45754d",
"#PI c #457a60",
".tb c #457bd1",
".CP c #457bdf",
"#PL c #457d60",
"#Wo c #457d96",
"#13 c #458145",
"#jP c #458295",
"#V. c #4585a8",
".Mj c #458ad8",
".Mq c #458bd1",
"#P0 c #458c6e",
".FC c #458de1",
".Mu c #458ed2",
".O5 c #4593dd",
".nQ c #4638c1",
"#LB c #464155",
".FL c #46454a",
"#WU c #46454d",
"#GL c #46457e",
"#ao c #464773",
"#jV c #464883",
"#hv c #464974",
".MN c #464a3c",
"#Ji c #464f78",
"##J c #4651ba",
"#a3 c #4654d7",
"#hd c #4655bc",
"#Ai c #46579f",
".mo c #4657c3",
".3x c #465ad3",
"#b8 c #465bc4",
"#O7 c #465bd8",
".3v c #465cc9",
"#E1 c #465d89",
"#eT c #465ec0",
".66 c #465ed8",
".3A c #465eda",
".9U c #466093",
"#hg c #4660bd",
".3t c #4660db",
".7b c #4661d6",
"#Z3 c #46639b",
"#DO c #46649a",
"#Xv c #466697",
"#bq c #4666cd",
"#W7 c #466858",
"#iy c #4668bf",
".50 c #4668e3",
".51 c #4669e1",
"#SD c #466ab4",
"#me c #466c83",
"#1n c #466c99",
"#Rr c #466cd9",
".YN c #466fdb",
".9T c #46719b",
".Aq c #4671d7",
"#td c #467390",
"#k1 c #46748e",
"#.5 c #467797",
".U3 c #467ac5",
"#2G c #467d84",
"#Lb c #467d9b",
".Mf c #4683d4",
".Eq c #4687e3",
"#NE c #468bb4",
".Ru c #468cd2",
".Mo c #468cd4",
".Mr c #468fd3",
".O4 c #4694de",
".Lh c #469ccd",
"##d c #473f7b",
"#mh c #474073",
"#fE c #4748a5",
"#HQ c #474a59",
"#ex c #4754bd",
"#.E c #4756cb",
".ry c #4758c4",
"#Uv c #475b5c",
"#bx c #475c9d",
"#VR c #475e58",
".tP c #475ec8",
"#AW c #475f8b",
"#AX c #476089",
".4I c #4760de",
"#eS c #4761c2",
".67 c #4761da",
".qp c #4763d1",
"#05 c #476460",
"#Cf c #476486",
"#aj c #476597",
".ZV c #4767d4",
"#CC c #476891",
"#Q3 c #47694e",
"#Q5 c #476973",
".07 c #4769d7",
"#Ia c #476a6e",
"#CD c #476a92",
"#zL c #476a94",
".pn c #476ad2",
"#Ib c #476c75",
".po c #476cd4",
"#Vi c #476dac",
".qs c #476dd8",
".AQ c #476dda",
".x2 c #476ebd",
"#Sm c #476f66",
"#e7 c #477090",
"#G8 c #47709c",
".pq c #4771d3",
".YL c #4772db",
"#K8 c #477582",
".4b c #4775c3",
"#Sq c #477751",
"#U2 c #477769",
"#Xa c #477960",
"#Wk c #477976",
".E8 c #477ee2",
".te c #477fdc",
"#OJ c #47805d",
".Nt c #4780cf",
".U7 c #4784d7",
".TQ c #4785d0",
".Ge c #4786e3",
"#Mf c #478874",
"#Mn c #47888a",
"#K4 c #478a9b",
".Mk c #478cda",
".Mn c #478dd2",
".Mm c #4791d0",
".Qg c #4793d1",
"#0M c #47974e",
".Lz c #484443",
"#LH c #48445f",
"#bF c #484572",
"#bA c #484a83",
"#pN c #484b80",
".mS c #484dcb",
"#vO c #484e80",
"#eu c #484eb0",
"#Vp c #485063",
"#nE c #485081",
"#ev c #4851b6",
"#RX c #48524a",
"#f4 c #4858b8",
"#gg c #485f81",
"#yp c #485f89",
".8p c #485fd3",
"#dC c #4860ce",
".3r c #4860dc",
"#Uz c #48625f",
".v9 c #4862c3",
"#VT c #486561",
"#Hl c #4866ac",
"#CB c #486891",
"#Mw c #486ec1",
"#SE c #4870b5",
".u7 c #4874d5",
"#bu c #487594",
"#TP c #487674",
"#W# c #487683",
"#mb c #48768d",
"#bt c #487791",
".qF c #4879d5",
".NU c #487ccf",
".ur c #487cd2",
".zN c #487de3",
"#18 c #488051",
".FD c #4882cb",
".rX c #4882d6",
"#dU c #4884a0",
".TV c #4885c8",
".SG c #4888d2",
".1p c #4889c9",
".K7 c #488ccb",
".SC c #488dd0",
".Rt c #488ed4",
".O3 c #4895dd",
".Y4 c #493443",
".RF c #493f48",
"#q5 c #494075",
"Qtd c #4941a8",
"#j1 c #494275",
"#zr c #494b7e",
"#QF c #495352",
"#jX c #495376",
".xd c #495591",
".8c c #4955bb",
".el c #4956be",
"#f3 c #4959bb",
"##Y c #495ed1",
".qn c #4960d0",
".xl c #4961c3",
".6C c #4962c6",
".7c c #4964d9",
"#Ro c #4967c9",
".2m c #4967df",
"#1P c #496942",
"#VO c #49695a",
".v3 c #496acb",
".wa c #496ad1",
"#Q6 c #496f7a",
"#1u c #497077",
"#0C c #497248",
"#Ni c #497371",
"#k4 c #497389",
"#ag c #49798f",
"#Ss c #497a5d",
"#Sw c #497d8b",
"#PX c #497f5d",
".Va c #4980c1",
"#Mr c #4981bc",
".Ns c #4981ce",
"#iE c #498295",
".NB c #4983d5",
"#P9 c #4984bc",
"#Wn c #4986a2",
"#k3 c #498796",
".SF c #4989d3",
".SK c #498cda",
"#P1 c #498e79",
"#Mg c #498e7c",
".Mp c #498fd7",
".FH c #4a403f",
"#pR c #4a4176",
".Kr c #4a454c",
"#Oe c #4a475a",
"#tk c #4a4982",
"#RG c #4a4b50",
"#MK c #4a4b5d",
"#AG c #4a4b81",
".iU c #4a4fc4",
".aC c #4a50ca",
"#ya c #4a517b",
".pe c #4a51c3",
".#Z c #4a55e3",
"#oP c #4a5686",
"#Ew c #4a568a",
"#he c #4a57bd",
"#EF c #4a5c8c",
"#f2 c #4a5cbe",
".3z c #4a5edb",
".9C c #4a61d5",
"#Yl c #4a635f",
"#Sv c #4a678f",
"#ma c #4a6986",
"#Ch c #4a6a91",
"#Su c #4a6d83",
"#SP c #4a6dad",
"#Ck c #4a6e90",
".8F c #4a6ea2",
".pp c #4a6fd7",
"#PQ c #4a716c",
".vF c #4a74c6",
"#M# c #4a7a60",
"#EO c #4a7a90",
"#F8 c #4a7aaa",
"#Q8 c #4a7b5d",
"#PM c #4a8162",
"#P5 c #4a81c4",
".E7 c #4a81e5",
"#Xr c #4a8283",
"#cF c #4a8299",
".Nu c #4a83d2",
".Me c #4a84d6",
".CS c #4a86dc",
".TU c #4a87ca",
".NE c #4a88d5",
"#jQ c #4a8b9d",
"#OR c #4a8ba9",
".SB c #4a8ecf",
".zL c #4a8ef3",
".Mc c #4a8fd0",
".JL c #4a90d6",
"#L. c #4a9195",
".SD c #4a91d3",
".O2 c #4a94db",
".Qf c #4a96d4",
"#Nx c #4a997a",
"#q4 c #4b447a",
"#hC c #4b467c",
"#LI c #4b4863",
".pd c #4b4ec1",
"#mj c #4b5181",
"#c8 c #4b5298",
".rv c #4b55ce",
".rw c #4b56cc",
".9i c #4b58b4",
"#LR c #4b5a5f",
".9z c #4b5acf",
"#yo c #4b5b7d",
"#.C c #4b5bbd",
".tQ c #4b5cc6",
".3y c #4b5dd9",
".T2 c #4b5ec4",
".3w c #4b5fd8",
"#Tq c #4b6061",
"#vH c #4b6281",
"#1Q c #4b6750",
".Xt c #4b67c8",
"#Ce c #4b6886",
".2l c #4b68de",
"#Qg c #4b69ed",
".T3 c #4b6ec0",
"#DB c #4b6fc7",
".wc c #4b71d6",
"#Xg c #4b754f",
"#.6 c #4b759f",
"#Wf c #4b767f",
"#ou c #4b7689",
".YM c #4b76df",
"#TN c #4b7979",
".up c #4b7bcf",
"#It c #4b7c80",
"#Cr c #4b7c9a",
".Df c #4b7cd9",
".AX c #4b7ddc",
"#ov c #4b7f8d",
"#Xs c #4b7f94",
"#P4 c #4b7fb8",
"#PN c #4b815f",
"#Nv c #4b8262",
".Vf c #4b82d5",
".Wr c #4b83d0",
".TP c #4b84d1",
".BF c #4b86d6",
".U6 c #4b88d8",
".TW c #4b8acd",
"#oG c #4c487b",
"#Ef c #4c4a71",
".pc c #4c4bc0",
"#Jg c #4c5076",
".9V c #4c528e",
"#WC c #4c5662",
"#QI c #4c5751",
".9x c #4c57cd",
".tR c #4c58c4",
".q. c #4c58d2",
".8i c #4c5ad4",
"#.l c #4c5fae",
"#EG c #4c6198",
".3u c #4c63d5",
"#Pv c #4c6456",
"#Dq c #4c647e",
".u3 c #4c64ce",
".68 c #4c64e0",
"#Tx c #4c6876",
".7s c #4c69a5",
".ZW c #4c6cd9",
"#IF c #4c6d90",
".ZS c #4c6dd6",
"#1N c #4c6e55",
"#04 c #4c6e6d",
"#zK c #4c6f97",
".wd c #4c6fd5",
"#Rq c #4c6fd7",
"#Qc c #4c70e0",
"#1g c #4c71a8",
".xo c #4c72d5",
".qt c #4c75df",
"#Wv c #4c76a6",
"#OB c #4c7a3a",
"#Rf c #4c7b8d",
"#2C c #4c7bc1",
"#FZ c #4c7d8c",
"#EN c #4c808e",
"#K5 c #4c8096",
".zi c #4c80d4",
".TO c #4c81cd",
".CO c #4c82e2",
".E6 c #4c82e6",
".U9 c #4c84db",
"#Yp c #4c8564",
"#P8 c #4c89c8",
".K4 c #4c89cc",
".Ho c #4c89da",
"#2. c #4c8a65",
"#Nw c #4c8a7b",
"#OQ c #4c8b9d",
".SE c #4c8cd4",
".SH c #4c8ed8",
"#Nz c #4c9085",
".Qe c #4c98d4",
"#HW c #4d455c",
"#HV c #4d455d",
"#MW c #4d4964",
"#.f c #4d5198",
".tT c #4d5aca",
".8j c #4d5bd5",
"#.L c #4d5cd1",
".tU c #4d5dcc",
"##I c #4d5ec6",
".rz c #4d60c6",
".xm c #4d61c2",
".rm c #4d61d2",
"#EA c #4d627d",
".8o c #4d64d8",
"#pE c #4d65bb",
".4H c #4d65df",
".6g c #4d66a8",
".ZR c #4d69d4",
".sz c #4d69d7",
".ZU c #4d6fda",
"#Ti c #4d705c",
".wb c #4d70d6",
".x1 c #4d72c2",
"#Yt c #4d7654",
".vY c #4d7acf",
"#Ve c #4d7bac",
"#XG c #4d7d71",
"#nk c #4d7e8f",
"#Sr c #4d7f59",
"#Re c #4d8084",
"#PJ c #4d856c",
".Nr c #4d85d2",
"#Ox c #4d8666",
".UX c #4d88d4",
"#Os c #4d8c6f",
"#P2 c #4d9182",
".Rs c #4d92d7",
".Rp c #4d95d0",
".Y7 c #4e2045",
".Wz c #4e3b69",
"#at c #4e3f78",
".mH c #4e3fd0",
"#oI c #4e4679",
"#nq c #4e467f",
"#sd c #4e477d",
"#MO c #4e4862",
".o0 c #4e49c9",
"#pM c #4e4b80",
"#Ek c #4e4d89",
".mR c #4e4dcd",
"#LJ c #4e4e66",
"#jZ c #4e4f87",
"#ns c #4e5184",
"#aY c #4e51c2",
"#Pe c #4e5275",
".NZ c #4e5452",
"#mv c #4e5484",
"#Pm c #4e5663",
"#fH c #4e56b9",
"#H5 c #4e5792",
"#zC c #4e5d86",
".ty c #4e5ee5",
".65 c #4e62dd",
"#VS c #4e6763",
".9# c #4e68bf",
".YE c #4e69d0",
"#Jq c #4e6e69",
"#0B c #4e6f5a",
"#LW c #4e715b",
".Vh c #4e71b5",
"#Qd c #4e71e7",
"#nj c #4e728a",
".yA c #4e72d3",
"#2F c #4e7a93",
"#Wt c #4e7a95",
"#Yn c #4e7c58",
"#0f c #4e7d9b",
".t. c #4e7dcd",
"#PS c #4e7e66",
"#hs c #4e7e92",
"#YY c #4e86ab",
".Gd c #4e86dd",
".td c #4e87de",
".UY c #4e8cd9",
"#Np c #4e8d58",
"#ND c #4e93b4",
".Rq c #4e96d1",
".Qd c #4e98d5",
".n3 c #4f3fbb",
"#nx c #4f477a",
"#oH c #4f487b",
"#oB c #4f4a84",
"#ML c #4f4d62",
"#X9 c #4f4f35",
"##L c #4f53be",
"#uy c #4f548b",
"#oC c #4f5587",
"#li c #4f5684",
".rx c #4f5cce",
"#Tf c #4f5d60",
"#zD c #4f6596",
".ZQ c #4f67d3",
"#Jr c #4f696a",
".2k c #4f69e0",
".zd c #4f6dcf",
".Wv c #4f6ea5",
".ZT c #4f70db",
"#Qf c #4f70f1",
"#A1 c #4f7290",
"#1t c #4f7383",
"#Wx c #4f78b6",
".Wd c #4f79cf",
"#Q7 c #4f7a73",
"#br c #4f7b96",
"#NA c #4f7bac",
".BC c #4f7bde",
".uo c #4f7ece",
"#Ol c #4f806d",
".TN c #4f80cd",
".DX c #4f80e7",
"#Ra c #4f865f",
".A1 c #4f88cb",
".Nv c #4f88d9",
".3R c #4f91ce",
".Ro c #4f95d0",
"#mo c #504a7a",
"#GM c #504e8f",
"#GN c #504f93",
"#H1 c #505084",
"#H4 c #505493",
"#U. c #505558",
"#vZ c #505662",
"#fj c #505783",
".Et c #505968",
"#gj c #505980",
".ql c #505dcd",
"#hf c #505ec1",
".9q c #505ec9",
".9d c #5066bc",
"#E. c #506775",
"#FJ c #50688e",
"#A0 c #506c94",
".zD c #5072cb",
".qr c #5072de",
".Ap c #5076d7",
"#Ux c #507764",
"#XJ c #507b9b",
"#T2 c #507bc0",
"#Xt c #508096",
"#PW c #508163",
"#2B c #5083c4",
".V# c #5083d6",
"#jR c #50869e",
".AY c #5087da",
".NV c #5087e4",
".SA c #508fd2",
".RH c #51152e",
".0l c #512443",
"#iS c #512a3f",
"##f c #513565",
"#se c #51487f",
"#lc c #514b7b",
".FG c #514f5c",
"#Fx c #514f90",
"#Tc c #515554",
"#l. c #515585",
"#Jh c #515882",
".8L c #515988",
"#ft c #515ba3",
".9j c #515bb0",
"#.A c #515fc0",
".9Z c #516194",
".9n c #5167bc",
".YB c #5167cc",
".w. c #516ac7",
"#Zm c #516b48",
"#Ty c #516b90",
"#YR c #516e72",
"#Cg c #516f95",
"#J7 c #516fb8",
"#TI c #51708d",
".GO c #5171ae",
"#1O c #51744c",
"#1o c #517597",
"#Vd c #51789f",
"#PR c #517978",
".U1 c #5179d0",
"#Nk c #517d6c",
".U0 c #5180d2",
".E5 c #5183e4",
"#K9 c #518c9c",
"#0g c #518cae",
".Iy c #5191d9",
".K6 c #5192d4",
".Rr c #5196db",
"#OL c #51987a",
"#OP c #51a184",
"#aE c #522777",
"Qtv c #522cb3",
"#aH c #523762",
"#pS c #52487d",
".mQ c #524bcd",
"#am c #525491",
"#bT c #525a99",
"#fl c #525b92",
"#ei c #525b9c",
"#M1 c #525c5e",
"#by c #5260a7",
"#a2 c #5260e5",
".YA c #5261c8",
".u4 c #5264d0",
"#rv c #5265a0",
"#B6 c #52689a",
".sK c #526dd6",
".yB c #5270d2",
"#J6 c #5272bb",
".we c #5272d9",
"#cJ c #5276aa",
"#Uy c #527766",
".xp c #527ada",
"#TR c #527e87",
"#TO c #52807d",
"#R# c #528365",
".V. c #5283e2",
".Nw c #528bdc",
"#e5 c #528ca0",
".O8 c #528ccc",
".K5 c #528fd2",
".T0 c #5292d9",
".SJ c #5296e1",
"#Nq c #529754",
".2E c #5298cc",
".O1 c #529ae4",
"#Mm c #529c8d",
"#0L c #529f5b",
".6o c #53335c",
"#Lz c #534a65",
"#ye c #534f82",
".sE c #534fc7",
"#Pq c #535562",
"#N0 c #535665",
"#gu c #53568d",
"#k8 c #535989",
"#Pl c #535b68",
"#hy c #535d81",
"#Ex c #535e94",
".8a c #535fa9",
"#.D c #5361ca",
"#B8 c #536394",
"#B7 c #536396",
".u5 c #5364d0",
".ys c #5369b2",
".5W c #536de8",
".sL c #536ed5",
".Xp c #5374d1",
".FE c #537ab3",
"#Xc c #537b73",
"#U3 c #53806c",
"#M9 c #53836b",
"#Ov c #538466",
"#iF c #53859c",
".Er c #5388ce",
".Nq c #538ac3",
"#Rd c #538c7d",
".SI c #5395e1",
".zK c #5399fb",
".O0 c #539be5",
".Qc c #539ddc",
".nR c #5443cd",
"#fe c #544473",
".6h c #54488a",
"#nw c #544d80",
"#mn c #545082",
"#Lx c #545365",
".qj c #5459bf",
"#aZ c #5459cf",
".Ez c #545c69",
"#bR c #545c9b",
".tS c #545cc7",
".9h c #545fb9",
".9y c #5460d6",
"#aV c #5461c7",
".q6 c #5463d8",
"#rb c #54678f",
".9A c #5468db",
".T4 c #5469aa",
"#2v c #546a9c",
".2i c #546fe4",
"#Oi c #547061",
".qq c #5472e0",
"#Tj c #547665",
"#Qe c #5476f2",
"#0. c #5477a1",
".SP c #5477d1",
"#PP c #547b5c",
"#Wr c #547f8f",
".SO c #5480df",
".Wc c #5482d7",
".TM c #5483d1",
".rD c #5483d3",
".qE c #5487e0",
"#JI c #54896b",
"#Ow c #54896d",
".NW c #5489e5",
".IF c #548bcc",
"#K1 c #548c9d",
".Nx c #548cdf",
".Sy c #548dd0",
"#Rb c #548e66",
".Sz c #548fd1",
".Qb c #549bdb",
".Ms c #549edf",
".mI c #5544d0",
"#tn c #554e84",
"#lb c #555281",
"#Of c #555462",
".#p c #5558b9",
"##K c #555ac0",
"#pZ c #556692",
"##W c #5566d8",
".8l c #5568de",
"#ED c #556970",
".5V c #556de7",
".9. c #556ec8",
".2j c #5570e5",
"#VY c #557367",
"#FO c #557488",
"#VU c #557570",
".4# c #5575d8",
".06 c #5575e4",
"#x4 c #55798f",
"#Q2 c #557a4e",
".xq c #557cdb",
".qu c #557ee8",
".u8 c #5580df",
"#2a c #558180",
"#1r c #55819a",
".s9 c #5583d1",
".BB c #5583e1",
".O7 c #5585cd",
"#KZ c #558b71",
".UZ c #558cdc",
".NA c #558dda",
".BE c #558de0",
"#PV c #55915e",
".Rn c #5597d3",
".OZ c #559ae5",
".2N c #562e46",
".MQ c #564148",
"#X3 c #564e65",
".pb c #5653c8",
".FM c #56555d",
"#LO c #565769",
"#NZ c #565968",
"#T8 c #565c50",
"#Te c #565c5c",
"#Zi c #566663",
"#WP c #56686a",
".8m c #5669df",
".rC c #566fc9",
"#Dt c #567095",
"#1M c #56716c",
"#Tv c #56765f",
"#UN c #567675",
"#UL c #567766",
"#UM c #567868",
"#YU c #567882",
"#YD c #567972",
".CN c #567cdd",
"#CW c #56808e",
".Jy c #568bcd",
".rW c #568ce2",
".Ve c #568ed8",
"#Me c #569582",
".OY c #569ae3",
".Qa c #569bdc",
".0h c #573448",
".0g c #573455",
".Ks c #573f4c",
"#zs c #575587",
".Vm c #575789",
"#Lw c #575968",
"#N1 c #575d6d",
"#nr c #575d8f",
".ru c #575fc1",
"#WQ c #57616b",
".RN c #576192",
".63 c #5763d3",
"#.J c #5764d7",
"#VP c #57666b",
"#an c #57669d",
"#Hm c #576da6",
".rB c #5770cc",
"#Tw c #57776c",
"#A2 c #577a9a",
".JR c #577fba",
"#2b c #578278",
"#1s c #578295",
"#ge c #57869a",
".U2 c #5787d1",
".UW c #578ad9",
".qD c #578ae3",
"#YZ c #578bb3",
".Ny c #578ed1",
".Nz c #5790d7",
"#Md c #579679",
".OX c #579be4",
"#OO c #57a78c",
".mL c #5847cb",
".Vl c #584f7a",
"#mp c #585081",
"#w4 c #585187",
"#iQ c #585282",
".Ex c #58585a",
"#.8 c #585898",
"#.g c #58598f",
"#SW c #585a55",
"#mi c #585e90",
"#QG c #586160",
".8k c #5868e1",
"#Ca c #586994",
"#Ds c #587092",
"#pD c #5870c6",
".XK c #5873a8",
"#G1 c #587583",
"#Tu c #587863",
".6D c #5878cf",
"#Vk c #587bbf",
".wP c #587dc4",
"#Vj c #587ebf",
".vE c #5881d0",
"#Pz c #588281",
"#e6 c #5887a1",
".rE c #5887d5",
"#dV c #5888ac",
"#He c #588a91",
".Sx c #588dd1",
"#XD c #588e90",
"#On c #588f78",
".U4 c #5890db",
".O9 c #5894ca",
".Rm c #5899d3",
".30 c #592943",
".32 c #592d3c",
"#lf c #594a83",
".aZ c #594cda",
"#q6 c #594f84",
"#al c #595295",
"#Ly c #59546b",
"#C8 c #595b94",
"#FI c #596891",
".FF c #59698b",
".Xs c #596dd0",
".sA c #596edb",
"#FK c #597099",
"#JR c #597291",
".2h c #5974e9",
".YC c #5975d9",
"#nn c #597894",
".xr c #597bdc",
".We c #597cd6",
"#Ww c #5983bd",
"#Nj c #59847b",
"#dW c #5984ae",
".Gc c #5989dd",
"#Sx c #598ca1",
".A2 c #598cdd",
".A0 c #5995d4",
"#Mk c #599c93",
".OW c #599ce3",
".Q# c #599ddc",
".Pd c #5a2537",
"Qtw c #5a27c2",
".LD c #5a4a54",
".mP c #5a4acf",
"#J. c #5a4e66",
"#d2 c #5a5c8d",
"#H2 c #5a5c95",
".sJ c #5a5cc0",
".8b c #5a64bb",
".64 c #5a68e2",
".8n c #5a6fe4",
".rA c #5a71d1",
"#AZ c #5a739c",
".zc c #5a74d5",
".05 c #5a78e8",
"#2E c #5a7caa",
".ML c #5a7cc4",
"#1m c #5a83b9",
"#Ou c #5a8663",
".s8 c #5a88d5",
"#Ip c #5a8e99",
".AZ c #5a92dc",
".U5 c #5a95e1",
".OV c #5a9de4",
".mJ c #5b49d3",
"#HT c #5b516c",
".WA c #5b5386",
".GW c #5b565d",
"#cR c #5b5885",
"#AH c #5b5b8f",
".Qz c #5b5d84",
"#KD c #5b6475",
"#Dk c #5b6799",
".MM c #5b6c7e",
"#Cc c #5b6d95",
".3b c #5b6fd0",
".4G c #5b6fe2",
".9B c #5b70e5",
".ZP c #5b72dc",
".47 c #5b74b6",
"#1p c #5b77a7",
".YD c #5b78dc",
".Ao c #5b7ad7",
".Es c #5b7ba4",
".E4 c #5b86e2",
".zO c #5b8bef",
".Ju c #5b8cd1",
".rU c #5b8de2",
"#PT c #5b9366",
".Hn c #5b94e3",
".Rl c #5b97d3",
".TX c #5b9adf",
".Mb c #5b9dda",
".JK c #5b9ee2",
".5f c #5c2737",
".1z c #5c2f46",
".#L c #5c36c1",
"#to c #5c5189",
"#.9 c #5c5598",
".Di c #5c5976",
"#Kz c #5c5c7e",
".Ey c #5c5f64",
"#H3 c #5c609d",
"#d1 c #5c6391",
"#Pj c #5c656c",
"#O5 c #5c6de1",
".4l c #5c6ed0",
".wf c #5c74de",
".sM c #5c7adc",
"#0A c #5c7b69",
"#Vl c #5c7ec5",
".wO c #5c7fc3",
".yC c #5c7fd9",
".DW c #5c80e1",
"#V3 c #5c8170",
"#1q c #5c82a6",
"#0b c #5c86b0",
"#Yg c #5c9261",
".Jz c #5c92d2",
".qC c #5c94df",
"#La c #5c96ae",
"#Rc c #5c9777",
".KZ c #5c9ad3",
".1x c #5d2b50",
".5d c #5d3152",
".2L c #5d3243",
".1w c #5d3a40",
".LE c #5d3c47",
".sF c #5d4cb4",
"#sf c #5d5388",
"#LA c #5d556d",
"#hB c #5d5e94",
"#QH c #5d6663",
".Ly c #5d687a",
"#eg c #5d6a96",
"#B5 c #5d6b9a",
"#.w c #5d6dcf",
"##X c #5d6ee2",
"#FL c #5d739a",
"#r7 c #5d7694",
"#GW c #5d7895",
"#0# c #5d7aa2",
"#Z4 c #5d7cab",
".Wg c #5d81d5",
"#JF c #5d887f",
"#JK c #5d9385",
"#PU c #5d9764",
".OU c #5d9de5",
".Re c #5d9ed6",
".Q. c #5d9ede",
"#Ml c #5daa96",
"#L# c #5dab9d",
".7B c #5e345c",
".n2 c #5e48c6",
".Jg c #5e4d53",
".o1 c #5e4eca",
"#uB c #5e5491",
"#zt c #5e5b8a",
".9g c #5e64ba",
"#.x c #5e68c7",
"#Dl c #5e6a9a",
"##H c #5e6ace",
"#xy c #5e6c89",
".9o c #5e6dbe",
"#B9 c #5e6e9f",
"#Tr c #5e6f76",
"#EY c #5e6f8b",
".3q c #5e6fe1",
"##w c #5e70ae",
".Na c #5e7295",
"#JT c #5e767a",
"#Dr c #5e7893",
"#gf c #5e7d9a",
"#KJ c #5e7e66",
"#0e c #5e819d",
".tA c #5e81e5",
"#G. c #5e82a4",
"#0a c #5e83ad",
"#Ot c #5e8661",
".Ce c #5e86db",
".um c #5e88d0",
".TH c #5e89d8",
"#U4 c #5e8a7d",
"#JO c #5e8fc7",
".Jx c #5e91d3",
"#Ma c #5e926c",
".Rk c #5e99d5",
".Rf c #5e9fd7",
"#j3 c #5f3656",
".93 c #5f3f70",
".XO c #5f436c",
"##q c #5f479d",
"#tp c #5f528a",
"#MN c #5f5671",
".H6 c #5f5a61",
"#Pc c #5f617a",
"#WR c #5f6772",
".62 c #5f67cc",
"#T# c #5f6c63",
".Xn c #5f6dce",
".5U c #5f74eb",
"#Dh c #5f75a7",
".9c c #5f78cc",
".Lx c #5f7fb8",
".un c #5f8bd6",
".rF c #5f8fd9",
"#Yo c #5f9571",
"#Ri c #5f95c4",
"#Zv c #5f9e67",
".P9 c #5f9fdd",
".U# c #602845",
".2M c #602a4e",
".mO c #604ad1",
"##g c #604d7b",
".48 c #605192",
"#GO c #605fa5",
".tV c #6063c4",
"#H6 c #6068a7",
"#Uo c #606b67",
".3c c #606dcd",
".sB c #606ddd",
".5r c #6072c6",
".Nb c #60769f",
".wg c #6077e1",
".x0 c #607ad1",
"#ht c #60829d",
".DV c #6084e5",
"#FP c #60858e",
".qv c #6089d9",
"#U7 c #608e9b",
".qy c #608fdd",
"#Om c #609380",
".Wq c #6096de",
".qB c #6098e3",
".Rg c #609bd3",
"#hG c #61292c",
".XP c #614f77",
"#bG c #615d82",
"#GP c #6160a6",
".q# c #6163da",
"#UA c #616d7b",
"#.K c #616ee1",
"### c #6171a5",
"#.k c #6172aa",
".2g c #6173e1",
"#.t c #6178ea",
".Xo c #617ad7",
"#UO c #617e8e",
".Hw c #617ecc",
".04 c #617fed",
".sN c #6180dd",
"#VV c #61847e",
".TI c #6186d4",
"#VN c #618e71",
"#XF c #61938a",
".St c #6198db",
".5c c #623458",
"#LP c #626171",
"#iO c #62639b",
".RO c #626494",
"#GQ c #6265ac",
"#Pk c #626a75",
"#gD c #626eaa",
"#Jo c #62708b",
".4o c #6274ca",
"#sH c #627ab6",
".Ne c #627ba3",
".TJ c #627cc6",
".3# c #6282d9",
"#1. c #6285a1",
".yD c #6286de",
"#Aw c #6287a4",
"#Py c #628a8c",
"#G3 c #628a92",
"#2D c #628ac5",
".Ix c #6296d2",
".qz c #6296e2",
".Rd c #629fd6",
".XT c #633157",
".1y c #633c57",
".mN c #6347d0",
".mK c #6351d7",
".Pk c #635a79",
".GQ c #635b80",
"#Pr c #636571",
".8K c #636699",
"#GR c #6367b0",
".ZN c #636cd5",
"#gF c #636db4",
"#Dn c #63709a",
"#hu c #637397",
"#b6 c #6373d2",
"#cK c #6380ba",
"#Ba c #63858f",
".SN c #6389de",
".wQ c #638ad5",
".Wb c #6390e3",
"#Sy c #6394b4",
"#Mi c #63968f",
".Rj c #639bd6",
".P6 c #639ddc",
".P8 c #63a0df",
".N2 c #643e49",
"#uC c #645492",
"#X4 c #645a7d",
"#vR c #645a96",
"Qti c #645dc4",
".Qq c #64606f",
"#zm c #6461a4",
"##G c #646ac8",
"#aU c #646aca",
".60 c #646bbc",
".Yz c #646fd8",
"#Dj c #6471a5",
".9p c #6471cd",
"#.v c #6471cf",
".N# c #647591",
".4F c #6475e1",
".HZ c #6478ab",
"#CX c #647a85",
".Nd c #647aa3",
"#Ax c #647c98",
".6E c #647dd7",
".Vg c #647ed3",
"#x5 c #648096",
"#Z8 c #6481b9",
".If c #6482ca",
".u9 c #6483d6",
"#jS c #6485a8",
".E3 c #6486dd",
".ul c #648cd2",
".zP c #648ef0",
"#Y0 c #6491ba",
"#Y1 c #6492c4",
"#Xb c #649577",
".Rh c #6497ce",
"#YX c #6498ae",
".rV c #6498ec",
".Ss c #6499dd",
".JA c #649bdb",
"#K2 c #64a19a",
".P7 c #64a1e0",
".1v c #653954",
".31 c #653a4e",
".mM c #6546d0",
".3T c #655795",
"#y. c #656297",
".Km c #656b81",
"#iH c #656c9a",
"#jT c #656d9e",
"#gk c #656f93",
"#O6 c #6578ff",
".2f c #6579ea",
"#M4 c #657b78",
".ED c #657bc6",
".Xl c #657cda",
"#EB c #657d89",
".xs c #6581e2",
"#0d c #6586a5",
".DU c #6586e5",
".wh c #658de2",
".TG c #658fe3",
"#JH c #659879",
"#Oy c #659e7b",
".2P c #662939",
".5b c #662c52",
".7v c #66578e",
".ST c #665872",
"#hD c #66608e",
"#wY c #666189",
"#HR c #666378",
"#Jk c #66689b",
".Ja c #66698a",
".ZM c #666fce",
"#C. c #6677a5",
"#IE c #66787a",
".2e c #667bf0",
"#I. c #667d9f",
".BA c #6680dd",
".uk c #668dd2",
"#PO c #668f57",
".Jt c #6690d8",
".qx c #6694e2",
"#VM c #669573",
".rT c #6696ea",
".Jv c #6697da",
"#Ir c #669988",
".Np c #669bd1",
".qA c #669be7",
"#OA c #66a070",
"#Nu c #66a36a",
".94 c #67395e",
"#Kn c #675e73",
"#I7 c #675f74",
".sD c #675fd8",
".9X c #67619f",
"#j0 c #67629a",
"#bz c #6767ad",
"#Uq c #67686a",
".6V c #676ab7",
".9Y c #676ca4",
"##. c #676ca6",
"#RI c #676e5e",
".8. c #676eb2",
".QA c #677494",
"#Zj c #67776d",
".2c c #6778ea",
".9f c #677bda",
"#zY c #678084",
"#iG c #6785a7",
".yE c #678be1",
"#zg c #678ca7",
".Js c #678fd4",
".rS c #6794e5",
"#F3 c #6798a9",
"#F4 c #6799a4",
".rG c #6799de",
"#Iu c #679a9d",
"#Cs c #679ab9",
".Su c #679adb",
".Iw c #679bd5",
".OT c #67a0ed",
".TZ c #67a7ee",
".P3 c #67a8e8",
".2K c #68365c",
".5e c #683a54",
".6p c #683b5a",
".95 c #683d5b",
".o2 c #684fc7",
"#d9 c #685b6f",
".8H c #685d9f",
"#AI c #68689a",
"#bH c #686995",
".0I c #6871bc",
"#Ts c #68727e",
".6U c #6872c7",
".4E c #6873dc",
".76 c #6874ca",
"#Cb c #687aa2",
"#wU c #687d92",
".An c #687dd6",
".Ie c #6880ca",
".s7 c #6885d5",
"#UK c #68887b",
".UV c #688edf",
"#0c c #6890b4",
".A4 c #6891fd",
".qw c #6893e2",
"#Hc c #689a99",
".Jw c #689bdd",
".JB c #689fdf",
"#Rg c #68a2a3",
".OS c #68a3ef",
".OR c #68a3f1",
".P5 c #68a4e3",
".P4 c #68a8e8",
"#hF c #69414c",
"#iR c #695578",
"#uD c #695791",
"#AC c #6968ac",
"#UB c #696d86",
"#RL c #697078",
".77 c #6970be",
".Xm c #6973d5",
".0H c #6974c4",
".5S c #6974e0",
".5T c #6979ea",
"#E# c #697b8f",
".2Y c #697bc5",
".CM c #697bdf",
".2Z c #697dd3",
".zb c #697ddc",
".SM c #6987cd",
"#M8 c #698878",
"#Z9 c #6989bc",
".Ii c #6990d5",
".Ri c #6996cd",
".rR c #6996e7",
"#Hd c #69a282",
".TY c #69aaee",
".6i c #6a528e",
".8I c #6a5e9c",
"#MM c #6a647e",
".9W c #6a64a4",
"#Tt c #6a6f82",
"#.u c #6a6fca",
"#gl c #6a719f",
".6T c #6a72c7",
"#Qv c #6a756f",
"#Dp c #6a789f",
".SQ c #6a7bc1",
"#W4 c #6a7e72",
".2d c #6a7ff4",
".xZ c #6a80d5",
".7Q c #6a82cc",
".3a c #6a84e1",
".wN c #6a8dd1",
".Jr c #6a8ec8",
"#U6 c #6a969f",
".rQ c #6a99e7",
"#Rh c #6aa3b7",
".OQ c #6aa5f3",
".P2 c #6aaae8",
".6q c #6b2e3e",
".1A c #6b3149",
".Vp c #6b3555",
".0m c #6b3956",
".#M c #6b47db",
".n1 c #6b51d0",
"#mr c #6b5c97",
".eN c #6b5cc1",
"#ny c #6b6394",
"#yf c #6b6595",
"#vL c #6b6788",
"#mg c #6b6998",
"#k6 c #6b6d96",
"#T9 c #6b706a",
"#RH c #6b7165",
"#iM c #6b7599",
".ZO c #6b75e4",
"#fr c #6b77ab",
".2b c #6b78e1",
".02 c #6b79e6",
"#FH c #6b7aa5",
".YY c #6b7fba",
".KE c #6b8095",
"#Z7 c #6b86bb",
"#EX c #6b8ac3",
".Ig c #6b8ec8",
"#U5 c #6b9594",
".Rc c #6ba2da",
"#Nr c #6bac94",
".SV c #6c304c",
".3Z c #6c3451",
".WE c #6c3555",
".2O c #6c404f",
".1u c #6c4772",
".MR c #6c4c57",
"#au c #6c5b92",
"#gn c #6c689b",
"#Ec c #6c6a92",
".7K c #6c6fb4",
".si c #6c6ff2",
"#LQ c #6c707c",
".75 c #6c76cd",
".6K c #6c77b7",
".9m c #6c77c6",
".Pl c #6c798c",
".5A c #6c79c8",
".01 c #6c7ae5",
"#C# c #6c7da9",
".LS c #6c7f90",
".Nc c #6c7fa9",
".J# c #6c83ad",
".Nf c #6c8aae",
".yF c #6c8cdf",
".Sv c #6c95d5",
".A3 c #6c98f9",
"#K3 c #6ca3c2",
".7D c #6d242f",
".8Q c #6d2c40",
".WB c #6d5e99",
".RM c #6d6783",
"#Fy c #6d68aa",
"#np c #6d6b9d",
"#Et c #6d6ca5",
".Dj c #6d6d87",
"#cL c #6d6db3",
"#Pd c #6d7091",
".Jn c #6d7170",
"#hA c #6d73a3",
"#M2 c #6d7577",
"#SY c #6d7663",
"#hz c #6d779b",
".Yy c #6d7ae2",
".CL c #6d7eda",
"#Fl c #6d808e",
".FS c #6d80c5",
".9a c #6d87dc",
".s6 c #6d8ada",
".3. c #6d91e5",
"#Wh c #6d92a5",
".wM c #6d93da",
".KY c #6da7d7",
".Vb c #6da7d9",
"#gp c #6e5b7b",
"#pT c #6e6498",
".7y c #6e6590",
"#iP c #6e699f",
".61 c #6e75cf",
".QR c #6e777c",
"#d0 c #6e779e",
".Vi c #6e7db4",
"#UD c #6e7f87",
"#oy c #6e87a5",
".II c #6e92c4",
".Ij c #6e95da",
".NX c #6e97d7",
".Sr c #6e9de1",
".rP c #6e9eea",
"#Hg c #6ea2a0",
".8P c #6f395d",
".0j c #6f456b",
"#gq c #6f4958",
".Jh c #6f545b",
"#le c #6f5890",
".sC c #6f5ed1",
".4B c #6f6cd3",
"Qth c #6f6fc7",
".qi c #6f6fcf",
"#xb c #6f7487",
"#iN c #6f75a5",
".5I c #6f75cb",
".LR c #6f7d97",
"#aK c #6f81c1",
".9b c #6f88dc",
".DT c #6f89e6",
".E2 c #6f8adb",
".Dq c #6f8fd8",
".sO c #6f8fe6",
".Ih c #6f93c5",
".t0 c #6f95e6",
".t1 c #6f96e5",
".Iv c #6fa2d7",
".rH c #6fa2e1",
".JJ c #6fa3d5",
"#Oz c #6fa87d",
".Ma c #6faae2",
".P1 c #6face5",
"#OF c #6fae67",
".rt c #7061b4",
"#oJ c #70669a",
"#oA c #706ba1",
".8J c #706ba3",
".H0 c #706d98",
"#fa c #7077a5",
"#GS c #7077bf",
".Yx c #707adb",
"#Ev c #707cae",
".Hx c #707ec5",
"#M7 c #708177",
".7W c #7081c6",
".sk c #7083e9",
"#UE c #70858a",
"#te c #7087a6",
".1W c #7088de",
".Wa c #7094ea",
".Cf c #7097f6",
".JC c #709bd0",
"#EQ c #70a3a7",
"#Iv c #70a6a8",
".WD c #714266",
".49 c #715a8e",
"#j2 c #715b8a",
"#GF c #716789",
"#KB c #716b91",
"#KA c #716d92",
"#fb c #7173a6",
".6S c #7173c6",
".5y c #7176ad",
".QQ c #717777",
".4u c #7177cd",
"#H7 c #7179ba",
"#Qz c #717b85",
".5G c #717bc2",
".03 c #717ded",
"#Di c #717eb3",
".QB c #71809d",
".EG c #7180df",
".FT c #7184c6",
".NY c #71879f",
".Gb c #718be2",
"#YT c #718d9b",
".Sq c #719ce1",
"#YW c #71a0a8",
".rO c #71a1e9",
".Rb c #71a4d9",
".rL c #71a4e6",
".6m c #724f77",
".7u c #725d9e",
".qa c #7268d9",
"#KC c #727190",
".Jm c #727268",
"#gm c #7273a9",
"#.z c #7276cf",
".0J c #727bbc",
".tZ c #727bd8",
"#Do c #727fa9",
"#UC c #72808b",
"#pJ c #7282a3",
".Xk c #7283dd",
".EE c #7287d8",
".xt c #7289e9",
".1V c #728ce1",
".W# c #728de6",
".Wf c #728feb",
".TF c #7296ec",
".Ik c #7299de",
"#Ws c #729caa",
".rN c #72a4e9",
".rM c #72a5e7",
".OP c #72aaf5",
"#Mh c #72ac9d",
".7C c #73334b",
".Qs c #73354e",
".pa c #7356c4",
".6j c #736795",
"#HS c #736a85",
"#D# c #7375a5",
"#.y c #7377d0",
".74 c #7378cc",
".TK c #737fc7",
".FQ c #737fd1",
".72 c #7381c2",
".5B c #7381cc",
"#UH c #738587",
"#If c #73938e",
".Kl c #7393b9",
".TE c #7393e8",
".TD c #739cdc",
".Il c #739cde",
"#XE c #73a6a1",
".KX c #73a8d2",
"#DE c #73adbb",
".3Y c #742950",
".H7 c #74636d",
"#w5 c #746a9f",
".7w c #746e9e",
".QS c #74818a",
"#Dm c #7481ae",
".4s c #7482da",
".89 c #7483c4",
".CK c #7483e0",
".FR c #7484d1",
".3S c #748dcf",
".uj c #748ed9",
".yG c #748fe0",
".vB c #7497d9",
"#BK c #749db3",
"#1l c #74a0d1",
"#XH c #74a295",
".rI c #74a8e2",
".rK c #74a9dd",
".6r c #75323b",
"#iT c #753d48",
".n0 c #7558d8",
"#vS c #7568a0",
"#pL c #756ea2",
".5H c #7576c8",
"#f# c #757ea5",
".KD c #757f8b",
".Oo c #7580a0",
"#GT c #7580c2",
"#UI c #758288",
"#IB c #7583b2",
".Am c #7584d9",
".S1 c #7586ba",
".EF c #7589e2",
"#BL c #758ba0",
"#GV c #758cb6",
".Ga c #758ee0",
".V9 c #7595ec",
".Sp c #759ce1",
"#YV c #759ea2",
".Cd c #759ee0",
"#XI c #75a2a5",
".JD c #75a3d5",
".rJ c #75aae0",
".P0 c #75ace4",
".EH c #767fda",
".N. c #768298",
"#mf c #7684a7",
"#zh c #7690ab",
".Hh c #7696cf",
".Hi c #769ad4",
".wj c #769ff1",
".wi c #76a0f6",
".KW c #76aacf",
".rn c #7763d6",
"#q7 c #776aa0",
".5P c #7778d5",
".9k c #7779c4",
"#Ps c #777a81",
".R6 c #77818b",
".00 c #7784ea",
".R7 c #778592",
".71 c #7785c2",
".4r c #7787de",
"#GU c #7788c0",
".xY c #7788da",
".7X c #7789cb",
"#UF c #778c8d",
".Or c #778ead",
".JU c #778eb8",
".Os c #778fab",
".KF c #7792ad",
".s5 c #7792e1",
".t2 c #779cea",
"#Wg c #779da8",
".Hj c #779fdc",
".M. c #77a8d1",
".Iu c #77a9da",
".MS c #784652",
".S2 c #786da7",
".6W c #7873b6",
".GP c #7882b5",
"#H8 c #7882c0",
".5F c #7882c7",
".3p c #7884e8",
".v. c #7887cc",
"#KG c #788885",
"#k5 c #7888aa",
".20 c #788bda",
".ui c #7890da",
".Hg c #7895d1",
".Dp c #7896d4",
".wL c #789ae1",
".vC c #789de3",
".UT c #789eef",
".vz c #789fe2",
".Hk c #78a4e5",
".Hm c #78a6f3",
".JI c #78aadb",
".OO c #78aef4",
".Wy c #795480",
".Ji c #795a62",
"#vT c #79689e",
".XQ c #796990",
"#uv c #797397",
"#cS c #79759a",
".xc c #7978b1",
".5R c #797ee4",
".ZL c #797fd5",
".3o c #7980db",
".za c #7984e0",
".EA c #79859f",
"#Zl c #798b7f",
".H# c #7990d4",
".sR c #799ae7",
".sS c #799eef",
".Im c #79a2e4",
".Hl c #79a5ec",
".M# c #79aee0",
".Kt c #7a4d54",
"#oK c #7a609d",
"#nA c #7a6aa8",
".2I c #7a6e94",
".qh c #7a75d1",
".rp c #7a76ee",
"#Ed c #7a78a0",
"#Jl c #7a79b2",
"#Vm c #7a8479",
"#LU c #7a8982",
".88 c #7a8abe",
".W. c #7a8ee7",
".A5 c #7a92d0",
".US c #7a99e9",
"#Z5 c #7a9ac1",
".sT c #7a9fef",
".Vq c #7b3f58",
".3X c #7b546f",
"#mq c #7b639d",
"#GH c #7b7591",
".PA c #7b7c81",
".0Z c #7b85e7",
".3n c #7b8dcd",
".xu c #7b8def",
".EC c #7b8fc1",
".Hf c #7b95d2",
".V8 c #7b95e9",
".B8 c #7b9ceb",
".vA c #7b9ede",
".ON c #7baeef",
".OG c #7bb0e2",
"#Is c #7bb487",
".7x c #7c76a2",
"#qY c #7c76a4",
"#BQ c #7c7fb6",
"#Up c #7c8081",
"#Qx c #7c878b",
".CJ c #7c87e1",
".4c c #7c88d2",
"#H9 c #7c8cc0",
".Ch c #7c91e4",
".Ha c #7c93d6",
".H. c #7c93d7",
".zQ c #7c9bed",
".UU c #7c9bee",
".sQ c #7c9dec",
".t3 c #7ca0ea",
".sU c #7ca1ef",
".OK c #7caeeb",
".PZ c #7cafe4",
".5g c #7d4852",
".XN c #7d527d",
"#nz c #7d65a1",
"#FB c #7d71c3",
".S3 c #7d75ae",
".6k c #7d779b",
"#zu c #7d77a3",
"#WT c #7d7d87",
"#Jm c #7d7db3",
".RP c #7d81ae",
".2a c #7d83e5",
".PB c #7d8592",
".LQ c #7d8598",
".21 c #7d8ed3",
".Id c #7d8fcd",
".1X c #7d8fe3",
".G4 c #7d91ce",
".5s c #7d91d8",
".Cg c #7d91f0",
".G# c #7d93df",
".Ds c #7d93e8",
".A6 c #7d95d5",
"#06 c #7d9693",
".zR c #7d9cec",
".wk c #7d9de8",
".Ip c #7da9e8",
".KG c #7dabc2",
".OJ c #7dafea",
".OL c #7dafee",
"#Ns c #7dc887",
".8R c #7e4556",
".SW c #7e505d",
"#pU c #7e659f",
"#El c #7e78b4",
"#Fp c #7e7a9f",
".5j c #7e7bb4",
".4D c #7e83e9",
".5J c #7e86db",
"#qW c #7e87a8",
".PC c #7e8a98",
".7U c #7e8abc",
".Op c #7e8dae",
".0c c #7e8eca",
".1Y c #7e8edc",
".4p c #7e8fe1",
".DS c #7e8fe7",
".uh c #7e92db",
".zS c #7e9be7",
".Jq c #7e9fca",
".Ng c #7ea0bc",
"#2A c #7eaad7",
".L9 c #7eacd0",
".It c #7eacdd",
".P. c #7eaddb",
".OM c #7eaeec",
".OH c #7eb3e7",
".OF c #7eb4e3",
"#Nt c #7ec384",
".nS c #7f44d2",
".o3 c #7f5dd5",
"#w6 c #7f73a5",
"#.h c #7f7fb1",
".Pz c #7f8084",
".4A c #7f81d8",
"#Og c #7f848a",
".3e c #7f84d8",
".3d c #7f86e1",
".1Z c #7f89d0",
".4q c #7f8fe4",
".E1 c #7f95e1",
".Dr c #7f95eb",
".s4 c #7f9be5",
".sP c #7f9ff2",
".In c #7fabea",
".JE c #7faedc",
".2G c #806b8a",
"#X5 c #807788",
"#Eu c #807fb8",
".LP c #80808c",
".2# c #8081dd",
".0Y c #8083e2",
".Py c #808581",
".4v c #8087df",
".6Q c #8089c0",
".6P c #808abf",
".6J c #808db7",
".5C c #808dd1",
".Oq c #8093b3",
"#UG c #809596",
".G9 c #8097dd",
"#EC c #809a9b",
".He c #809ad7",
".vy c #80a3e5",
".sV c #80a4ee",
".OI c #80b3ec",
".SU c #813a5c",
".LF c #81484f",
".Y8 c #815377",
"#ff c #815d77",
".Qy c #816a84",
".WS c #8176ba",
".Oh c #817c83",
".M4 c #817d8e",
"#Fs c #817da0",
".Zr c #817eb5",
".78 c #8180c4",
"#fs c #818bc6",
".6L c #818dc9",
".PD c #8190a3",
".A7 c #8196d9",
".zT c #8199e1",
"#YG c #81a5a3",
".TC c #81a7e5",
".Ra c #81a9e6",
".Io c #81adec",
".No c #81aed8",
"#OI c #81b591",
".ro c #8278f2",
".M5 c #828095",
"#WS c #828490",
".Dk c #828499",
"#Jn c #8286b3",
".Ia c #82887e",
".Yw c #828adf",
".6Z c #828ed8",
".ug c #8293d9",
".1J c #8294dc",
".Hb c #829ada",
"#Z6 c #829fc9",
".So c #82a8e9",
".vD c #82aaf2",
".Is c #82ade0",
".JH c #82b5e2",
".RG c #833e5d",
".96 c #836a8a",
"#oL c #8373b1",
"#GG c #837c9b",
".4h c #83809f",
".4t c #8384d6",
".Uh c #8386b9",
".4j c #8388bf",
".yr c #8388cc",
".Ui c #838ccf",
".0u c #838fc1",
".R8 c #8390a1",
".Jo c #83919c",
"#JS c #83969c",
".G8 c #8396da",
".yH c #8396e5",
".sZ c #83a7e5",
".sW c #83a8ee",
".KV c #83aacb",
".Nn c #83abcf",
".0k c #845c7e",
"#hE c #84728c",
"#yg c #847ba8",
".5. c #847d9f",
"#Fq c #847ea4",
".Bz c #8480e1",
".3f c #8485d5",
".5x c #8486b9",
".z# c #8488df",
".Pa c #84899f",
".6R c #848ac4",
".M9 c #848b9b",
".xX c #848bdb",
".Al c #848cdd",
".4d c #848ecb",
".xv c #848fdf",
"#Qw c #849084",
".QT c #8491a2",
"#eh c #8491be",
".G. c #8495db",
".t4 c #84a6ed",
".sY c #84a7e7",
".sX c #84aaeb",
".Ir c #84ade3",
".OE c #84bae8",
".Ky c #857791",
"#I9 c #857892",
"#sg c #8578ae",
"#cX c #857c91",
".QP c #85827d",
".5w c #8585a7",
".7G c #8587ae",
"#Eb c #8588ab",
".6I c #858bbd",
".By c #858be3",
"#no c #858eb7",
"#Ea c #8590ac",
".5E c #8590d2",
"#Hq c #85989e",
".LT c #859aaf",
".Dt c #859aed",
".Hd c #859ddb",
"#G2 c #85a5b0",
".Iq c #85aee6",
"##t c #8676a5",
".GX c #867b83",
"#I8 c #867c95",
".M6 c #86838e",
".ZK c #8687d9",
".Vx c #8689b6",
".EI c #868cda",
".T8 c #868dbb",
"#UJ c #868f98",
".On c #8690ab",
".73 c #8690d5",
".1I c #8692c2",
"#Dg c #8694c5",
".va c #8695da",
"#x6 c #8696ad",
".G7 c #869adf",
".UD c #869b92",
"#LV c #869e90",
".Hc c #869edc",
".s3 c #86a0ea",
"#1k c #86aed1",
".KK c #86afdd",
".Qt c #874960",
".rq c #8776dc",
".Vn c #877bbb",
"#s. c #8780a9",
".Og c #87818b",
".3V c #87839e",
".6u c #8784af",
"#AJ c #8785b4",
".5Q c #878aeb",
"#Tb c #878c88",
".Px c #878e87",
".Om c #878fa4",
".5z c #8793b9",
".FU c #8799d9",
".A8 c #8799db",
".6F c #8799e3",
".wl c #879bda",
"#yI c #87a1a0",
".t7 c #87a7e4",
".Nm c #87aaca",
".R# c #87aee9",
".PX c #87b3e4",
".JF c #87b8e3",
".Qm c #87c2ea",
".p. c #8864d2",
"#d6 c #886989",
".3U c #8872a1",
".WT c #887ab5",
".qg c #8880d6",
".M7 c #888691",
".M8 c #888a97",
".R5 c #888f95",
"#us c #888fac",
".5O c #888fdf",
".7V c #8895c9",
".1K c #889aee",
".wK c #88a3e8",
".LW c #88a4c9",
".t6 c #88a7e7",
".LX c #88a8cf",
".PY c #88b3e6",
".KR c #88b4d7",
".nT c #894eda",
".5a c #896a89",
".KA c #897b88",
".KB c #897f87",
".qf c #897fd5",
".FN c #898896",
".9l c #898bd5",
"#RJ c #899184",
".DR c #8991e2",
".F9 c #8997d8",
"#Fm c #8999a9",
".G3 c #8999cd",
".1L c #899aea",
".zU c #899ce0",
".Ot c #899fb7",
".vb c #89a3f0",
".nU c #8a52db",
".rr c #8a68b5",
"#Eo c #8a71cc",
".4z c #8a83d1",
".Oi c #8a8a8c",
"#yn c #8a8ea7",
".10 c #8a8fcf",
".CI c #8a90e6",
".6M c #8a95cd",
".0V c #8a95d3",
".LV c #8aa3c2",
".vc c #8aa4e1",
".vx c #8aa8e8",
".KJ c #8ab5df",
".KS c #8ab6db",
".JG c #8abbe6",
".nZ c #8b5acf",
".Y1 c #8b628a",
".p# c #8b6bda",
"#q8 c #8b72a9",
"#GE c #8b81a3",
".4C c #8b8af0",
"#BW c #8b8dc0",
".1O c #8b8fce",
".Ol c #8b939e",
".Vy c #8b93d1",
".uf c #8b95da",
".G5 c #8ba2e5",
"#YS c #8ba3ad",
".s2 c #8ba3eb",
".Do c #8ba6d3",
".LY c #8bacd5",
".t5 c #8bacef",
".PW c #8bb7e4",
".Ku c #8c4e4f",
".o4 c #8c65da",
".0e c #8c6d8f",
"#lg c #8c7ba8",
"#FC c #8c83d2",
".36 c #8c86cc",
".5# c #8c88a1",
".4f c #8c89cc",
".79 c #8c8acb",
".KC c #8c8b93",
"#C0 c #8c8cb0",
".Bx c #8c90e9",
"#SX c #8c9383",
".Xj c #8c97e7",
".5t c #8c98ea",
".Tl c #8c99a1",
"#Pu c #8c9b94",
".Vz c #8c9bdc",
".3m c #8c9fda",
".nW c #8d59d8",
".U. c #8d7390",
"#pV c #8d7eb9",
".T5 c #8d7fb4",
".WR c #8d84c5",
"#X8 c #8d8583",
"#th c #8d87ab",
".E0 c #8d8bdf",
"#Fo c #8d8daf",
".0A c #8d8ec7",
".5K c #8d8ede",
".Ak c #8d94e4",
".F8 c #8d95d4",
"#M3 c #8d9999",
".Tk c #8d9ba6",
".1q c #8d9cd3",
".Sw c #8da3df",
".s0 c #8da4e8",
".s1 c #8da4ea",
"#2n c #8daecd",
".RB c #8db6f8",
".RA c #8dc0ff",
".Ql c #8dc2f4",
".Pg c #8e3d44",
".LG c #8e484a",
".qb c #8e76e4",
".Yi c #8e83c7",
".LO c #8e848c",
".1P c #8e90c1",
".24 c #8e90cd",
".6H c #8e96bb",
"#C2 c #8e96bd",
".5D c #8e9cdd",
"#Zk c #8e9d9a",
".TB c #8eb1e9",
".Dg c #8eb1f3",
".KU c #8eb6d9",
".KL c #8eb8e2",
"#j4 c #8f586b",
".XS c #8f6289",
".33 c #8f6370",
"#tq c #8f82b8",
"#Kl c #8f859e",
".6X c #8f89c9",
".5n c #8f8dce",
".6Y c #8f90d3",
"#D. c #8f91c4",
".FW c #8f97e0",
".Ib c #8f989f",
".7T c #8f9ac8",
".PE c #8f9fb8",
".UR c #8fa2ef",
".LU c #8fa7c1",
"#ZR c #8fafaa",
".Qk c #8fbbfc",
".MT c #904951",
".LH c #904e4f",
".nV c #9058dd",
".6l c #907fa3",
".2H c #90829c",
".ZJ c #908bdd",
".F0 c #9095d7",
".FZ c #9095d9",
".Pw c #909994",
".6O c #909acd",
"#Qy c #909ba1",
".R9 c #909dae",
".FV c #909de1",
".Dh c #909fca",
".19 c #909fd8",
".2. c #90a0dc",
".Du c #90a1f1",
".UC c #90a3a1",
".Ci c #90a5e6",
".G6 c #90a7eb",
".vd c #90a8e6",
".Ua c #915265",
".o9 c #916bda",
".Y5 c #916f94",
".35 c #917fb1",
".Jl c #918086",
".z. c #918ce0",
".Zk c #918dca",
".5N c #918dd7",
".ZA c #9192c8",
"#C9 c #9194cb",
".F7 c #9195d5",
".23 c #9195dc",
"#Ay c #9196b4",
".VB c #9199ca",
".xx c #919ae7",
".85 c #919cd2",
".yI c #919ceb",
".Ic c #919dc3",
"#FG c #919dcf",
"#GA c #919faa",
".WN c #919fdc",
".70 c #91a0db",
"#Id c #91afad",
".LZ c #91b4dc",
".L8 c #91bcdc",
".KT c #91bcdf",
"#cV c #92696d",
"#X6 c #928891",
"#Kk c #928aa1",
".4g c #928eb1",
".Yj c #9291cb",
"#CY c #9294a0",
".4e c #9294e1",
".4. c #9295dc",
".Ww c #9296c3",
"#oz c #9297c1",
".FY c #9297db",
"#Pt c #929a9c",
".Pv c #929a9d",
".Tm c #929da1",
".6N c #929ed2",
".t8 c #92a8f3",
".Sn c #92b4f1",
".R. c #92b7ec",
".Vd c #92cdff",
"#gr c #935d5d",
".Kx c #937b89",
"#go c #938db9",
".xW c #938fdc",
"#pK c #9392be",
".TL c #9396db",
".F1 c #9398d8",
".8U c #939ac6",
".ue c #939ade",
".QU c #93a2b9",
".V7 c #93a3f1",
".t9 c #93a7f0",
".tz c #93a7ff",
".vw c #93a8e7",
".PV c #93c0e9",
".N5 c #94414b",
".nX c #9460dc",
".Y0 c #946e95",
".Yr c #9486d3",
"#En c #948bc2",
".0X c #9491ec",
"#AK c #9493bd",
".F6 c #9495d6",
".F3 c #9499d3",
".Ul c #949bc7",
"#gE c #94a1d5",
".1M c #94a2e9",
".QC c #94a6be",
".0v c #94a7ec",
".Jp c #94acc8",
".KM c #94bee4",
".Y6 c #956d92",
"#Da c #9580ab",
".Kz c #95869b",
"#aI c #9587b8",
"#Km c #9589a1",
".Yh c #958bc7",
".Ug c #9594b6",
"#BP c #9598cf",
".F2 c #9599d8",
".22 c #959be7",
"#C1 c #959cc8",
".RQ c #959ec7",
".Dv c #959ee9",
".xw c #95a0f0",
"#bV c #95a1c7",
".Pm c #95a2b3",
".2F c #95a3d0",
".wJ c #95a6eb",
".TA c #95b1e3",
".KQ c #95bede",
".H8 c #967f89",
".EZ c #9693e4",
".Zj c #9694df",
".O. c #9695a7",
".WQ c #9695d1",
".Bw c #9696ec",
"#BY c #9697c5",
".Yv c #9698e3",
".0z c #9699de",
".Ok c #969b9f",
".ZG c #969bdf",
"#Ta c #969c98",
".v# c #969edd",
"#c6 c #96a3c6",
".0x c #96a3f2",
".3l c #96a5dc",
".u. c #96a7ef",
".Nh c #96b6cd",
".Ry c #96b9fb",
".Rz c #96c3ff",
".rs c #9773b9",
".1t c #9783a8",
"#iV c #9785af",
".5L c #978dd4",
".Ya c #978fbe",
"#qX c #9790ba",
"#Fz c #9790d3",
".3W c #9792a6",
"#Kj c #9794a5",
"#Ee c #9795bd",
"#Df c #9798c6",
"#r8 c #979abb",
".5v c #979ac3",
".FX c #979ae9",
".F4 c #979cd6",
"#vI c #979db3",
"#Fn c #979eb8",
".0K c #979ed4",
".Dl c #97a0b1",
".Tn c #97a1a3",
".7S c #97a3cd",
".Zf c #97a8ed",
"#OG c #97d896",
".sG c #9875c7",
".Vs c #988587",
"##j c #9888b7",
"##h c #988cbe",
".99 c #988fbc",
".QO c #989793",
".25 c #9898ca",
".EJ c #9898d6",
".DQ c #9898e2",
".UE c #989ba2",
".S6 c #989bc4",
".WM c #989fd3",
".WP c #98a1dc",
".6G c #98a5d2",
".18 c #98a5da",
".Uk c #98a8dc",
"#Oh c #98a9a3",
".Qn c #98c7f3",
".Qw c #995758",
".N9 c #99879f",
"#av c #998bc6",
".T9 c #998dcb",
".X6 c #9990df",
".4i c #9996cb",
"#zB c #999cbb",
".11 c #999cd3",
".yJ c #99a0f0",
".zV c #99a2e3",
".0S c #99a3d4",
".Tj c #99a7b4",
".7Y c #99a9e7",
".P# c #99b1d7",
".Nl c #99b8d4",
".Ca c #99bbeb",
"#q9 c #9a8bc2",
".5M c #9a8fd3",
".W5 c #9a93c6",
"#CZ c #9a95ab",
".Zq c #9a98bf",
".Zz c #9a99d2",
".Oj c #9a9b9d",
".5u c #9a9ee5",
".FP c #9aa0ba",
".3h c #9aa0d4",
".UQ c #9aa2eb",
".Pu c #9aa3ac",
".Ze c #9aa7db",
".u# c #9aa8ef",
".ve c #9ab0ea",
".L0 c #9ab6db",
".PU c #9ac6eb",
".RI c #9b6774",
".N3 c #9b6d7a",
".2J c #9b76a9",
".qc c #9b76df",
".6v c #9b91b3",
".ZI c #9b92e5",
"#FA c #9b95d5",
".VC c #9b97ca",
"#d3 c #9b98c7",
".ZB c #9b9dd0",
".Xi c #9b9ee5",
".F5 c #9ba0d8",
".xy c #9ba2e8",
".A9 c #9ba4e5",
".0U c #9ba5e0",
".vv c #9ba6e4",
".0T c #9ba7db",
".KN c #9bc6e8",
".tW c #9c8edd",
".y9 c #9c90e2",
"##u c #9c94c5",
".Of c #9c95a5",
".X5 c #9c99e0",
".0B c #9c9bc3",
".Ym c #9c9bd4",
".S4 c #9c9cd0",
".Dw c #9c9fe4",
".1N c #9ca0e9",
".ZD c #9ca1d8",
"#zi c #9ca5c4",
".2X c #9ca8d8",
".wm c #9ca8e2",
".G2 c #9ca9d6",
".ua c #9ca9ef",
".Tz c #9cb1de",
".nY c #9d6ce2",
".Ys c #9d91db",
".7F c #9d98b8",
".CH c #9d98e8",
".W6 c #9d99d6",
".4w c #9d9bee",
"#BX c #9d9fcf",
".ud c #9da1e1",
".0R c #9da4d2",
".V6 c #9da4ec",
".X2 c #9daced",
".RC c #9dafef",
".PT c #9dcae9",
".N4 c #9e5e6c",
".4y c #9e91d9",
".M3 c #9e949f",
".0W c #9e98f2",
"#FD c #9e9ae6",
"#AB c #9e9cdd",
"#BM c #9ea0b5",
"#AQ c #9ea0c6",
"#.i c #9ea0d0",
".ub c #9ea8ed",
".RR c #9eabce",
".Uj c #9eadf0",
".7R c #9eaee2",
".0w c #9eafff",
".Sm c #9ebbf3",
".Q9 c #9ec2f2",
".OD c #9ec3f0",
".0f c #9f7fa4",
"#sh c #9f87b9",
"#BZ c #9f8bb0",
".1S c #9fa3bc",
".R4 c #9fa4a7",
".wI c #9fa7e8",
".VA c #9faee7",
"#EZ c #9fb0b7",
".vf c #9fb2ec",
".1s c #a08baa",
".ZH c #a092e9",
".EL c #a099dc",
".EK c #a09dd2",
".W9 c #a09ecd",
".Yp c #a09fe5",
"#B4 c #a0a2cb",
".S5 c #a0a4d3",
".G1 c #a0a9d2",
"#2m c #a0b6cb",
".L1 c #a0bee4",
".KP c #a0c5e2",
".KH c #a0cdea",
".o5 c #a16ddc",
".Jj c #a1838b",
".1r c #a18bb2",
"#hI c #a18cb3",
".sI c #a18de2",
"#ms c #a18fbf",
".xV c #a195e1",
".Aj c #a196e2",
".Zv c #a19ebd",
".Yu c #a19ee5",
".X. c #a19fce",
".Yk c #a1a0d9",
".0Q c #a1a5d4",
".vu c #a1a5e2",
".Zh c #a1a8f6",
".0y c #a1aaf5",
".WO c #a1b1ed",
"#2z c #a1bfd7",
".L6 c #a1c5dd",
".L5 c #a1c8e5",
".o8 c #a278e6",
"##r c #a28dc5",
".Yg c #a29ac9",
"#zv c #a29dc6",
".Xh c #a2a0e1",
".Yq c #a2a0e9",
".Yl c #a2a1da",
".Yn c #a2a1db",
".VV c #a2a2ba",
".26 c #a2a4cb",
".0L c #a2a5c8",
"#FE c #a2a5e8",
".3i c #a2aadb",
"#FF c #a2abe6",
".X3 c #a2acf1",
"#1h c #a2adc1",
".vg c #a2b1e8",
".wn c #a2b1ec",
".Cc c #a2ccfe",
".PS c #a2cfec",
".y8 c #a395e4",
"#r9 c #a398c0",
".RE c #a399b4",
".Yt c #a39ce2",
".EY c #a39de7",
"#Fr c #a39fc4",
"#BO c #a3a0cf",
".UP c #a3a4e5",
"#Ki c #a3a5b2",
".X4 c #a3a6ed",
".EB c #a3b5dd",
".Ou c #a3b8cb",
"#KI c #a3bca9",
"#Js c #a3bcb8",
".C# c #a3c0f8",
".KO c #a3c6e2",
".KI c #a3cff2",
".7E c #a46872",
".o7 c #a476e3",
"##k c #a47c94",
".LJ c #a48c9a",
".GY c #a498a2",
"#aw c #a4a1cc",
".Yo c #a4a4e4",
".27 c #a4a7ca",
".ZC c #a4a7da",
".Zi c #a4a8f2",
"#wV c #a4a9bc",
".ZE c #a4a9e3",
".S. c #a4adbe",
"#c7 c #a4b0da",
".Zg c #a4b1ff",
".PF c #a4b5cf",
".L7 c #a4c7db",
"#OH c #a4e4b2",
"#bJ c #a58280",
".Pj c #a58296",
"#uE c #a592c9",
".EM c #a59cdd",
".Yf c #a59ec0",
".tY c #a59eee",
".Zs c #a5a3d4",
".uc c #a5a6e7",
"##v c #a5acd8",
"#RK c #a5aead",
".wo c #a5b9f8",
".Sl c #a5bcee",
".OA c #a5c3df",
".Cb c #a5cbf8",
"#aF c #a680af",
"#si c #a698cb",
".VD c #a699d1",
".yK c #a69ae4",
".Dy c #a69cd9",
".Bv c #a69fef",
".Dx c #a6a0e0",
".8V c #a6a1c9",
".zW c #a6a6e6",
"##i c #a6a7d3",
".12 c #a6a8db",
".3g c #a6a9e0",
".X1 c #a6abd5",
".UB c #a6b0b9",
".7Z c #a6b6f2",
".L4 c #a6cfef",
".o6 c #a775e4",
".qd c #a778de",
".Ai c #a79be3",
".4x c #a79de6",
".W4 c #a79fc4",
"#tf c #a7a6c8",
".xz c #a7a7e5",
".28 c #a7adcd",
".86 c #a7afde",
".vh c #a7b4e9",
".Q8 c #a7c8f3",
".OB c #a7c9ee",
".L2 c #a7caf0",
".Qv c #a8666a",
".Kv c #a86c6c",
".qe c #a874d8",
".LN c #a899a0",
".I# c #a89ba2",
"#tg c #a89cc0",
"#Em c #a8a0d9",
".Oe c #a8a2ae",
".DP c #a8a2e8",
"#GD c #a8a3c1",
".V5 c #a8a8e8",
".98 c #a8afdb",
"#ID c #a8b29a",
".QV c #a8b4ce",
"#zX c #a8c8bd",
".OC c #a8cbf5",
".Uc c #a99793",
".vt c #a9a8e4",
".VU c #a9a9c3",
"#GB c #a9b2c1",
".29 c #a9b2d1",
".17 c #a9b5e5",
".Sk c #a9bce7",
".Cj c #a9bdf0",
".C. c #a9c2ff",
"#ZS c #a9c8ca",
".Q7 c #a9c9ef",
".PR c #a9d7f1",
".RK c #aa7e7b",
"#ut c #aa9eb2",
".Xe c #aaa1e2",
"#bL c #aaa5bb",
".zX c #aaa5e5",
".Zw c #aaa6c7",
".wH c #aaa8e7",
".Zu c #aaa9cb",
".1R c #aaabc7",
"#x7 c #aaacc5",
".ZF c #aaafef",
"#xx c #aabcc8",
".Q6 c #aac8ea",
".L3 c #aad0f5",
".Vo c #ab90af",
".WC c #ab90b1",
".yL c #ab9fe7",
"#d5 c #aba0d8",
".yM c #aba0e4",
"#fc c #aba7d9",
".Si c #abb9de",
".Ty c #abb9e0",
".Q5 c #abc8e8",
".H9 c #ac979e",
".vm c #acaee7",
".0G c #acb0cd",
".vl c #acb1e9",
".Sj c #acbbe4",
".Dm c #acbdcf",
".B9 c #acbdff",
".XR c #ad8fb3",
"#ax c #ad99ca",
"#fi c #ad9bb3",
".CG c #ad9de4",
".WU c #ad9ec7",
".6y c #ada0d6",
".EN c #ada4e3",
".Y# c #ada5ca",
".Xg c #ada7e7",
".Zl c #ada8d0",
".X# c #adabda",
".vn c #adace6",
".QN c #adafaa",
".0E c #adafbe",
".Ti c #adb7c3",
".3k c #adbaee",
"#Gc c #adc1cc",
".Ni c #adcada",
".Xf c #aea5e6",
".Xc c #aea8e6",
".0M c #aeafce",
".Pt c #aeb5c5",
".vk c #aeb5ec",
".VT c #aeb7d6",
".4k c #aebbde",
".Qo c #aec3f8",
"#.. c #af8da5",
".8S c #af92a8",
"#ts c #afa2d0",
".X7 c #afa6d1",
".EX c #afa6e9",
"#BN c #afa8c9",
".vs c #afabe6",
".vo c #afabe8",
".IG c #afaef0",
".1Q c #afafd3",
".Qp c #afb0dc",
"#.j c #afb8e3",
".Dn c #afc4e1",
".Nk c #afcde5",
"#cU c #b097b4",
".0D c #b0afbf",
".vi c #b0baed",
".87 c #b0bbe8",
"#YE c #b0cdcb",
".Pe c #b17889",
".Qx c #b18086",
"#vW c #b19ac8",
"#Ep c #b19bf0",
".y7 c #b1a1e0",
"#Az c #b1aad3",
".xA c #b1ace4",
".W8 c #b1afe0",
".T7 c #b1b1d7",
".UO c #b1b2eb",
".B. c #b1b3f0",
".0P c #b1b5e5",
".16 c #b1bcea",
"#Hn c #b1bfca",
"#bI c #b29fb3",
".Ah c #b2a3e6",
".vr c #b2a6e6",
".vq c #b2a8e7",
".Ye c #b2a9c4",
".vp c #b2a9e8",
".Xd c #b2acec",
"#Ju c #b2cdba",
".Vk c #b396c4",
".xU c #b39fe7",
"#X7 c #b3a7b3",
".EQ c #b3a9de",
".QD c #b3c5d9",
"#2w c #b3c5f5",
".Vc c #b3edff",
".RL c #b4979c",
".5i c #b49dc7",
"#tr c #b49dcb",
".yN c #b4a8e6",
".Xb c #b4afe7",
".Zt c #b4b3db",
"#GC c #b4b6cd",
".S# c #b4bbcb",
".1U c #b4bbd7",
".Ck c #b4c0f0",
".Oz c #b4cce4",
".Ph c #b56365",
".LI c #b58a91",
"#B0 c #b59fc3",
"#AL c #b5a2c0",
"#nB c #b5a3d5",
".DA c #b5a7e2",
".Dz c #b5a7e4",
".EW c #b5a9e7",
".8Y c #b5ade0",
"#zl c #b5b0ea",
".Cl c #b5b7f0",
"#Hp c #b5c1a9",
".PI c #b5c1d9",
"#E0 c #b5c7d1",
".Ov c #b5c8d7",
".Pf c #b67281",
".MW c #b68892",
".N8 c #b68a99",
".y6 c #b6a6e4",
".zY c #b6a7ea",
".Y. c #b6acc5",
".EO c #b6ace8",
".wG c #b6aceb",
".Zy c #b6afd8",
"#AA c #b6afe5",
".UN c #b6b8eb",
"#aJ c #b6bbe5",
".RS c #b6c1df",
"#bU c #b6c3e3",
"#YF c #b6ced2",
"#ZU c #b6d2e0",
"#uF c #b79ee0",
".ER c #b7aadf",
".EP c #b7ace6",
".G0 c #b7b1bd",
".Um c #b7b1dd",
".Xa c #b7b3e5",
".WL c #b7b6d8",
".0N c #b7b7d3",
".1T c #b7bdd7",
".Q3 c #b7c5e2",
".PG c #b7c7e1",
"#vU c #b8a6da",
".EV c #b8a8e6",
".7H c #b8b3d3",
".S0 c #b8bbda",
"#iU c #b98a9e",
"#ay c #b98ea2",
".XM c #b994bd",
".ET c #b9a5e4",
".LM c #b9a7b5",
".LK c #b9a7c1",
".EU c #b9a7e5",
"#oM c #b9a9da",
"#d4 c #b9b4dc",
".Zn c #b9b5c3",
".SR c #b9b6e5",
".R3 c #b9b7b8",
".wp c #b9b7e8",
".13 c #b9bcef",
".3j c #b9c3f4",
".vj c #b9c3f6",
".QF c #b9c5d3",
".Q4 c #b9c7ea",
".PP c #b9d0f2",
"#1j c #b9daed",
".MX c #baa3b5",
".Bu c #baa8f2",
".zZ c #baabec",
".W3 c #bab2ca",
".97 c #bab2d7",
"#zj c #bab6db",
".Zo c #bab7ca",
".S7 c #babadc",
".Sh c #bac4e8",
".PH c #bac8e2",
"#hH c #bb8b97",
".Vt c #bb9fab",
"#pW c #bbabda",
".DB c #bbace5",
".Zx c #bbb5db",
".QG c #bbc1cd",
".Tx c #bbc3e7",
"#2k c #bbcacd",
".PO c #bbcfe8",
".Kw c #bc9399",
".5k c #bca5bf",
".yO c #bcafe7",
"#vJ c #bcb1c1",
".To c #bcbbcd",
".sj c #bcc1ff",
".QE c #bcccdc",
".Nj c #bcd8e4",
"#09 c #bcdcf1",
".MV c #bd7578",
".2Q c #bd8ea0",
".XU c #bd96b5",
".CF c #bda4e5",
"#uG c #bda5d9",
".DO c #bda6ea",
".xT c #bda6ee",
"#zw c #bdaac6",
".Ag c #bdabe7",
".SS c #bdafd0",
".ES c #bdb1e3",
".8T c #bdb6d5",
".W7 c #bdb7fd",
".V4 c #bdb9f4",
".Zd c #bdc0e1",
".Th c #bdc3cf",
".PQ c #bdd4fd",
".Vr c #be9da4",
".0d c #bea7d5",
"##s c #beacd2",
".wF c #beb0ee",
"#Eq c #beb0fd",
".VE c #beb2e0",
".Cm c #beb4f9",
".B# c #beb6f1",
".xC c #beb7eb",
".UM c #bec0f0",
".QM c #bec4c2",
".15 c #bec5f3",
".Pn c #becad8",
".X9 c #bfb3c7",
".Ba c #bfb4ec",
"#yh c #bfb6e1",
".xB c #bfb8ec",
"#08 c #bfd9e6",
".RJ c #c09090",
"#d7 c #c09199",
".LL c #c0afc2",
".MY c #c0b2c9",
"#Er c #c0b9fc",
"#fd c #c0bbe4",
".wq c #c0bdec",
".0C c #c0c0d8",
".Pp c #c0c9d0",
"#w9 c #c1abcf",
".y5 c #c1b0e7",
".yP c #c1b1e0",
".Z# c #c1b4c6",
"#w7 c #c1b4e2",
"#x9 c #c1b9e2",
".QJ c #c1d1e0",
".Qu c #c28493",
"#aG c #c2a1c0",
"#vV c #c2aae4",
".WG c #c2aeba",
".Co c #c2b3ec",
".M2 c #c2b5bc",
".0O c #c2c4f5",
"#KH c #c2d6cd",
"#Db c #c3acd6",
".DN c #c3aded",
".JS c #c3aee9",
"#AM c #c3afcb",
".DC c #c3b2e8",
".WV c #c3b5cf",
"#tv c #c3bfcd",
".WH c #c4adbd",
".Cp c #c4b3ea",
".XL c #c4bbe6",
".PJ c #c4c7d6",
".VS c #c4caea",
".Tv c #c4ccf1",
".QK c #c4d1d9",
".MU c #c57073",
".Y9 c #c5a7c1",
".DE c #c5b2e0",
".Z. c #c5b8cc",
".Vw c #c5c2df",
".FO c #c5c7dc",
".Tw c #c5cbed",
".Sg c #c5ceeb",
".Po c #c5cfd9",
".QW c #c5cfea",
"#Dc c #c6b0d7",
".DD c #c6b4e6",
".XW c #c6b5c7",
".z0 c #c6b8f3",
"#x8 c #c6bfde",
".Tg c #c6cad5",
".Cq c #c7b5e9",
".VM c #c7b7c1",
".Bb c #c7b9ee",
".Cn c #c7b9ff",
"#vK c #c7bace",
".z1 c #c7bdf2",
"#wW c #c7bed1",
".Yd c #c7bfd6",
".wr c #c7c1f1",
".RD c #c7c5f7",
".Ps c #c7c7d1",
".UF c #c7cacf",
"#r. c #c8b9e4",
"#wX c #c8bbd5",
"#Es c #c8c4ff",
".RU c #c8cadf",
".QL c #c8d2d4",
"#2l c #c8d9e3",
".PN c #c8d9e9",
".Pi c #c9868d",
".Ub c #c9aaa8",
".wE c #c9b2ea",
".DF c #c9b4df",
".wD c #c9b5ea",
"#yi c #c9b6d6",
".M1 c #c9bac1",
"#uu c #c9bacf",
".5m c #c9bfda",
"#zk c #c9c1f2",
".Od c #c9c4cb",
".R2 c #c9c7ca",
".VW c #c9c9e1",
".14 c #c9cdfd",
".Ts c #c9d2d7",
".Q2 c #c9d6e9",
".QI c #c9d8eb",
".Bt c #caabee",
".8W c #caadc9",
".wA c #cabde8",
".VF c #cabee6",
".wz c #cac0e5",
".6w c #cac2da",
".wy c #cac3e5",
".V3 c #cac7fe",
".QH c #caccd9",
"#IC c #cad2d4",
".Ow c #cadaea",
"#Ie c #cae7e2",
".Af c #cbb4e8",
".y4 c #cbb7e8",
".wC c #cbb7ea",
".2S c #cbb9df",
".wB c #cbbbea",
".wt c #cbbeea",
".W2 c #cbc0d0",
".Yb c #cbc1d9",
".ws c #cbc2ef",
"#cT c #cbc7fa",
".RV c #cbc8db",
".Zp c #cbc8e5",
".Pq c #cbcfd8",
".RT c #cbd2ec",
".Oy c #cbe0f3",
".Cr c #ccb8e9",
"#De c #ccc1eb",
".X8 c #ccc2db",
".GZ c #ccc4cf",
".wx c #ccc5e7",
".UL c #ccc7de",
".Tf c #ccccd4",
".RW c #ccd2e2",
".xS c #cdb6ec",
".M0 c #cdbdc8",
".2R c #cdbed3",
".IH c #cdbef7",
".0p c #cdbfd8",
".Yc c #cdc3db",
"#2y c #cdd7e3",
".CE c #ceafeb",
".DM c #ceb6f0",
".DG c #ceb7e3",
".I. c #cebdc5",
".XX c #cebdcd",
".wu c #cebde9",
".6x c #cebfdc",
".Uq c #cec0d1",
".Zm c #cec9df",
".0F c #ced0e7",
".RX c #ced1e2",
"#aA c #cfb8be",
"#B1 c #cfbadb",
".Bc c #cfbef2",
".Ob c #cfcad0",
".UK c #cfcade",
".Pr c #cfd2db",
"#G# c #cfe5f2",
".WF c #d0adc1",
".YZ c #d0bdeb",
".yQ c #d0bee8",
".WW c #d0c1d6",
".VG c #d0c1de",
".W1 c #d0c3cc",
".O# c #d0cedc",
".Wx c #d1b2de",
".xR c #d1baee",
"#Dd c #d1bfe7",
".MZ c #d1c3d4",
".UI c #d1d0d8",
"#yJ c #d1e6e1",
"#07 c #d1e9ed",
".6s c #d29ca9",
".37 c #d2b5c9",
".2V c #d2bdce",
"#w8 c #d2bde8",
".Vj c #d2beef",
".Uw c #d2c1d3",
".5l c #d2c5d6",
".Uv c #d2c7cd",
".QZ c #d2d5de",
".Q0 c #d2d7dd",
".Ox c #d2e3f5",
".XV c #d3bbd1",
".Cs c #d3bce8",
".Uy c #d3c7df",
".VZ c #d3cdef",
".Sc c #d3d6db",
".Tr c #d3d8db",
"#1i c #d3e6f7",
".CD c #d4b9e4",
".Jk c #d4bfc6",
".7I c #d4c0db",
".VH c #d4c3d6",
".z2 c #d4cbfa",
".V2 c #d4d1ff",
".Sd c #d4d9dc",
".Tu c #d4ddfa",
".xQ c #d5bfee",
"#yj c #d5c1dc",
".V0 c #d5cef7",
".V1 c #d5cef8",
".RY c #d5d8e9",
".Ab c #d5dee3",
".7J c #d6bde4",
".DL c #d6bef2",
".y3 c #d6c1ec",
"#zx c #d6c2db",
".Bd c #d6c4f4",
".39 c #d6cdea",
".Te c #d6d4e2",
".VR c #d6d9f8",
".Bs c #d7afeb",
".DH c #d7bbec",
".Ae c #d7bdea",
".wv c #d7c5ef",
".WZ c #d7caf5",
".Oc c #d7d2d8",
".UJ c #d7d3e1",
".Sf c #d7e0f1",
".xP c #d8c3ee",
".xD c #d8c4e9",
"#B2 c #d8c7e9",
"#uJ c #d8d3d9",
".PK c #d8deea",
".Tt c #d8e1f0",
"##l c #d9aaa2",
"#lh c #d9bcda",
".DI c #d9bdee",
".DK c #d9c1f1",
".Zb c #d9c8d0",
".Ux c #d9cadf",
".WY c #d9cbee",
".VY c #d9d6f1",
".R1 c #d9d8e0",
".0n c #dab6d0",
".CC c #dac0e7",
".DJ c #dac0ef",
".Ct c #dac1e9",
".Be c #dac7f4",
".38 c #dac8d4",
"#j6 c #dac9f5",
"#sj c #dacbf2",
".VN c #daccd9",
".UA c #daddee",
".Ud c #dbbdc7",
".xO c #dbc7ec",
".S8 c #dbd7f2",
".Oa c #dbd8e3",
"#j5 c #dcaec8",
".6t c #dcc2df",
".Ur c #dccbd5",
".W0 c #dccfd6",
".VP c #dcd7ee",
".Se c #dce5ec",
".PM c #dceaf5",
".VL c #ddd1e7",
"#sl c #ddd6e8",
".UH c #dddee2",
".sH c #deb8ff",
".0q c #debfe1",
".Za c #dec8dd",
".Bf c #dec8ef",
".xE c #decaed",
".xN c #decbe9",
".XY c #decddd",
".WX c #ded0e9",
".QY c #deddeb",
".tX c #dfcbff",
".SZ c #dfced4",
".Un c #dfd1ff",
".VO c #dfd4e5",
".2W c #dfdbf4",
".VQ c #dfdcf9",
".z6 c #dfdde8",
".0t c #dfe0fc",
".QX c #dfe6ff",
"#ZT c #dffcff",
"#bK c #e0c2c2",
".Cu c #e0c6eb",
".xF c #e0caee",
"##m c #e0cbda",
".xM c #e0cee8",
".1D c #e0d1f2",
".z4 c #e0d3f1",
".S9 c #e0d6ef",
".Sb c #e0e0ec",
".RZ c #e0e2f1",
".A# c #e0e7ed",
"#az c #e1b0a1",
".CB c #e1c7ea",
".y2 c #e1c9ed",
".0r c #e1cad4",
".T6 c #e1caf6",
".ww c #e1ccf7",
"#AN c #e1cde8",
".Cw c #e1ceec",
".1G c #e1cfdd",
".T# c #e1d6e7",
".z3 c #e1d6fe",
".Aa c #e1eaef",
".Q1 c #e1ebf5",
".1B c #e2b7cb",
".SX c #e2bfbd",
".Ad c #e2c6ee",
".yR c #e2cdf4",
".Cx c #e2cfeb",
".xL c #e2d0e8",
"#tt c #e2d4f7",
".Up c #e2d6ee",
"#B3 c #e2d8fd",
"#vY c #e2dde4",
"#gs c #e3b4bc",
".Bg c #e3c9ee",
".WI c #e3cedf",
"#gt c #e3ceed",
".Uu c #e3d7db",
".Ta c #e3d9f1",
".R0 c #e3e2f0",
"#Ga c #e3f0e7",
"#Jt c #e3fbee",
".Cv c #e4caed",
".Cy c #e4d0eb",
"#mu c #e4d1ef",
"#AO c #e4d4ee",
"#.a c #e4d5f4",
".yZ c #e4d7e8",
".T. c #e4d8e6",
".N6 c #e58b8d",
"#.# c #e5bbbf",
".JT c #e5c1f1",
"#mt c #e5cae9",
".Bq c #e5cde3",
".CA c #e5ceeb",
".Cz c #e5d1ec",
".Td c #e5e0f6",
".Uz c #e5e1f8",
".A. c #e5eaf0",
".5h c #e6bbcf",
"#uH c #e6d1f0",
"#nD c #e6d5f5",
".yS c #e6d7ec",
".Uo c #e6dcf7",
".VX c #e6e4fc",
".PL c #e6f0fa",
"#Gb c #e6f7f1",
".Bj c #e7e0f0",
".z9 c #e7eaf3",
".Bh c #e8cdee",
".xG c #e8d0f2",
".VI c #e8d6e4",
".Tp c #e8e8f4",
"#Ho c #e8f2d7",
".N7 c #e99ea3",
".Br c #e9baf0",
".Ac c #e9cbef",
".SY c #e9ccc6",
".z5 c #e9d9f3",
".Bk c #e9e1f0",
".Sa c #e9e6f7",
".z8 c #e9e9f3",
".Bi c #eacfee",
".y1 c #ead1ef",
".Bp c #ead3e7",
".VK c #eaddef",
".0o c #eaddf1",
".8X c #ebcadf",
"#oO c #ebdcfb",
"#xa c #ebe5ef",
".xK c #eccfee",
".Vu c #ecd0e6",
".xI c #ecd1f2",
".xH c #ecd3f3",
"#pX c #ecd5f2",
".yU c #ecdff3",
".Tb c #ece2fd",
".z7 c #eceaf5",
".1H c #eceaff",
"#zz c #eddff0",
".Bl c #ede3ee",
".Tc c #ede7ff",
".UG c #edeef2",
"#d8 c #eec5c9",
"#zy c #eedbee",
".yT c #eedff4",
".y0 c #efd5f2",
"#vX c #efdbf6",
".2U c #f0cfe0",
".xJ c #f0d3f2",
"#oN c #f0d7f7",
".Bo c #f0dbea",
".WJ c #f0e2f3",
".yY c #f0e3f4",
".yV c #f0e3f7",
".Bm c #f0e4ee",
".Tq c #f0f3f8",
"#nC c #f1d6f7",
".Uf c #f1e1fc",
".yX c #f1e4f6",
"#ra c #f1e7ff",
"#cW c #f2d0d1",
".Bn c #f2e2ed",
".2T c #f3c3ff",
".34 c #f3cfe9",
".0s c #f3e5f4",
".yW c #f3e6f8",
"#pY c #f3e6ff",
".X0 c #f3efff",
"#r# c #f4ddf7",
".1E c #f5cbfd",
".Ut c #f5e5e8",
"#AP c #f5ecff",
"#ym c #f5effd",
".Us c #f6e5eb",
"#yl c #f6e8f5",
".1F c #f7d8e7",
".VJ c #f7e6f6",
".XZ c #f7ebf7",
".WK c #f7f2ff",
"#yk c #f8e5f8",
"#tu c #f8e6f6",
".Vv c #f8eaff",
"#sk c #f9e6f9",
".1C c #f9ecff",
".Ue c #fbdbf2",
"#zA c #fbf3ff",
"#x. c #fce9fd",
"#uI c #fdeffc",
"#x# c #fdf0fa",
"#2x c #fefbff",
"#fg c #ffd0d6",
"#fh c #ffe0e5",
".Zc c #fff9ff",
"Qt.Qt#QtaQtbQtcQtdQteQtfQtgQthQtiQtjQtkQtlQtmQtnQtoQtpQtqQtrQtsQttQtuQtvQtwQtxQtyQtzQtAQtBQtCQtDQtEQtFQtGQtHQtIQtJQtKQtLQtMQtNQtOQtPQtQQtRQtSQtTQtUQtVQtWQtXQtYQtZQt0Qt1Qt2Qt3Qt4Qt5Qt6Qt7Qt8Qt9.#..##.#a.#b.#c.#d.#e.#f.#g.#h.#i.#j.#k.#l.#m.#n",
".#o.#p.#q.#r.#s.#t.#u.#v.#w.#x.#y.#z.#A.#B.#C.#D.#E.#F.#G.#H.#I.#J.#K.#L.#M.#N.#O.#P.#Q.#R.#S.#T.#U.#V.#W.#X.#Y.#Z.#0.#1.#2.#3.#4.#5.#6.#7.#8.#9.a..a..a#.aa.ab.ac.ad.ae.af.ag.ah.ai.aj.ak.al.am.an.ao.ap.ap.aq.ar.as.at.au.#h.av.aw.ax.ay.az.aA",
".aB.aC.aD.aE.aF.aG.aH.aI.aJ.aK.aL.aM.aN.aO.aP.aQ.aR.aS.aT.aU.aV.aW.aX.aY.aZ.a0.a1.a2.a3.a4.a5.a6.a7.a8.a9.b..b#.ba.bb.bc.bd.be.bf.bg.bh.bi.bj.bk.bl.bm.bn.bo.bp.bp.bq.br.bs.bt.bu.bv.bw.bx.by.by.bz.bA.bB.bB.bC.bD.bE.bF.bG.bH.bI.bJ.bK.bL.bM.bN",
".bO.bP.bQ.bR.bS.bT.bU.bV.bW.bX.bY.bZ.b0.b1.b2.b3.b4.b5.b6.b7.b8.b9.c..c#.ca.cb.cc.cd.ce.aW.cf.cg.ch.ci.cj.ck.cl.cm.cn.co.cp.cq.cr.cs.ct.cu.cv.cw.cx.cy.cz.cA.cB.cC.cD.cE.cF.cG.cH.cI.cJ.cK.cL.cM.cN.cO.cP.cQ.ax.cR.cS.cT.cU.cV.cW.cX.cY.cZ.c0.c1",
".c2.c3.c4.c5.c6.c7.c8.c9.d..d#.da.db.dc.dd.de.df.dg.dh.di.dj.dk.dl.dm.dn.do.dp.dq.dr.ds.dt.du.ac.dv.dw.dx.dy.dz.dA.dB.dC.cu.dD.dE.dF.dG.dH.dI.dJ.dK.dK.dL.dM.dN.dO.dP.dQ.dR.dS.dT.dU.dV.dW.dX.dX.dY.dZ.dZ.d0.d1.d2.c0.d3.d4.d5.d6.d7.d8.d9.e..e#",
".ea.eb.ec.ed.ee.ef.eg.eh.ei.ej.ek.el.em.en.eo.ep.eq.er.es.et.eu.ev.ew.ex.ey.ez.eA.eB.eC.eD.eE.eF.eG.eH.eI.eJ.eK.eL.eM.eN.eO.eP.eQ.eR.eS.eT.eU.eV.eW.eX.eY.eZ.e0.e1.e2.e3.e4.e5.e6.e7.e8.e9.f..f#.fa.fb.fb.fc.fd.fe.ff.fg.fh.fi.fj.fk.fl.fm.fn.fo",
".fp.fq.fr.fs.ft.fu.fv.fw.fx.fy.fz.fA.fA.fB.fC.fD.fE.fF.fG.fH.fI.fJ.fK.fL.fM.fN.fO.fP.fQ.fR.fS.fT.fU.fV.fW.fX.fY.fZ.f0.f1.cW.f2.f3.f4.f5.f6.f7.f8.f9.g..g#.ga.gb.gc.gd.ge.gf.gg.gh.gi.gj.gj.gk.gk.gl.gm.gn.go.gp.gq.gr.gs.gt.gu.gv.gw.gx.gy.gz.gz",
".gA.gB.gC.gD.gE.gF.gG.gH.gI.gJ.gK.gL.gM.gN.gO.gP.gQ.gR.gS.gT.gU.gV.gW.gX.gY.gZ.g0.g1.g2.g3.g4.g5.g6.g7.g8.bx.g9.f2.h..h#.ha.hb.hc.hd.he.hf.hg.hh.hi.hj.hk.hl.hm.hn.ho.hp.hq.ge.ge.hr.hs.ht.hu.hv.hw.hx.he.hy.hz.hA.hB.hC.hD.hE.hF.hG.hH.hI.hJ.hK",
".hL.hM.hN.hO.hP.hQ.fW.hR.hS.fR.hT.hU.hV.hW.hX.hY.hZ.h0.h1.h2.h3.h4.h5.h6.h7.h7.h8.h9.h8.i..i#.i..fQ.ia.ib.ic.id.ie.if.ig.ih.ii.ij.cC.cA.ik.cx.il.im.in.io.dV.ip.iq.ir.is.it.iu.iv.iw.gT.ix.iy.iz.gz.iA.iB.iC.iD.iE.iF.iG.iH.iI.iJ.iK.iL.iM.iN.iO",
".iP.iQ.iR.iS.d3.iT.iU.iV.iW.iX.iY.iZ.i0.i1.i2.i3.i4.i5.i6.i7.i8.i9.j..j#.ja.jb.jc.jd.fy.je.jf.jg.jh.ji.jj.jk.jl.jm.jn.jo.jp.jq.jr.js.jt.ju.jv.jw.jx.jy.jz.jA.jB.jC.jD.jD.jE.jF.jG.jH.jI.jJ.jK.jL.jM.jN.jO.jP.jQ.jR.jS.jT.jU.jV.jW.jX.jY.jZ.j0.j1",
".j2.j3.gR.j4.j5.j6.j7.j8.hL.hv.jt.jt.hv.gd.gf.j9.jP.k..k#.ka.kb.kc.kd.kd.ke.kf.kg.kh.ki.kj.kk.kl.km.fg.kn.ko.kp.kq.kr.ks.kt.ku.kv.kw.kx.ky.kz.kA.kB.kC.kD.kE.kF.kF.kG.kH.kI.kJ.kK.kL.kM.kN.jr.kO.kP.kQ.kR.kS.kT.kU.kV.kW.kX.kY.kZ.k0.k1.k2.k3.k4",
".k5.k6.k7.k8.k9.l..l#.jI.la.fE.lb.lc.ld.le.iD.lf.lg.lh.li.lj.lk.ll.lm.ln.lo.lp.gW.lq.lq.lr.ls.lt.lu.lv.lw.lx.ly.lz.lA.lB.lC.lD.lE.lF.lG.lH.lI.kT.lJ.lK.lL.lM.lN.lO.lP.lQ.lR.lS.lT.lU.lV.lW.lX.lY.lZ.l0.l1.l2.l3.l4.l5.l6.l7.l8.l9.m..m#.ma.mb.m#",
".mc.md.me.mf.mg.mh.mi.mj.fE.jq.mk.ml.jq.mm.mn.mo.mp.mq.mr.ms.mt.mu.mv.mw.mx.my.mz.mA.b#.mB.mC.mD.mE.mF.mG.mH.mI.mJ.mK.mL.mM.mN.mO.mP.mQ.mR.mS.mT.mU.mV.mW.mX.mY.mZ.m0.m1.m2.m3.m4.m5.m6.m7.m8.m9.n..n#.na.nb.nc.nd.ne.nf.ng.nh.ni.nj.nk.nl.nm.nn",
".no.np.nq.nr.ns.nt.nu.nv.nw.nx.ny.nz.nA.c#.nB.nC.nD.nE.nF.nG.nH.nI.lI.nJ.nK.nL.nM.nN.nO.nP.nQ.nR.nS.nT.nU.nV.nW.nX.nY.nZ.n0.n1.n2.n3.n4.n5.n6.n7.n8.n9.o..o#.oa.ob.oc.od.ee.oe.of.og.oh.oi.oj.ok.ol.om.on.oo.op.oq.or.os.ot.ou.ov.ow.ox.oy.oz.oA",
".oB.oC.oD.oE.oF.oG.oH.oI.oJ.oK.oL.oM.oN.oO.oP.oQ.oR.oS.oT.oU.#G.oV.oV.oW.oX.oY.oZ.o0.o1.o2.o3.o4.o5.o6.o7.o8.o9.p..p#.pa.pb.pc.pd.pe.pf.pg.ph.pi.pj.pk.pl.pm.pn.po.po.pp.pq.pr.ps.pt.pu.pv.pw.px.py.pz.pA.pB.pC.pD.pE.pF.pG.pH.pI.pJ.pK.pL.pM.pN",
".e9.pO.pP.pQ.pR.hX.mp.pS.pT.pU.pV.pW.pX.pY.pZ.p0.p1.p2.p3.p4.p5.p6.p7.p8.p9.q..q#.qa.qb.qc.qd.qe.qf.qg.qh.qi.qj.qk.ql.qm.qn.qo.qp.qq.qr.qs.qt.qu.qv.qw.qx.qy.qz.qA.qB.qC.qD.qE.qF.qG.qH.qI.qJ.qK.qL.qM.qN.qO.qP.qQ.qR.qS.qT.qU.qV.qW.qX.qY.qZ.q0",
".q1.q2.q3.q4.q5.q6.q7.q8.q9.r..r#.ra.rb.rc.rd.re.rf.rg.rh.ri.rj.rk.rl.rm.rn.ro.rp.rq.rr.rs.rt.ru.rv.rw.rx.ry.rz.rA.rB.rC.rD.rE.rF.rG.rH.rI.rJ.rK.rL.rM.rN.rO.rP.rQ.rR.rS.rT.rU.rV.rW.rX.rY.rZ.r0.r1.r2.r3.r4.r5.r6.r6.r7.r8.r9.s..s#.sa.sb.sc.sd",
".se.sf.sg.sh.si.sj.sk.sl.sm.sn.so.sp.sq.sr.ss.st.su.sv.sw.sx.sy.sz.sA.sB.sC.sD.sE.sF.sG.sH.sI.sJ.sK.sL.sM.sN.sO.sP.sQ.sR.sS.sT.sU.sV.sW.sX.sY.sZ.s0.s1.s2.s3.s4.s5.s6.s7.s8.s9.t..t#.ta.tb.tc.td.te.tf.tg.th.ti.tj.tk.tl.tm.tn.to.tp.tq.tr.ts.tt",
".tu.tv.tw.tx.ty.tz.tA.tB.tC.tD.tE.tF.tG.tH.tI.tJ.tK.tL.tM.tN.tO.tP.tQ.tR.tS.tT.tU.tV.tW.tX.tY.tZ.t0.t1.t2.t3.t4.t5.t6.t7.t8.t9.t9.u..u#.ua.ub.ub.uc.ud.ue.uf.ug.uh.ui.uj.uk.ul.um.un.uo.up.uq.ur.us.ut.uu.uv.uw.ux.uy.uz.uA.uB.uC.uD.uE.uF.uG.uH",
".uI.uJ.uK.uL.uM.uN.uO.uP.uQ.uR.uS.uT.uU.uV.uW.uX.uY.uZ.u0.u1.u2.u3.u4.u5.u6.u7.u8.u9.v..v#.va.vb.vc.vd.ve.vf.vg.vh.vi.vj.vk.vl.vm.vn.vo.vp.vq.vr.vs.vt.vu.vv.vw.vx.vy.vz.vA.vB.vC.vD.vE.vF.vG.vH.vI.vJ.vK.vL.vM.tp.vN.vO.vP.uB.vQ.vR.vS.vS.vT.vU",
".vV.vW.vX.vY.vZ.v0.v1.v2.v3.v4.v5.v6.v7.v8.v9.w..w#.wa.wb.wc.wd.we.wf.wg.wh.wi.wj.wk.wl.wm.wn.wo.wp.wq.wr.ws.wt.wu.wv.ww.wx.wy.wz.wA.wB.wC.wD.wE.wF.wG.wH.wI.wJ.wK.wL.wM.wN.wO.wP.wQ.wR.wS.wT.wU.wV.wW.wX.wY.wZ.w0.w1.w2.w3.w4.w4.w5.w6.w7.w8.w8",
".w9.x..x#.xa.xb.xc.xd.xe.xf.xg.xh.xi.xj.xk.xl.xm.xn.xo.xp.xq.xr.xs.xt.xu.xv.xw.xx.xy.xz.xA.xB.xC.xD.xE.xF.xG.xH.xI.xJ.xK.xL.xM.xN.xO.xP.xQ.xR.xS.xT.xU.xV.xW.xX.xY.xZ.x0.x1.x2.x3.x4.x5.x6.x7.x8.x9.y..y#.ya.yb.yc.yd.ye.yf.yg.yg.yh.yi.yj.yk.yl",
".ym.yn.yo.yp.yq.yr.ys.yt.yu.yv.yw.yx.yy.yz.yA.yB.yC.yD.yE.yF.yG.yH.yI.yJ.yK.yL.yM.yN.yO.yP.yQ.yR.yS.yT.yU.yV.yW.yX.yY.yZ.y0.y1.y2.y3.y4.y5.y6.y7.y8.y9.z..z#.za.zb.zc.zd.ze.zf.zg.zh.zi.zj.zk.zl.zm.zm.zn.tm.zo.zp.zq.zr.zs.zt.zu.zv.zw.zx.zy.zz",
".zA.zB.zC.zD.zE.zF.zG.zH.zI.zJ.zK.zL.zM.zN.zO.zP.zQ.zR.zS.zT.zU.zV.zW.zX.zY.zZ.z0.z1.z2.z3.z4.z5.z6.z7.z8.z9.A..A#.Aa.Ab.Ac.Ad.Ae.Af.Ag.Ah.Ai.Aj.Ak.Al.Am.An.Ao.Ap.Aq.Ar.As.At.Au.Av.Aw.Ax.Ay.Az.AA.AB.AC.AD.AE.AF.AG.AH.AI.AJ.zv.AK.AL.AM.AN.AO",
".AP.AQ.AR.AS.AT.AU.AV.AW.AX.AY.AZ.A0.A1.A2.A3.A4.A5.A6.A7.A8.A9.B..B#.Ba.Bb.Bc.Bd.Be.Bf.Bg.Bh.Bi.Bj.Bk.Bl.Bm.Bn.Bo.Bp.Bq.Br.Bs.Bt.Bu.Bv.Bw.Bx.By.Bz.BA.BB.BC.xo.BD.BE.BF.BG.BH.BI.BJ.BK.BL.BM.BN.BO.BP.BQ.BR.BS.BT.BU.BV.BW.BW.BX.BX.BY.BZ.B0.B1",
".B2.B3.B4.B5.B6.B7.B8.B9.C..C#.Ca.Cb.Cc.Cd.Ce.Cf.Cg.Ch.Ci.Cj.Ck.Cl.Cm.Cn.Co.Cp.Cq.Cr.Cs.Ct.Cu.Cv.Cw.Cx.Cy.Cz.CA.CB.CC.CD.CE.CF.CG.CH.CI.CJ.CK.CL.CM.CN.CO.CP.CQ.CR.CS.CT.CU.CV.CW.CX.CY.CZ.C0.C1.C2.C3.C4.C5.C6.C7.C8.C9.BV.BV.D..D..B1.D#.D#.Da",
".Db.Dc.Dd.De.Df.Dg.Dh.Di.Dj.Dk.Dl.Dm.Dn.Do.Dp.Dq.Dr.Ds.Dt.Du.Dv.Dw.Dx.Dy.Dz.DA.DB.DC.DD.DE.DF.DG.DH.DI.DJ.DK.DL.DM.DN.DO.DP.DQ.DR.DS.DT.DU.DV.DW.DX.DY.DZ.D0.D1.D2.D3.D4.D5.D6.D7.D8.D9.E..E#.Ea.Eb.Ec.Ec.Ed.Ee.Ef.Eg.Eh.Ei.Ei.Ej.Ek.Ek.El.El.Em",
".En.Eo.Ep.Eq.Er.Es.Et.Eu.Ev.Ew.Ex.Ey.Ez.EA.EB.EC.ED.EE.EF.EG.EH.EI.EJ.EK.EL.EM.EN.EO.EP.EQ.ER.ES.ET.EU.EV.EW.EX.EY.EZ.E0.E1.E2.E3.E4.E5.E6.E7.E8.E9.F..F#.Fa.Fb.Fc.Fd.Fe.Ff.Fg.Fh.Fi.Fj.Fk.BR.Fl.Fm.Fn.Fo.Fp.Fq.Fr.Fs.Ft.Fu.Fu.Fv.Fw.Fx.Fy.Fy.Fz",
".FA.FB.FC.FD.FE.FF.FG.FH.FI.FJ.FK.FL.FM.FN.FO.FP.FQ.FR.FS.FT.FU.FV.FW.FX.FY.FZ.F0.F1.F2.F3.F4.F5.F6.F7.F8.F9.G..G#.Ga.Gb.rS.Gc.Gd.Ge.Gf.Gg.Gh.Gi.Gj.Gk.Gl.Gm.Gn.Go.Gp.Gq.Gr.Gs.Gt.Gu.Gv.Gw.Gx.Gy.Gz.GA.Gz.GB.GC.GD.GE.GF.GG.GH.GI.GJ.GJ.GJ.GK.GK",
".GL.GM.GN.GO.GP.GQ.GR.GS.GT.GU.GV.GW.GX.GY.GZ.G0.G1.G2.G3.G4.G5.G6.G7.G8.G9.H..H#.Ha.Hb.Hc.Hd.He.Hf.Hg.Hh.Hi.Hj.Hk.Hl.Hm.Hn.Ho.Hp.Hq.Hr.Hs.Ht.Hu.Hv.Hw.Hx.Hy.Hz.HA.HB.HC.HD.HE.HF.HG.HH.HI.HJ.HK.HL.HM.HN.HO.HP.HQ.HR.HS.HT.HT.HT.HU.HU.HV.HV.HV",
".HW.HX.HY.HZ.H0.H1.H2.H3.H4.H5.H6.H7.H8.H9.I..I#.Ia.Ib.Ic.Id.Ie.If.Ig.Ih.Ii.Ij.Ik.Il.Im.In.Io.Ip.Iq.Ir.Is.It.Iu.Iv.Iw.Ix.Iy.Iz.IA.IB.IC.IC.ID.IE.IF.IG.IH.II.IJ.IK.IL.IM.IN.IO.IP.IQ.IR.IS.IT.IU.IV.IW.IX.IY.IZ.I0.I1.I2.I0.I3.I3.I3.I4.I5.I6.I7",
".I8.I9.J..J#.Ja.Jb.Jc.Jd.Je.Jf.Jg.Jh.Ji.Jj.Jk.Jl.Jm.Jn.Jo.Jp.Jq.Jr.Js.Jt.Ju.Jv.Jw.Jx.Jy.Jz.JA.JB.JC.JD.JE.JF.JG.JH.JI.JJ.JK.JL.JM.JN.JO.JO.JP.JQ.JR.JS.JT.JU.JV.JW.JX.JY.JZ.J0.J1.J2.J3.J4.J5.J6.JQ.J7.J8.J9.K..K#.Ka.Kb.Kc.Kc.Kd.Kd.Ke.Kf.Kg.Kh",
".Ki.Kj.Kk.Kl.Km.Kn.Ko.Kp.Kq.Kr.Ks.Kt.Ku.Kv.Kw.Kx.Ky.Kz.KA.KB.KC.KD.KE.KF.KG.KH.KI.KJ.KK.KL.KM.KN.KO.KP.KQ.KR.KS.KT.KU.KV.KW.KX.KY.KZ.K0.K1.K2.K3.K4.K5.K6.K7.K8.K9.L..L#.La.Lb.Lc.Ld.Le.Lf.Lg.Lh.Li.Lj.Lk.K9.K9.Ll.Ll.Lm.Ln.Lo.Lp.Lq.Lr.Ls.Lt.L.",
".Lu.Lv.Lw.Lx.Ly.Lz.LA.LB.LC.LD.LE.LF.LG.LH.LI.LJ.LK.LL.LM.LN.LO.LP.LQ.LR.LS.LT.LU.LV.LW.LX.LY.LZ.L0.L1.L2.L3.L4.L5.L6.L7.L8.L9.M..M#.Ma.Mb.Mc.Md.Me.Me.Mf.Mg.Mh.Mi.Mj.Mk.Ml.Mm.Mn.Mo.Mp.Mq.Mr.Ms.Mt.Mu.Mv.Mw.Mx.My.My.Mz.MA.MB.MC.MD.ME.MF.MG.MH",
".MI.MJ.MK.ML.MM.MN.MO.MP.MQ.MR.MS.MT.MU.MV.MW.MX.MY.MZ.M0.M1.M2.M3.M4.M5.M6.M7.M8.M9.N..N#.Na.Nb.Nc.Nd.Ne.Nf.Ng.Nh.Ni.Nj.Nk.Nl.Nm.Nn.No.Iu.Np.Nq.Nr.Ns.Nt.Nu.Nv.Nw.Nx.BE.Ny.Nz.NA.Nv.NB.NC.ND.NE.NF.NG.NH.NI.NJ.NK.NK.NL.NM.NN.NO.NP.NQ.NR.NS.NT",
".NU.NV.NW.NX.NY.NZ.N0.N1.N2.N3.N4.N5.N6.N7.N8.N9.O..O#.Oa.Ob.Oc.Od.Oe.Of.Og.Oh.Oi.Oj.Ok.Ol.Om.On.Oo.Op.Oq.Or.Os.Ot.Ou.Ov.Ow.Ox.Oy.Oz.OA.OB.OC.OD.OE.OF.OG.OH.OI.OJ.OK.OL.OM.ON.OO.OP.OQ.OR.OS.OT.OU.OV.OW.OX.OY.OZ.O0.O1.O2.O3.O3.O3.O4.O5.O6.O6",
".O7.O8.O9.P..P#.Pa.Pb.Pc.Pd.Pe.Pf.Pg.Ph.Pi.Pj.Pk.Pl.Pm.Pn.Po.Pp.Pq.Pr.Ps.Pt.Pu.Pv.Pw.Px.Py.Pz.PA.PB.PC.PD.PE.PF.PG.PH.PI.PJ.PK.PL.PM.PN.PO.PP.PQ.PR.PS.PT.PU.PV.PW.PX.PY.PZ.P0.P1.P2.P3.P4.P5.P6.P7.P8.P9.Q..Q#.Qa.Qb.Qc.Qd.Qe.Qf.Qg.Qh.Qh.Qi.Qj",
".Qk.Ql.Qm.Qn.Qo.Qp.Qq.Qr.Qs.Qt.Qu.Qv.Qw.Qx.Qy.Qz.QA.QB.QC.QD.QE.QF.QG.QH.QI.QJ.QK.QL.QM.QN.QO.QP.QQ.QR.QS.QT.QU.QV.QW.QX.QY.QZ.Q0.A#.Q1.Q2.Q3.Q4.Q5.Q6.Q7.Q8.Q9.R..R#.Ra.Rb.Rc.Rd.Re.Rf.Rg.Rh.Ri.Rj.Rk.Rl.Rm.Rn.Ro.Rp.Rq.Rr.Rs.Rt.Ru.Rv.My.Rw.Rx",
".Ry.Rz.RA.RB.RC.RD.RE.RF.RG.RH.RI.RJ.RK.RL.RM.RN.RO.RP.RQ.RR.RS.RT.RU.RV.RW.RX.RY.RZ.R0.R1.R2.R3.R4.R5.R6.R7.R8.R9.S..S#.Sa.Sb.Sc.Sd.Se.Sf.Sg.Sh.Si.Sj.Sk.Sl.Sm.Sn.So.Sp.Sq.Sr.Ss.St.Su.Sv.Dp.Sw.Jx.Sx.Sy.Sz.SA.SB.SC.SD.SE.SF.SG.SH.SI.SJ.SK.SL",
".SM.SN.SO.SP.SQ.SR.SS.ST.SU.SV.SW.SX.SY.SZ.S0.S1.S2.S3.S4.S5.S6.S7.S8.S9.T..T#.Ta.Tb.Tc.Td.Te.Tf.Tg.Th.Ti.Tj.Tk.Tl.Tm.Tn.To.Tp.Tq.Tr.Ts.Tt.Tu.Tv.Tw.Tx.Ty.Tz.TA.TB.TC.TD.TE.TF.TG.TH.TI.TJ.TK.TL.TM.TN.TO.TP.TQ.TR.TS.TT.TU.TV.TW.TX.TY.TZ.T0.T1",
".T2.T3.T4.T5.T6.T7.T8.T9.U..U#.Ua.Ub.Uc.Ud.Ue.Uf.Ug.Uh.Ui.Uj.Uk.Ul.Um.Un.Uo.Up.Uq.Ur.Us.Ut.Uu.Uv.Uw.Ux.Uy.Uz.UA.UB.UC.UD.UE.UF.UG.UH.UI.UJ.UK.UL.UM.UN.UO.UP.UQ.UR.US.UT.UU.UV.UW.UX.UY.UZ.U0.U1.U2.U3.U4.U5.U6.U7.U8.U9.V..V#.Va.Vb.Vc.Vd.Ve.Vf",
".Vg.Vh.Vi.Vj.Vk.Vl.Vm.Vn.Vo.Vp.Vq.Vr.Vs.Vt.Vu.Vv.Vw.Vx.Vy.Vz.VA.VB.VC.VD.VE.VF.VG.VH.VI.VJ.VK.VL.VM.VN.VO.VP.VQ.VR.VS.VT.VU.VV.VW.VX.VY.VZ.V0.V1.V2.V3.V4.V5.V6.V7.V8.V9.W..W#.Wa.Wb.Wc.Wd.We.Wf.Wg.Wh.Wi.uq.Wj.qF.Wk.Wl.Wm.Wn.Wo.Wp.Wq.Wr.Ws.Wt",
".Wu.Wv.Ww.Wx.Wy.Wz.WA.WB.WC.WD.WE.WF.WG.WH.WI.WJ.WK.WL.WM.WN.WO.WP.WQ.WR.WS.WT.WU.WV.WW.WX.WY.WZ.W0.W1.W2.W3.W4.W5.W6.W7.W8.W9.X..X#.Xa.Xb.Xc.Xd.Xe.Xf.Xg.Xh.Xi.Xj.Xk.Xl.Xm.Xn.Xo.sN.Xp.Xq.Xr.Xs.Xt.Xu.Xv.Xw.Xx.Xy.Xz.XA.XB.XC.XD.XE.XF.XG.XH.XI",
".XJ.XK.XL.XM.XN.XO.XP.XQ.XR.XS.XT.XU.XV.XW.XX.XY.XZ.X0.X1.vg.X2.X3.X4.X5.X6.WR.X7.X8.X9.Y..Y#.Ya.Yb.Yc.Yd.Ye.Yf.Yg.Yh.Yi.Yj.Yk.Yl.Ym.Yn.Yo.Yp.Yq.Yr.Ys.Yt.Yu.Yv.Yw.Yx.Yy.Yz.YA.YB.YC.YD.YE.YF.YG.YH.YI.YJ.YK.YL.YM.YN.YO.YP.YQ.YR.YS.YT.YU.YV.YW",
".YX.YY.YZ.Y0.Y1.Y2.Y3.Y4.Y5.Y6.Y7.Y8.Y9.Z..Z#.Za.Zb.Zc.Zd.Ze.Zf.Zg.Zh.Zi.Zj.Zk.Zl.Zm.Zn.Zo.Zp.Zq.Zr.Zs.Zt.Zu.Zv.Zw.Zx.Zy.Zz.ZA.ZB.ZC.ZD.ZE.ZF.ZG.ZH.ZI.ZJ.ZK.ZL.ZM.ZN.ZO.ZP.ZQ.ZR.ZS.ZT.ZU.ZV.ZW.ZX.ZY.ZZ.Z0.Z1.Z2.Z3.Z4.Z5.Z6.Z7.Z8.Z9.0..0#.0a",
".0b.0c.0d.0e.0f.0g.0h.0i.0j.0k.0l.0m.0n.0o.0p.0q.0r.0s.0t.0u.0v.0w.0x.0y.0z.0A.0B.0C.0D.0E.0F.0G.0H.0I.0J.0K.X1.0L.0M.0N.0O.0P.0Q.0R.0S.0T.0U.0V.0W.0X.0Y.0Z.00.01.02.03.04.05.06.07.ZX.08.09.1..1#.1a.1b.1c.1d.1e.1f.1g.1h.1i.1j.1k.1l.1m.1n.1o",
".1p.1q.1r.1s.1t.1u.1v.1w.1x.1y.1z.1A.1B.1C.1D.1E.1F.1G.1H.1I.1J.1K.1L.1M.1N.1O.1P.1Q.1R.1S.1T.1U.1V.1W.1X.1Y.1Z.10.11.12.13.14.15.16.17.18.19.2..2#.2a.2b.2c.2d.2e.2f.2g.2h.2i.2j.2k.2l.2m.2n.2o.2p.2q.2r.2s.2t.2u.2v.2w.2x.2y.2z.2A.XF.2B.2C.2D",
".2E.2F.2G.2H.2I.2J.2K.2L.2M.2N.2O.2P.2Q.2R.2S.2T.2U.2V.2W.2X.2Y.2Z.20.21.22.23.24.25.26.27.28.29.3..3#.3a.3b.3c.3d.3e.3f.3g.3h.3i.3j.3k.3l.3m.3n.3o.3p.3q.3r.3s.3t.3u.3v.3w.3x.3y.3y.3z.3A.3B.3C.3D.3E.3F.3G.3H.3I.3J.3K.3L.2t.3M.3N.1l.3O.3P.3Q",
".3R.3S.3T.3U.3V.3W.3X.3Y.3Z.30.31.32.33.34.35.36.37.38.39.4..4#.4a.4b.4c.4d.4e.4f.4g.4h.4i.4j.4k.4l.4m.4n.4o.4p.4q.4r.4s.4t.4u.4v.4w.4x.4y.4z.4A.4B.4C.4D.4E.4F.4G.4H.4I.4J.4K.4L.4M.4N.4O.4P.4Q.4R.4S.4T.4U.4V.4W.4X.4Y.4Z.40.41.42.Av.43.44.45",
".46.47.48.49.5..5#.5a.5b.5c.5d.5e.5f.5g.5h.5i.5j.5k.5l.5m.5n.5o.5p.5q.5r.5s.5t.5u.5v.5w.5x.5y.5z.5A.5B.Hx.5C.5D.5E.5F.5G.5H.5I.5J.5K.5L.5M.5N.5O.5P.5Q.5R.5S.5T.5U.5V.5W.5X.5Y.5Z.50.51.52.53.54.3F.55.56.57.57.58.59.59.Xz.6..6#.6a.6b.6c.6d.6e",
".6f.6g.6h.6i.6j.6k.6l.6m.6n.6o.6p.6q.6r.6s.6t.6u.6v.6w.6x.6y.6z.6A.6B.6C.6D.6E.6F.6G.6H.6I.GP.6J.6K.6L.6M.6N.6O.6P.6Q.6R.6S.6T.6U.6V.6W.6X.6Y.6Z.60.61.62.63.64.65.66.67.68.69.7..7#.7a.7b.7c.7c.7d.7e.7f.3K.7g.7h.7i.7i.7j.7k.7l.7m.7n.7o.7p.7q",
".7r.7s.7t.7u.7v.7w.7x.7y.7z.7A.7B.7C.7D.7E.37.7F.7G.7H.7I.7J.7K.7L.7M.7N.7O.7P.7Q.7R.7S.7T.7U.7V.7W.7X.7Y.7Z.70.71.72.73.74.75.76.77.78.79.8..8#.8a.8b.8c.8d.8e.8f.8g.8h.8i.8j.8k.8l.8m.8n.8o.8p.8q.8r.8s.8t.8u.7N.8v.8v.8w.8x.8y.8z.8A.8B.8C.8D",
".8E.8F.8G.8H.8I.8J.8K.8L.8M.8N.8O.8P.8Q.8R.8S.8T.8U.8V.8W.8X.8Y.8Z.80.81.82.83.84.85.86.87.88.89.9..9#.9a.9b.9c.9d.9e.9f.9g.9h.9i.9j.9k.9l.9m.9n.9o.9p.9q.9r.9s.9t.9u.9v.9w.9x.9y.9z.9A.9B.9C.8p.9D.9D.9E.9F.9G.9H.9I.9J.9K.9L.9M.9N.9O.9P.9Q.9R",
".9S.9T.9U.9V.9W.9X.9Y.9Z.90.91.92.93.94.95.96.97.98.99#..#.##.a#.b#.c#.d#.e#.f#.g#.h#.i#.j#.k#.l#.m#.n#.o#.p#.q#.r#.s#.t#.u#.v#.w#.x#.y#.z#.A#.B#.C#.D#.E#.F#.G#.H#.I#.I#.J#.K#.L#.M#.N#.O#.P#.Q#.R#.S.7f#.T#.U#.V#.W#.W#.X.9G#.Y#.Z#.0#.1#.2#.3",
"#.4#.5#.6#.7#.8#.9##.#####a##b##c##d##e##f##g##h##i##j##k##l##m##n##o##p##q##r##s##t##u##v##w##x##y##z##A##B##C##D##E##F##G##H##I##J##K##L##M##N##O##P##Q##R##S##T##U##V##W##X##Y##Z##0##1##2##3##4##5##6##7##7##8##9#a.#a##aa#ab#ac#ad#ae#.0#af",
"#ag#ah#ai#aj#ak#al#am#an#ao#ap#aq#ar#as#at#au#av#aw#ax#ay#az#aA#aB#aC#aD#aE#aF#aG#aH#aI#aJ#aK#aL#aM#aN#aO#aP#aQ#aR#aS#aT#aU#aV#aW#aX#aY#aZ#a0#a1#a2#a3#a4#a5#a6#a7#a8#a9#b.#b##ba#bb#bc#bd#be#bf#bg.4S#bh#bi#bj.7f##8.8r#bk.54#bl#bm#bn#bo#bp#bq",
"#br#bs#bt#bu#bv#bw#bx#by#bz#bA#bB#bC#bD#bE#bF#bG#bH#bI#bJ#bK#bL#bM#bN#bO#bP#bQ#bR#bS#bT#bU#bV#bW#bX#bY#bZ#b0#b1#b2#b3#b4#b5#b6#b7#b2#b8#b9#c.#c##ca.eu#cb#cc#cd#ce#cf#c##cg#ch#ci#cj#ck.9K#cl#cm#cn#co#cp#cq#cr#cs#ct#cu#cv#cw#cx#cy#cz#cA#cB#cC",
"#cD#cE#cF#cG#cH#cI#cJ#cK#cL#cM#cN#cO#cP#cQ#cR#cS#cT#cU#cV#cW#cX#cY#cZ#c0#c1#c2#c3#c4#c5#c6#c7#c8#c9#d.#d##da#db#dc#dd#de#df#dg#dh#di#dj#dk.ph#dl#dm#dn#do#dp#dq#dr#ds#dt#du#du#dv#dw#dx#dy#dz#dA#dB#dC#dD#dE#dF#dG#dH#dI#dJ#dK#.m#dL#dM#cA#dN#dO",
"#dP#dQ#dR#dS#dT#dU#dV#dW#dX#dY#dZ#d0#d1#d2#d3#d4#d5#d6#d7#d8#d9#e.#e##ea#eb#ec#ed#ee#ef#eg#eh#ei#ej#ek#el#em#en#eo#ep#eq#er#es#et#eu#ev#ew#ex#ey.hQ#ez#eA#eB#eC#eD#eE#eF#eG#eH#eI#eJ#eK#eL#eM#eN#eO#eP#eQ#eR#eS#eT#eU#eV#cy#eW#dL#dM#eX#eY#eZ#eK",
"#e0#e1#e2#e3#e4#e5#e6#e7#e8#e9#f.#f##fa#fb#fc#fd#fe#ff#fg#fh#fi#fj#fk#fl#ee#fm#fn#fo#fp#fq#fr#fs#ft#fu#fv#fw#fx#fy#fz#fA#fB#fC#fD#fE#fF#fG#fH#fI#fJ#fK#fL#fM#fN#fO#fP#fQ#fR#fS#fT#fU#eH#fV#fW#fX#fY#fY#fZ#f0#f1#f2#f3#f4#f5#f5#f5#f6#f7#f8#f9#g.",
"#g##ga#gb#gc#gd#ge#gf#gg#gh#gi#gj#gk#gl#gm#gn#go#gp#gq#gr#gs#gt#gu#gv#gw#gx#gy#gz#gA#gB#gC#gD#gE#gF#gG#gH#gI#gJ#gK#gL#gL#gM#gN#gO#gP#gQ#gR#gS#gT#gU#gV#gW#gX#gY#gZ#g0#g1#g2#g3#g4#g5#g6#g7#g8#g9#h.#h##ha#hb#hc#hd#he#hf#hg#hh#hi#hj#hk#hl#hm#hn",
"#ho#hp#hq#hr#hs#ht#hu#hv#hw#hx#hy#hz#hA#hB#hC#hD#hE#hF#hG#hH#hI#hJ#hK#hL#hM#hN#hO#hP#hQ#hR#hS#hT#hU#hV#hW#gH#hX#hY#hZ#hR#h0#h1#h2#h3#h4#h5#h6#h7#h8#h9#i.#i##ia#ib#ic#id#ie#if#ig#ih#ii#ij#ik#il#im.hj#in#io#ip#iq#ir#is#it#iu#iv#iw#ix#iy#iz#iA",
"#iB#iC#iD#iE#iF#iG#iH#iI#iJ#iK#iL#iM#iN#iO#iP#iQ#iR#iS#iT#iU#iV#iW#iX#iY#iZ#i0#iZ#i1#i2#i3#i4#i5#i6#i7#i8#i9#j.#j##j##ja#jb#jc#jd#je#jf#jg#jh#ji#jj#jk#jl#jm#i.#jn#jo#jp#jk#jq#jr#js#jt#ju#jv#jw#jx#jy#jz#jA#jB#jC#jD#jE#jF#jG#jH#jI#jJ#jK#jL#jM",
"#jN#jO#jP#jQ#jR#jS#jT#jU#jV#jW#jX#hy#jY#jZ#j0#j1#j2#j3#j4#j5#j6#j7#j8#j9#k.#jo#k##ka#kb#kc#kd#ke#kf#kg#kh#ki#kj#kk#kl#km#kn#ko#kp#kq#kr#ks#kt#ku#kv#kw#kx#ky#kz#i.#kA#kB#kC#kD#kE#kF#kG#kH#kI#kJ#kK#kL#kM#kN#kO#kP#kQ#kR#kS#kT#kU#kV#kW#kX#kY#kZ",
"#k0#k1#k2#k3#k4#k5#k6#k7#k8#k9#l.#l##la#lb#lc#ld#le#lf#lg#lh.Cx#li#lj#lk#ll#lm#ln#lo#lp#lq#lr#ls#i3#lt#lu#lv#lw#lx#ly#lz#lA#lB#lC#lD#lE#lF#lG#lH#lI#lJ#lK#lK#lL#lM#lN#lO#lP#lQ#lR#lS#lT#lU#lV#lW#lX#lY#lZ#l0#l0#l1#l2#l3#l4#l5#l6#l7#l8#l9#m.#m#",
"#ma#mb#mc#md#me#mf#mg#mh#mi#mj#mk#ml#mm#mn#mo#mp#mq#mr#ms#mt#mu#mv#mw#mx#my#mz#mA#mB#mC#i1#mD#mE#mF#mG#mH#mI#ja#mJ#mK#mL#mM#mN#mO#mP#hW#mQ#mR#mS#mT#mU#mV#mV#mW#mX#mY#mZ#m0#m1#m2#m3#m4#m5#m6#m7#m8#m9#n.#n##na#n##nb#nc#nd#l4#ne#l6#nf#ng#nh#ni",
"#nj#nk#nl#nm#nn#no#np#nq#nr#ns#nt#nu#nv#nw#nx#ny#nz#nA#nB#nC#nD#nE#nF#nG#nH#nI#nJ#nK#nL#nM#nN#nO#nP#nQ#nQ#nR#nS#nT#nU#kb#nV#mV#nW#nX#nY#nZ#mE#n0#n1#n2#n3#n4#n5#aq#n6#n7#n8#n9#o.#o##oa#ob#oc#od#oe#of#og#oh#oi#oj#ok#ol#om#on#oo#op#oq#or#os#ot",
"#ou#ov#ow#ox#oy#oz#oA#oB#oC#oD#oE#oF#oG#oH#oI#oJ#oK#oL#oM#oN#oO#oP#oQ#oR#oS#oT#oU#oV#oW#oX#oY#oZ#o0#o1#o2#nQ#o3#o4#lq#o5#n6#o6#o7#o8#o9#p.#p##pa#pb#pc#o5#pd#pe#pf#nU#pg#ph#pi#pj#pk#pl#pm#pn#po#pp#pq#pr#ps#pt#pu#pv#pw#px#py#pz#pA#pB#pC#pD#pE",
"#pF#pG#pH#pI#pJ#pK#pL#pM#pN#pO#pP#pQ#oG#pR#pS#pT#pU#pV#pW#pX#pY#pZ#p0#p1#p2#p3#p4#p5#p6#p7#p8#p9#q.#q##qa#qb#n1#qc#qd#qe#qf#qg#qh#qi#qj#qk#ql#qm#qn#qo#qp#qq#qr#qs#qt#qu#qv#qw#qx#qy#qz#qA#qB#qC#qD#qE#qF#qG#qH#qI#qJ#qK#qL#qM#qN#qO#py#qP#qQ#qR",
"#qS#qT#qU#qV#qW#qX#qY#qZ#q0#q1#q2#q3#q4#q5#q6#q7#q8#q9#r.#r##ra#rb#rc#rd#re#rf#rg#rh#ri#rj#rk#rl#rm#rn#qd#ro#rp#rq#rr#rs#rt#ru#rv#rw#rx#ry#rz#fq#rA#rB#rA#rC#rD#rE#rF#rG#rH#rH#rI#rJ#rK#rL#rM#rN#rO#rP#rQ#rR#rS#rT#rU#rV#rW#rX#rY#rZ#r0#r1#r2#r3",
"#r4#r5#r6#r7#r8#r9#s.#s#.8M#sa#sb#sc#sd#se#sf#sg#sh#si#sj#sk#sl#sm#sn#so#sp#sq#sr#ss#st#su#sv#sw#sx#sy#sz#sA#sB#sC#sD#sE#sF#sG#sH#sI#sJ#sK#sL#sM#sN#sO#sP#sQ#sQ#sR#sR#sS#sT#sU#sU#sV#sW#sX#rV#rV#sY#sZ#s0#s1#s2#s3#s4#s5#s6#s7#s8#s9#t.#t##ta#tb",
"#tc#r4#td#te#tf#tg#th#ti#tj#tk#tl#tm#tn#to#tp#tq#tr#ts#tt#tu#tv#tw#tx#ty#tz#tA#tB#tC#tD#tE#tF#tG#tH#tI#tJ#tK#tL#tM#tN#kt#tO#tP#tQ#tR#tS#tT#tU#tV#tW#tX#tY#tZ#t0#t1#t2#t2#t3#t4#t5#t6#t7#t8#t9#u.#u##ua#ub#uc#ud#ue#uf#ug#uh#ui#uj#uk#ul#um#un#uo",
"#up#uq#ur#us#ut#uu#uv#uw#ux#uy#uz#uA#uB#uC#uD#uE#uF#uG#uH#uI#uJ#uK#uL#uM#uN#uO#uP#uQ#uR#uS#uT#uU#uV#uW#uX#uY#uZ#u0#u1#u2#u3#u4#u5#u6#u7#u8#u9#v.#v##va#vb#vc#vd#ve#vf#vg#vh#vi#vj#vk#vl#vm#vn#vo#vp#vq#vr#vs#vt#vu#vv#vw#vx#vy#vz#vA#vB#vC#vD#vE",
"#vF#vG#vH#vI#vJ#vK#vL#vM#vN#vO#vP#vQ#vR#vS#vT#vU#vV#vW#vX#uI#vY#vZ#v0#v1#v2#v3#v4#v5#v6#v7#v8#v9#w.#w##wa#wb#wc#wd#we#wf#wg#wh#wi#wj#wk#wl#wm#wn#wo#wp#wq#wr#qG#ws#wt#wu#wv#ww#wx#wy#wz#wA#wB#wC#wD#wE#wF#wG#wH#wI#wJ#wK#wL#wM#wN#wO#wP#wQ#qA#wR",
"#wS#wT#wU#wV#wW#wX#wY#wZ#w0#w1#w2#w3#w4#w5#w6#w7#w8#w9#x.#x##xa#xb#xc#xd#xe#xf#xg#xh#xi#xj#ss#xk#xl#xm#xn#xo#xp#xq#xr#xs#xt#xu#xv#xw#xx#xy#xz#xA#xB#n5#xC#xD#xE#xF#xG#xH#xI#xJ#xK#xL#xM#xN#xO#xP#xQ#xR#xS#xT#xU#xV#xW#xX#xY#xZ#x0#qK#rN#x1#x2#x3",
"#x4#x5#x6#x7#x8#x9#y.#y##ya#yb#yc#yd#ye#yf#yg#yh#yi#yj#yk#yl#ym#yn#yo#yp#hp#yq#yr#ys#yt#yu#yv#yw#yx#yy#yz#yA#yB#yC#yD#yE#yF#yG#yH#yI#yJ#yK#yL#yM#yN#yO#yP#yQ#yR#yS#yT#yU#yV#yW#yX#yY#yZ#y0#y1#y2#y3#y4#y5#y6#y7#y8#y9#z.#z##za#zb#zc#zd#pb#ze#zf",
"#zg#zh#zi#zj#zk#zl#zm#zn#zo#zp#zq#zr#zs#zt#zu#zv#zw#zx#zy#zz#zA#zB#zC#zD#zE#zF#zG#zH#zI#zJ#zK#zL#zM#zN#zO#zP#zQ#zR#zS#zT#zU#zV#zW#zX#zY#zZ#z0#z1#z2#z3#z4#z5#z6#z7#z8#z9#A.#A##Aa#Ab#Ac#Ad#Ae#Af#Ag#Ah#Ai#Aj#Ak#Al#Am#An#Ao#Ap#Aq#Ar#As#At#Au#Av",
"#Aw#Ax#Ay#Az#AA#AB#AC#AD#AE#w1#AF#AG#AH#AI#AJ#AK#AL#AM#AN#AO#AP#AQ#AR#AS#AT#AU#AV#AW#AX#AY#AZ#A0#A1#A2#A3#A4#A5#A6#A7#A8#A9#B.#B##Ba#Bb#Bc#Bd#Be#Bf#wg#Bg#Bh#Bi#Bj#Bk#Bl#Bm#Bn#Bo#Bp#Bq#Br#Bs#Bt#Bu#Bv#Bw#Bx#By#Bz#BA#BB#BC#BD#BE#BF#BG#BH#BI#BJ",
"#BK#BL#BM#BN#BO#BP#BQ#BR#BS#BT#BU#BV#iO#BW#BX#BY#BZ#B0#B1#B2#B3#B4#B5#B6#B7#B8#B9#C.#C##Ca#Cb#Cc#Cd#Ce#Cf#Cg#Ch#Ci#Cj#Ck#Cl#Cm#Cn#Co#Cp#Cq#Cr#Cs#Ct#Cu#Cv#Cw#Cx#Cy#Cz#CA#CB#CC#CD#CE#CF#CG#CH#CI#j9#CJ#qK#CK#CL#CM#c3#CN#CO#CP#CQ#CR#CS#CT#CU#CV",
"#CW#CX#CY#CZ#C0#C1#C2#C3#C4#C5#C6#C7#C8#C9#D.#D##Da#Db#Dc#Dd#De#Df#Dg#Dh#Di#Dj#Dk#Dl#Dm#Dn#Do#Dp#Dq#Dr#Ds#Dt#Du#Dv#Dw#Dx#Dy#Dz#DA#DB#DC#DD#DE#DF#DG#DH#DI#DJ#DK#DL#DM#DN#DO#DP#DQ#DR#DS#DT#DU#DV#pi#DW#ug#DX#DY#DZ#D0#D1#D2#D3#D4#D5#D6#D7#D8#D9",
"#E.#E##Ea#Eb#Ec#Ed#Ee#Ef#Eg#Eh#Ei#Ej#Ek#El#Em#En#Eo#Ep#Eq#Er#Es.Ym#Et#Eu#Ev#Ew#Ex#Ey#Ez#EA#EB#EC#ED#EE#EF#EG#EH#EI#EJ#EK#EL#EM#EN#EO#EP#EQ#ER#ES#ET#EU#EV#EW#EX#EY#EZ#E0#E1#E2#qy#E3#E4#E5#E6#E7#E8#E9#F.#F##tY#Fa#Fb#Fc#Fd#Fe#Ff#Fg#Fh#Fi#Fj#Fk",
"#Fl#Fm#Fn#Fo#Fp#Fq#Fr#Fs#Ft#Fu#Fv#Fw#Fx#Fy#Fz#FA#FB#FC#FD#FE#FF#FG#FH#FI#FJ#FK#FL#FM#FN#FO#FP#FQ#FR#FS#FT#FU#FV#FW#FX#FY#FZ#F0#F1#F2#F3#F4#F5#F6#F7#F8#F9#G.#G##Ga#Gb#Gc#Gd#Ge#Gf#Gg#Gh#Gi#Gj#Gk#Gl#Gm#Gn#Go#BE#Gp#Gq#Gr#Gs#Gt#Gu#Gv#Gw#Gx#Gy#Gz",
"#GA#GB#GC#GD#GE#GF#GG#GH#GI#GJ#GK#GL#GM#GN#GO#GP#GQ#GR#GS#GT#GU#GV#GW#GX#GY#GZ#G0#G1#G2#G3#G4#G5#G6#G7#G8#G9#H.#H##Ha#Hb#Hc#Hd#He#Hf#Hg#Hh#Hi#Hj#Hk#Hl#Hm#Hn#Ho#Hp#Hq#Hr#Hs#Ht#Hu#Hv#Hw#Hx#Hy#Hz#HA#kh#HB#HC#HD#HE#HF#HG#HH#HI#HJ#HK#HL#HM#HN#HO",
"#HP#HQ#HR#HS#HT#HU#HV#HW#HX#HY#HZ#H0#H1#H2#H3#H4#H5#H6#H7#H8#H9#I.#I##Ia#Ib#Ic#Id#Ie#If#Ig#Ih#Ii#Ij#Ik#Il#Im#In#Io#Ip#Iq#Ir#Is#It#Iu#Iv#Iw#Ix#Iy#Iz#IA#IB#IC#ID#IE#IF#IG#IH#II#IJ#IK#IL#IM#IN#IO#IP#IQ#IR#IS#IT#IU#IV#IW#IX#IY#IZ#I0#I1#I2#I3#I4",
"#I5#I6#I7#I8#I9#J.#J##Ja#Jb#Jc#Jd#Je#Jf#Jg#Jh#Ji#Jj#Jk#Jl#Jm#Jn#Jo#Jp#Jq#Jr#Js#Jt#Ju#Jv#Jw#Jx#Jy#Jz#JA#JB#JC#JD#JE#JF#JG#JH#JI#JJ#JK#JL#JM#JN#JO#JP#JQ#JR#JS#JT#JU#JV#JW#JX#ET#JY#JZ#J0#J1#J2#J3#J4#J5#J6#J7#J8#J9#K.#K##Ka#Kb#Kc#Kd#Ke#Kf#Kg#Kh",
"#Ki#Kj#Kk#Kl#Km#Kn#Ko#Kp#Kq#Kr#Ks#Kt#Ku#Kv#Kw#Kx#Ky#Kz#KA#KB#KC#KD#KE#KF#KG#KH#KI#KJ#KK#KL#KM#KN#KO#KP#KQ#KR#KS#KT#KU#KV#KW#KX#KY#KZ#K0#K1#K2#K3#K4#K5#K6#K7#K8#K9#L.#L##La#Lb#Lc#Ld#Le#Lf#Lg#Lh#Li#Lj#Lk#Ll#Lm#Ln#jq#Lo#Lp#Lq#Lr#Ls#Lt#Lu#Lv#Lv",
"#Lw#Lx#Ly#Lz#LA#LB#LC#LD#LE#LF#LG#LH#LI#LJ#LK#LL#LM#LN#LO#LP#LQ#LR#LS#LT#LU#LV#LW#LX#LY#LZ#L0#L1#L2#L3#L4#L5#L6#L7#L8#L9#M.#M##Ma#Mb#Mc#Md#Me#Mf#Mg#Mh#Mi#Mj#Mk#Ml#Mm#Mn#Mo#Mp#Mq#Mr#Ms#Mt#Mu#Mv#Mw#Mx#My#m0#Mz#MA#MB#MC#MD#ME#MF#MG#MH#MI#MJ#MJ",
"#MK#ML#MM#MN#MO#MP#MQ#MR#MS#MT#MT#MU#MV#MW#MX#MY#MZ#M0#M1#M2#M3#M4#M5#M6#M7#M8#M9#N.#N##Na#Nb#Nc#Nd#Ne#Nf#Ng#Nh#Ni#Nj#Nk#Nl#Nm#Nn#No#Np#Nq#Nr#Ns#Nt#Nu#Nv#Nw#Nx#Ny#Nz#NA#NB#NC#ND#NE#NF#NG#NH#NI#NJ#NK#NL#NM#NN#NO#NP#NQ#NR#NS#NT#NU#NV#NW#NX#NY",
"#NZ#N0#N1#N2#N3#N4#N5#N6#N7#N8#N9#O.#O##Oa#Ob#Oc#Od#Oe#Of#Og#Oh#Oi#Oj#Ok#Ol#Om#On#Oo#Op#Oq#Or#Os#Ot#Ou#Ov#Ow#Ox#Oy#Oz#OA#OB#OC#KM#OD#OE#OF#OG#OH#OI#OJ#OK#OL#OM#ON#OO#OP#OQ#OR#OS#OT#OU#OV#OW#OX#OY#OZ#O0#O1#O2#O3#O4#O5#O6#O7#h##O8#O9#P.#P##Pa",
"#Pb#MQ#Pc#Pd#Pe#Pf#Pg#Ph#Pi#Pj#Pk#Pl#Pm#Pn#Po#Pp#Pq#Pr#Ps#Pt#Pu#Pv#Pw#Px#Py#Pz#PA#PB#PC#PD#PE#PF#PG#PH#PI#PJ#PK#PL#PM#PN#PO#PP#PQ#PR#PS#PT#PU#PV#PW#PX#PY#PZ#P0#P1#P2#P3#P4#P5#P6#P7#P8#P9#Q.#Q##Qa#Qb.po#Qc#Qd#Qe#Qf#Qg#Qh#Qi#Qj#Qk#Ql#Qm#Qn#Qo",
"#Qp#Qq#Qr#Qs#Qt#Qu#Qv#Qw#Qx#Qy#Qz#QA#QB#QC.FI#QD#QE#QF#QG#QH#QI#QJ#QK#QL#QM#QN#QO#QP#QQ#QR#QS#QT#QU#QV#QW#QX#QY#QZ#Q0#Q1#Q2#Q3#Q4#Q5#Q6#Q7#Q8#Q9#R.#R##Ra#Rb#Rc#Rd#Re#Rf#Rg#Rh#Ri#Rj#Rk#Rl#Rm#Rn#Ro#Rp#Rq#Rr#Rs#Rt#Ru#Rv#Rw#Rx#Ry#Rz#RA#RB#RC#RD",
"#RE#RF#RG#RH#RI#RJ#RK#RL#RM#RN#RO#RP#RQ#RR#RS#RT#RU#RV#RW#RX#RY#RZ#R0#R1#R2#R3#R4#R5#R6#R7#R8#R9#S.#S##Sa#Sb#Sc#Sd#Se#Sf#Sg#Sh#Si#Sj#Sk#Sl#Sm#Sn#So#Sp#Sq#Sr#Ss#St#Su#Sv#Sw#Sx#Sy#Sz#SA#SB#SC#SD#SE#SF#SG#SH#SI#SJ#SK#SL#SM#SN#SO#SP#SQ#SR#SS#ST",
"#SU#SV#SW#SX#SY#SZ#S0#S1#S2#S3#S4#S5#RQ#S6#S7#S8#S9#T.#T##Ta#Tb#Tc#Td#Te#Tf#Tg#Th#Ti#Tj#Tk#Tl#QB#Tm#Tn#To#Tp#Tq#Tr#Ts#Tt#Tu#Tv#Tw#Tx#Ty#Tz#TA#TB#TC#TD#TE#TF#TG#TH#TI#TJ#TK#TL#TM#TN#TO#TP#TQ#TR#TS#TT#TU#TV#TW#TX#TY#TZ#T0#T1#T2#T3#T4#T5#T6#T7",
"#T8#T9#U.#U##Ua#Ub#Uc#Ud#Ue#Uf#Ug#Uh#Ui#Uj#Uk#Ul#Um#Un#Uo#Up#Uq#Ur#Us#Ut#Uu#Uv#Uw#Ux#Uy#Uz#UA#UB#UC#UD#UE#UF#UG#UH#UI#UJ#UK#UL#UM#UN#UO#UP#UQ#UR#US#UT#UU#UV#UW#UX#UY#UZ#U0#U1#U2#U3#U4#U5#U6#U7#U8#U9#V.#V##Va#Vb#Vc#Vd#Ve#Vf#Vg#Vh#Vi#Vj#Vk#Vl",
"#Vm#Vn#Vo#Vp#Vq#Vr#Vs#Vt#Vu#Tl#Vv#Vw#Vx#Vy#Vz#VA#VB#VC#VD#VE#VF#VG#VH#VI#VJ#VK#VL#VM#VN#VO#VP#VQ#VR#VS#VT#VU#VV#VW#VX#VY#VZ#V0#V1#V2#V3#V4#V5#V6#V7#V8#V9#W.#W##Wa#Wb#Wc#Wd#We#Wf#Wg#Wh#Wi#Wj#Wk#Wl#Wm#Wn#Wo#Wp#Wq#Wr#Ws#Wt#Wu#Wv#Ww#Wx#Wy#Wz#WA",
"#WB#WC#WD#WE#WF#WG#WH#WI#WJ#WK#WL#Vx#WM#WN#WO#WP#WQ#WR#WS#WT#WU#WV#WW#WX#WY#WZ#W0#W1#W2#W3#W4#W5#W6#W7#W8#W9#X.#X##Xa#Xb#Xc#Xd#Xe#Xf#Xg#Xh#Xi#Xj#Xk#Xl#Xm#Xn#Xo#Xp#Xq#Xr#Xs#Xt#Xu#Xv#Xw#DP#Xx#Xy#Xz#XA#XB#XC#XD#XE#XF#XG#XH#XI#XJ#XK#XL#XM#XN#XO",
"#XP#XQ#XR#Vp#XS#XT#XU#XV#XW#XX#XY#XZ#X0#X1#X2#X3#X4#X5#X6#X7#X8#X9#Y.#Y##Ya#Yb#Yc#Yd#Ye#Yf#Yg#Yh#Yi#Yj#Yk#Yl#Ym#Yn#Yo#Yp#Yq#Yr#Ys#Yt#Yu#Yv#Yw#Yx#Yy#Yz#YA#YB#YC#YD#YE#YF#YG#YH#YI#YJ#YK#YL#YM#YN#YO#YP#YQ#YR#YS#YT#YU#YV#YW#YX#YY#YZ#Y0#Y1#Y2#Y3",
"#Y4#Y5#Y6#Y7#Y8#Y9#Z.#Z##Za#Zb#WI#Zc#Zd#Ze#Zf#Zg#Zh#Zi#Zj#Zk#Zl#Zm#Zn#Zo#Zp#Zq#Zr#Zs#Zt#Zu#Zv#Zw#Zx#Zy#Zz#ZA#ZB#ZC#ZD#ZE#ZF#ZG#ZH#ZI#ZJ#ZK#ZL#ZM#ZN#ZO#ZP#ZQ#ZR#ZS#ZT#ZU#ZV#ZW#ZX#ZY#ZZ#Z0#Z1#Z2#Z3#Z4#Z5#Z6#Z7#Z8#Z9#0.#0##0a#0b#0c#0d#0e#0f#0g",
"#0h#0i#0j#0k#0l#0m#0n#0o#0p#0q#0r#0s#0t#0u#0v#0w#0x#0y#0z#0A#0B#0C#0D#0E#0F#0G#0H#0I#0J#0K#0L#0M#0N#0O#0P#0Q#0R#0S#0T#0U#0V#0W#0X#0Y#0Z#00#01#02#03#04#05#06#07#08#09#1.#1##1a#1b#1c#1d#1e#1f#1g#1h#1i#1j#1k#1l#1m#1n#1o#1p#1q#1r#1s#1t#1u#1v#1w",
"#1x#1y#1z#1A#1B#1C#1D#1E#1F#1G#1H#1I#1J#1K#1L#1M#1N#1O#1P#1Q#1R#1S#1T#1U#1V#1W#1X#1Y#1Z#10#11#12#13#14#15#16#17#18#19#2.#2##2a#2b#2c#2d#2e#2f#2g#2h#2i#2j#2k#2l#2m#2n#2o#2p#2q#2r#2s#2t#2u#2v#2w#2x#2y#2z#2A#2B#2C#2D#2E#2F#2G#2H#2I#2J#2K#2L#2M"};

static const char* const image_read_data[] = { 
"16 16 241 2",
"#O c #001026",
"bK c #040e2b",
"#0 c #0c6bcb",
"ac c #0c6bce",
"#L c #0f6bca",
"bM c #10233d",
"#A c #122341",
"bN c #182359",
"#j c #1870c5",
"bJ c #19213b",
"#l c #212b4a",
"bL c #252a40",
"bA c #253551",
".R c #2779b6",
"#Z c #287fcd",
"bB c #293b4b",
".S c #29406a",
".B c #2a436a",
".8 c #2b313e",
".6 c #2b78d1",
"bC c #2f3a66",
"#K c #3284d6",
"bI c #333a50",
"bz c #343c53",
"#i c #348bdb",
".5 c #368bd9",
"bH c #393f5d",
"ab c #3987cd",
"ar c #3a6bbf",
"#k c #3c527b",
"#N c #3f5476",
"#y c #3f65b0",
"#4 c #40636c",
"#z c #424767",
"#3 c #425666",
"bn c #434e5e",
"ad c #448dd9",
"#m c #464e69",
"#x c #467ed1",
"#1 c #468ddc",
"as c #4892db",
"by c #4b576b",
"bP c #4e709d",
".7 c #505b80",
"aK c #515f6c",
".k c #524f45",
"aX c #525f6d",
"aw c #52606d",
".A c #555a62",
"ag c #556270",
"b. c #556372",
"bs c #58637f",
".Q c #59778b",
"bx c #5d6d7f",
".T c #5e627f",
"bO c #605a64",
"#M c #628dd2",
".C c #696974",
"aF c #6c9cdd",
"#w c #7295d6",
"#P c #747e8d",
"bw c #758797",
"bQ c #79928c",
"aS c #7ba6cd",
"b# c #7d828c",
"ah c #7d8891",
"ax c #7e828b",
"aY c #7e838d",
"aL c #7e848c",
"bo c #848990",
"aE c #8888cd",
"at c #89bde5",
"ae c #8cbde3",
"#2 c #90c0e9",
".c c #918967",
"bv c #92a8b2",
".e c #938869",
"aG c #93c4ee",
"bD c #9495ad",
"bd c #949bc1",
".r c #9692a8",
".q c #9699c9",
"#B c #979da4",
"am c #999ec4",
"#T c #999ec5",
"aO c #999fc3",
"#D c #9a9ec3",
".V c #9a9ec4",
"## c #9a9ec5",
"#8 c #9b9ec4",
"#o c #9b9ec5",
".l c #9c9db0",
".g c #9d9377",
"bu c #9fbfc4",
".v c #a199ac",
".G c #a1a5cc",
"aT c #a1d6dd",
".j c #a4936b",
".i c #a49687",
"br c #a6a6ac",
".t c #aba6b5",
"bm c #abb5bd",
".d c #aea176",
"#v c #afcdd7",
".f c #b0a06d",
"bG c #b0b0ba",
".D c #b0b2bf",
"#h c #b1d0d8",
"aR c #b2ceda",
".h c #b6a876",
"bt c #b8d8da",
".a c #bab2b4",
".b c #bba971",
"bR c #bbb7ca",
"a3 c #bde9d8",
"a4 c #bdead9",
".s c #beb39e",
".x c #bfb4b1",
"a1 c #bfebe0",
".4 c #c1dbde",
"#Y c #c1e2e0",
"bc c #c2c4c5",
"aq c #c2d0db",
"aP c #c2ebde",
"be c #c2f2e3",
".F c #c3c3c4",
"aj c #c3c3c5",
"#J c #c3dee1",
"#. c #c4c3c4",
"#S c #c4c3c5",
"al c #c4c4c4",
"bp c #c4c4c5",
"az c #c4c4c6",
"aZ c #c4c5c7",
"bl c #c4d3d2",
".u c #c5bdad",
"aN c #c5c3c6",
"a0 c #c5c4c4",
"#n c #c5c4c5",
"bb c #c5c4c6",
"aD c #c5d2e1",
"an c #c5eade",
"a2 c #c5f1de",
"Qt c #c6c6c5",
".o c #c6c6c9",
"bU c #c6c7c8",
"#6 c #c6c7c9",
"#R c #c6c9ca",
"aB c #c6ece3",
".p c #c7c6c5",
"bT c #c7c6c8",
".9 c #c7c7c9",
"ak c #c7c8c9",
"aA c #c8c6c8",
"#7 c #c8c7c9",
".E c #c8c7cb",
".# c #c8c8cd",
"aa c #c8e7dd",
"#9 c #c8ece1",
".U c #c9c8c9",
"bS c #c9c8ca",
"#5 c #c9c9c6",
".n c #c9c9c8",
"aH c #c9eae0",
"a5 c #c9f0da",
"#C c #cac7c9",
"#U c #caece0",
"au c #cbe5e3",
"ap c #cbeeda",
"ao c #cbf2e0",
"bf c #cbfee7",
".z c #ccc1b6",
"aQ c #ccf5df",
"bE c #cdccca",
"a. c #cdf2df",
"aC c #cdf6e1",
"#E c #ceede2",
"a6 c #cef0db",
".w c #cfc9c1",
"bF c #cfcfcc",
"ba c #cfcfcf",
"#p c #cfebe0",
"ay c #d0cece",
"aM c #d0cfcf",
"ai c #d1d1d1",
".H c #d1d6df",
"bk c #d1e8e1",
"#a c #d1ebe1",
"aU c #d1f1e1",
"#W c #d2efdf",
"#V c #d2f4e2",
"a7 c #d3f3de",
"bg c #d3ffed",
"#Q c #d4d0d0",
"aW c #d4eedc",
"#q c #d4f2dd",
"a# c #d4f2e2",
"bq c #d5d3d5",
".W c #d5f0e3",
"#r c #d5f1df",
"bj c #d5f1e9",
"#F c #d5f4e2",
"#H c #d6f1e2",
".y c #d7d2d9",
".m c #d7d7d7",
"aV c #d7f1de",
".X c #d7f3df",
"af c #d8ece2",
"#G c #d8f3e3",
"a8 c #d8f7e2",
"bh c #d8ffed",
".2 c #d9efdc",
"#b c #d9f4e2",
"#c c #daf1e1",
"#t c #dbefe0",
"bi c #dbfff0",
"#f c #dcefe1",
"aJ c #dcf1de",
".Z c #dcf1df",
"#s c #dcf2e1",
".Y c #dcf3df",
"#d c #ddf2e0",
".1 c #def0df",
"#X c #def4df",
"#e c #e0f1e0",
"aI c #e0f5df",
".0 c #e1f4e2",
"#I c #e4f6e0",
".L c #e5ece2",
".3 c #e5f5e0",
".J c #e6eae9",
"a9 c #e7ffeb",
"av c #e8f7e3",
".O c #e8f7ea",
"#u c #eafae1",
".N c #ebf4ea",
"#g c #ebf7e5",
".P c #ecf7e5",
".M c #eef7ee",
".I c #f0f4ed",
".K c #f0f6ed",
"Qt.#.a.b.c.d.e.f.g.h.i.j.k.l.m.n",
".o.p.q.r.s.t.u.v.w.x.y.z.A.B.C.D",
".E.F.G.H.I.J.K.L.M.N.O.P.Q.R.S.T",
".U.F.V.W.X.Y.Z.0.1.2.3.4.5.6.7.8",
".9#.###a#b#c#d#e#f#g#h#i#j#k#l#m",
".9#n#o#p#q#r#s#t#u#v#w#x#y#z#A#B",
"#C.F#D#E#F#G#H#I#J#K#L#M#N#O#P#Q",
"#R#S#T#U#V#W#X#Y#Z#0#1#2#3#4#5#6",
"#7#.#8#9a.a#aaabacadaeafagahaiaj",
"akalamanaoapaqarasatauavawaxayaz",
"aAaz.VaBaCaDaEaFaGaHaIaJaKaLaMaz",
".EaNaOaPaQaRaSaTaUaVaW#taXaYayaZ",
".9a0##a1a2a3a4a5a6a7a8a9b.b#babb",
".9bcbdbebfbgbhbibjbkblbmbnbobabp",
"bqbrbsbtbubvbwbxbybzbAbBbCbDbEaZ",
"bFbGbHbIbJbKbLbMbNbObPbQbRbSbTbU"};

static const char* const image_cpu_data[] = { 
"16 16 138 2",
"#C c #424244",
"#P c #454547",
"#Z c #48484a",
"#r c #4a4a43",
"#s c #4b4b4c",
"#B c #4c4c45",
"#7 c #4c4c4d",
"#D c #4d4d4e",
"#O c #54544c",
"#Y c #565650",
"#6 c #585852",
"#R c #5a5a59",
"#Q c #5d5d5e",
"#2 c #5e5e5e",
"#q c #61615e",
"#f c #636362",
"#1 c #636363",
"a# c #636365",
"#A c #646461",
"ab c #646463",
"#0 c #656567",
"#9 c #666667",
"#N c #6a6a68",
"ac c #6a6a69",
"#X c #6b6b69",
"af c #6d6d6d",
"#8 c #6d6d70",
"#t c #6e6e6e",
"#e c #6f6f64",
"#p c #717167",
".5 c #727268",
"aa c #737374",
".R c #747475",
".G c #757576",
"#z c #77776d",
"#5 c #777773",
".x c #787879",
"ae c #797979",
"#S c #7a7a7a",
"#M c #7c7c72",
"#W c #7d7d74",
".m c #808082",
".J c #81817d",
".k c #82827e",
".U c #82827f",
"a. c #828282",
"#g c #828284",
".s c #83837e",
"#T c #848487",
"#d c #8b8b84",
"#3 c #8c8c8c",
"#E c #8d8d8d",
".6 c #909091",
"#o c #94948c",
".l c #98989a",
"#H c #9a9a9b",
".u c #9b9b9b",
".4 c #9d9d9a",
"#G c #9d9d9d",
".Q c #9d9d9f",
".2 c #9d9da2",
"#4 c #9e9ea0",
".t c #9f9f9e",
".F c #9f9fa2",
".w c #9f9fa3",
"#y c #a0a096",
".P c #a2a2a4",
".3 c #a2a2a7",
".A c #a3a3a3",
".1 c #a3a3a6",
".v c #a4a4a7",
".B c #a5a5a3",
".E c #a5a5a8",
"#L c #a7a79d",
"#c c #a7a7a8",
".K c #a8a8a8",
"#w c #a9a9a9",
".0 c #ababac",
".D c #ababad",
".n c #acacad",
"#b c #acacae",
".O c #adadad",
".y c #aeaead",
".S c #afafb0",
".Z c #b0b0b0",
".N c #b1b1b0",
".C c #b1b1b1",
".Y c #b2b2b2",
".L c #b3b3b0",
"ah c #b3b3b3",
"#V c #b4b49f",
"#n c #b6b6b3",
"#a c #b8b8b8",
"#F c #b9b9b9",
"#m c #b9b9ba",
".M c #bababb",
".X c #bbbbbb",
".7 c #bdbdb5",
"## c #bebebe",
".V c #bfbfbd",
"#l c #c0c0c0",
".T c #c1c1c0",
".g c #c1c1c1",
".I c #c2c2c2",
".z c #c3c3c3",
"#x c #c3c3c5",
"#v c #c4c4c2",
".r c #c4c4c4",
".f c #c5c5c4",
".j c #c5c5c5",
".p c #c6c6c6",
".d c #c7c7c7",
".# c #c8c8c7",
".c c #c8c8c8",
"Qt c #c9c9c9",
"#I c #cacabf",
".a c #cacaca",
".W c #cacacb",
".b c #cbcbcb",
"ad c #cccccc",
"#k c #cdcdcd",
".h c #cecece",
"#. c #cfcfcf",
".e c #cfcfd0",
".q c #d0d0d0",
".i c #d0d0d1",
"#K c #d2d2d0",
".H c #d2d2d1",
".o c #d2d2d2",
"#j c #d5d5d4",
"ag c #d7d7d7",
"#U c #d9d9d0",
"#i c #dcdcd2",
".9 c #dcdcdd",
"#J c #dcdcde",
".8 c #dddddd",
"#u c #e7e7e9",
"#h c #ebebe4",
"QtQtQtQtQtQtQtQtQt.#.a.b.cQtQtQt",
"QtQtQtQtQtQtQt.d.a.e.f.g.h.dQtQt",
"QtQtQtQtQt.d.a.i.j.k.l.m.n.o.pQt",
"QtQtQt.d.a.q.r.s.t.u.v.w.x.y.o.p",
".c.d.b.i.z.s.A.B.C.D.E.w.F.G.y.H",
".b.q.I.J.K.L.g.M.N.O.E.P.w.Q.R.S",
".T.U.O.V.h.W.g.X.Y.Z.0.1.2.3.4.5",
".6.7.8.9#.Qt.j###a.C.n#b#c#d#e#f",
"#g#h#i.e#j#k.d#l#m#m#n#o#p#q#r#s",
"#t#u#v#w#x.o.c.W#v#y#z#A#B#C#D#E",
"#F#G#H.A#I#J#K#L#M#N#O#P#Q#f#R.j",
".q.I#S#T#U#V#W#X#Y#Z#0#1#2.d.zQt",
".d.b.o#3#4#5#6#7#8#1#9.p.IQt.a.c",
"Qt.c.a.ja.a#aaabac.p.IQt.b.cQtQt",
"QtQt.cad.daeaf.p.gQt.b.cQtQtQtQt",
"QtQtQt.d#kagah.b#k.c.cQtQtQtQtQt"};

static const char* const image_port_data[] = {
"16 16 158 2",
"  	c None",
"! 	c black",
"# 	c #9BE3A4",
"$ 	c #84DBAF",
"% 	c #50C1B7",
"& 	c #5AC27E",
"' 	c #3AA8BD",
"( 	c #92DFA7",
") 	c #91E278",
"* 	c #A6EC93",
"+ 	c #9FE888",
", 	c #7ED856",
"- 	c #51C229",
". 	c #199D84",
"0 	c #0D8BEA",
"1 	c #73D086",
"2 	c #6BCF3F",
"3 	c #97E57D",
"4 	c #BDF7B8",
"5 	c #B2F2AE",
"6 	c #90E183",
"7 	c #58C52D",
"8 	c #18A288",
"9 	c #0081E7",
": 	c #018256",
"; 	c #30AD34",
"< 	c #5FC933",
"= 	c #85DC61",
"> 	c #9EE89A",
"? 	c #99E581",
"@ 	c #A4EAC6",
"A 	c #59C5D7",
"B 	c #129FC1",
"C 	c #018C75",
"D 	c #008200",
"E 	c #007459",
"F 	c #429DE1",
"G 	c #0C8AB0",
"H 	c #42BA21",
"I 	c #60C933",
"J 	c #6CCF40",
"K 	c #70D158",
"L 	c #75D4E6",
"M 	c #3CB7FF",
"N 	c #0497CC",
"O 	c #008E00",
"P 	c #007D00",
"Q 	c #016D10",
"R 	c #003262",
"S 	c #2987D8",
"T 	c #0279CF",
"U 	c #20A71E",
"V 	c #34B31A",
"W 	c #3EB81F",
"X 	c #3DB8C8",
"Y 	c #2DB0FF",
"Z 	c #269CF1",
"[ 	c #4AA5CE",
"] 	c #72B4B0",
"^ 	c #70A9AA",
"_ 	c #166D29",
"` 	c #073D5B",
"a 	c #247ACE",
"b 	c #0069CF",
"c 	c #027EB4",
"d 	c #09955C",
"e 	c #10A017",
"f 	c #0A9E35",
"g 	c #1D90EB",
"h 	c #AFCEE9",
"i 	c #A9CDED",
"j 	c #B0DDFC",
"k 	c #A5D0F3",
"l 	c #9BC3E1",
"m 	c #4C6F92",
"n 	c #2777C9",
"o 	c #0057BD",
"p 	c #0067CD",
"q 	c #0072D8",
"r 	c #00826E",
"s 	c #008B00",
"t 	c #3A9068",
"u 	c #80A6D8",
"v 	c #A8CCEC",
"w 	c #B8DAF2",
"x 	c #CDF0FF",
"y 	c #C5EBFF",
"z 	c #B9E3FD",
"{ 	c #4F6888",
"| 	c #3083C9",
"} 	c #0045AB",
"~ 	c #0051B7",
" !	c #005BC1",
"!!	c #0063AD",
"#!	c #007800",
"$!	c #418874",
"%!	c #91BAE5",
"&!	c #A8D1F3",
"'!	c #B3D8F3",
"(!	c #91B7E4",
")!	c #82ACE2",
"*!	c #33435B",
"+!	c #1157B5",
",!	c #013CA2",
"-!	c #0044AA",
".!	c #0048AE",
"0!	c #096811",
"1!	c #03565C",
"2!	c #355CA1",
"3!	c #8EB6E2",
"4!	c #A2CDF2",
"5!	c #81A9DD",
"6!	c #ABCCEB",
"7!	c #C8E5F6",
"8!	c #4F5F70",
"9!	c #185BBE",
":!	c #1743A9",
";!	c #154699",
"<!	c #255A74",
"=!	c #0C3CA1",
">!	c #0E3B9E",
"?!	c #355BB5",
"@!	c #8EB5E7",
"A!	c #81ABE1",
"B!	c #5C7699",
"C!	c #9BB7CE",
"D!	c #C7E8FC",
"E!	c #5E748E",
"F!	c #1F53A1",
"G!	c #3066C8",
"H!	c #4466BB",
"I!	c #4E67CD",
"J!	c #3B60C6",
"K!	c #2E51AD",
"L!	c #102652",
"M!	c #0B0E13",
"N!	c #A5C4E0",
"O!	c #9AC2E9",
"P!	c #00244A",
"Q!	c #001D41",
"R!	c #000E21",
"S!	c #29364A",
"T!	c #2C3A4F",
"U!	c #5C7797",
"V!	c #6F8FB6",
"W!	c #9BBAD7",
"X!	c #B2DAFC",
"Y!	c #83AAD5",
"Z!	c #B5DEFF",
"[!	c #A9CFF3",
"]!	c #A7CEF3",
"^!	c #A2C8EC",
"_!	c #7EA7D5",
"`!	c #546F90",
"a!	c #0C1016",
"b!	c #99BEE6",
"c!	c #94C2F3",
"d!	c #577294",
"        # $ % & '               ",
"    ( ) * + , - . 0             ",
"  1 2 3 4 5 6 7 8 9 :           ",
"  ; < = > ? @ A B C D E         ",
"F G H I J K L M N O P Q R       ",
"S T U V W X Y Z [ ] ^ _ `       ",
"a b c d e f g h i j k l m       ",
"n o p q r s t u v w x y z {     ",
"| } ~  !!!#!$!u %!&!'!(!)!*!    ",
"  +!,!-!.!0!1!2!3!4!5!6!7!8!    ",
"    9!:!;!<!=!>!?!@!A!B!C!D!E!  ",
"      F!G!H!I!J!K!L!M!!   N!O!  ",
"          P!Q!R!S!T!U!V!W!X!Y!  ",
"              i Z![!]!^!_!`!a!  ",
"            b!c!d!              ",
"                                "};

// 32*32*24b
static const char* const image_ai32_data[] = {
"32 32 178 2",
"  	c None",
"! 	c white",
"# 	c #FCFCFC",
"$ 	c #E8E8E8",
"% 	c #DCDCDC",
"& 	c #F0F0F0",
"' 	c #B0ACAC",
"( 	c #B8B4B4",
") 	c #D0D0D0",
"* 	c #C8C4C0",
"+ 	c #B8B8B8",
", 	c #F4F0F0",
"- 	c #B0A8A8",
". 	c #DCE0DC",
"0 	c #F8F8F8",
"1 	c #BCBCBC",
"2 	c #F4F4F4",
"3 	c #F0F4DC",
"4 	c #F8F8F4",
"5 	c #C4BCC4",
"6 	c #E4E0E8",
"7 	c #F8F8F0",
"8 	c #A4E030",
"9 	c #B0D480",
": 	c #B8B4A0",
"; 	c #D4E8B0",
"< 	c #F4F8F4",
"= 	c #E4ECC4",
"> 	c #80D418",
"? 	c #6CA438",
"@ 	c #7CC818",
"A 	c #84D044",
"B 	c #DCDCE0",
"C 	c #FCFCF8",
"D 	c #E8ECE0",
"E 	c #ACB8A4",
"F 	c #8C8488",
"G 	c #88B85C",
"H 	c #90AC88",
"I 	c #F8F0F0",
"J 	c #F4E0E0",
"K 	c #F0D8D8",
"L 	c #F8F4F4",
"M 	c #C0B8B8",
"N 	c #D4D0D8",
"O 	c #E8BCB8",
"P 	c #CC5C54",
"Q 	c #C02428",
"R 	c #B41014",
"S 	c #B40C10",
"T 	c #CC5858",
"U 	c #E4ACA8",
"V 	c #E4DCDC",
"W 	c #C4BCBC",
"X 	c #F8ECE8",
"Y 	c #C8605C",
"Z 	c #B00000",
"[ 	c #B40000",
"] 	c #B80000",
"^ 	c #C00008",
"_ 	c #C00000",
"` 	c #C44444",
"a 	c #F0D4D4",
"b 	c #D0D4CC",
"c 	c #CCD4D0",
"d 	c #C03834",
"e 	c #A80000",
"f 	c #B80008",
"g 	c #BC0004",
"h 	c #C00004",
"i 	c #C4000C",
"j 	c #CC0008",
"k 	c #C80000",
"l 	c #C41418",
"m 	c #BC6C6C",
"n 	c #C87070",
"o 	c #D44C50",
"p 	c #D43C44",
"q 	c #D83C40",
"r 	c #D85860",
"s 	c #C86860",
"t 	c #B80004",
"u 	c #C80008",
"v 	c #900008",
"w 	c #C00010",
"x 	c #D00008",
"y 	c #D00000",
"z 	c #D80008",
"{ 	c #D80010",
"| 	c #D84048",
"} 	c #F0D0D0",
"~ 	c #B00808",
" !	c #B40004",
"!!	c #B00810",
"#!	c #780010",
"$!	c #B80010",
"%!	c #880810",
"&!	c #B80018",
"'!	c #E00020",
"(!	c #E00010",
")!	c #D83840",
"*!	c #E8E4E8",
"+!	c #C87878",
",!	c #E00018",
"-!	c #D80020",
".!	c #E80018",
"0!	c #D07080",
"1!	c #C05050",
"2!	c #980010",
"3!	c #800008",
"4!	c #D00010",
"5!	c #E00008",
"6!	c #D01030",
"7!	c #D8D0D0",
"8!	c #C04848",
"9!	c #D86880",
":!	c #A89898",
";!	c #902020",
"<!	c #A01018",
"=!	c #A81020",
">!	c #A03040",
"?!	c #981018",
"@!	c #D80018",
"A!	c #C89098",
"B!	c #E8A098",
"C!	c #F8F8E8",
"D!	c #C85850",
"E!	c #C08080",
"F!	c #D0B8A8",
"G!	c #B02830",
"H!	c #F0F0E0",
"I!	c #E07068",
"J!	c #C06878",
"K!	c #F0F8F8",
"L!	c #C01010",
"M!	c #D04038",
"N!	c #E04040",
"O!	c #E05850",
"P!	c #D83838",
"Q!	c #B85870",
"R!	c #E8F0F0",
"S!	c #D0A8A0",
"T!	c #B06078",
"U!	c #B03030",
"V!	c #A88090",
"W!	c #F0F8F0",
"X!	c #C8A8A8",
"Y!	c #B81840",
"Z!	c #B0B0B8",
"[!	c #B87880",
"]!	c #986878",
"^!	c #E0E8E8",
"_!	c #B06870",
"`!	c #B00008",
"a!	c #A03850",
"b!	c #FCF8F8",
"c!	c #A88080",
"d!	c #A02848",
"e!	c #98A0A0",
"f!	c #B8B0B0",
"g!	c #A04848",
"h!	c #D00018",
"i!	c #C80020",
"j!	c #983050",
"k!	c #D0D8D8",
"l!	c #A89090",
"m!	c #A04048",
"n!	c #A82038",
"o!	c #886070",
"p!	c #A8B0B0",
"q!	c #A07880",
"r!	c #985058",
"s!	c #A02038",
"t!	c #905058",
"u!	c #907880",
"v!	c #A0A8A8",
"w!	c #C0C8C8",
"x!	c #B8C0C0",
"! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! # ! $ % ! # ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! # ! & ' % # ! # ! ! ! ! ! ",
"! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! # # # ( ) & ! ! ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! # ! * + & # ! # ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! # ! , - . 0 ! # ! ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! # ! ! ) 1 2 # # ! ! ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! 3 4 5 6 # ! # ! ! ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! ! ! ! ! ! ! # ! 7 8 9 : ; < ! ! ! ! ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! ! ! # # ! # # ! = > ? @ A B ! ! ! ! ! ! ! ! ! ! ",
"! ! ! ! ! ! ! # # ! ! ! ! # C ! D E F G H 6 ! ! ! ! ! ! ! ! ! ! ",
"! ! ! ! ! # # ! ! I J K L ! ! ! # $ M N B # ! # ! ! ! ! ! ! ! ! ",
"! ! ! ! # ! ! O P Q R S Q T U 0 ! V W 0 ! # # # # ! ! ! ! ! ! ! ",
"! ! ! # ! X Y Z [ ] ] ^ _ _ ] ` a b c ! ! ! ! ! ! ! # ! ! ! ! ! ",
"! ! # # X d e f g g h ^ ^ i j k l m n o p q p r U # ! # ! ! ! ! ",
"! ! # ! s e f t t h h u u i v w x u y y z { { { { | K ! # ! ! ! ",
"! # ! } ~ t  !t g ^ ^ u ^ u !!#!$!{ !!%!&!'!'!'!'!(!)!*!! # ! ! ",
"# # ! +!e f  !t h ^ h u %!f { w i $!%!&!{ ,!-!,!,!'!.!0!0 ! # ! ",
"# # ! 1!Z f ^ ^ ^ ^ ^ x 2!3!x z z 4!5!{ $!w ,!,!'!'!.!6!7!! # ! ",
"# ! # 8!Z f ^ ^ ^ u u h 9!:!;!2!<!=!>!?!$!@!'!'!'!'!.!,!A!# # ! ",
"# # # 1![ f ^ ^ ^ i h ^ B!C!D!E!F!G!H!I!(!'!,!,!'!'!'!,!J!K!! # ",
"! # ! n Z ^ ^ ^ ^ ^ ^ h L!M!h N!O!x P!N!@!'!@!,!'!'!'!.!Q!R!! # ",
"# # ! S!e t g h g ^ ^ ^ h _ u k k 4!{ { ,!@!@!-!,!'!'!.!T!R!! # ",
"# # ! $ U!_ ^ ^ g g g h ^ u u 4!4!{ -!@!,!@!@!'!,!'!.!'!V!W!! # ",
"! # # # X!!!^ ^ g g h h ^ u j j 4!4!@!@!{ @!@!@!,!'!.!Y!Z!# ! ! ",
"! ! ! ! K![!Z h g ^ g h u u u 4!4!@!{ @!@!@!,!,!'!.!'!]!. ! # # ",
"! ! # # ! ^!_!`!_ ^ g h h u u 4!4!@!@!@!-!,!,!'!'!,!a!+ b!! # ! ",
"! ! ! # ! # ^!c!=!] h ^ u u u u 4!4!{ @!@!'!'!,!,!d!e!& ! # ! ! ",
"! ! ! ! # ! ! R!f!g!!!h j j 4!4!4!h!@!,!,!,!,!i!j!e!$ ! # ! ! ! ",
"! ! ! ! ! ! ! ! 0 k!l!m!=!$!u x x { ,!@!@!i!n!o!p!$ ! ! ! ! ! ! ",
"! ! ! ! ! ! ! # ! ! & k!' q!r!>!s!n!n!a!t!u!v!k!0 ! # ! ! ! ! ! ",
"! ! ! ! ! ! ! ! # # ! ! 0 R!% w!+ ' Z!x!c $ 0 ! ! # ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! ! ! # # # ! ! ! ! # # ! ! ! ! # ! ! ! ! ! ! ! ! "};

static const char* const image_di32_data[] = {
"32 32 192 2",
"  	c None",
"! 	c white",
"# 	c #FCFCFC",
"$ 	c #F4F4B8",
"% 	c #F0F0BC",
"& 	c #F8F8FC",
"' 	c #FCFCF8",
"( 	c #F0F07C",
") 	c #F4F030",
"* 	c #F0F038",
"+ 	c #ECEC74",
", 	c #F0F0E8",
"- 	c #ECEC9C",
". 	c #F0F010",
"0 	c #F8F818",
"1 	c #F8F810",
"2 	c #E8E870",
"3 	c #F0F0F4",
"4 	c #F0F0D4",
"5 	c #E8E028",
"6 	c #F8F820",
"7 	c #D8D8A8",
"8 	c #E0E050",
"9 	c #E8E8E8",
": 	c #F0E8C0",
"; 	c #F0F068",
"< 	c #F0F0D8",
"= 	c #E8E858",
"> 	c #F0F058",
"? 	c #D0D078",
"@ 	c #F0F0F8",
"A 	c #F8F8F0",
"B 	c #E8E068",
"C 	c #F0F018",
"D 	c #F0F020",
"E 	c #E0E030",
"F 	c #C8C840",
"G 	c #B0B058",
"H 	c #A8A070",
"I 	c #B8B8A0",
"J 	c #F8F8F8",
"K 	c #F0F0D0",
"L 	c #E0E070",
"M 	c #E0D858",
"N 	c #E0E038",
"O 	c #F0E818",
"P 	c #D0C020",
"Q 	c #C0A828",
"R 	c #A08030",
"S 	c #805838",
"T 	c #703850",
"U 	c #704878",
"V 	c #B0A8B8",
"W 	c #D8D8E0",
"X 	c #E0E0E8",
"Y 	c #D8D028",
"Z 	c #E8E008",
"[ 	c #E8E018",
"] 	c #A08830",
"^ 	c #785830",
"_ 	c #887068",
"` 	c #887080",
"a 	c #785080",
"b 	c #683078",
"c 	c #601870",
"d 	c #501860",
"e 	c #581868",
"f 	c #784880",
"g 	c #B8B828",
"h 	c #B0B048",
"i 	c #A0A060",
"j 	c #989870",
"k 	c #603848",
"l 	c #502058",
"m 	c #481058",
"n 	c #602078",
"o 	c #D0D0E0",
"p 	c #706068",
"q 	c #707070",
"r 	c #E0D8E0",
"s 	c #702070",
"t 	c #582060",
"u 	c #681870",
"v 	c #C0C0B0",
"w 	c #B0B0B0",
"x 	c #C0C0C8",
"y 	c #907890",
"z 	c #501858",
"{ 	c #602870",
"| 	c #381840",
"} 	c #804890",
"~ 	c #887888",
" !	c #200030",
"!!	c #603860",
"#!	c #A078A0",
"$!	c #702078",
"%!	c #704870",
"&!	c #702080",
"'!	c #703880",
"(!	c #E8E0E8",
")!	c #502850",
"*!	c #481050",
"+!	c #783088",
",!	c #782880",
"-!	c #601070",
".!	c #582860",
"0!	c #908090",
"1!	c #905090",
"2!	c #783090",
"3!	c #681880",
"4!	c #9870A8",
"5!	c #887088",
"6!	c #481850",
"7!	c #584860",
"8!	c #502858",
"9!	c #582068",
":!	c #602868",
";!	c #684868",
"<!	c #988090",
"=!	c #A870A0",
">!	c #682078",
"?!	c #802890",
"@!	c #782890",
"A!	c #702880",
"B!	c #D0C8D8",
"C!	c #482848",
"D!	c #D0B8D0",
"E!	c #988098",
"F!	c #A898A8",
"G!	c #805878",
"H!	c #803880",
"I!	c #782088",
"J!	c #B0A0B0",
"K!	c #381040",
"L!	c #602070",
"M!	c #702870",
"N!	c #701878",
"O!	c #782888",
"P!	c #802898",
"Q!	c #803890",
"R!	c #E0E0E0",
"S!	c #401048",
"T!	c #602068",
"U!	c #B8B0C0",
"V!	c #685068",
"W!	c #682070",
"X!	c #782080",
"Y!	c #802888",
"Z!	c #882898",
"[!	c #802090",
"]!	c #A888B0",
"^!	c #882890",
"_!	c #883098",
"`!	c #F0F8F0",
"a!	c #F0E0E8",
"b!	c #802088",
"c!	c #9030A0",
"d!	c #9868B0",
"e!	c #E8F0E8",
"f!	c #502060",
"g!	c #9038A0",
"h!	c #A038B0",
"i!	c #A060B8",
"j!	c #E0E8E0",
"k!	c #603068",
"l!	c #9038A8",
"m!	c #A038B8",
"n!	c #681878",
"o!	c #702088",
"p!	c #902898",
"q!	c #9838A8",
"r!	c #A088A8",
"s!	c #C8C0C8",
"t!	c #9840B0",
"u!	c #501058",
"v!	c #9058A0",
"w!	c #D0D0D0",
"x!	c #601868",
"y!	c #781878",
"z!	c #803090",
"{!	c #A098A8",
"|!	c #F0F0F0",
"}!	c #9890A0",
"~!	c #601060",
" #	c #882090",
"!#	c #D0D8D0",
"##	c #C0B8C0",
"$#	c #807080",
"%#	c #B8B8B8",
"&#	c #A098A0",
"'#	c #A0A0A8",
"(#	c #D8E0D8",
"! ! ! ! ! ! ! ! ! ! ! # ! # $ % & ! # ! ! ! ! ! ! ! ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! ! ! # ! ' ( ) * + , ! # ! ! ! ! ! ! ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! ! ! # ! - . 0 0 1 2 3 ! # # ! ! ! ! ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! ! # ! 4 5 0 6 6 0 6 7 # ! ! # # ! ! ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! # # # 2 . 6 6 6 0 0 8 9 # : ; ; < ! ! ! ! ! ! ! ",
"! ! ! ! ! ! # ! # ! 4 5 0 0 0 0 0 0 6 = > 6 0 0 ? @ ! # ! ! ! ! ",
"! ! ! ! ! # ! ! # A B C D C 0 6 6 6 6 D E F G H I J ! # ! ! ! ! ",
"! ! ! ! # ! K L M N C 0 6 6 O P Q R S T U V W X & ! ! ! ! ! ! ! ",
"! ! ! # ! < Y Z [ [ Y Q ] ^ _ ` a b c d e f X ! ! ! ! ! ! ! ! ! ",
"! ! # ! # ? g h i j k l m n o p q r s t l u b o ! # ! ! ! ! ! ! ",
"! ! ! ! J v w x 9 y z { | } ~  !!!#!$!%!#!&!&!'!(!! # ! ! ! ! ! ",
"! ! ! ! # # ! ! r )!t { | *!c +!,!-!.!0!1!&!2!3!4!J ! # ! ! ! ! ",
"! ! ! ! ! ! # ! 5!6!.!{ b 7!8!9!:!;!<!=!>!+!?!@!A!B!! # # ! ! ! ",
"! ! ! ! ! # ! (!C!l :!{ n D!E!F!G!#!H!&!2!+!?!?!I!4!' ! ! ! ! ! ",
"! ! ! ! ! # ! J!K!.!9!{ L!{ M!H!+!N!A!2!@!O!@!P!?!Q!R!! # ! ! ! ",
"! ! ! ! # # ! ~ S!9!T!L!{ c c c A!$!,!A!+!@!@!?!?!O!U!! # # ! ! ",
"! ! ! ! ! ! ! V!S!l 9!W!>!c c c $!N!X!,!,!A!O!Y!Z![!]!# ! ! ! ! ",
"! ! ! ! ! ! J !!z .!L!>!>!c c u $!X!X!,!$!$!,!^!_!Z!4!`!! ! ! ! ",
"! ! ! ! # ! a!8!t L!>!>!$!>!&!&!&!X!b!?!Y!Y!_!_!_!c!d!e!! ! ! ! ",
"! ! ! ! # ! (!.!f!9!>!W!u u &!&!&!?!?!b!?!_!_!_!g!h!i!j!! ! # ! ",
"! ! ! ! ! ! , k!9!L!L!c c u &!N!&!?!X!X!O!P!Z!_!l!m!i!R!! # ! ! ",
"! ! ! ! ! ! J %!z n L!u $!N!n!n!>!&!I!I!I!Z!c!_!l!m!i!R!! # # ! ",
"! ! ! ! ! ! ! G!e $!W!>!$!$!$!u $!&!o!Y!?!^!p!_!g!h!4!9 ! ! ! ! ",
"! ! ! ! # # ! E!e $!$!X!,!$!s >!$!o!@!?!^!^!?!_!g!q!r!A ! # ! ! ",
"! ! ! ! ! # ! s!t W!>!O!Y!X!X!$!&!I!b!^!^!?!?!_!g!t!U!! ! ! ! ! ",
"! ! ! ! ! ! ! J %!u!u N!X!b!X!X!&!I!b!?!?!?!?!_!l!v!w!! # # ! ! ",
"! ! ! ! ! # # ! x 6!x!$!X!X!X!y!X!b![!@!^!Z!Z!^!z!{!A ! # ! ! ! ",
"! ! ! ! ! ! # ! # r!*!x!s X!N!N!X!X!I!P!^!^!^!X!5!R!! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! ! |!}!l u!~!N!N!X!X!b! #[!I!'!y !#! ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! # ! J ##$#!!:!x!>!>!>!'!a y %#e!! ! ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! ! # ! ! |!w!%#{!}!&#'#%#(#|!! ! # ! ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! ! ! # # ! ! ! ! ! ! ! ! ! ! # # ! ! ! ! ! ! ! ! "};

static const char* const image_pi32_data[] = {
"32 32 217 2",
"  	c None",
"! 	c white",
"# 	c #FFFFF8",
"$ 	c #F8F8E8",
"% 	c #D0D8D8",
"& 	c #E8F0E0",
"' 	c #F8F8F8",
"( 	c #C0D8B0",
") 	c #B8D0A0",
"* 	c #C8D0C0",
"+ 	c #70B850",
", 	c #C0D0B8",
"- 	c #F8F8F0",
". 	c #78B858",
"0 	c #88B860",
"1 	c #A0C888",
"2 	c #A8B898",
"3 	c #88C878",
"4 	c #70A848",
"5 	c #C0B8B8",
"6 	c #80C868",
"7 	c #78A860",
"8 	c #98B868",
"9 	c #A8C890",
": 	c #58B030",
"; 	c #A8C088",
"< 	c #A0C088",
"= 	c #88B060",
"> 	c #88A070",
"? 	c #90C870",
"@ 	c #60B840",
"A 	c #709850",
"B 	c #A0A0A0",
"C 	c #F0F8F8",
"D 	c #FFF8FF",
"E 	c #B8C8B0",
"F 	c #68A840",
"G 	c #60B830",
"H 	c #98C878",
"I 	c #B8C8A0",
"J 	c #68C048",
"K 	c #78B050",
"L 	c #98A080",
"M 	c #80C060",
"N 	c #789858",
"O 	c #989888",
"P 	c #A8D890",
"Q 	c #B8B8A8",
"R 	c #78A848",
"S 	c #60B838",
"T 	c #78B850",
"U 	c #68C050",
"V 	c #78B860",
"W 	c #78C060",
"X 	c #60C048",
"Y 	c #68B840",
"Z 	c #689840",
"[ 	c #68B040",
"] 	c #70B048",
"^ 	c #70A840",
"_ 	c #78B048",
"` 	c #80A068",
"a 	c #A8A8A8",
"b 	c #E0A0A0",
"c 	c #B03828",
"d 	c #983010",
"e 	c #A02810",
"f 	c #A02808",
"g 	c #983828",
"h 	c #A05848",
"i 	c #A04840",
"j 	c #A05048",
"k 	c #982008",
"l 	c #A82010",
"m 	c #B02818",
"n 	c #B84838",
"o 	c #E8C0C0",
"p 	c #A81000",
"q 	c #981008",
"r 	c #A00810",
"s 	c #B00810",
"t 	c #A80000",
"u 	c #B05058",
"v 	c #C04038",
"w 	c #B80000",
"x 	c #A81010",
"y 	c #A80800",
"z 	c #B80808",
"{ 	c #C04838",
"| 	c #FFF8F8",
"} 	c #C88070",
"~ 	c #982010",
" !	c #901808",
"!!	c #981810",
"#!	c #901810",
"$!	c #A01808",
"%!	c #A00808",
"&!	c #400800",
"'!	c #881010",
"(!	c #C00810",
")!	c #881800",
"*!	c #882018",
"+!	c #801810",
",!	c #A01008",
"-!	c #B02018",
".!	c #781810",
"0!	c #801008",
"1!	c #C83020",
"2!	c #A81008",
"3!	c #981010",
"4!	c #A80810",
"5!	c #C80010",
"6!	c #882810",
"7!	c #803018",
"8!	c #A02008",
"9!	c #882010",
":!	c #701810",
";!	c #B01808",
"<!	c #B81008",
"=!	c #B00808",
">!	c #C00800",
"?!	c #C00008",
"@!	c #B80810",
"A!	c #C82038",
"B!	c #E0E0E0",
"C!	c #B86850",
"D!	c #782010",
"E!	c #783020",
"F!	c #902810",
"G!	c #881810",
"H!	c #601818",
"I!	c #782018",
"J!	c #783028",
"K!	c #682018",
"L!	c #B81000",
"M!	c #C80008",
"N!	c #C00818",
"O!	c #D80018",
"P!	c #E080A0",
"Q!	c #F8FFFF",
"R!	c #882818",
"S!	c #782818",
"T!	c #903018",
"U!	c #802810",
"V!	c #A82008",
"W!	c #700808",
"X!	c #B88898",
"Y!	c #E00018",
"Z!	c #B84060",
"[!	c #C09898",
"]!	c #782008",
"^!	c #983018",
"_!	c #A03018",
"`!	c #A82810",
"a!	c #B02008",
"b!	c #B01008",
"c!	c #A81808",
"d!	c #981808",
"e!	c #C80000",
"f!	c #D00018",
"g!	c #C81830",
"h!	c #E0C0C0",
"i!	c #B08078",
"j!	c #B02808",
"k!	c #D80010",
"l!	c #C81028",
"m!	c #A06858",
"n!	c #882008",
"o!	c #B80820",
"p!	c #C81020",
"q!	c #E00818",
"r!	c #986050",
"s!	c #D01028",
"t!	c #A87068",
"u!	c #702818",
"v!	c #B80800",
"w!	c #C0C8C8",
"x!	c #C80018",
"y!	c #D80818",
"z!	c #883828",
"{!	c #982810",
"|!	c #A88090",
"}!	c #902008",
"~!	c #B04058",
" #	c #C8D0D0",
"!#	c #A82808",
"##	c #B82040",
"$#	c #A898A0",
"%#	c #902818",
"&#	c #C81030",
"'#	c #987888",
"(#	c #B89090",
")#	c #B81030",
"*#	c #986078",
"+#	c #B09098",
",#	c #902828",
"-#	c #B81800",
".#	c #A82040",
"0#	c #A01810",
"1#	c #B01800",
"2#	c #B01018",
"3#	c #984058",
"4#	c #984038",
"5#	c #A81810",
"6#	c #982038",
"7#	c #906880",
"8#	c #A07880",
"9#	c #903838",
":#	c #981820",
";#	c #884858",
"<#	c #A098A0",
"=#	c #A88890",
">#	c #905058",
"?#	c #883850",
"@#	c #988090",
"A#	c #A89098",
"B#	c #B8B8C0",
"! ! ! ! ! ! # ! ! ! ! ! ! $ # ! % & ! ' ! ! ! ! ! ! ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! # ' ( & ! ) % * + , ! ! - & - ! ! ! ! ! ! ! ! ! ",
"! ! ! ! ! # $ ! ! ' . 0 & 1 2 3 4 5 # ( 6 7 * ! ! ! ! ! ! ! ! ! ",
"! ! ! ! ! - 8 0 ( ' 9 : ; < = + > * ? @ A B C ! # ! ! ! ! ! ! ! ",
"! ! ! ! ! D E F G H I + + 0 J K L M @ N O ) P ? ; C ! ! ! ! ! ! ",
"! ! ! ! ! ! ' Q R S . T U + U . V U + 7 W X Y Z B C ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ' * 0 [ ] + ] ^ ] ] T _ _ R K ` a & ! ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! b c d e f g h i j k e l l m n o ! ! ! ! ! ! ! ! ",
"! ! ! ! ! ! o n p q r s t b $ u % v w x x r y z { o ! ! ! ! ! ! ",
"! ! ! ! | } ~  !!!#!$!!!%!o O &!B b t !!'!#!z z w (!b ! ! ! ! ! ",
"! ! ! ! } )!*!~ !!!!#!+!,!-!.!0!v 1!2!.!'!3!z 4!x z 5!b ! ! ! ! ",
"! | ! o 6!7!e ~ 8!9!~ :!!!;!<!<!t 0!:!3!=!3!>!?!4!@!5!A!B!! ! ! ",
"! ! ! C!D!E!F!F!~ e ~ G!H!D!I!J!K!+!2!L!L!<!=!=!M!(!N!O!P!Q!! ! ",
"' ! B!R!S!T!U!e V!8!9!8!~ W!X!B!e !!!!;!L!>!=!=!?!@!N!Y!Z!C ! ! ",
"' ! [!]!^!_!`!a!V!9!V!8!V!b!v n c!8!d!;!b!L!>!e!?!f!Y!Y!g!h!! | ",
"' ! i!D!^!U!F!`!6!j!V!V!c!8! !p c!c!;!b!L!>!z ?!k!O!O!Y!l!5 ! | ",
"| ! m!n!_!F!e 6!F!j!V!9!8!V!V!V!c!c!;!b!L!>!4!@!k!o!p!q!l!5 ! | ",
"# ! r!6!T!9!`!8!V!j!V!9!~ V!8!V!;!c!;!L!>!>!M!f!O!O!O!q!s!5 ! | ",
"' ! t!D!u!F!`!a!a!a!V!8!8!V!c!V!c!;!;!v!?!(!M!5!O!Y!q!q!A!w!! | ",
"' ! [!D!^!`!e V!a!8!8!#!9!;!V!c!;!;!L!>!M!4!x!5!O!Y!q!y!Z!B!! D ",
"' ! % z!{!e F!V!a!V!V!8!8!c!V!;!V!;!v!>!e!?!M!5!f!y!y!l!|!C ! ! ",
"! ! Q!t!}!`!j!a!a!V!8!V!V!V!V!#!V!;!L!L!>!e!M!M!O!q!Y!~! #! ! ! ",
"! ! ! % g !#a!a!V!8!8!V!V!V!V!$!;!;!L!>!>!>!M!k!k!Y!##$#C ! ! ! ",
"! ! ! ! [!%#V!`!!!c!V!V!V!V!V!;!;!L!L!L!>!>!M!M!k!&#'#& ! ! ! ! ",
"! ! ! ! Q!(#~ V!a!V!e U!8!;!;!;!;!b!L!L!>!>!M!M!)#*#% ! ! ! ! ! ",
"! ! ! ! ! C +#,#V!j!8!k 8!8!V!V!$! !-#L!>!>!?!.#'#% ! ! ! ! ! ! ",
"! ! ! ! ! ! Q!5 j 0#;!a!V!8!8!V!c!8!;!1#L!2#3#a & ! ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! B!+#4#$!8!V!V!8!c!V!V!5#6#7#w!' ! ! ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! ! ' % 8#9#!!d!8!8!0#:#;#<#B!! ! ! ! ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! ! ! ! C  #=#>#,#*!?#@# #' ! ! ! ! ! ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! ! ! ! ! ! ' B!5 A#B#C ! ! ! ! ! ! ! ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! ! ! ! ! ' ! ! ! ! ! ! ' ! ! ! ! ! ! ! ! ! ! ! ! "};

static const char* const image_comm32_data[] = {
"32 32 198 2",
"  	c None",
"! 	c white",
"# 	c #F8F8F8",
"$ 	c #F4F4F4",
"% 	c #FCFCFC",
"& 	c #E4E0E0",
"' 	c #A49CA0",
"( 	c #484048",
") 	c #D8D8D8",
"* 	c #584850",
"+ 	c #181018",
", 	c #C0C0C0",
"- 	c #B0B0B0",
". 	c #A8A8A8",
"0 	c #D8D0D0",
"1 	c #180810",
"2 	c #282028",
"3 	c #605858",
"4 	c #080008",
"5 	c #686068",
"6 	c #989090",
"7 	c black",
"8 	c #D0C8C8",
"9 	c #605050",
": 	c #100810",
"; 	c #201018",
"< 	c #505050",
"= 	c #908888",
"> 	c #181010",
"? 	c #100808",
"@ 	c #201820",
"A 	c #201818",
"B 	c #606060",
"C 	c #100008",
"D 	c #E0D8D8",
"E 	c #707070",
"F 	c #E8F0E8",
"G 	c #705868",
"H 	c #401030",
"I 	c #180010",
"J 	c #282020",
"K 	c #808088",
"L 	c #F8F0F0",
"M 	c #E0D0D8",
"N 	c #984070",
"O 	c #900858",
"P 	c #901860",
"Q 	c #781050",
"R 	c #480838",
"S 	c #180818",
"T 	c #E8E8E8",
"U 	c #B0A8A8",
"V 	c #A09098",
"W 	c #807878",
"X 	c #B0A8B0",
"Y 	c #B880A0",
"Z 	c #801850",
"[ 	c #880850",
"] 	c #881058",
"^ 	c #981060",
"_ 	c #800850",
"` 	c #B84090",
"a 	c #403038",
"b 	c #281820",
"c 	c #404040",
"d 	c #787878",
"e 	c #888080",
"f 	c #484040",
"g 	c #D8B8C8",
"h 	c #780040",
"i 	c #901058",
"j 	c #600838",
"k 	c #681048",
"l 	c #801050",
"m 	c #601040",
"n 	c #A82078",
"o 	c #B84888",
"p 	c #B03870",
"q 	c #683058",
"r 	c #983068",
"s 	c #581040",
"t 	c #400828",
"u 	c #280018",
"v 	c #200010",
"w 	c #282830",
"x 	c #303038",
"y 	c #E0E0E0",
"z 	c #D0A8B8",
"{ 	c #A04870",
"| 	c #A01068",
"} 	c #701048",
"~ 	c #B01078",
" !	c #A80868",
"!!	c #A00868",
"#!	c #B02878",
"$!	c #A81868",
"%!	c #781048",
"&!	c #A01870",
"'!	c #A81870",
"(!	c #A01868",
")!	c #983870",
"*!	c #A89898",
"+!	c #F0F0F0",
",!	c #B888A0",
"-!	c #701040",
".!	c #A80870",
"0!	c #981860",
"1!	c #A81068",
"2!	c #A81070",
"3!	c #F0E8F0",
"4!	c #882860",
"5!	c #980858",
"6!	c #500830",
"7!	c #480828",
"8!	c #801058",
"9!	c #681040",
":!	c #900058",
";!	c #903868",
"<!	c #600840",
"=!	c #700848",
">!	c #700840",
"?!	c #A01060",
"@!	c #580838",
"A!	c #B090A0",
"B!	c #F0E0E8",
"C!	c #680838",
"D!	c #B06890",
"E!	c #F0E8E8",
"F!	c #880050",
"G!	c #981068",
"H!	c #C01080",
"I!	c #B80870",
"J!	c #C878A8",
"K!	c #780048",
"L!	c #901060",
"M!	c #980860",
"N!	c #680840",
"O!	c #B81078",
"P!	c #C01078",
"Q!	c #802058",
"R!	c #900860",
"S!	c #580830",
"T!	c #B00870",
"U!	c #881050",
"V!	c #A03878",
"W!	c #D0D0D0",
"X!	c #B080A0",
"Y!	c #B01878",
"Z!	c #801858",
"[!	c #C02080",
"]!	c #987890",
"^!	c #980868",
"_!	c #C82090",
"`!	c #C098B0",
"a!	c #B01068",
"b!	c #800848",
"c!	c #D01888",
"d!	c #C05898",
"e!	c #A00860",
"f!	c #B81080",
"g!	c #C01888",
"h!	c #B81878",
"i!	c #B05090",
"j!	c #E0E8E0",
"k!	c #B098A8",
"l!	c #B01070",
"m!	c #B81070",
"n!	c #A81878",
"o!	c #903070",
"p!	c #F0F8F0",
"q!	c #B08098",
"r!	c #986888",
"s!	c #D8E0E0",
"t!	c #600830",
"u!	c #901050",
"v!	c #B088A0",
"w!	c #883868",
"x!	c #780840",
"y!	c #C00878",
"z!	c #982870",
"{!	c #B8B8B8",
"|!	c #987088",
"}!	c #805878",
"~!	c #884870",
" #	c #A06888",
"!#	c #A08898",
"##	c #D8E0D8",
"$#	c #883068",
"%#	c #804870",
"&#	c #B00868",
"'#	c #981868",
"(#	c #887888",
")#	c #A098A0",
"*#	c #A088A0",
"+#	c #988898",
",#	c #C8C8C8",
"-#	c #D0D8D8",
".#	c #C0C8C0",
"! ! ! ! # $ # % ! ! % ! ! ! % ! ! ! & ' ! % ! ! ! ! ! ! ! ! ! ! ",
"! ! ! ! ! ! ! % % ! ! ! ! % ! ' ( ) * + , ! % ! ! ! ! ! ! ! ! ! ",
"! ! ! ! - . ) ! ! % % % % ! 0 1 2 3 1 4 5 % % ! ! ! ! ! ! ! ! ! ",
"! % % ! 6 7 4 3 8 ! ! ! % ! 9 : 2 ; + : < $ ! ! ! ! ! ! ! ! ! ! ",
"! ! ! ! # = > 7 ? ( ' # ! 0 ; @ @ A A : B $ ! ! ! ! ! ! ! ! ! ! ",
"! ! ! ! ! # - < > 4 C ( D = ? @ A @ A : E # % % % % % % % % ! ! ",
"! ! ! ! ! ! % F - G H I 2 2 + J A @ @ : K # % ! ! ! ! ! ! ! ! ! ",
"! ! ! ! % ! ! L M N O P Q R S : + : > + . ! ! T 0 U V 6 W X # % ",
"! ! ! ! % % Y Z [ O ] ^ _ ` W a b c ; : d e f A C 7 7 7 : 5 T ! ",
"! ! ! % ! g h O i j k l m n o p q T r s t u v b w x < d - y # ! ",
"! ! ! % z { O | } } ~ ] } ~  !!!#!p $!%!&!'!(!)!*!8 y +!% ! ! ! ",
"! % ! ,!h O -!Q %!%!.!| m } %!0!1!.!i m 2!^ %!0!$!o 3!! % % ! ! ",
"% ! # 4!5!l 6!Q 7!8!| 2!^ ] 8!s k Z m P 1!1!] 9!'!:!,!% % % ! ! ",
"% ! % ;!:!%!<!=!m ~ >!%!1!1!~ | 8!l ^ | ?!| ?!@!(!2!A!% ! ! ! ! ",
"% ! B!N :!i l C!9!i j |  !!!2! !.!!!!!| 1!%!i ] 9!| D!# ! % ! ! ",
"% E!4!F!O j } 7!G!%!9!2!!!!!!!!!| | 2!] ^ ^ } H!-!] I!J!% ! % ! ",
"! g K!L!j @!] t O ^ @!i M!!!!!| 1!| .!i } i N!O!-!(!P!#!y ! % % ",
"! & Q!R!@!<!2!S!N!1!-!O !!!! !!!2!!!T!U!9!} L!O!l (!H!V!W!! % % ",
"% ! X!F!] S!L!@!8!!!j L!T!2!!! ! ! ![ j l 2!i 2!Y!Z![!]!F ! % ! ",
"% L ;!F!M!Q ] j @!| ] j %!%!!!.! !.!!!2!%!^!| l (!&!_!`!! ! ! ! ",
"! g K!O R!6!_ M!6!@!2!L!] !!!!1!a!b!%!>!9!~ b!8!'!n c!d!+!! % ! ",
"! D Z!:!^ 6!>!e!!!<!] 2![ | | %!j j ] ] 1!>!l f!g!P h!i!j!! % % ",
"% % k!Q!M![ 7!j !!L!m j } | l!| L!2!m!O!m!} n!h!h!Z o!V p!! % ! ",
"% % % q!:!!![ 7!!! !1!%!^ 1!^ 1!O!m!l %!>!Q H!i %!P r!s!! ! ! ! ",
"! % ! `!F!M!G!j t!9! !i @!>!i %!u!U!-!Q Q 1!a!%!(!P!v!% ! % ! ! ",
"! % ! T w!:!M!G!G!} x!1!] &!O!2!l l | y!m!x!} ] O!z!{!% ! % ! ! ",
"! % ! ! 0 |!}!P T!| C!9!L!l!l 2!O!U!j i >!8!Y!)!~!V T ! % ! ! ! ",
"! ! ! ! ! p!F  #:! !.!2!~ l!U!j C!Q ^ %!8!l!'!!###$ ! ! ! ! ! ! ",
"! ! ! ! % ! ! & r!$#%#0!&#&#&!L!^ a! !'#1!| ~!W!! ! % ! ! ! ! ! ",
"! ! ! ! ! % % ! +!W!##k!)!o!(#|!'#L!%#)#*#+#,## % % ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! ! ! ! # -#.#T +!X +#, # # # ! ! ! ! ! ! ! ! ! ! ",
"! ! ! ! ! ! ! ! % % % % ! ! ! ! ! % ! ! % ! % ! ! ! ! ! ! ! ! ! "};

static const char* const image_fs32_data[] = {
"32 32 351 2",
"  	c None",
"! 	c black",
"# 	c #97C9FB",
"$ 	c #95C6F8",
"% 	c #93C4F5",
"& 	c #D8EBFE",
"' 	c #86C7FE",
"( 	c #60B9FF",
") 	c #B7DDFE",
"* 	c #D1E7FE",
"+ 	c #D8E9FD",
", 	c white",
"- 	c #E4F2FE",
". 	c #35ABFE",
"0 	c #71C1FD",
"1 	c #B9D4F2",
"2 	c #BDD7F6",
"3 	c #EBF3FD",
"4 	c #F8FBFE",
"5 	c #ECF5FF",
"6 	c #AAC9EC",
"7 	c #A6C6EF",
"8 	c #FCFEFF",
"9 	c #F6FAFF",
": 	c #9FCFFF",
"; 	c #C4E2FF",
"< 	c #EAF4FF",
"= 	c #F5F9FE",
"> 	c #96B4D7",
"? 	c #9CBEE9",
"@ 	c #EFF6FE",
"A 	c #F6FBFF",
"B 	c #F0F8FF",
"C 	c #ABD5FF",
"D 	c #B6DAFF",
"E 	c #A5D2FF",
"F 	c #C8E3FF",
"G 	c #E9F2FC",
"H 	c #7C99C0",
"I 	c #92B3E1",
"J 	c #DDEAFA",
"K 	c #BADDFF",
"L 	c #AFD7FF",
"M 	c #B4D9FF",
"N 	c #AAD4FF",
"O 	c #C5E2FF",
"P 	c #EBF5FF",
"Q 	c #7691B5",
"R 	c #959A8A",
"S 	c #CBDEF5",
"T 	c #EAF5FF",
"U 	c #C7E3FF",
"V 	c #A3D1FF",
"W 	c #B3D9FF",
"X 	c #A8D3FF",
"Y 	c #AED6FF",
"Z 	c #ADD6FF",
"[ 	c #A8D4FF",
"] 	c #C2E0FF",
"^ 	c #C5D9F3",
"_ 	c #516685",
"` 	c #D2A624",
"a 	c #ECD89D",
"b 	c #F2E5BD",
"c 	c #D7D5C4",
"d 	c #ADCAEF",
"e 	c #DAEDFF",
"f 	c #E3F2FF",
"g 	c #CCE6FF",
"h 	c #9ECEFF",
"i 	c #BADCFF",
"j 	c #A7D3FF",
"k 	c #B0D8FF",
"l 	c #C8E4FF",
"m 	c #BAD1EF",
"n 	c #F2E3B7",
"o 	c #FFFEC8",
"p 	c #FFFFB1",
"q 	c #F7F9A3",
"r 	c #8FAFD8",
"s 	c #9DCEFF",
"t 	c #D5EAFF",
"u 	c #DDEFFF",
"v 	c #D1E8FF",
"w 	c #BBDDFF",
"x 	c #99CCFF",
"y 	c #B7DBFF",
"z 	c #AAD5FF",
"{ 	c #A1B9DE",
"| 	c #D9B23F",
"} 	c #FFFAE4",
"~ 	c #FFFF99",
" !	c #E8EAA1",
"!!	c #92B3DD",
"#!	c #D3EAFF",
"$!	c #B4DAFF",
"%!	c #B8DCFF",
"&!	c #A1D0FF",
"'!	c #CBE6FF",
"(!	c #D7ECFF",
")!	c #BCDEFF",
"*!	c #87A5D4",
"+!	c #F2DFAC",
",!	c #FFFCB6",
"-!	c #FFFB95",
".!	c #E7E198",
"0!	c #89ABDE",
"1!	c #A4D1FF",
"2!	c #AED7FF",
"3!	c #A0D0FF",
"4!	c #B5DAFF",
"5!	c #9CCEFF",
"6!	c #B2D9FF",
"7!	c #D1E9FF",
"8!	c #C1E0FF",
"9!	c #9AC9FC",
":!	c #6A81AA",
";!	c #F2DEA8",
"<!	c #FFFCAB",
"=!	c #FFF48E",
">!	c #CECA9D",
"?!	c #8EB6E9",
"@!	c #A9D4FF",
"A!	c #A6D2FF",
"B!	c #CBE0EF",
"C!	c #C9D1BF",
"D!	c #B6B78F",
"E!	c #B0A672",
"F!	c #B1902F",
"G!	c #BB9E48",
"H!	c #A77D00",
"I!	c #F2DCA2",
"J!	c #FFF6A3",
"K!	c #FFF892",
"L!	c #FFEB85",
"M!	c #CDC296",
"N!	c #8DB4E7",
"O!	c #A4D2FF",
"P!	c #AEC3BF",
"Q!	c #B5BD9F",
"R!	c #B8B580",
"S!	c #C2B160",
"T!	c #CFC180",
"U!	c #DFBF60",
"V!	c #E6CC80",
"W!	c #EFDFAF",
"X!	c #F2E6BF",
"Y!	c #FCF9EF",
"Z!	c #AF8300",
"[!	c #EFD590",
"]!	c #FFF09C",
"^!	c #FFF08A",
"_!	c #FFDE78",
"`!	c #B3AC9C",
"a!	c #91BBEE",
"b!	c #ACD5FF",
"c!	c #B2D3EF",
"d!	c #C6A940",
"e!	c #ECD99F",
"f!	c #FBFEFF",
"g!	c #F0FDFF",
"h!	c #E9FCFF",
"i!	c #E2FCFF",
"j!	c #B8DFFF",
"k!	c #E6F2F9",
"l!	c #FFFFF6",
"m!	c #E2C66C",
"n!	c #624900",
"o!	c #E6C365",
"p!	c #FFE893",
"q!	c #FFE781",
"r!	c #FFE680",
"s!	c #FFD771",
"t!	c #ABA6A0",
"u!	c #9EB9C6",
"v!	c #C5B260",
"w!	c #F5ECCF",
"x!	c #E0F3FF",
"y!	c #BCE2FF",
"z!	c #A0D3FF",
"{!	c #BDF0FF",
"|!	c #C0F3FF",
"}!	c #AADDFF",
"~!	c #BFDFF8",
" #	c #FFFFEE",
"!#	c #FCF9DF",
"##	c #BC900F",
"$#	c #E6C262",
"%#	c #FFE59E",
"&#	c #FFDF79",
"'#	c #FCDA71",
"(#	c #F2CE5B",
")#	c #E6BD3D",
"*#	c #DFB42E",
"+#	c #E6C25C",
",#	c #E2C670",
"-#	c #E9D28F",
".#	c #F9F2DF",
"0#	c #E4F7FF",
"1#	c #ABDEFF",
"2#	c #9BCEFF",
"3#	c #B5E8FF",
"4#	c #B9ECFF",
"5#	c #AEE1FF",
"6#	c #ACCCE2",
"7#	c #F9FCE4",
"8#	c #FFFFE2",
"9#	c #E6CC71",
":#	c #6A5000",
";#	c #E6C15D",
"<#	c #FFDF95",
"=#	c #FFD56F",
">#	c #F2C653",
"?#	c #DFBD57",
"@#	c #FFFFF0",
"A#	c #FFFFE6",
"B#	c #FFFBC9",
"C#	c #CCE4EA",
"D#	c #B1E4FF",
"E#	c #B3E6FF",
"F#	c #AFE2FF",
"G#	c #A1D0F8",
"H#	c #F2DC89",
"I#	c #FFFFDB",
"J#	c #C99F1C",
"K#	c #130E00",
"L#	c #E6BF5A",
"M#	c #FFDA8D",
"N#	c #FFCE68",
"O#	c #DFB643",
"P#	c #FFFFF9",
"Q#	c #FFFFCD",
"R#	c #FFFFB7",
"S#	c #FFFFA8",
"T#	c #FFFCA1",
"U#	c #F9EE92",
"V#	c #ACD2E8",
"W#	c #A5D8FF",
"X#	c #ACDFFF",
"Y#	c #9ACDFF",
"Z#	c #E6E6A6",
"[#	c #FFD873",
"]#	c #FFFFCF",
"^#	c #ECD982",
"_#	c #826200",
"`#	c #DCB036",
"a#	c #FED787",
"b#	c #FDCA62",
"c#	c #F7C456",
"d#	c #FFFFD9",
"e#	c #FFFF9C",
"f#	c #FFFB96",
"g#	c #F9E68A",
"h#	c #A0CEF7",
"i#	c #A3D6FF",
"j#	c #A6D9FF",
"k#	c #9CCFFF",
"l#	c #D2DAB8",
"m#	c #FFF590",
"n#	c #FFD973",
"o#	c #FFFFC8",
"p#	c #D6AC26",
"q#	c #241B00",
"r#	c #D9AB29",
"s#	c #FCD788",
"t#	c #F8C557",
"u#	c #E7B437",
"v#	c #FFFDB6",
"w#	c #FFFC96",
"x#	c #FFF18B",
"y#	c #ECDB92",
"z#	c #A0CDF6",
"{#	c #BFD3CC",
"|#	c #FFE882",
"}#	c #FFD872",
"~#	c #FFFFBC",
" $	c #F2E68D",
"!$	c #8E6A00",
"#$	c #D2A732",
"$$	c #FCD78A",
"%$	c #F3C04E",
"&$	c #DFB239",
"'$	c #FFFEF8",
"($	c #FFF791",
")$	c #ECD58B",
"*$	c #B3CFDB",
"+$	c #F9DC80",
",$	c #FFF58F",
"-$	c #FFFFB2",
".$	c #D9B32D",
"0$	c #342700",
"1$	c #D3A830",
"2$	c #FBD483",
"3$	c #ECB941",
"4$	c #FFFAD3",
"5$	c #FFE27C",
"6$	c #FFD16B",
"7$	c #F9F294",
"8$	c #A47B00",
"9$	c #D0A223",
":$	c #FAD17B",
";$	c #DFAC26",
"<$	c #FFF3B4",
"=$	c #FFED87",
">$	c #FFD46E",
"?$	c #DFBF3C",
"@$	c #513D00",
"A$	c #C49300",
"B$	c #FAD178",
"C$	c #D7A720",
"D$	c #FFE98A",
"E$	c #FCD86F",
"F$	c #B88A00",
"G$	c #BF8F00",
"H$	c #FFD581",
"I$	c #FFF6D6",
"J$	c #F5D565",
"K$	c #E9C347",
"L$	c #DCB027",
"M$	c #C99B10",
"N$	c #503C00",
"O$	c #EFC154",
"P$	c #FFEAAA",
"Q$	c #FCDA70",
"R$	c #F2CD5A",
"S$	c #E6BC3C",
"T$	c #D9AB1F",
"U$	c #AE8200",
"V$	c #8E6B00",
"W$	c #5F4700",
"X$	c #251C00",
"Y$	c #E2B43B",
"Z$	c #FFDA7B",
"[$	c #F9D064",
"]$	c #ECC148",
"^$	c #E2B533",
"_$	c #D6A516",
"`$	c #785A00",
"a$	c #533E00",
"b$	c #DFBC57",
"c$	c #FFF7E4",
"d$	c #F5C959",
"e$	c #E9BA3E",
"f$	c #DCAC23",
"g$	c #C9990E",
"h$	c #9A7300",
"i$	c #6C5100",
"j$	c #453400",
"k$	c #DCB950",
"l$	c #DFB94D",
"m$	c #161000",
"                          # $ % % %                             ",
"                          & ' ( ( ) *                           ",
"                        + , - . 0 , , 1                         ",
"                      2 , , , 3 4 5 5 , 6                       ",
"                    7 8 8 8 8 8 9 : ; < = >                     ",
"                  ? @ A A A A B C D E F B G H                   ",
"                I J B B B B B K L L M N O P J Q                 ",
"              R S T T T T T U V W X Y Z [ ] T ^ _               ",
"      ` a b c d e f f f f g h i h i j k C j l f m               ",
"      n o p q r s t u u v s w x w s y E L z u u u {             ",
"    | } ~ ~ ~  !!!E #!#!E $!s $!s %!s $!&!'!(!(!(!)!*!          ",
"    +!,!~ ~ ~ -!.!0!1!)!z 1!2!3!2!s 4!5!6!5!7!7!8!9!:!          ",
"    ;!<!~ ~ ~ ~ =!>!?!@!w E A![ V L 5!L x 8!B!C!D!E!F!G!H!      ",
"    I!J!K!K!K!K!K!L!M!N!N M &!O!P!Q!R!S!T!U!V!W!X!, , Y!Z!      ",
"    [!]!^!^!^!^!^!^!_!`!a!b!c!d!e!X!Y!f!g!h!i!j!k!l!l!m!n!      ",
"    o!p!q!q!q!q!q!q!r!s!t!u!v!w!x!y!z!{!|!|!}!~! # #!###!       ",
"    $#%#&#&#&#'#(#)#*#+#,#-#.#0#1#2#3#4#4#5#6#7#8#8#9#:#        ",
"    ;#<#=#=#>#?#W!.#, @#A#B#C#}!D#5#E#E#F#G#H#I#I#I#J#K#        ",
"    L#M#N#N#O#P#Q#R#S#S#S#T#U#V#W#X#X#1#Y#Z#[#]#]#^#_#          ",
"    `#a#b#c#,#d#e#e#e#e#e#e#f#g#h#i#j#k#l#m#n#o#o#p#q#          ",
"    r#s#t#u#w!v#w#w#w#w#w#w#w#x#y#z#k#{#|#w#}#~# $!$!           ",
"    #$$$%$&$'$($($($($($($($($($L!)$*$+$,$($s!-$.$0$            ",
"    1$2$3$,#4$x#x#x#x#x#x#x#x#x#x#5$6$L!x#x#=#7$8$!             ",
"    9$:$;$X!<$=$=$=$=$=$=$=$=$=$=$=$r!=$=$=$>$?$@$              ",
"    A$B$C$, D$|#|#|#|#|#|#|#|#|#|#|#|#|#|#|#E$F$!               ",
"    G$H$U!I$5$5$5$5$5$5$5$5$5$5$5$5$5$J$K$L$M$N$                ",
"      O$W!P$_!_!_!_!_!_!_!_!Q$R$S$T$U$V$W$X$!                   ",
"      Y$, Z$}#}#}#}#[$]$^$_$8$`$a$K#!                           ",
"      b$c$>$d$e$f$g$h$i$j$! !                                   ",
"      k$l$U$V$W$X$!                                             ",
"        m$!                                                     ",
"                                                                "};

// 16*16*24b
static const char* const image_ai_data[] = {
"16 16 166 2",
"  	c None",
"! 	c white",
"# 	c #FEFEFF",
"$ 	c #FEFEFE",
"% 	c #FEFDFD",
"& 	c #F9F9F8",
"' 	c #D6D5D5",
"( 	c #FDFDFD",
") 	c #FEFFFF",
"* 	c #FEFFFE",
"+ 	c #FDFDFC",
", 	c #FEFEFD",
"- 	c #D5D4D3",
". 	c #E3E3E3",
"0 	c #FFFFFE",
"1 	c #FFFEFF",
"2 	c #FFFEFE",
"3 	c #F1EDF3",
"4 	c #CECCCE",
"5 	c #FEFBFB",
"6 	c #FDFAFB",
"7 	c #FCFAF9",
"8 	c #EAF9CF",
"9 	c #CAD5B3",
": 	c #EBEDE6",
"; 	c #BCD592",
"< 	c #76A837",
"= 	c #C7D8B2",
"> 	c #FEFCFC",
"? 	c #FCFDFB",
"@ 	c #FDFCFB",
"A 	c #E8B4B2",
"B 	c #DB8B8C",
"C 	c #E4A8A8",
"D 	c #F9EEEE",
"E 	c #EEF3FA",
"F 	c #CCD2D4",
"G 	c #F3FFFF",
"H 	c #FEFDFC",
"I 	c #FCFAFA",
"J 	c #F6E3E1",
"K 	c #C23B3A",
"L 	c #B50000",
"M 	c #BA0000",
"N 	c #BD0000",
"O 	c #CA2123",
"P 	c #D69291",
"Q 	c #E4AFAE",
"R 	c #F0A5A8",
"S 	c #EDB1B3",
"T 	c #F9F3F3",
"U 	c #FCF9F9",
"V 	c #C64848",
"W 	c #AE0000",
"X 	c #BD040A",
"Y 	c #C30309",
"Z 	c #C4010A",
"[ 	c #AB0008",
"] 	c #C20006",
"^ 	c #B70008",
"_ 	c #D20009",
"` 	c #DA000C",
"a 	c #DE2837",
"b 	c #F1D8DA",
"c 	c #FDFAFA",
"d 	c #EFD8D7",
"e 	c #B20407",
"f 	c #BA0206",
"g 	c #C00006",
"h 	c #C40009",
"i 	c #A30916",
"j 	c #C00009",
"k 	c #C0000A",
"l 	c #B20012",
"m 	c #CC051A",
"n 	c #E20523",
"o 	c #E6000D",
"p 	c #DE4A5D",
"q 	c #F8FCFC",
"r 	c #FEF9FA",
"s 	c #E9C8C7",
"t 	c #B50105",
"u 	c #C30008",
"v 	c #C70007",
"w 	c #D58580",
"x 	c #BA5655",
"y 	c #C04C50",
"z 	c #CB5557",
"{ 	c #D40116",
"| 	c #E4021F",
"} 	c #E6011D",
"~ 	c #D90C2A",
" !	c #E6DADE",
"!!	c #F1E7E7",
"#!	c #B61216",
"$!	c #BF0104",
"%!	c #BF0108",
"&!	c #C00005",
"'!	c #C91213",
"(!	c #D01B20",
")!	c #D51C24",
"*!	c #DF1A29",
"+!	c #DE011A",
",!	c #DB001C",
"-!	c #E3001D",
".!	c #DB0829",
"0!	c #DCCBD1",
"1!	c #FDF8F8",
"2!	c #FDFFFF",
"3!	c #C8787A",
"4!	c #B80000",
"5!	c #BF050B",
"6!	c #BE0106",
"7!	c #C20003",
"8!	c #C90007",
"9!	c #D1000D",
":!	c #D90012",
";!	c #D80015",
"<!	c #D8021D",
"=!	c #EB0118",
">!	c #C82644",
"?!	c #E2EAEB",
"@!	c #FCFCFC",
"A!	c #F1F4F4",
"B!	c #B84E52",
"C!	c #B70000",
"D!	c #C20002",
"E!	c #C7030A",
"F!	c #CB030F",
"G!	c #D20315",
"H!	c #D60318",
"I!	c #DA031E",
"J!	c #E7001A",
"K!	c #D40018",
"L!	c #BB939F",
"M!	c #FBFFFF",
"N!	c #EFF6F5",
"O!	c #BC8082",
"P!	c #B21317",
"Q!	c #C20001",
"R!	c #CC0004",
"S!	c #D3000C",
"T!	c #DB0011",
"U!	c #DB0012",
"V!	c #C40823",
"W!	c #AF7987",
"X!	c #F0FAF8",
"Y!	c #FFFDFE",
"Z!	c #FCFDFC",
"[!	c #FCFFFF",
"]!	c #D8D0D2",
"^!	c #BB8489",
"_!	c #B44C57",
"`!	c #B63244",
"a!	c #B73B50",
"b!	c #B16471",
"c!	c #C1B6BB",
"d!	c #F4FDFB",
"e!	c #FDFEFD",
"f!	c #FDFCFC",
"g!	c #ECFFFF",
"h!	c #D6EFED",
"i!	c #D9F4F1",
"j!	c #F5FFFF",
"k!	c #FFFCFC",
"l!	c #FCFDFD",
"! ! ! ! ! ! # $ % $ & ' $ ( ( ! ",
"! ! ! ! ! ) * $ + , - . ! ( $ ! ",
"! 0 ! ) 1 ! 2 ( ! 3 4 ! $ $ $ ! ",
"2 $ $ $ 5 6 7 ( 8 9 : $ ( $ ! ! ",
"$ $ % ! ! ! ! ! ; < = > ? ( $ ! ",
") % ! @ A B C D E F G ! ) H ! $ ",
"I $ J K L M N O P Q R S T ! % * ",
"U ( V W X Y Z [ ] ^ _ ` a b 2 c ",
"! d e f g h i j k l m n o p q r ",
"$ s t j u v w x y z { | } ~  !! ",
"0 !!#!$!%!&!'!(!)!*!+!,!-!.!0!* ",
"1!2!3!4!5!6!7!8!9!:!;!<!=!>!?!2 ",
"@!% A!B!C!D!E!F!G!H!I!J!K!L!M!c ",
"$ ( ! N!O!P!Q!R!S!T!U!V!W!X!Y!Z!",
"2 $ ( ! [!]!^!_!`!a!b!c!d!2 e!$ ",
"$ ! * f!1!! ! g!h!i!j!! k!l!) ) "};

static const char* const image_di_data[] = {
"16 16 171 2",
"  	c None",
"! 	c #FFFFFE",
"# 	c #FEFEFE",
"$ 	c #FFFEFE",
"% 	c #FEFFFF",
"& 	c #FEFDFC",
"' 	c #FBFBE8",
"( 	c #F1F16E",
") 	c #F6F6E2",
"* 	c white",
"+ 	c #FDFDF5",
", 	c #FEFEF8",
"- 	c #FEFEFD",
". 	c #FEFEFF",
"0 	c #FEFEFA",
"1 	c #FDFDFD",
"2 	c #F1F170",
"3 	c #F7F70F",
"4 	c #EFEF58",
"5 	c #F5F3F9",
"6 	c #FDFEFF",
"7 	c #F2EFBF",
"8 	c #F0EE13",
"9 	c #FDFC1E",
": 	c #FEFE0E",
"; 	c #F5F792",
"< 	c #FDFCAB",
"= 	c #F2F068",
"> 	c #F5F4E8",
"? 	c #FFFEFF",
"@ 	c #FCFCE9",
"A 	c #F5F3B8",
"B 	c #F6F744",
"C 	c #FBFA11",
"D 	c #F3EB1D",
"E 	c #E2D721",
"F 	c #C6B52D",
"G 	c #C8C156",
"H 	c #D0D183",
"I 	c #EAEAE2",
"J 	c #FEFFFE",
"K 	c #FDFDFB",
"L 	c #F6F6E9",
"M 	c #CFCB43",
"N 	c #CCC92F",
"O 	c #AB9633",
"P 	c #94714E",
"Q 	c #9A8B74",
"R 	c #8B6A7F",
"S 	c #5B176B",
"T 	c #66337F",
"U 	c #E0D7F1",
"V 	c #FCFCFD",
"W 	c #FDFDFC",
"X 	c #EFEEE6",
"Y 	c #D7D8C7",
"Z 	c #B4A9BD",
"[ 	c #45115E",
"] 	c #4E1E67",
"^ 	c #623473",
"_ 	c #733E7D",
"` 	c #845984",
"a 	c #79337E",
"b 	c #783988",
"c 	c #ECE8EE",
"d 	c #FEFDFE",
"e 	c #795C7B",
"f 	c #52175D",
"g 	c #744A7B",
"h 	c #7E5381",
"i 	c #79467B",
"j 	c #86548B",
"k 	c #7B328E",
"l 	c #731C88",
"m 	c #AD88B8",
"n 	c #FDFBFD",
"o 	c #FDFCFD",
"p 	c #DEDADD",
"q 	c #4C2253",
"r 	c #5F216C",
"s 	c #6B2C79",
"t 	c #76397E",
"u 	c #7A2E81",
"v 	c #742385",
"w 	c #772D8D",
"x 	c #7F2690",
"y 	c #8A439A",
"z 	c #F3F3F4",
"{ 	c #FCFBFC",
"| 	c #C6BAC5",
"} 	c #471950",
"~ 	c #652672",
" !	c #651C72",
"!!	c #5E146D",
"#!	c #701A78",
"$!	c #772581",
"%!	c #73287F",
"&!	c #82298D",
"'!	c #832E93",
"(!	c #DED6E2",
")!	c #FBFAFB",
"*!	c #BBA9BA",
"+!	c #4F165A",
",!	c #682376",
"-!	c #681C73",
".!	c #6D1D7C",
"0!	c #792186",
"1!	c #7F258C",
"2!	c #802A8E",
"3!	c #893099",
"4!	c #9034A6",
"5!	c #D7C5DD",
"6!	c #FAF9FC",
"7!	c #C4B4C4",
"8!	c #551860",
"9!	c #661F72",
":!	c #691C73",
";!	c #6C1B79",
"<!	c #732180",
"=!	c #772387",
">!	c #822793",
"?!	c #8D329D",
"@!	c #993AAE",
"A!	c #D3C0DA",
"B!	c #FAF9FB",
"C!	c #DAD2DA",
"D!	c #631F6A",
"E!	c #74217D",
"F!	c #76217E",
"G!	c #6C1D75",
"H!	c #701F7D",
"I!	c #7E248E",
"J!	c #892591",
"K!	c #8A3099",
"L!	c #9540A5",
"M!	c #DBD4DE",
"N!	c #FEFDFD",
"O!	c #F9F9F9",
"P!	c #754677",
"Q!	c #65106E",
"R!	c #84298B",
"S!	c #78217E",
"T!	c #772083",
"U!	c #83258E",
"V!	c #852C94",
"W!	c #862496",
"X!	c #9759A7",
"Y!	c #F1F4F2",
"Z!	c #CEC7D0",
"[!	c #581C5F",
"]!	c #67106E",
"^!	c #751779",
"_!	c #781A80",
"`!	c #7E1E8F",
"a!	c #811E90",
"b!	c #7B2B84",
"c!	c #C3B8C6",
"d!	c #D0CBD1",
"e!	c #805F84",
"f!	c #733879",
"g!	c #773681",
"h!	c #83478D",
"i!	c #96709D",
"j!	c #CBC7CC",
"k!	c #FEFFFD",
"l!	c #FDFDFE",
"m!	c #E2EAE2",
"n!	c #D2D9D4",
"o!	c #E4EFE4",
"p!	c #FCFBFD",
"q!	c #FDFEFE",
"! # $ % & ! ' ( ) * + , - # * * ",
". ! . - 0 1 2 3 4 5 . 6 * # # . ",
"! # # . * 7 8 9 : ; < = > ? 1 $ ",
"# # * @ A B C D E F G H I J 1 # ",
"K # L M N O P Q R S T U * V # # ",
"W * X Y Z [ ] ^ _ ` a b c d 1 # ",
"% # . * e f g h i j k l m * n # ",
"# o ! p q r s t u v w x y z $ 1 ",
"# { # | } ~  !!!#!$!%!&!'!(!* )!",
"J )!* *!+!,!-!.!0!1!2!3!4!5!# 6!",
"# { # 7!8!9!:!;!<!=!>!?!@!A!. B!",
"$ o * C!D!E!F!G!H!I!J!K!L!M!* )!",
"# 1 N!O!P!Q!R!S!T!U!V!W!X!Y!# 1 ",
"$ # { * Z![!]!^!_!`!a!b!c!* o # ",
"? * # 1 * d!e!f!g!h!i!j!k!l!- J ",
"! # . # )!* * m!n!o!* * p!q!$ # "};

static const char* const image_pi_data[] = {
"16 16 199 2",
"  	c None",
"! 	c #FEFEFF",
"# 	c #FFFFFE",
"$ 	c #FEFEFE",
"% 	c white",
"& 	c #FDFFFE",
"' 	c #F4F8F0",
"( 	c #F7F9F4",
") 	c #DFEED6",
"* 	c #BEDBB1",
"+ 	c #FDFFFA",
", 	c #F6FAF5",
"- 	c #FDFDFE",
". 	c #FEFFFF",
"0 	c #FDFDFD",
"1 	c #DEE9CB",
"2 	c #F4F5EC",
"3 	c #AACC91",
"4 	c #BFD1AB",
"5 	c #93BD7B",
"6 	c #A7BC93",
"7 	c #C5E0B6",
"8 	c #9FBA8C",
"9 	c #FBF6FB",
": 	c #FFFEFE",
"; 	c #FDFDFC",
"< 	c #FEFEFD",
"= 	c #B2C698",
"> 	c #83BF62",
"? 	c #88CA70",
"@ 	c #71C152",
"A 	c #6FB750",
"B 	c #81BE6C",
"C 	c #69B551",
"D 	c #8ABD7D",
"E 	c #9DC885",
"F 	c #DEDFD4",
"G 	c #FEFDFD",
"H 	c #FEFFFE",
"I 	c #B2AB83",
"J 	c #7A7E2A",
"K 	c #7F873A",
"L 	c #88954E",
"M 	c #80863B",
"N 	c #897C39",
"O 	c #867B31",
"P 	c #A39F82",
"Q 	c #F7FEFF",
"R 	c #FDFCFB",
"S 	c #FCF6F5",
"T 	c #C88377",
"U 	c #A9231C",
"V 	c #9F0000",
"W 	c #C84450",
"X 	c #B0888E",
"Y 	c #C06463",
"Z 	c #AB0504",
"[ 	c #9B090F",
"] 	c #C11C22",
"^ 	c #DF8183",
"_ 	c #FDFCFC",
"` 	c #FBFAF9",
"a 	c #FFFDFD",
"b 	c #B46F60",
"c 	c #860D00",
"d 	c #961C0D",
"e 	c #89190E",
"f 	c #9F251C",
"g 	c #8E170C",
"h 	c #A52B23",
"i 	c #8E150F",
"j 	c #99120F",
"k 	c #B20505",
"l 	c #B20000",
"m 	c #DC6F7C",
"n 	c #FDFFFF",
"o 	c #FDF8F8",
"p 	c #E2C5BF",
"q 	c #7E240F",
"r 	c #942C16",
"s 	c #A0240D",
"t 	c #902010",
"u 	c #7F160C",
"v 	c #A75751",
"w 	c #872016",
"x 	c #A41006",
"y 	c #B80C03",
"z 	c #B50909",
"{ 	c #BF0712",
"| 	c #CD0C1F",
"} 	c #EED4D9",
"~ 	c #B7867C",
" !	c #872008",
"!!	c #9E2B14",
"#!	c #9C240E",
"$!	c #A3200B",
"%!	c #A61B0A",
"&!	c #B13C2D",
"'!	c #A9210E",
"(!	c #AC1505",
")!	c #B80D03",
"*!	c #BE0306",
"+!	c #CF0617",
",!	c #D80011",
"-!	c #DA99A3",
".!	c #AA7164",
"0!	c #871F07",
"1!	c #9A2A13",
"2!	c #A7250B",
"3!	c #A3220B",
"4!	c #9C1E0C",
"5!	c #A31802",
"6!	c #AA1A06",
"7!	c #B31404",
"8!	c #BD0603",
"9!	c #C6010E",
":!	c #D3061A",
";!	c #D70012",
"<!	c #D48E99",
"=!	c #B1847C",
">!	c #841E08",
"?!	c #A82911",
"@!	c #AF2107",
"A!	c #9C200D",
"B!	c #9F1C0C",
"C!	c #AC1D09",
"D!	c #AC1907",
"E!	c #BA0A02",
"F!	c #BC020A",
"G!	c #CD0112",
"H!	c #DF0317",
"I!	c #D4061C",
"J!	c #D4AFB8",
"K!	c #DBCAC7",
"L!	c #97270F",
"M!	c #AA250D",
"N!	c #AA200A",
"O!	c #A21F0B",
"P!	c #A71E09",
"Q!	c #A41C09",
"R!	c #AB1907",
"S!	c #BB0A02",
"T!	c #C20203",
"U!	c #CD0410",
"V!	c #DF0010",
"W!	c #BF374D",
"X!	c #E8EDEF",
"Y!	c #FCFAFA",
"Z!	c #B98079",
"[!	c #A31400",
"]!	c #AA210E",
"^!	c #A2210E",
"_!	c #AA1908",
"`!	c #B21505",
"a!	c #B81003",
"b!	c #C20904",
"c!	c #D40004",
"d!	c #C10C24",
"e!	c #CCBCC4",
"f!	c #FCF9FA",
"g!	c #FCFCFC",
"h!	c #F5F7F9",
"i!	c #B1736F",
"j!	c #A31903",
"k!	c #9F1A03",
"l!	c #A3210D",
"m!	c #AC1E0A",
"n!	c #A61809",
"o!	c #B71604",
"p!	c #BD0000",
"q!	c #AE1C2C",
"r!	c #C1A7B1",
"s!	c #FBFFFF",
"t!	c #FDFCFD",
"u!	c #FDFEFD",
"v!	c #FAFFFF",
"w!	c #CBAEAF",
"x!	c #A63F35",
"y!	c #9A1603",
"z!	c #9F1802",
"{!	c #A41702",
"|!	c #9E1309",
"}!	c #A3525C",
"~!	c #D5D5DA",
" #	c #FEFCFC",
"!#	c #FDFEFE",
"##	c #FEFDFC",
"$#	c #EBEEF0",
"%#	c #BD9C9D",
"&#	c #A04E48",
"'#	c #973E3E",
"(#	c #B79EA5",
")#	c #EEF7F8",
"*#	c #FDFBFC",
"+#	c #FFFEFF",
",#	c #FBF8F8",
"-#	c #EFFBFE",
".#	c #DDE8EB",
"0#	c #FBFAFA",
"! # $ % & ' ( ) * % + , - $ $ . ",
"$ $ 0 1 2 3 4 5 6 7 8 9 % 0 $ : ",
"0 ; < = > ? @ A B C D E F $ 0 $ ",
". G H % I J K L M N O P Q G 0 H ",
"R G S T U V W X Y Z [ ] ^ _ G G ",
"` a b c d e f g h i j k l m n o ",
"% p q r s t u v w x y z { | } # ",
"$ ~  !!!#!$!%!&!'!(!)!*!+!,!-!. ",
"% .!0!1!2!3!4!5!6!7!8!9!:!;!<!: ",
"$ =!>!?!@!A!B!C!D!E!F!G!H!I!J!. ",
"% K!L!M!N!O!P!Q!R!S!T!U!V!W!X!a ",
"Y!. Z![!]!^!P!_!`!a!b!c!d!e!% f!",
"g!G h!i!j!k!l!m!n!o!p!q!r!s!t!u!",
"$ G : v!w!x!y!z!{!|!}!~!%  #$ $ ",
"% % !###% $#%#&#'#(#)#% *#$ % +#",
"$ $ % u!,#% % -#.#% a 0#+#. $ H "};

static const char* const image_comm_data[] = {
"16 16 200 2",
"  	c None",
"! 	c white",
"# 	c #FEFEFE",
"$ 	c #F5F5F5",
"% 	c #FCFCFC",
"& 	c #F1EEEF",
"' 	c #CFC9CA",
"( 	c #8D8789",
") 	c #ECECED",
"* 	c #FDFDFD",
"+ 	c #FFFFFE",
", 	c #FAFAFA",
"- 	c #B5B1B3",
". 	c #A39FA0",
"0 	c #FEFDFD",
"1 	c #80777A",
"2 	c #3F343A",
"3 	c #231920",
"4 	c #BEBDBF",
"5 	c #FBFBFB",
"6 	c #FFFEFF",
"7 	c #CDCBCC",
"8 	c #332D31",
"9 	c #333133",
": 	c #9EA19F",
"; 	c #E0E0DD",
"< 	c #281C22",
"= 	c #1B1218",
"> 	c #140910",
"? 	c #B1AEB1",
"@ 	c #F9FEFC",
"A 	c #8E7683",
"B 	c #49042D",
"C 	c #532E44",
"D 	c #181619",
"E 	c #120B11",
"F 	c #151317",
"G 	c #D4D7D7",
"H 	c #FEFDFC",
"I 	c #E7E2E3",
"J 	c #D6D3D3",
"K 	c #E0DFE0",
"L 	c #B76994",
"M 	c #962264",
"N 	c #860F54",
"O 	c #931D68",
"P 	c #793961",
"Q 	c #5A4552",
"R 	c #4A263A",
"S 	c #6D5964",
"T 	c #493F44",
"U 	c #2E2F2E",
"V 	c #353033",
"W 	c #9A989B",
"X 	c #FDFCFC",
"Y 	c #F7F1F3",
"Z 	c #B66F96",
"[ 	c #80004B",
"] 	c #730A47",
"^ 	c #8D105F",
"_ 	c #7E1355",
"` 	c #9E1466",
"a 	c #B7357F",
"b 	c #8F1C5D",
"c 	c #820450",
"d 	c #7E1755",
"e 	c #AC7D99",
"f 	c #EAEAEB",
"g 	c #E2CCD7",
"h 	c #82004A",
"i 	c #670F40",
"j 	c #700F4A",
"k 	c #960E60",
"l 	c #930F60",
"m 	c #851059",
"n 	c #790A4C",
"o 	c #8B115B",
"p 	c #A7176C",
"q 	c #820F4F",
"r 	c #A3206F",
"s 	c #ECEBEC",
"t 	c #FCFBFB",
"u 	c #BC7FA3",
"v 	c #830750",
"w 	c #6A0D42",
"x 	c #780C4C",
"y 	c #810D51",
"z 	c #A50B6A",
"{ 	c #A60C6D",
"| 	c #A20D69",
"} 	c #A30C68",
"~ 	c #910E58",
" !	c #851254",
"!!	c #8A0D57",
"#!	c #DB9FC3",
"$!	c #FCF8FA",
"%!	c #F8FBF8",
"&!	c #9B3A75",
"'!	c #68013D",
"(!	c #6C0E45",
")!	c #800B4F",
"*!	c #830D54",
"+!	c #A10B69",
",!	c #A10B68",
"-!	c #A90C6E",
".!	c #920C5A",
"0!	c #760D49",
"1!	c #991164",
"2!	c #99085E",
"3!	c #B9478C",
"4!	c #F4FCF8",
"5!	c #FFFBFE",
"6!	c #FDFEFD",
"7!	c #AE5F8D",
"8!	c #7D004C",
"9!	c #740F4C",
":!	c #770C4A",
";!	c #860C55",
"<!	c #8A0C59",
"=!	c #A40B69",
">!	c #AC0A6B",
"?!	c #820D4F",
"@!	c #8C0E59",
"A!	c #981360",
"B!	c #A3106B",
"C!	c #C97FB0",
"D!	c #FBFEFD",
"E!	c #FEF8FC",
"F!	c #F7FBF9",
"G!	c #9A3672",
"H!	c #78014A",
"I!	c #770D48",
"J!	c #7F0B4F",
"K!	c #831053",
"L!	c #920E5E",
"M!	c #9C0D63",
"N!	c #7F0D4C",
"O!	c #900D5A",
"P!	c #8B0E56",
"Q!	c #9B1768",
"R!	c #AC1271",
"S!	c #BF639E",
"T!	c #FBFFFD",
"U!	c #FEF9FD",
"V!	c #D2C0CB",
"W!	c #910B5D",
"X!	c #700A44",
"Y!	c #8C0C5A",
"Z!	c #850E53",
"[!	c #890D55",
"]!	c #9D0D62",
"^!	c #A00D66",
"_!	c #930D5A",
"`!	c #8B0F59",
"a!	c #A9176B",
"b!	c #90175E",
"c!	c #C1ADBC",
"d!	c #FEFFFE",
"e!	c #FBFAFB",
"f!	c #FDFCFD",
"g!	c #FBFDFB",
"h!	c #A14D80",
"i!	c #870054",
"j!	c #810D50",
"k!	c #870E53",
"l!	c #871259",
"m!	c #9E1365",
"n!	c #8C1054",
"o!	c #8B1055",
"p!	c #91135B",
"q!	c #8B0C56",
"r!	c #9F3578",
"s!	c #EDEDED",
"t!	c #FEFDFE",
"u!	c #EDF2F0",
"v!	c #C1A3B5",
"w!	c #9A1668",
"x!	c #880957",
"y!	c #A9096A",
"z!	c #8B0754",
"{!	c #8B0852",
"|!	c #870850",
"}!	c #8E0055",
"~!	c #A75D8D",
" #	c #D7D8D9",
"!#	c #D4CDD3",
"##	c #C2A1B6",
"$#	c #A85085",
"%#	c #A46A90",
"&#	c #9B3170",
"'#	c #A96C93",
"(#	c #B285A3",
")#	c #E1DEDF",
"*#	c #FEFFFF",
"+#	c #FCFDFC",
",#	c #FBF9FA",
"-#	c #EFFFF9",
".#	c #D7E4DD",
"0#	c #F3FFFA",
"1#	c #FAFBFB",
"! # ! ! # $ % & ' ( ) ! * # # + ",
", # - . 0 ! ! 1 2 3 4 # 5 * 0 6 ",
", # 7 8 9 : ; < = > ? ! ! ! ! # ",
"! * ! @ A B C D E F G H I J K # ",
"* ! ! L M N O P Q R S T U V W ! ",
"X Y Z [ ] ^ _ ` a b c d e f ! 0 ",
"! g h i j k l m n o p q r s * t ",
"* u v w x y z { | } ~  !!!#!# $!",
"%!&!'!(!)!*!+!,!-!.!0!1!2!3!4!5!",
"6!7!8!9!:!;!<!=!>!?!@!A!B!C!D!E!",
"F!G!H!I!J!K!L!M!N!O!P!Q!R!S!T!U!",
"! V!W!X!Y!Z![!]!^!_!`!a!b!c!d!e!",
"f!g!h!i!j!k!l!m!n!o!p!q!r!s!6 % ",
"X t!u!v!w!x!y!z!{!|!}!~! #* # # ",
"d!t!! ! !###$#%#&#'#(#)#! f!# ! ",
"# *#+#,#! ! -#*#.#0#! ! 1#d!! # "};

static const char* const image_fs_data[] = {
"16 16 55 1",
" 	c None",
"!	c black",
"#	c #7394C4",
"$	c #5CB7FF",
"%	c #7090C0",
"&	c white",
"'	c #CC9933",
"(	c #CB9832",
")	c #6C8CBC",
"*	c #FAFDFF",
"+	c #B4DAFF",
",	c #30A7FD",
"-	c #6987B7",
".	c #F2F9FF",
"0	c #CBE8FF",
"1	c #FFFF99",
"2	c #6581B1",
"3	c #EAF6FF",
"4	c #FFF791",
"5	c #FFF48E",
"6	c #617DAD",
"7	c #E2F3FF",
"8	c #C99630",
"9	c #FFEB85",
":	c #5E79A9",
";	c #B0BAB6",
"<	c #B3801A",
"=	c #C7942E",
">	c #FFE07A",
"?	c #DDEBF0",
"@	c #A3700A",
"A	c #C5922C",
"B	c #FFD46E",
"C	c #BBBFCD",
"D	c #AEDAFF",
"E	c #A06D07",
"F	c #C28F29",
"G	c #FFCC66",
"H	c #9E6B05",
"I	c #C08D27",
"J	c #9C6903",
"K	c #BD8A24",
"L	c #BF8C26",
"M	c #9A6701",
"N	c #BA8721",
"O	c #B8851F",
"P	c #D0AC57",
"Q	c #D3A03A",
"R	c #996600",
"S	c #B5821C",
"T	c #B07D17",
"U	c #AE7B15",
"V	c #AB7812",
"W	c #A8750F",
"X	c #A5720C",
"    #######$    ",
"    %&&&&&&$$   ",
"  '()*++++*,,,  ",
" '&&-......00-  ",
"'&1123++++++32! ",
"(4556777777776! ",
"89'':;;;;;;;;:< ",
"=>'&?&&&&&&&&?@ ",
"AB'1C?DDDDDD?CE!",
"FG(1C????????CH!",
"IGA1C????????CJ!",
"KGL1CCCCCCCCCCM!",
"NGO1BPPPPPPPQ1R!",
" S<TUVWX@EHJMR! ",
"   !!!!!!!!!!!  ",
"                "};
#endif
